SystemOrganization addCategory: #'Pinesoft-Widgets'!

Trait named: #TEasilyThemed
	uses: {}
	category: 'Pinesoft-Widgets'!

!TEasilyThemed commentStamp: 'gvc 5/18/2007 11:55' prior: 0!
Trait providing useful theme-related methods.!

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/18/2007 14:55'!
abort: aStringOrText
	"Open an error dialog."

	^self abort: aStringOrText title: 'Error' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/18/2007 14:55'!
abort: aStringOrText title: aString
	"Open an error dialog."

	^self theme
		abortIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/30/2006 09:37'!
alert: aStringOrText
	"Open an alert dialog."

	^self alert: aStringOrText title: 'Alert' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/30/2006 09:38'!
alert: aStringOrText title: aString
	"Open an alert dialog."

	^self theme
		alertIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 14:19'!
chooseColor
	"Answer the result of a color selector dialog ."

	^self chooseColor: Color black! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseColor: aColor 
	"Answer the result of a color selector dialog with the given color."

	^self theme
		chooseColorIn: self
		title: 'Colour Selector' translated
		color: aColor! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/22/2006 11:04'!
chooseColor: aColor title: title
	"Answer the result of a color selector dialog with the given title and initial colour."

	^self theme
		chooseColorIn: self
		title: title
		color: aColor! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 4/2/2007 15:34'!
chooseDirectory: title 
	"Answer the result of a file dialog with the given title, answer a directory."

	^self
		chooseDirectory: title
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/15/2007 14:45'!
chooseDirectory: title path: path
	"Answer the result of a file dialog with the given title, answer a directory."

	^self theme
		chooseDirectoryIn: self
		title: title
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/12/2007 14:24'!
chooseDropList: aStringOrText list: aList
	"Open a drop list chooser dialog."

	^self
		chooseDropList: aStringOrText
		title: 'Choose' translated
		list: aList! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/12/2007 14:23'!
chooseDropList: aStringOrText title: aString list: aList
	"Open a drop list chooser dialog."

	^self theme
		chooseDropListIn: self
		text: aStringOrText
		title: aString
		list: aList! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 4/4/2007 16:08'!
chooseFileName: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	to show, path and preview type."

	^self theme
		chooseFileNameIn: self
		title: title
		extensions: exts
		path: path
		preview: preview! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseFont
	"Answer the result of a font selector dialog."

	^self chooseFont: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseFont: aFont 
	"Answer the result of a font selector dialog with the given initial font."

	^self theme
		chooseFontIn: self
		title: 'Font Selector' translated
		font: aFont! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 11:13'!
deny: aStringOrText
	"Open a denial dialog."

	^self deny: aStringOrText title: 'Access Denied' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 11:13'!
deny: aStringOrText title: aString
	"Open a denial dialog."

	^self theme
		denyIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/31/2006 15:32'!
fileOpen: title
	"Answer the result of a file open dialog with the given title."

	^self
		fileOpen: title
		extensions: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileOpen: title extensions: exts
	"Answer the result of a file open dialog with the given title and extensions to show."

	^self
		fileOpen: title
		extensions: exts
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 12/18/2006 11:21'!
fileOpen: title extensions: exts path: path
	"Answer the result of a file open dialog with the given title, extensions to show and path."

	^self 
		fileOpen: title
		extensions: exts
		path: path
		preview: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 13:38'!
fileOpen: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions to show, path and preview type."

	^self theme
		fileOpenIn: self
		title: title
		extensions: exts
		path: path
		preview: preview! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title
	"Answer the result of a file save dialog with the given title."

	^self
		fileSave: title
		extensions: nil
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title extensions: exts
	"Answer the result of a file save dialog with the given title."

	^self
		fileSave: title
		extensions: exts
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title extensions: exts path: path
	"Answer the result of a file save dialog with the given title, extensions to show and path."

	^self theme
		fileSaveIn: self
		title: title
		extensions: exts
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/31/2006 15:32'!
fileSave: title path: path
	"Answer the result of a file save open dialog with the given title."

	^self
		fileSave: title
		extensions: nil
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/29/2006 16:51'!
message: aStringOrText
	"Open a message dialog."

	^self message: aStringOrText title: 'Information' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/27/2006 10:24'!
message: aStringOrText title: aString
	"Open a message dialog."

	^self theme
		messageIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 15:13'!
newAlphaImage: aForm help: helpText
	"Answer an alpha image morph."

	^self theme
		newAlphaImageIn: self
		image: aForm
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/26/2006 11:39'!
newAlphaSelector: aModel getAlpha: getSel setAlpha: setSel help: helpText
	"Answer an alpha channel selector with the given selectors."

	^self theme
		newAlphaSelectorIn: self
		for: aModel
		getAlpha: getSel
		setAlpha: setSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/5/2006 14:44'!
newAutoAcceptTextEditorFor: aModel getText: getSel setText: setSel getEnabled: enabledSel
	"Answer a text editor for the given model."

	^self theme
		newAutoAcceptTextEditorIn: self
		for: aModel
		getText: getSel
		setText: setSel
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 12:51'!
newAutoAcceptTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 13:00'!
newAutoAcceptTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 6/18/2007 11:37'!
newButtonFor: aModel action: actionSel getEnabled: enabledSel label: label help: helpText
	"Answer a new button."

	^self
		newButtonFor: aModel
		getState: nil
		action: actionSel
		arguments: nil
		getEnabled: enabledSel 
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:45'!
newButtonFor: aModel action: actionSel label: label help: helpText
	"Answer a new button."

	^self
		newButtonFor: aModel
		getState: nil
		action: actionSel
		arguments: nil
		getEnabled: nil 
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/17/2007 15:22'!
newButtonFor: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel getLabel: labelSel help: helpText
	"Answer a new button."

	^self theme
		newButtonIn: self for: aModel
		getState: stateSel
		action: actionSel
		arguments: args
		getEnabled: enabledSel 
		getLabel: labelSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:47'!
newButtonFor: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel label: label help: helpText
	"Answer a new button."

	^self theme
		newButtonIn: self for: aModel
		getState: stateSel
		action: actionSel
		arguments: args
		getEnabled: enabledSel 
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCancelButton
	"Answer a new cancel button."

	^self newCancelButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:33'!
newCancelButtonFor: aModel
	"Answer a new cancel button."

	^self theme
		newCancelButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 16:26'!
newCheckboxFor: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox with the given label."

	^self theme
		newCheckboxIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:53'!
newCheckboxFor: aModel getSelected: getSel setSelected: setSel label: label help: helpText
	"Answer a checkbox with the given label."

	^self theme
		newCheckboxIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCloseButton
	"Answer a new close button."

	^self newCloseButtonFor: self ! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCloseButtonFor: aModel
	"Answer a new close button."

	^self theme
		newCloseButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/22/2006 09:24'!
newColorChooserFor: aModel getColor: getSel setColor: setSel getEnabled: enabledSel help: helpText
	"Answer a color chooser with the given selectors."

	^self theme
		newColorChooserIn: self
		for: aModel
		getColor: getSel
		setColor: setSel
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:34'!
newColorChooserFor: aModel getColor: getSel setColor: setSel help: helpText
	"Answer a color chooser with the given selectors."

	^self theme
		newColorChooserIn: self
		for: aModel
		getColor: getSel
		setColor: setSel
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:30'!
newColorPickerFor: target getter: getterSymbol setter: setterSymbol
	"Answer a new color picker for the given morph and accessors."

	^self theme
		newColorPickerIn: self
		for: target
		getter: getterSymbol
		setter: setterSymbol! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/22/2006 09:44'!
newColorPresenterFor: aModel getColor: getSel help: helpText
	"Answer a color presenter with the given selectors."

	^self theme
		newColorPresenterIn: self
		for: aModel
		getColor: getSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:21'!
newColumn: controls
	"Answer a morph laid out with a column of controls."

	^self theme
		newColumnIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 5/15/2007 17:39'!
newDialogPanel
	"Answer a new main dialog panel."

	^self theme
		newDialogPanelIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a drop list for the given model."

	^self theme
		newDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."

	^self theme
		newDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a drop list for the given model."

	^self
		newDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 14:14'!
newEmbeddedMenu
	"Answer a new menu."

	^self theme
		newEmbeddedMenuIn: self
		for: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:21'!
newExpander: aString
	"Answer an expander with the given label."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: #()! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:20'!
newExpander: aString for: aControl
	"Answer an expander with the given label and control."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: {aControl}! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:21'!
newExpander: aString forAll: controls
	"Answer an expander with the given label and controls."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabel: aString
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: nil
		label: aString
		offset: 1
		alpha: 0.5
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabelFor: aModel label: aString getEnabled: enabledSel
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: aModel
		label: aString
		offset: 1
		alpha: 0.5
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabelFor: aModel label: aString offset: offset alpha: alpha getEnabled: enabledSel
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: aModel
		label: aString
		offset: offset
		alpha: alpha
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 15:56'!
newGroupbox
	"Answer a plain groupbox."

	^self theme
		newGroupboxIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:21'!
newGroupbox: aString
	"Answer a groupbox with the given label."

	^self theme
		newGroupboxIn: self
		label: aString! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:22'!
newGroupbox: aString for: control
	"Answer a groupbox with the given label and control."

	^self theme
		newGroupboxIn: self
		label: aString
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:22'!
newGroupbox: aString forAll: controls
	"Answer a groupbox with the given label and controls."

	^self theme
		newGroupboxIn: self
		label: aString
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 15:57'!
newGroupboxFor: control
	"Answer a plain groupbox with the given control."

	^self theme
		newGroupboxIn: self
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 10:33'!
newGroupboxForAll: controls
	"Answer a plain groupbox with the given controls."

	^self theme
		newGroupboxIn: self
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:59'!
newHSVASelector: aColor help: helpText
	"Answer a hue-saturation-volume selector with the given color."

	^self theme
		newHSVASelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:46'!
newHSVSelector: aColor help: helpText
	"Answer a hue-saturation-volume selector with the given color."

	^self theme
		newHSVSelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 16:28'!
newHueSelector: aModel getHue: getSel setHue: setSel help: helpText
	"Answer a hue selector with the given selectors."

	^self theme
		newHueSelectorIn: self
		for: aModel
		getHue: getSel
		setHue: setSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/25/2006 15:36'!
newImage: aForm
	"Answer a new image."

	^self theme
		newImageIn: self
		form: aForm! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/11/2006 13:13'!
newImage: aForm size: aPoint
	"Answer a new image."

	^self theme
		newImageIn: self
		form: aForm
		size: aPoint! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 15:51'!
newLabel: aString
	"Answer a new text label."

	^self
		newLabelFor: nil
		label: aString
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 15:50'!
newLabelFor: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^self theme
		newLabelIn: self
		for: aModel
		label: aString
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:22'!
newLabelGroup: labelsAndControls
	"Answer a morph laid out with a column of labels and a column of associated controls."

	^self theme
		newLabelGroupIn: self
		for: labelsAndControls
		spaceFill: false! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:23'!
newLabelGroupSpread: labelsAndControls
	"Answer a morph laid out with a column of labels and a column of associated controls."

	^self theme
		newLabelGroupIn: self
		for: labelsAndControls
		spaceFill: true! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:45'!
newListFor: aModel list: listSelector selected: getSelector changeSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^self theme
		newListIn: self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:48'!
newListFor: aModel list: listSelector selected: getSelector changeSelected: setSelector help: helpText
	"Answer a list for the given model."

	^self
		newListFor: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/12/2006 16:09'!
newMenu
	"Answer a new menu."

	^self theme
		newMenuIn: self
		for: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/12/2006 16:09'!
newMenuFor: aModel
	"Answer a new menu."

	^self theme
		newMenuIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:32'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a morph drop list for the given model."

	^self 
		newMorphDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:58'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^self theme
		newMorphDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:32'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a morph drop list for the given model."

	^self 
		newMorphDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:27'!
newMorphListFor: aModel list: listSelector getSelected: getSelector setSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a morph list for the given model."

	^self theme
		newMorphListIn: self
		for: aModel
		list: listSelector
		getSelected: getSelector
		setSelected: setSelector
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:28'!
newMorphListFor: aModel list: listSelector getSelected: getSelector setSelected: setSelector help: helpText
	"Answer a morph list for the given model."

	^self
		newMorphListFor: aModel
		list: listSelector
		getSelected: getSelector
		setSelected: setSelector
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:25'!
newNoButton
	"Answer a new No button."

	^self newNoButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:26'!
newNoButtonFor: aModel
	"Answer a new No button."

	^self theme
		newNoButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:23'!
newOKButton
	"Answer a new OK button."

	^self newOKButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 3/23/2007 15:58'!
newOKButtonFor: aModel
	"Answer a new OK button."

	^self
		newOKButtonFor: aModel
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 3/23/2007 15:56'!
newOKButtonFor: aModel getEnabled: enabledSel
	"Answer a new OK button."

	^self theme
		newOKButtonIn: self
		for: aModel
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 5/15/2007 17:40'!
newPanel
	"Answer a new panel."

	^self theme
		newPanelIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:39'!
newPluggableDialogWindow
	"Answer a new pluggable dialog."

	^self
		newPluggableDialogWindow: 'Dialog'! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:38'!
newPluggableDialogWindow: title
	"Answer a new pluggable dialog with the given content."

	^self
		newPluggableDialogWindow: title
		for: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:38'!
newPluggableDialogWindow: title for: contentMorph
	"Answer a new pluggable dialog with the given content."

	^self theme
		newPluggableDialogWindowIn: self
		title: title
		for: contentMorph! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 5/22/2007 15:39'!
newRadioButtonFor: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox (radio button appearance) with the given label."

	^self theme
		newRadioButtonIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 12:55'!
newRadioButtonFor: aModel getSelected: getSel setSelected: setSel label: label help: helpText
	"Answer a checkbox (radio button appearance) with the given label."

	^self
		newRadioButtonFor: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		label: label
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/15/2007 17:48'!
newRow
	"Answer a morph laid out as a row."

	^self theme
		newRowIn: self
		for: #()! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:27'!
newRow: controls
	"Answer a morph laid out with a row of controls."

	^self theme
		newRowIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:38'!
newSVSelector: aColor help: helpText
	"Answer a saturation-volume selector with the given color."

	^self theme
		newSVSelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/15/2007 15:41'!
newSeparator
	"Answer an horizontal separator."

	^self theme
		newSeparatorIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:30'!
newSliderFor: aModel getValue: getSel setValue: setSel getEnabled: enabledSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: 0
		max: 1
		quantum: nil
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:13'!
newSliderFor: aModel getValue: getSel setValue: setSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: 0
		max: 1
		quantum: nil
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:28'!
newSliderFor: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: min
		max: max
		quantum: quantum
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:42'!
newString: aStringOrText
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: self theme labelFont
		style: #plain! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:42'!
newString: aStringOrText font: aFont style: aStyle
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: aFont
		style: aStyle! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:43'!
newString: aStringOrText style: aStyle
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: self theme labelFont
		style: aStyle! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/16/2006 08:41'!
newTabGroup: labelsAndPages
	"Answer a tab group with the given tab labels associated with pages."

	^self theme
		newTabGroupIn: self
		for: labelsAndPages! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 4/11/2007 16:25'!
newText: aStringOrText
	"Answer a new text."

	^self theme
		newTextIn: self
		text: aStringOrText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 12:50'!
newTextEditorFor: aModel getText: getSel setText: setSel
	"Answer a text editor for the given model."

	^self
		newTextEditorFor: aModel
		getText: getSel
		setText: setSel
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/5/2006 14:51'!
newTextEditorFor: aModel getText: getSel setText: setSel getEnabled: enabledSel 
	"Answer a text editor for the given model."

	^self theme
		newTextEditorIn: self
		for: aModel
		getText: getSel
		setText: setSel
		getEnabled: enabledSel ! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 12:56'!
newTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 13:00'!
newTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 12:50'!
newTextEntryFor: aModel getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self
		newTextEntryFor: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:28'!
newTitle: aString for: control
	"Answer a morph laid out with a column with a title."

	^self theme
		newTitleIn: self
		label: aString
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 6/20/2007 09:38'!
newToolDockingBar
	"Answer a tool docking bar."

	^self theme
		newToolDockingBarIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:07'!
newToolSpacer
	"Answer a tool spacer."

	^self theme
		newToolSpacerIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:06'!
newToolbar
	"Answer a toolbar."

	^self theme
		newToolbarIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:07'!
newToolbar: controls
	"Answer a toolbar with the given controls."

	^self theme
		newToolbarIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:08'!
newToolbarHandle
	"Answer a toolbar handle."

	^self theme
		newToolbarHandleIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:28'!
newTreeFor: aModel list: listSelector selected: getSelector changeSelected: setSelector
	"Answer a new tree morph."
	
	^self theme
		newTreeIn: self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:55'!
newVerticalSeparator
	"Answer a vertical separator."

	^self theme
		newVerticalSeparatorIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:25'!
newYesButton
	"Answer a new Yes button."

	^self newYesButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:23'!
newYesButtonFor: aModel
	"Answer a new yes button."

	^self theme
		newYesButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'theme' stamp: 'gvc 8/25/2006 10:03'!
preferredCornerStyle
	"Answer the preferred corner style."

	^#square! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:28'!
proceed: aStringOrText
	"Open a proceed dialog."

	^self proceed: aStringOrText title: 'Proceed' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/25/2006 16:20'!
proceed: aStringOrText title: aString
	"Open a proceed dialog and answer true if not cancelled, false otherwise."

	^self theme
		proceedIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:28'!
question: aStringOrText
	"Open a question dialog."

	^self question: aStringOrText title: 'Question' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 2/28/2007 12:35'!
question: aStringOrText title: aString
	"Open a question dialog and answer true if yes,
	false if no and nil if cancelled."

	^self theme
		questionIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:46'!
questionWithoutCancel: aStringOrText
	"Open a question dialog."

	^self questionWithoutCancel: aStringOrText title: 'Question' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 2/28/2007 12:35'!
questionWithoutCancel: aStringOrText title: aString
	"Open a question dialog and answer true if yes,
	false if no and nil if cancelled."

	^self theme
		questionWithoutCancelIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:44'!
textEntry: aStringOrText
	"Open a text entry dialog."

	^self textEntry: aStringOrText title: 'Entry' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:45'!
textEntry: aStringOrText title: aString
	"Open a text entry dialog."

	^self
		textEntry: aStringOrText
		title: aString
		entryText: ''! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:43'!
textEntry: aStringOrText title: aString entryText: defaultEntryText
	"Open a text entry dialog."

	^self theme
		textEntryIn: self
		text: aStringOrText
		title: aString
		entryText: defaultEntryText! !

!TEasilyThemed methodsFor: 'theme' stamp: 'gvc 8/24/2006 18:44'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

Trait named: #TEnableOnHaloMenu
	uses: {}
	category: 'Pinesoft-Widgets'!

!TEnableOnHaloMenu commentStamp: 'gvc 5/18/2007 11:56' prior: 0!
Trait providing an "enabled" option on the halo menu.!

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:22'!
addToggleItemsToHaloMenu: aCustomMenu 
	"Add toggle-items to the halo menu"
	
	super addToggleItemsToHaloMenu: aCustomMenu.
	aCustomMenu
		addUpdating: #enabledString
		target: self
		action: #toggleEnabled! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:24'!
enabled
	"Answer the enabled state of the receiver."

	self requirement! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:24'!
enabled: aBoolean
	"Set the enabled state of the receiver."

	self requirement! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:22'!
enabledString
	"Answer the string to be shown in a menu to represent the 
	'enabled' status"
	
	^ (self enabled
		ifTrue: ['<on>']
		ifFalse: ['<off>']), 'enabled' translated! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:23'!
toggleEnabled
	"Toggle the enabled state."

	self enabled: self enabled not! !

!MCFileRepositoryInspector class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:49'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveIcon! !

EventHandler subclass: #EventHandlerPlus
	instanceVariableNames: 'mouseOverRecipient mouseOverSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!EventHandlerPlus commentStamp: 'gvc 5/18/2007 13:13' prior: 0!
Support for handling mouseOver events (no button down).!

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:19'!
handlesMouseOver: evt
	"Answer whether we can handle the event."
	
	mouseOverRecipient ifNotNil: [^ true].
	^super handlesMouseOver: evt! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:23'!
methodRefList
	"Return a MethodReference for each message I can send."
	
	|list adder|
	list := super methodRefList.
	adder := [:recip :sel | recip
				ifNotNil: [list
						add: (MethodReference new
								setStandardClass: (recip class whichClassIncludesSelector: sel)
								methodSymbol: sel)]].
	adder value: mouseOverRecipient value: mouseOverSelector.
	^list! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:20'!
mouseOver: event fromMorph: sourceMorph
	"Relay the event."
	
	^ self send: mouseOverSelector to: mouseOverRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:24'!
on: eventName send: selector to: recipient
	"Register the selector and recipient for the given event name."
	
	eventName == #mouseOver ifTrue:
		[mouseOverRecipient := recipient.  mouseOverSelector := selector. ^ self].
	^super on: eventName send: selector to: recipient! !

!MCVersionInspector class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:49'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveIcon! !

!DualChangeSorter class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:09'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveIcon! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/23/2007 11:25'!
action
	"Answer the action selector."

	^self actionSelector! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/23/2007 11:26'!
actionSelector: aSymbol 
	"Set actionSelector to be the action defined by aSymbol.
	SimpleButtonMorph cross-compatibility"

	actionSelector := aSymbol.
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 16:14'!
adoptColor: aColor
	"Go through paneColorChanged instead."
	
	self paneColorChanged! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/8/2006 12:21'!
adoptPaneColor: aColor

	super adoptPaneColor: aColor.
	Preferences gradientButtonLook ifFalse:[^self].
	aColor ifNil: [^self].
	self adoptColor: self colorToUse! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/23/2007 11:27'!
arguments
	"Answer the static arguments.
	SimpleButtonMorph cross-compatibility."

	^arguments! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 12:23'!
borderStyleToUse
	"Return the borderStyle to use for the receiver."
	
	|state mo|
	Preferences gradientButtonLook ifFalse:[^super borderStyle].
	state := self getModelState.
	mo := self containsMousePoint.
	^(self enabled ifNil: [true])
		ifTrue: [showSelectionFeedback
			ifTrue: [state
				ifTrue: [self selectedPressedBorderStyle]
				ifFalse: [self pressedBorderStyle]]
			ifFalse: [mo
				ifTrue: [state
					ifTrue: [self selectedMouseOverBorderStyle]
					ifFalse: [self mouseOverBorderStyle]]
				ifFalse: [state
					ifTrue: [self selectedBorderStyle]
					ifFalse: [self normalBorderStyle]]]]
		ifFalse: [state
			ifTrue: [self selectedDisabledBorderStyle]
			ifFalse: [self disabledBorderStyle]]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 16:57'!
changed
	"Update the fillStyle here."

	|lc pc bs|
	self borderWidth > 0 ifTrue: [
		self setProperty: #borderStyle toValue: (bs := self borderStyleToUse).
		borderColor := bs style.
		borderWidth := bs width].
	self setProperty: #fillStyle toValue: self fillStyleToUse.
	color := self fillStyle asColor.
	(self label respondsTo: #enabled:)
		ifTrue: [self label enabled: self enabled]
		ifFalse: [pc := self normalColor.
				lc := pc contrastingColor.
				self enabled not
					ifTrue: [lc := pc muchDarker].
		(label isNil or: [label isMorph]) ifFalse: [self submorphs notEmpty ifTrue: [
			self submorphs first submorphs first color: lc]]].
	super changed! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/8/2006 13:29'!
color: aColor
	"Check to avoid repeats of the same color."

	aColor ifNil: [^self].
	((self valueOfProperty: #lastColor) = aColor and: [
	self getModelState = (self valueOfProperty: #lastState)])
		ifTrue: [^self].
	super color: aColor.
	Preferences gradientButtonLook ifTrue:[self adoptColor: aColor]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/9/2007 12:09'!
colorToUse
	"Answer the color we should use."

	|c|
	c _ self getModelState
		ifTrue: [onColor
					ifNil: [self paneColor]
					ifNotNil: [onColor isTransparent
								ifTrue: [self paneColor]
								ifFalse: [onColor]]]
		ifFalse: [offColor
					ifNil: [self paneColor]
					ifNotNil: [offColor isTransparent
								ifTrue: [self paneColor]
								ifFalse: [offColor]]].
	^c! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/6/2006 16:00'!
containsMousePoint
	"Answer whether the mouse is in the receiver and our window is active.
	Not ideal, but no easy way of determining if a mouse over would be sent
	to the receiver."
	
	|w|
	w _ self ownerThatIsA: SystemWindow.
	(w notNil and: [w isActive not]) ifTrue: [^false].
	^self containsPoint: (self globalPointToLocal: Sensor peekMousePt)! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/19/2007 13:04'!
contentHolder
	"Answer the alignment morph for extra control."

	^self submorphs first! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:53'!
disabledBorderStyle
	"Return the disabled borderStyle of the receiver."
	
	^self theme buttonDisabledBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:53'!
disabledFillStyle
	"Return the disabled fillStyle of the receiver."
	
	^self theme buttonDisabledFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/16/2007 15:11'!
drawOn: aCanvas 
	"Avoid the selection feedback."
	
	super drawOn: aCanvas! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/17/2007 15:19'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/8/2006 10:08'!
extent: aPoint 
	"Set the receiver's extent to value provided.
	Update the gradient fills."

	aPoint = self extent ifTrue: [^super extent: aPoint].
	Preferences gradientButtonLook ifTrue:[
		self fillStyle isGradientFill
			ifTrue: [self fillStyle direction: 0@aPoint y]].
	^super extent: aPoint! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/14/2007 13:41'!
fillStyleToUse
	"Return the fillStyle to use for the receiver."
	
	|fs state mo|
	fs := super fillStyle.
	Preferences gradientButtonLook ifFalse:[^fs].
	state := self getModelState.
	mo := self containsMousePoint.
	fs := (self enabled ifNil: [true])
		ifTrue: [showSelectionFeedback
			ifTrue: [state
				ifTrue: [self selectedPressedFillStyle]
				ifFalse: [self pressedFillStyle]]
			ifFalse: [mo
				ifTrue: [state
					ifTrue: [self selectedMouseOverFillStyle]
					ifFalse: [self mouseOverFillStyle]]
				ifFalse: [state
					ifTrue: [self selectedFillStyle]
					ifFalse: [self normalFillStyle]]]]
		ifFalse: [state
			ifTrue: [self selectedDisabledFillStyle]
			ifFalse: [self disabledFillStyle]].
	^fs! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 16:33'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^(self bounds width < 6 or: [self bounds height < 6])
		ifTrue: [super focusBounds]
		ifFalse: [super focusBounds insetBy: self borderWidth + 
					(self label isMorph ifTrue: [1] ifFalse: [2])]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 15:00'!
focusColor
	"Answer the keyboard focus indication color."

	^self color contrastingColor! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/13/2007 15:53'!
getMenuSelector: aSymbol
	"Set the menu selector."

	getMenuSelector := aSymbol! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:37'!
handlesKeyboard: evt
	"Answer true, we'll handle spacebar for pressing plus the usual
	tab navigation."
	
	^true! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/8/2006 13:40'!
handlesMouseOver: evt

	^ true! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/8/2006 13:41'!
handlesMouseOverDragging: evt

	^ true! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 10:08'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap.
	"<--so naked buttons work right"
	self vResizing: #shrinkWrap.
	self wrapCentering: #center;
		 cellPositioning: #topCenter.
	model := nil.
	label := nil.
	getStateSelector := nil.
	actionSelector := nil.
	getLabelSelector := nil.
	getMenuSelector := nil.
	shortcutCharacter := nil.
	askBeforeChanging := false.
	triggerOnMouseDown := false.
	onColor := nil.
	offColor := nil.
	feedbackColor := nil.
	showSelectionFeedback := false.
	allButtons := nil.
	argumentsProvider := nil.
	argumentsSelector := nil.
	self borderStyle: BorderStyle thinGray.
	self extent: 20 @ 15.
	self setProperty: #lastState toValue: false! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 12:13'!
isDefault
	"Answer whether the button is considered to be a default one."

	^self valueOfProperty: #isDefault ifAbsent: [false] ! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 12:17'!
isDefault: aBoolean
	"Set whether the button is to be considered default."

	aBoolean
		ifTrue: [self setProperty: #isDefault toValue: true]
		ifFalse: [self removeProperty: #isDefault].
	self changed! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 15:17'!
keyStroke: event 
	"Process spacebar for action and tab keys for navigation."
	
	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character space
		ifTrue: [self performAction]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:46'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/16/2007 10:39'!
label: aStringOrTextOrMorph
	"Label this button with the given string or morph."

	| r |
	self removeAllMorphs.
	"nest label in a row for centering"
	r := AlignmentMorph newRow
		borderWidth: 0;
		layoutInset: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		wrapCentering: #center; 
		listCentering: #center; 
		cellPositioning: #center.
	aStringOrTextOrMorph isMorph
		ifTrue: [
			label := aStringOrTextOrMorph.
			r addMorph: aStringOrTextOrMorph]
		ifFalse: [
			label := aStringOrTextOrMorph.
			r addMorph: self newLabel].
	self addMorph: r.
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/16/2007 15:27'!
label: aStringOrTextOrMorph font: aFont
	"Label this button with the given string or morph."

	| r |
	self removeAllMorphs.
	"nest label in a row for centering"
	r := AlignmentMorph newRow
		borderWidth: 0;
		layoutInset: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		wrapCentering: #center;
		listCentering: #center;
		cellPositioning: #center.
	aStringOrTextOrMorph isMorph
		ifTrue: [
			label := aStringOrTextOrMorph.
			r addMorph: aStringOrTextOrMorph]
		ifFalse: [
			label := aStringOrTextOrMorph.
			r addMorph: (self newLabel: aFont)].
	self addMorph: r.
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 13:21'!
labelMorph
	"Answer the actual label morph."

	self hasSubmorphs ifFalse: [^nil].
	self firstSubmorph hasSubmorphs ifFalse: [^nil].
	^self firstSubmorph firstSubmorph! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 13:34'!
model
	"Answer the receiver's model."
	
	^model! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/18/2007 10:59'!
mouseEnter: evt
	"Update the appearance."
	
	Preferences gradientButtonLook
		ifTrue: [self changed]
		ifFalse: ["0.09375 is exact in floating point so no cumulative rounding error will occur"
				self color: (self color adjustBrightness: -0.09375)].
	super mouseEnter: evt! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/18/2007 11:00'!
mouseLeave: evt
	"Update the appearance."
	
	Preferences gradientButtonLook
		ifTrue: [self changed]
		ifFalse: ["0.09375 is exact in floating point so no cumulative rounding error will occur"
				self color: (self color adjustBrightness: 0.09375).
				self update: nil].
	super mouseLeave: evt! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:53'!
mouseOverBorderStyle
	"Return the mouse over borderStyle of the receiver."
	
	^self theme buttonMouseOverBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:53'!
mouseOverFillStyle
	"Return the mouse over fillStyle of the receiver."
	
	^self theme buttonMouseOverFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/9/2007 12:27'!
mouseUp: evt

	|all|
	all _ allButtons copy.
	all ifNotNil: [all do: [:m |
		m showSelectionFeedback: false; changed]].
	all ifNil: [^ self].
	allButtons _ nil.
	all do: [:m |
		(m containsPoint: evt cursorPoint) ifTrue: [m performAction]].
	self changed
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
newLabel
	"Answer a new label for the receiver."

	^self theme buttonLabelFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 14:40'!
newLabel: aFont
	"Answer a new label for the receiver with the given font."

	^self newLabel
		font: aFont! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalBorderStyle
	"Return the normal borderStyle of the receiver."
	
	^self theme buttonNormalBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalColor
	"Return the normal colour for the receiver."
	
	^self theme buttonColorFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme buttonNormalFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 18:44'!
onColor
	"Answer the on color."
	
	^onColor
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/2/2006 12:15'!
onColor: colorWhenOn offColor: colorWhenOff
	"Set the fill colors to be used when this button is on/off."

	onColor := colorWhenOn.
	offColor := colorWhenOff.
	self update: #onOffColor
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/9/2007 12:11'!
paneColorChanged
	"Update the fillStyle here.
	Optimised to not send #changed if no changes."

	|lc pc|
	self borderStyle: self borderStyleToUse.
	self fillStyle: self fillStyleToUse.
	pc := self normalColor.
	lc := pc contrastingColor.
	self enabled not
		ifTrue: [lc := pc muchDarker].
	label isMorph ifFalse: [self labelMorph ifNotNilDo: [:m | m color: lc]]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
pressedBorderStyle
	"Return the pressed borderStyle of the receiver."
	
	^self theme buttonPressedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme buttonPressedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/22/2006 13:18'!
roundedCorners
	"Answer the corners to round."

	^self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners] ! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/8/2007 16:54'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedBorderStyle
	"Return the selected borderStyle of the receiver."
	
	^self theme buttonSelectedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedDisabledBorderStyle
	"Return the selected disabled borderStyle of the receiver."
	
	^self theme buttonSelectedDisabledBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedDisabledFillStyle
	"Return the selected disabled fillStyle of the receiver."
	
	^self theme buttonSelectedDisabledFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^self theme buttonSelectedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedMouseOverBorderStyle
	"Return the selected mouse over borderStyle of the receiver."
	
	^self theme buttonSelectedMouseOverBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedMouseOverFillStyle
	"Return the selected mouse over fillStyle of the receiver."
	
	^self theme buttonSelectedMouseOverFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedPressedBorderStyle
	"Return the selected pressed borderStyle of the receiver."
	
	^self theme buttonSelectedPressedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedPressedFillStyle
	"Return the selected pressed fillStyle of the receiver."
	
	^self theme buttonSelectedPressedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/26/2006 16:46'!
showSelectionFeedback: aBoolean
	"Set the feedback."

	showSelectionFeedback _ aBoolean! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:30'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/29/2007 13:38'!
themeChanged
	"Set the border style to thin gray in the case of going to StandardSqueak."

	(self theme isKindOf: UIThemeStandardSqueak)
		ifTrue: [self borderStyle: BorderStyle thinGray].
	self window ifNotNilDo: [:w |
		self cornerStyle: (self theme buttonCornerStyleIn: w)].
	super themeChanged! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/6/2006 13:06'!
update: aParameter 

	|state|
	getLabelSelector ifNotNil: [
		aParameter == getLabelSelector ifTrue: [
			self label: (model perform: getLabelSelector)]].
	state _ self getModelState.
	(state ~= (self valueOfProperty: #lastState) or: [
	getStateSelector isNil and: [aParameter == #onOffColor]])
		ifTrue: [self color: self colorToUse.
				self setProperty: #lastState toValue: state]! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/28/2006 22:03'!
updateFeedbackForEvt: evt

	| newState |
	newState := self containsPoint: evt cursorPoint.
	newState = showSelectionFeedback ifFalse: [
		showSelectionFeedback := newState.
		self changed].
! !

!PluggableButtonMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/8/2007 13:43'!
wantsKeyboardFocusNavigation
	"Answer whether the receiver would like keyboard focus
	when navigated to by keyboard."

	^super wantsKeyboardFocusNavigation and: [
		self valueOfProperty: #wantsKeyboardFocusNavigation ifAbsent: [true]]! !

!Canvas methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/14/2006 14:33'!
frameRectangle: aRectangle width: width colors: colors dashes: dashes
	"Draw a rectangle with the given width, colors and dash lengths."

	self
		frameRectangle: aRectangle
		width: width
		colors: colors
		dashes: dashes
		offset: self origin! !

!Canvas methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/18/2006 16:52'!
frameRectangle: aRectangle width: width colors: colors dashes: dashes offset: offset
	"Draw a rectangle with the given width, colors and dash lengths.
	The offset specifies how the coordinate system is translated from the screen origin
	(infinite forms are 0@0 screen based)."

	|o s hf vf c r ds di d os l|
	width < 1 ifTrue: [^self].
	dashes size < 2
		ifTrue: [^self  frameRectangle: aRectangle width: width color: colors first].
	r := aRectangle.
	s := dashes sum * width.
	ds := dashes size.
	di := 1.
	d := (dashes at: di) * width.
	c := colors at: di.
	hf := Form extent: s @ 1 depth: 32.
	r height >= width ifTrue: [
		o := r left + offset x \\ s.
		0 to: s - 1 do: [:x |
			hf colorAt: x + o \\ s  @ 0 put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := 0.
		l := r width truncateTo: width.
		self
			fillRectangle: (r topLeft + (os@0) extent: l@width)
			color: (InfiniteForm with: hf)].
	vf := Form extent: 1 @ s depth: 32.
	r width >= width ifTrue: [
		o := r top + offset y + width + (s - (r width \\ s)) \\ s.
		0 to: s - 1 do: [:y |
			vf colorAt: 0 @ (y + o \\ s) put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := width - (r width \\ width).
		l := r height - os truncateTo: width.
		self
			fillRectangle: (r topRight + (width negated @ os) extent: width@l)
			color: (InfiniteForm with: vf)].
	r height > width ifTrue: [
		o := r right + offset x - (width * 2) + (r height \\ s) + (r width \\ s) \\ s.
		0 to: s - 1 do: [:x |
			hf colorAt: o + s -1 - x \\ s  @ 0 put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := width - (r width \\ width + (r height \\ width) \\ width).
		l := r width - os truncateTo: width.
		os := (r width - os) \\ width.
		self
			fillRectangle: (r bottomLeft + (os @ width negated) extent: l@width)
			color: (InfiniteForm with: hf)].
	r width > width ifTrue: [
		o :=  r top + offset y + (r height * 2 \\ s) + (r width * 2 \\ s) - (width * 3) \\ s.
		0 to: s - 1 do: [:y |
			vf colorAt: 0 @ (o + s -1 - y \\ s) put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		l := r height - (2 * width) + os.
		os := width.
		self
			fillRectangle: (r topLeft + (0@os) extent: width@l)
			color: (InfiniteForm with: vf)]! !

!Canvas methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/17/2006 10:42'!
line: pt1 to: pt2 width: width colors: colors dashes: dashes startingOffset: startingOffset 
	"Draw a line using the given width, colors and dash lengths.
	Dash lengths are considered as multiples of width."

	|dist deltaBig segmentOffset phase segmentLength startPoint distDone endPoint segLens lens l ep|
	width = 0 ifTrue: [^startingOffset].
	dist := pt1 dist: pt2.
	dist = 0 ifTrue: [^startingOffset].
	(dashes allSatisfy: [:d | d = 0]) ifTrue: [^startingOffset].
	deltaBig := pt2 - pt1.
	segLens := dashes collect: [:d | d * width].
	
	"Figure out what phase we are in and how far, given startingOffset."
	segmentOffset := startingOffset \\ segLens sum.
	lens := segLens readStream.
	l := 0.
	[lens atEnd or: [segmentOffset <= (l := l + lens next)]] whileFalse: [].
	segmentLength := lens atEnd
		ifTrue: [phase := segLens size.
				segLens sum - segmentOffset]
		ifFalse: [phase := lens position.
				(segLens first: phase) sum - segmentOffset.].
	startPoint := pt1.
	distDone := 0.0.
	segmentLength < (segLens at: phase)
		ifTrue: [startPoint := startPoint + (deltaBig * segmentLength / dist).
				distDone := distDone + segmentLength.
				phase := phase \\ segLens size + 1.
				segmentLength :=  (segLens at: phase)].
	[distDone < dist] whileTrue: 
			[segmentLength := segmentLength min: dist - distDone.
			endPoint := startPoint + (deltaBig * segmentLength / dist).
			ep := startPoint + (deltaBig * (segmentLength - width max: 0) / dist).
			self 
				line: startPoint truncated
				to: ep truncated
				width: width
				color: (colors at: phase).
			distDone := distDone + segmentLength.
			phase := phase \\ segLens size + 1.
			startPoint := endPoint.
			segmentLength := segLens at: phase].
	^startingOffset + distDone! !

!TranscriptStream class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:10'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallLeftFlushIcon! !

!MenuItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:47'!
themeChanged
	"Also pass on to the submenu if any."

	super themeChanged.
	self subMenu ifNotNilDo: [:m | m themeChanged]! !

MenuItemMorph subclass: #ToggleMenuItemMorph
	instanceVariableNames: 'getStateSelector enablementSelector keyText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ToggleMenuItemMorph commentStamp: 'gvc 5/18/2007 10:22' prior: 0!
A menu item that supports on/off state (using standard icons), enablement and display of "accelerator" key text.!

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/29/2007 16:25'!
adoptPaneColor: paneColor
	"Pass on to submenu too."
	
	super adoptPaneColor: paneColor.
	self hasSubMenu ifTrue: [self subMenu adoptPaneColor: paneColor]! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 13:03'!
basicDrawOn: aCanvas 
	"Draw on the canvas. Taken from MenuItemMorph for minor refactoring."
	
	| stringColor stringBounds fill selColor|
	self isSelected & self isEnabled
		ifTrue: [fill := self selectionFillStyle.
				selColor := fill asColor.
				aCanvas
					fillRectangle: self bounds
					fillStyle: self selectionFillStyle
					borderStyle: self selectionBorderStyle.
			stringColor := ((self selectionTextColor luminance - selColor luminance) abs < 0.6)
					ifTrue: [selColor darker contrastingColor]
					ifFalse: [self selectionTextColor]]
		ifFalse: [stringColor := ((self color luminance - self owner paneColor luminance) abs < 0.3)
					ifTrue: [self owner color contrastingColor]
					ifFalse: [self color]].
	stringBounds := self bounds.
	self isInDockingBar
		ifTrue: [stringBounds := stringBounds left: stringBounds left
							+ (Preferences tinyDisplay
									ifTrue: [1]
									ifFalse: [4])].
	self hasIcon
		ifTrue: [| i iconForm |
			i := self icon.
			self isEnabled
				ifTrue: [iconForm := i]
				ifFalse: [iconForm := Form extent: i extent depth: 32.
						iconForm fillColor: (Color white alpha: 0.003922).
						(iconForm getCanvas asAlphaBlendingCanvas: 0.5)
							drawImage: i
							at: 0@0].
			aCanvas translucentImage: iconForm at: stringBounds left @ (self top + (self height - iconForm height // 2)).
			stringBounds := stringBounds left: stringBounds left + iconForm width + 2].
	self hasMarker
		ifTrue: [stringBounds := stringBounds left: stringBounds left + self submorphBounds width + 8].
	stringBounds := stringBounds top: stringBounds top + stringBounds bottom - self fontToUse height // 2.
	self isEnabled
		ifTrue: [aCanvas
				drawString: contents
				in: stringBounds
				font: self fontToUse
				color: stringColor]
		ifFalse: [aCanvas
				drawString: contents
				in: (stringBounds translateBy: -1)
				font: self fontToUse
				color: self owner color muchDarker;
				drawString: contents
				in: stringBounds 
				font: self fontToUse
				color: self owner color lighter].
	self hasSubMenu
		ifTrue: [| subMenuMarker subMenuMarkerPosition | 
			subMenuMarker := self subMenuMarker mapColor: Color black to: stringColor.
			subMenuMarkerPosition := self right - subMenuMarker width @ (self top + self bottom - subMenuMarker height // 2).
			self isInDockingBar
				ifTrue: [subMenuMarkerPosition := subMenuMarkerPosition - (4 @ -1)].
			aCanvas paintImage: subMenuMarker at: subMenuMarkerPosition]! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/2/2007 13:51'!
drawKeyTextOn: aCanvas 
	"Draw the key text on the canvas."
	
	|stringColor ktp ktw b|
	self keyText ifNil: [^self].
	ktp := self hasSubMenu ifTrue: [self right - self subMenuMarker width] ifFalse: [self right].
	ktp := ktp - (ktw := self fontToUse widthOfString: self keyText).
	b := (ktp @ (self bounds top + self bounds bottom - self fontToUse height // 2) extent: ktw @ self height).
	self isEnabled
		ifTrue: [self isSelected
					ifTrue: [stringColor := ((self selectionTextColor luminance - self selectionFillStyle asColor luminance) abs < 0.6)
								ifTrue: [self selectionFillStyle asColor darker contrastingColor]
								ifFalse: [self selectionTextColor]]
					ifFalse: [stringColor := ((self color luminance - self owner paneColor luminance) abs < 0.3)
								ifTrue: [self owner paneColor contrastingColor]
								ifFalse: [self color]].
				aCanvas
					drawString: self keyText
					in: b
					font: self fontToUse
					color: stringColor]
		ifFalse: [aCanvas
				drawString: self keyText
				in: (b translateBy: -1)
				font: self fontToUse
				color: self owner color muchDarker;
				drawString: self keyText
				in: b 
				font: self fontToUse
				color: self owner color lighter].! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 15:30'!
drawOn: aCanvas 
	"Need to check isEnabled here."
	
	self
		isEnabled;
		basicDrawOn: aCanvas;
		drawKeyTextOn: aCanvas! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 09:35'!
enablementSelector
	"Answer the value of enablementSelector"

	^ enablementSelector! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 09:35'!
enablementSelector: anObject
	"Set the value of enablementSelector"

	enablementSelector := anObject! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 09:16'!
getStateSelector
	"Answer the value of getStateSelector"

	^ getStateSelector! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 09:16'!
getStateSelector: anObject
	"Set the value of getStateSelector"

	getStateSelector := anObject! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 09:20'!
icon
	"Answer the receiver's icon."
	
	|state|
	self getStateSelector ifNil: [^super icon].
	state _ self target perform: self getStateSelector.
	state = true ifTrue: [^self onIcon].
	state = false ifTrue: [^self offIcon].
	^super icon! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 09:44'!
isEnabled
	"Answer whether the item is enabled."
	
	|state|
	self enablementSelector ifNil: [^super isEnabled].
	state := self target perform: self enablementSelector.
	self isEnabled: state.
	^state! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 16:13'!
keyText
	"Answer the value of keyText"

	^ keyText! !

!ToggleMenuItemMorph methodsFor: 'accessing' stamp: 'gvc 6/9/2006 16:13'!
keyText: anObject
	"Set the value of keyText"

	keyText := anObject! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 16:18'!
minWidth
	"Plus the key text if any."
	
	|w|
	w := super minWidth.
	self keyText ifNotNil: [w := w + (self fontToUse widthOfString: self keyText) + 12].
	^w! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 09:21'!
offIcon
	"Answer the off icon."
	
	^MenuIcons smallCancelIcon! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 09:21'!
onIcon
	"Answer the on icon."
	
	^MenuIcons smallOkIcon! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/9/2006 15:07'!
select: evt
	"Don't if not enabled."
	
	self isEnabled ifFalse: [^self].
	^super select: evt! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 13:03'!
selectionBorderStyle
	"Answer the border style to use with the receiver is the selected element."
	
	^self isInDockingBar 
		ifTrue: [self theme menuItemInDockingBarSelectedBorderStyleFor: self]
		ifFalse: [self theme menuItemSelectedBorderStyleFor: self]! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 12:55'!
selectionFillStyle
	"Answer the fill style to use with the receiver is the selected element."
	
	^self isInDockingBar 
		ifTrue: [self theme menuItemInDockingBarSelectedFillStyleFor: self]
		ifFalse: [self theme menuItemSelectedFillStyleFor: self]! !

!ToggleMenuItemMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 15:28'!
selectionTextColor
	"Answer the color to use for text when selected."
	
	^self color! !

!FileList2 methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/20/2007 12:23'!
morphicPatternPane
	"Remove the vertical scrollbar since the minHeight would otherwise
	be too large to fit the layout frame."
	 |pane|
 	pane := PluggableTextMorph 
		on: self 
		text: #pattern 
		accept: #pattern:.
 	pane
		acceptOnCR: true;
		hideVScrollBarIndefinitely: true.
 	^pane! !

!TestRunner class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:53'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallOkIcon! !

!TestRunner methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/10/2006 12:11'!
buildWith: aBuilder
	| window |
	window _ aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (LayoutFrame fractions: (0.00 @ 0.00 corner: 0.25 @ 1.00) offsets: (0@0 corner: 0@-35))
				yourself);
			add: ((self buildClassesWith: aBuilder)
				frame: (LayoutFrame fractions: (0.25 @ 0.00 corner: 0.50 @ 1.00) offsets: (0@0 corner: 0@-35))
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (LayoutFrame fractions: (0.50 @ 0.50 corner: 1.00 @ 1.00) offsets: (0@0 corner: 0@-35))
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: (0@-35 corner: 0@0));
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!TestRunner methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 12:01'!
selectAllClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 12:01'!
selectInverseClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 11:59'!
selectNoClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := Set new.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 12:01'!
selectSubclasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BottomLeftGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 10:52'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w _ SystemWindow borderWidth.
		((self bounds translateBy: w@w negated)
			containsPoint: aPoint) not]! !

!BottomLeftGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 12:11'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds left: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!ChangeSorter class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:09'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveIcon! !

!ListItemWrapper methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/11/2006 13:53'!
highlightingColor

	^Color black! !

!ListItemWrapper methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/23/2006 15:53'!
item
	"Answer the item. It is useful!!"
	
	^item! !

!ListItemWrapper methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/26/2006 11:11'!
model
	"Answer the model. It is useful!!"
	
	^model! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 10:47'!
changed
	"Need to invalidate the selection frame."

	container ifNil: [^super changed].
	self invalidRect: self selectionFrame.
	super changed! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 2/9/2007 10:32'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge.
	Only draw now if no toggle."

	| myBounds myCenter hLineY hLineLeft |
	self isSoleItem ifTrue: [ ^self ].
	self hasToggle ifTrue: [^self].
	myBounds := self toggleBounds.
	myCenter := myBounds center.
	hLineY := myCenter y - 1.
	hLineLeft := myCenter x.
	"Draw line from toggle to text. Use optimised form since vertical."
	aCanvas
		frameRectangle: (hLineLeft @ hLineY corner: myBounds right + 3 @ (hLineY + 1))
		width: 1
		colors: {lineColor. Color transparent}
		dashes: #(1 1)! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 2/9/2007 10:34'!
drawLinesToFirstChildOn: aCanvas lineColor: lineColor 
	"Draw line from me to first child.
	Don't bother if the first child has a toggle.."

	| vLineX vLineTop vLineBottom childBounds childCenter |
	self firstChild hasToggle ifTrue: [^self].
	childBounds := self firstChild toggleBounds.
	childCenter := childBounds center.
	vLineX := childCenter x.
	vLineTop := bounds bottom.
	self firstChild hasToggle
		ifTrue: [vLineBottom := childCenter y - (childBounds height // 2) + 1]
		ifFalse: [vLineBottom := childCenter y - 2].
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: 1
		colors: {lineColor. Color transparent}
		dashes: #(1 1)! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 2/9/2007 10:32'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"Draw line from me to next sibling"
	
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom |
	myBounds := self toggleBounds.
	nextSibBounds := self nextSibling toggleBounds.
	myCenter := myBounds center.
	vLineX := myCenter x.
	vLineTop := myCenter y + 1.
	vLineBottom := nextSibBounds center y - 1.
	"Draw line from me to next sibling"
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: 1
		colors: {lineColor. Color transparent}
		dashes: #(1 1)! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 15:34'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."
	
	|frame|
	self highlightedForMouseDown ifTrue: [
		container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
		frame := self selectionFrame.
		aCanvas 
			frameRectangle: frame
			width: 1
			colors: {container mouseDownHighlightColor. Color transparent}
			 dashes: #(1 1)]! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/1/2006 16:43'!
drawToggleOn: aCanvas in: aRectangle

	| aForm centeringOffset |
	complexContents hasContents ifFalse: [^self].
	aForm := isExpanded 
		ifTrue: [container expandedForm]
		ifFalse: [container notExpandedForm].
	centeringOffset := ((aRectangle height - aForm extent y) / 2.0) truncated.
	^aCanvas 
		paintImage: aForm 
		at: (aRectangle topLeft translateBy: 0 @ centeringOffset).
! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 11/17/2006 10:22'!
lastChild
	"Answer the last child."

	|c|
	c _ self firstChild ifNil: [^nil].
	[c nextSibling isNil] whileFalse: [c _ c nextSibling].
	^c! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/15/2007 13:17'!
minHeight
	"Answer the minimum height of the receiver."
	
	| iconHeight |
	iconHeight := self hasIcon
				ifTrue: [self icon height + 2]
				ifFalse: [0].
	^(self fontToUse height max: iconHeight) max: super minHeight! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/15/2007 13:15'!
minWidth
	"Fixed to work such that guessed width is unnecessary in
	#adjustSubmorphPositions."

	| iconWidth |
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	^(13 * indentLevel + 15 + (self fontToUse widthOfString: contents)
		+ iconWidth) max: super minWidth! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 15:38'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	
	|box|
	box _ super outerBounds.
	container ifNil: [^box].
	^box left: (box left min: self selectionFrame left)! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 15:34'!
selectionFrame
	"Answer the selection frame rectangle."

	|frame|
	frame := self bounds: self bounds in: container.
	frame := self
		bounds: ((frame left: container innerBounds left) right: container innerBounds right)
		from: container.
	^frame! !

!IndentingListItemMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/25/2007 19:42'!
toggleRectangle

	| h |
	h := bounds height.
	^(bounds left + (13 * indentLevel)) @ bounds top extent: 9@h! !

!SMSqueakMap class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:52'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallProjectIcon! !

!FileList class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:47'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallOpenIcon! !

!ChangeList class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:47'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveIcon! !

StringMorph subclass: #EmbossedStringMorph
	instanceVariableNames: 'style trackPaneColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!EmbossedStringMorph commentStamp: 'gvc 5/18/2007 13:15' prior: 0!
A label that underdraws to the top-left and/or bottom-right with a lighter and/or darker colour to the receiver.!

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:53'!
adoptPaneColor: paneColor
	"Set the color."
	
	(paneColor notNil and: [self trackPaneColor])
		ifTrue: [self color: paneColor].
	super adoptPaneColor: paneColor! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 17:03'!
drawOn: aCanvas
	"Draw the hi/lowlights too."

	|box|
	self style == #plain
		ifTrue: [^super drawOn: aCanvas].
	box := self bounds.
	(self style == #inset or: [self style == #insetNoHighlight])
		ifTrue: [self style == #insetNoHighlight
					ifFalse: [aCanvas drawString: self contents in: (box translateBy: 1)
								font: self fontToUse color: self color veryMuchLighter].
				aCanvas
					drawString: self contents in: (box translateBy: -1)
					font: self fontToUse color: self color muchDarker;
					drawString: self contents in: box
					font: self fontToUse color: self color]
		ifFalse: [self style == #raisedNoHighlight
					ifFalse: [aCanvas drawString: self contents in: (box translateBy: -1)
								font: self fontToUse color: self color veryMuchLighter].
				aCanvas
					drawString: self contents in: (box translateBy: 1)
					font: self fontToUse color: self color muchDarker;
					drawString: self contents in: box
					font: self fontToUse color: self color]! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:55'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self
		style: #inset;
		trackPaneColor: true.! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:52'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self
		style: #inset;
		trackPaneColor: true! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:16'!
measureContents
	"Measure the contents for fitting. Add 2@2 for hi/lowlights."

	^super measureContents + 2! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 4/27/2006 12:09'!
style
	"Answer the value of style"

	^ style! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 5/10/2006 15:26'!
style: anObject
	"Set the value of style"

	style := anObject.
	self changed! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:35'!
styleSymbols
	"Answer the valid styles."

	^#(plain inset insetNoHighlight raised raisedNoHighlight)! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:52'!
trackPaneColor
	"Answer the value of trackPaneColor"

	^ trackPaneColor! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:52'!
trackPaneColor: anObject
	"Set the value of trackPaneColor"

	trackPaneColor := anObject! !

StringMorph subclass: #LabelMorph
	instanceVariableNames: 'getEnabledSelector enabled model disabledStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!LabelMorph commentStamp: 'gvc 5/18/2007 12:48' prior: 0!
String morph with enablement support. When disabled the text will appear inset.!

LabelMorph subclass: #FuzzyLabelMorph
	instanceVariableNames: 'offset alpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!FuzzyLabelMorph commentStamp: 'gvc 5/18/2007 13:16' prior: 0!
A label that underdraws to the top-left, top-right, bottom-right and bottom left by a specifed offset in a contrasting colour to the receiver's with a specified alpha value.!

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/26/2007 16:57'!
alpha
	"Answer the value of alpha"

	^ alpha! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 12:51'!
alpha: anObject
	"Set the value of alpha"

	alpha := anObject.
	self changed! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 12:49'!
drawOn: aCanvas
	"Draw based on enablement."
	
	|c|
	c := self color twiceDarker contrastingColor alpha: self alpha.
	aCanvas
		drawString: self contents
		in: (self bounds translateBy: 0@-1)
		font: self fontToUse
		color: c;
		drawString: self contents
		in: (self bounds translateBy: (self offset * 2)@-1)
		font: self fontToUse
		color: c;
		drawString: self contents
		in: (self bounds translateBy: (self offset * 2)@(self offset * 2 - 1))
		font: self fontToUse
		color: c;
		drawString: self contents
		in: (self bounds translateBy: 0@(self offset * 2 - 1))
		font: self fontToUse
		color: c;
		drawString: self contents
		in: (self bounds translateBy: self offset@(self offset - 1))
		font: self fontToUse
		color: (self enabled ifTrue: [self color] ifFalse: [self paneColor muchDarker])! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 12:52'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	offset := 1.
	alpha := 0.5.
	super initWithContents: aString font: aFont emphasis: emphasisCode! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 12:52'!
initialize
	"Initialize the receiver."

	offset := 1.
	alpha := 0.5.
	super initialize! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/29/2007 17:02'!
measureContents
	"Add 2 times offset."
	
	^super measureContents ceiling + (self offset * 2) asPoint! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/16/2007 10:45'!
offset
	"Answer the value of offset"

	^ offset! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 13:06'!
offset: anObject
	"Set the value of offset"

	offset := anObject.
	self fitContents! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/29/2007 17:22'!
setWidth: width
	"Set the width/extent."
	
	self extent: width @ (self fontToUse height ceiling + (2 * self offset))! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:35'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:43'!
disabledStyle
	"Answer the value of disabledStyle"

	^ disabledStyle! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:53'!
disabledStyle: anObject
	"Set the value of disabledStyle"

	disabledStyle := anObject.
	self
		changed: #disabledStyle;
		changed! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:46'!
drawOn: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self paneColor.
	self enabled
		ifTrue: [aCanvas
					drawString: self contents
					in: self bounds
					font: self fontToUse
					color: ((self color luminance - pc luminance) abs < 0.4
							ifTrue: [pc contrastingColor]
							ifFalse: [self color])]
		ifFalse: [self disabledStyle == #inset ifTrue: [
					aCanvas
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker;
						drawString: self contents
						in: (self bounds translateBy: 1)
						font: self fontToUse
						color: pc lighter].
				self disabledStyle == #plain ifTrue: [	
					aCanvas
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker]]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:35'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:28'!
enabled
	"Answer the value of enabled"

	^enabled! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:55'!
enabled: aBoolean
	"Set the value of enabled"

	enabled := aBoolean.
	self
		changed: #enabled;
		changed! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:28'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:27'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:51'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self
		disabledStyle: #plain;
		enabled: true! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:44'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		disabledStyle: #plain;
		enabled: true! !

!LabelMorph methodsFor: 'layout' stamp: 'gvc 6/15/2007 13:17'!
minHeight
	"Answer the receiver's minimum height.
	based on font height."
	
	^self fontToUse height rounded max: super minHeight! !

!LabelMorph methodsFor: 'layout' stamp: 'gvc 6/15/2007 13:15'!
minWidth
	"Answer the minumum width of the receiver.
	Based on font and contents."

	^self measureContents x max: super minWidth! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:52'!
model
	"Answer the value of model"

	^model! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:54'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:53'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:27'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:27'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!StringMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/22/2007 12:18'!
handlesMouseDown: evt
	"If the shift key is pressed then yes.
	As normal if the editableStringMorphs preference is false."
	
	^(Preferences editableStringMorphs and: [
			evt shiftPressed and: [self wantsKeyboardFocusOnShiftClick]])
		ifTrue: [true]
		ifFalse: [super handlesMouseDown: evt]! !

!StringMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 12:24'!
measureContents
	"Round up in case fractional."
	
	| f |
	f := self fontToUse.
	^(((f widthOfString: contents) max: self minimumWidth)  @ f height) ceiling! !

!StringMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/15/2007 13:18'!
minHeight
	"Answer the minimum height of the receiver."
	
	^self fontToUse height max: super minHeight! !

!StringMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/22/2007 12:14'!
mouseDown: evt
	"If the shift key is pressed, make this string the keyboard input focus.
	Process as normal if the editableStringMorphs preference is false."

	(Preferences editableStringMorphs and: [
			evt shiftPressed and: [self wantsKeyboardFocusOnShiftClick]])
		ifTrue: [self launchMiniEditor: evt]
		ifFalse: [super mouseDown: evt].
! !

!StringMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/9/2007 12:29'!
paneColor
	"Answer the window's pane color or our owner's color otherwise."

	^self paneColorOrNil ifNil: [self owner ifNil: [Color transparent] ifNotNil: [self owner color]]! !

!StringMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 12:24'!
setWidth: width
	"Round up in case fractional."
	
	self extent: (width @ (font ifNil: [TextStyle defaultFont]) height) ceiling! !

SystemWindow subclass: #StandardWindow
	uses: TEasilyThemed - {#theme}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!StandardWindow commentStamp: 'gvc 5/18/2007 12:05' prior: 0!
Themed SystemWindow that avoids being picked up except via the title bar. Supports opening in "fullscreen" mode, taking docking bars into account (not flaps though).
Prevents yellow button menu.
Uses TEasilyThemed for easy theme access to subclasses.!

StandardWindow class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

StandardWindow subclass: #DialogWindow
	instanceVariableNames: 'cancelled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!DialogWindow commentStamp: 'gvc 5/18/2007 13:26' prior: 0!
Dialog style window with no window controls (expand, collapse etc). Usually opened modally (the morph that is used to modally open determines the modal scope, use of World implies "system modal").
Designed to be subclassed with content.
Supports Escape key for cancel and Enter key for default button.!

DialogWindow subclass: #AboutDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!AboutDialogWindow commentStamp: 'gvc 5/18/2007 13:53' prior: 0!
Default superclass for application about dialogs.!

!AboutDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 16:32'!
newButtons
	"Answer new buttons as appropriate."

	^{self newCloseButton isDefault: true}! !

DialogWindow subclass: #ColorSelectorDialogWindow
	instanceVariableNames: 'selectedColor hsvaMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ColorSelectorDialogWindow commentStamp: 'gvc 5/18/2007 13:35' prior: 0!
Standard dialog for selecting a colour by HSVA colour selector, picking from the screen or editing of values.!

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
alpha
	"Answer the alpha value of the selected color."

	^(self selectedColor alpha * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:21'!
alpha: anInteger
	"Set the alpha value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: (c alpha: anInteger / 255)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 16:39'!
basicSelectedColor: anObject
	"Set the value of selectedColor"

	selectedColor := anObject.
	self
		changed: #selectedColor;
		changed: #red;
		changed: #green;
		changed: #blue;
		changed: #hue;
		changed: #saturation;
		changed: #brightness;
		changed: #alpha! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
blue
	"Answer the blue value of the selected color."

	^(self selectedColor blue * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
blue: anInteger
	"Set the blue value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: c red * 255 g: c green * 255 b: anInteger range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
brightness
	"Answer the brightness value of the selected color."

	^(self selectedColor brightness * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:37'!
brightness: anInteger
	"Set the brightness value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: c hue s: c saturation v: anInteger / 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:13'!
colorSelected: aColor
	"A color has been selected.."

	self basicSelectedColor: aColor! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:16'!
defaultLabel
	"Answer the default label for the receiver."

	^'Colour Selector' translated! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
green
	"Answer the green value of the selected color."

	^(self selectedColor green * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
green: anInteger
	"Set the green value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: c red * 255 g: anInteger b: c blue * 255 range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:04'!
hsvaMorph
	"Answer the value of hsvaMorph"

	^ hsvaMorph! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:04'!
hsvaMorph: anObject
	"Set the value of hsvaMorph"

	hsvaMorph := anObject! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
hue
	"Answer the hue value of the selected color."

	^(self selectedColor hue / 359 * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:16'!
hue: anInteger
	"Set the hue value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: (anInteger / 255 * 359) rounded s: c saturation v: c brightness) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:06'!
initialize
	"Initialize the receiver."

	self
		basicSelectedColor: Color blue.
	super initialize.
	self selectedColor: self selectedColor! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:11'!
newColorComponentFieldMorph: aspect
	"Answer a text entry for the specified aspect of the color."

	^(self
		newTextEntryFor: self
		get: aspect
		set: (aspect, ':') asSymbol
		class: Integer
		getEnabled: nil
		help: nil)
		acceptOnFocusChange: true;
		minWidth: 40! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 14:16'!
newColorPickerButtonMorph
	"Answer a button to enable picking of colour."

	^self
		newButtonFor: self
		getState: nil
		action: #pickColor
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: ((
			ScriptingSystem formAtKey: #Eyedropper)
				scaledIntoFormOfSize: 16))
		help: 'Pick a colour from the screen' translated.! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:32'!
newColorPresenterMorph
	"Answer a color presenter."

	^self
		newColorPresenterFor: self
		getColor: #selectedColor 
		help: 'Shows the selected colour' translated! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:14'!
newContentMorph
	"Answer a new content morph."

	self hsvaMorph: self newHSVAColorSelectorMorph.
	^self newRow: {
		self newGroupbox: 'Colour' translated forAll: {
			self hsvaMorph.
			(self newRow: {
				(self newLabelGroup: {
					'Selected colour' translated -> self newColorPresenterMorph})
					vResizing: #shrinkWrap.
				self newColorPickerButtonMorph})
				cellPositioning: #leftCenter}.
		(self newGroupbox: 'Values' translated for: 
			(self newLabelGroup: {
				'Red' translated -> (self newColorComponentFieldMorph: #red).
				'Green' translated -> (self newColorComponentFieldMorph: #green).
				'Blue' translated -> (self newColorComponentFieldMorph: #blue).
				'Hue' translated -> (self newColorComponentFieldMorph: #hue).
				'Saturation' translated -> (self newColorComponentFieldMorph: #saturation).
				'Brightness' translated -> (self newColorComponentFieldMorph: #brightness).
				'Alpha' translated -> (self newColorComponentFieldMorph: #alpha)}))
			hResizing: #shrinkWrap}! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 13:11'!
newHSVAColorSelectorMorph
	"Answer a hsva color selector."

	^HSVAColorSelectorMorph new
		extent: (40@28) + 152;
		when: #selectedColor send: #colorSelected: to: self! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/25/2006 12:02'!
pickColor
	"Pick a colour from the screen."

	|p d c h|
	h := self world activeHand.
	d := Delay forMilliseconds: 20.
	h showTemporaryCursor: (ScriptingSystem formAtKey: #Eyedropper) 
			hotSpotOffset: 6 negated @ 4 negated.
	[Sensor anyButtonPressed] whileFalse: 
		[p := Sensor cursorPoint.
			(self hsvaMorph containsPoint: p)
				ifFalse: ["deal with the fact that 32 bit displays may have garbage in the alpha bits"
						c := Display depth = 32 
							ifTrue: [Color
									colorFromPixelValue: ((Display pixelValueAt: p) bitOr: 16rFF000000)
									depth: 32]
							ifFalse: [Display colorAt: p]].
			self world activeHand position: p.
			self selectedColor ~= c ifTrue: [
				self selectedColor: c].
			self world displayWorldSafely.
			d wait].
	h showTemporaryCursor: nil! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:29'!
red
	"Answer the red value of the selected color."

	^(self selectedColor red * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
red: anInteger
	"Set the red value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: anInteger g: c green * 255 b: c blue * 255 range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
saturation
	"Answer the saturation value of the selected color."

	^(self selectedColor saturation * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:36'!
saturation: anInteger
	"Set the saturation value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: c hue s: anInteger / 255 v: c brightness) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:49'!
selectedColor
	"Answer the value of selectedColor"

	^ selectedColor! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:03'!
selectedColor: aColor
	"Set the value of selectedColor. Update the color selectors."

	self basicSelectedColor: aColor.
	self hsvaMorph selectedColor: aColor! !

!DialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:59'!
inactiveFillStyleFor: aWindow
	"Return the inactive fillStyle for the given window."
	
	^self theme dialogWindowInactiveFillStyleFor: aWindow! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/27/2006 11:15'!
acceptTextMorphs
	"Accept any text morphs except for those that have no edits."

	self allMorphs do: [:p |
		((p respondsTo: #accept) and: [
			(p respondsTo: #hasUnacceptedEdits) and: [
				p hasUnacceptedEdits]]) ifTrue: [p accept]]! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 13:04'!
activate
	"Set the default focus for now, will want to
	remember it at some point."
	
	super activate.
	self world ifNil: [^self].
	self defaultFocusMorph ifNotNilDo: [:m |
		self world activeHand newKeyboardFocus: m]! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/24/2007 11:35'!
activeFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme dialogWindowActiveFillStyleFor: self! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 10:25'!
addInitialPanel
	"Add the panel."

	self addMainPanel! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 16:52'!
addMainPanel
	"Add the main panel."

	self addMorph: self newMainPanel frame: (0@0 corner: 1@1)! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 16:19'!
animateClose
	"Animate closing."! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/27/2006 11:11'!
applyChanges
	"Apply the changes."

	self acceptTextMorphs! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 10:10'!
cancel
	"Cancel and close."

	self close! !

!DialogWindow methodsFor: 'accessing' stamp: 'gvc 8/14/2006 14:12'!
cancelled
	"Answer the value of cancelled"

	^ cancelled! !

!DialogWindow methodsFor: 'accessing' stamp: 'gvc 8/14/2006 14:12'!
cancelled: anObject
	"Set the value of cancelled"

	cancelled := anObject! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 10:10'!
close
	"Close the window."

	self delete! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:23'!
defaultButton
	"Answer the default button."

	^self
		findDeepSubmorphThat: [:m |
			(m isKindOf: PluggableButtonMorph) and: [m isDefault]]
		ifAbsent: [] ! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/25/2007 16:03'!
defaultFocusMorph
	"Answer the morph that should have the keyboard
	focus by default when the dialog is opened."
	
	^self defaultButton
		ifNil: [(self respondsTo: #nextMorphWantingFocus)
					ifTrue: [	self nextMorphWantingFocus]]
		ifNotNilDo: [:b | b enabled ifTrue: [b]]! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 12:40'!
defaultLabel
	"Answer the default label for the receiver."

	^'Dialog' translated! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:42'!
escapePressed
	"Default is to cancel."

	self cancel! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:50'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	
	(super handlesKeyboard: evt) ifTrue: [^true].
	^evt keyCharacter = Character cr or: [
		evt keyCharacter = Character escape]
	! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/24/2007 11:36'!
inactiveFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme dialogWindowInactiveFillStyleFor: self! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 10:47'!
initialExtent
	"Answer the default extent for the receiver."

	|rl paneExt|
	rl := self getRawLabel.
	paneExt _ self paneMorphs isEmpty
		ifTrue: [0@0]
		ifFalse: [self paneMorphs first minExtent].
	^paneExt + (2@ self labelHeight) + (2 * self class borderWidth)
		max: rl extent + 20! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 16:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		cancelled: true;
		addInitialPanel;
		removeCornerGrips! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 16:45'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."
	
	super initializeLabelArea.
	self removeBoxes! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 16:42'!
keyStroke: evt
	"Check for return and escape keys."

	super keyStroke: evt.
	evt keyCharacter = Character cr ifTrue: [self returnPressed. ^true].
	evt keyCharacter = Character escape ifTrue: [self escapePressed. ^true].
	^false! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 13:28'!
keyboardFocusChange: aBoolean
	"Set the focus to the default button."

	aBoolean
		ifTrue: [self defaultButton ifNotNilDo: [:b |
					self activeHand newKeyboardFocus: b]]! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 12:35'!
newButtonRow
	"Answer a new ok/cancel button row."

	|answer buttons e|
	buttons _ self newButtons.
	e _ 0@0.
	buttons do: [:b | e _ e max: b minExtent + (8@4)].
	buttons do: [:b | b extent: e].
	answer _ Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	buttons do: [:b | answer addMorphBack: b].
	^answer! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:50'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true. self newCancelButton}! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 11:58'!
newContentMorph
	"Answer a new content morph."

	^Morph new
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/15/2007 17:40'!
newMainPanel
	"Answer a new main panel."

	^self newDialogPanel
		addMorphBack: self newContentMorph;
		addMorphBack: self newButtonRow;
		yourself! !

!DialogWindow methodsFor: 'controls' stamp: 'gvc 8/25/2006 16:08'!
newText: aStringOrText
	"Answer a new text."

	^self theme
		newTextIn: self
		text: aStringOrText! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 14:12'!
ok
	"Apply the changes and close."

	self
		cancelled: false;
		applyChanges;
		delete! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 8/25/2006 10:04'!
preferredCornerStyle
	"Answer the preferred corner style."

	^#rounded! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:48'!
returnPressed
	"Default is to do the default button."

	(self defaultButton ifNil: [^self]) performAction! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2007 11:42'!
setFramesForLabelArea
	"Fill the width of the window (including border)."
	
	|frame|
	super setFramesForLabelArea.
	labelArea ifNil: [^ self].	
	frame _ labelArea layoutFrame.
	frame
		leftOffset: 0;
		rightOffset: 0! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 16:56'!
themeChanged
	"Get rid of corner grips."

	super themeChanged.
	self removeCornerGrips.! !

!DialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 17:14'!
title: aString
	"Set the window title."
	
	super title: aString.
	label fitContents.
	self minimumExtent: ((label width + 20 min: (Display width // 2))@ self minimumExtent y)! !

DialogWindow subclass: #FileDialogWindow
	instanceVariableNames: 'directoryTreeMorph fileListMorph directories selectedDirectory selectedFileIndex fileSelectionBlock showDirectoriesInFileList fileSortBlock fileNameText defaultExtension actionSelector answer entryCache entryCacheDirectory previewType previewMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!FileDialogWindow commentStamp: 'gvc 5/18/2007 13:10' prior: 0!
Dialog based file chooser for selcting or saving files. Supports various types of answer (file stream, file name, directory path etc) with optional extension filters and image or text file preview.!

!FileDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:41'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallOpenIcon! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:33'!
actionSelector
	"Answer the value of actionSelector"

	^ actionSelector! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:33'!
actionSelector: anObject
	"Set the value of actionSelector"

	actionSelector := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 10:49'!
addInitialPanel
	"Add the panel."

	super addInitialPanel.
	self selectDirectory: FileDirectory default! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/31/2006 15:19'!
answer
	"Answer the result of performing the action selector."
	
	self cancelled ifTrue: [^nil].
	^answer! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/31/2006 15:20'!
answer: anObject
	"Set the answer."
	
	answer _ anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerDirectory
	"Set the receiver to answer a directory."
	
	self actionSelector: #selectedAnyFileDirectory.
	self  fileSelectionBlock: self directoryFileSelectionBlock.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:08'!
answerFileEntry
	"Set the receiver to answer the selected file entry."
	
	self actionSelector: #selectedFileEntry.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:00'!
answerFileName
	"Set the receiver to answer the selected file name."
	
	self actionSelector: #selectedFileName.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerForceSaveFile
	"Set the receiver to answer a forced new file stream."
	
	self actionSelector: #saveForcedSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerOpenFile
	"Set the receiver to answer a new file stream on an existing file."
	
	self actionSelector: #openSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerPathName
	"Set the receiver to answer the selected path name."
	
	self actionSelector: #selectedPathName.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerSaveFile
	"Set the receiver to answer a new file stream."
	
	self actionSelector: #saveSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/27/2006 11:38'!
cache: dir
	"Cache the contents of the given directory and answer them."

	self entryCacheDirectory = dir
		ifFalse: [Cursor wait showWhile: [
					self
						entryCache: dir entries;
						entryCacheDirectory: dir]].
	^self entryCache! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:23'!
clearEntryCache
	"Clear the entry cache."

	self
		entryCache: nil;
		entryCacheDirectory: nil! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/11/2006 13:33'!
defaultExtension
	"Answer the value of defaultExtension"

	^ defaultExtension! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/11/2006 13:33'!
defaultExtension: anObject
	"Set the value of defaultExtension"

	defaultExtension := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 16:06'!
defaultFileSelectionBlock
	"Answer the default file selection block."

	^[:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [self fileNamePattern match: de name]] fixTemps! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 16:04'!
defaultFileSortBlock
	"Answer the default file stor block"

	^[:de1 : de2 |
		de1 isDirectory = de2 isDirectory
			ifTrue: [de1 name <= de2 name]
			ifFalse: [de1 isDirectory
						ifTrue: [true]
						ifFalse: [de2 isDirectory
									ifTrue: [false]
									ifFalse: [de1 name <= de2 name]]]] fixTemps! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:19'!
defaultLabel
	"Answer the default label for the receiver."

	^'File' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:29'!
deleteFileOrDirectory
	"Delete the selected file or directory."

	|entry|
	self hasSelectedFileOrDirectory ifFalse: [^self].
	entry := self selectedFileEntry.
	entry isDirectory
		ifTrue: [(self 
					proceed: 'Are you sure you wish to delete the\selected directory along with its files?' withCRs translated
					title: 'Delete Directory' translated) ifTrue: [
						self selectedFileDirectory deleteDirectory: entry name.
						self
							clearEntryCache;
							updateDirectories]]
		ifFalse: [(self 
					proceed: 'Are you sure you wish to delete the\file' withCRs translated, ' "', entry name, '"?'
					title: 'Delete Directory' translated) ifTrue: [
						self selectedFileDirectory deleteFileNamed: entry name.
						self
							selectedFileIndex: 0;
							clearEntryCache;
							updateFiles]].! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:19'!
directories
	"Answer the value of directories"

	^ directories! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:19'!
directories: anObject
	"Set the value of directories"

	directories := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 14:42'!
directoryFileSelectionBlock
	"Answer the directory file selection block."

	^[:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [false]] fixTemps! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:29'!
directoryNamesFor: item
	"Answer the filtered entries."
	
	^item directoryNames! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
directoryTreeMorph
	"Answer the value of directoryTreeMorph"

	^ directoryTreeMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
directoryTreeMorph: anObject
	"Set the value of directoryTreeMorph"

	directoryTreeMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:13'!
doubleClickFile
	"If the selected entry is a directory then navigate it
	otherwise ok the dialog."
	
	|fe de sm|
	fe := self selectedFileEntry.
	fe ifNil: [^self].
	fe isDirectory
		ifTrue: [de := self selectedFileDirectory.
				sm := self directoryTreeMorph selectedMorph.
				self changed: #(openPath), de pathParts.
				self selectedDirectory: (sm children detect: [:w |
					w complexContents item localName = fe name]) complexContents]
		ifFalse: [self ok]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCache
	"Answer the value of entryCache"

	^ entryCache! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCache: anObject
	"Set the value of entryCache"

	entryCache := anObject! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCacheDirectory
	"Answer the value of entryCacheDirectory"

	^ entryCacheDirectory! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCacheDirectory: anObject
	"Set the value of entryCacheDirectory"

	entryCacheDirectory := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 11:07'!
fileItems
	"Answer the items for the contents of the selected directory."

	^Cursor wait showWhile: [
		self files collect: [:de |
			(self newRow: {
				ImageMorph new newForm: (self iconFor: de).
				StringMorph contents: de name font: self theme listFont})
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				fullBounds;
				hResizing: #rigid;
				vResizing: #rigid;
				changeNoLayout]]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
fileListMorph
	"Answer the value of fileListMorph"

	^ fileListMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
fileListMorph: anObject
	"Set the value of fileListMorph"

	fileListMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 16:13'!
fileNamePattern
	"Answer the file name pattern to filter on."
	
	^self fileNameText withBlanksTrimmed, '*'! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 15:54'!
fileNameText
	"Answer the typed file name."

	^fileNameText! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/3/2007 15:19'!
fileNameText: aString
	"The typed file name has changed."

	fileNameText = aString asString ifTrue: [^self].
	fileNameText := aString asString.
	self updateFiles.
	self
		changed: #fileNameText;
		changed: #okEnabled.
	self selectFileFromPattern! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:39'!
fileSelectionBlock
	"Answer the value of fileSelectionBlock"

	^ fileSelectionBlock! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:45'!
fileSelectionBlock: anObject
	"Set the value of fileSelectionBlock"

	fileSelectionBlock := anObject.
	self updateFiles! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:51'!
fileSortBlock
	"Answer the value of fileSortBlock"

	^ fileSortBlock! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:51'!
fileSortBlock: anObject
	"Set the value of fileSortBlock"

	fileSortBlock := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/27/2006 11:39'!
files
	"Answer the contents of the selected directory."

	^(self selectedDirectory ifNil: [^#()]) item isNil
		ifTrue: [#()]
		ifFalse: [Cursor wait showWhile: [
				((self cache: self selectedDirectory item) select: self fileSelectionBlock)
					asSortedCollection: self fileSortBlock]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:21'!
hasParentDirectory
	"Answer whether the selected directory in the tree part has a parent."

	^(self selectedFileDirectory ifNil: [^false])
		containingDirectory pathName notEmpty! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:17'!
hasSelectedFileOrDirectory
	"Answer whether a file or directopry is selected in the file list."

	^self selectedFileIndex ~= 0! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/27/2006 13:50'!
iconFor: anEntry
	"Answer the icon to use for the directory entry."

	^anEntry isDirectory
		ifTrue: [MenuIcons smallOpenIcon]
		ifFalse: [(self isImageFile: anEntry name)
					ifTrue: [MenuIcons smallPaintIcon]
					ifFalse: [MenuIcons smallLeftFlushIcon]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:18'!
initialDirectories
	"Answer the initial directories."
	
	| dirList |
	dirList := (FileDirectory on: '') directoryNames collect: [ :each |
		FileDirectoryWrapper with: (FileDirectory on: each) name: each model: self].
	dirList isEmpty ifTrue:[
		dirList := Array with: (FileDirectoryWrapper 
			with: FileDirectory default 
			name: FileDirectory default localName 
			model: self)].
	^dirList! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:20'!
initialize
	"Initialize the receiver."

	selectedFileIndex := 0.
	fileNameText _ ''.
	self
		answerPathName;
		directories: self initialDirectories;
		showDirectoriesInFileList: true;
		fileSelectionBlock: self defaultFileSelectionBlock;
		fileSortBlock: self defaultFileSortBlock.
	super initialize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 13:53'!
isImageFile: aString
	"Answer whether the file name indicates an image file."

	aString ifNil: [^false].
	^#('pcx' 'bmp' 'jpeg' 'xbm' 'pnm' 'ppm' 'gif' 'pam' 'jpg' 'png' 'pbm')
		includes: (FileDirectory extensionFor: aString) asLowercase! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:39'!
newActionButtonRow
	"Answer a new row with the action buttons."
	
	^(self newRow: {
		self newUpButton.
		self newNewDirectoryButton.
		self newDeleteButton})
		listCentering: #bottomRight! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:39'!
newContentMorph
	"Answer a new content morph."

	self
		directoryTreeMorph: self newDirectoryTree;
		fileListMorph: self newFileList;
		previewMorph: self newPreviewMorph.
	^self newRow: {
		self newColumn: {
			self newGroupbox: 'Directory' translated for: self directoryTreeMorph.
			self newLabelGroup: {
				'File name' translated->self newFileNameTextEntry}}.
		self newGroupbox: 'File' translated forAll: {
			self fileListMorph.
			self newActionButtonRow}},
		(self previewMorph notNil
			ifTrue: [{self newGroupbox: 'Preview' translated for: self previewMorph}]
			ifFalse: [#()])! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:15'!
newDeleteButton
	"Answer a new delete button."

	^self 
		newButtonFor: self
		getState: nil
		action: #deleteFileOrDirectory
		arguments: nil
		getEnabled: #hasSelectedFileOrDirectory
		label: (ImageMorph new image: MenuIcons smallDeleteIcon)
		help: 'Press to delete the selected file or directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:19'!
newDirectory
	"Create a new directory within the selected directory."

	|dir dirName title|
	dir := self selectedFileDirectory ifNil: [^self].
	title := 'Create Directory' translated.
	dirName := self
		textEntry: 'Enter directory name' translated
		title: title.
	dirName ifNil: [^self].
	[dir createDirectory: dirName]
		on: Error
		do: [:ex | [((dir fileExists: dirName) or: [(dir directoryNamed: dirName) exists])
					ifTrue: [^self
								alert: 'A file or directory already exists\with the name' withCRs translated, ' "', dirName, '"'
								title: title]] on: Error do: [].
					^self
						alert: 'Invalid directory name' translated, ' "', dirName, '"'
						title: title].
	self updateDirectories! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 09:22'!
newDirectoryTree
	"Answer a new directory tree."
	
	^(self newTreeFor: self
		list: #directories
		selected: #selectedDirectory
		changeSelected: #selectedDirectory:)
		hResizing: #rigid;
		minHeight: 200;
		extent: 180@20! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 13:29'!
newFileList
	"Answer a new file list."
	
	^(self newMorphListFor: self
			list: #fileItems
			getSelected: #selectedFileIndex
			setSelected: #selectedFileIndex:
			help: nil)
		doubleClickSelector: #doubleClickFile;
		minWidth: 200! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/3/2007 15:20'!
newFileNameTextEntry
	"Answer a new file name text entry morph."

	^self
		newAutoAcceptTextEntryFor: self
		getText: #fileNameText
		setText: #fileNameText:
		getEnabled: nil
		help: 'File name filter pattern' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:33'!
newImagePreviewMorph
	"Answer a new image preview morph."

	^ImagePreviewMorph new
		cornerStyle: self preferredCornerStyle;
		image: nil
		size: self previewSize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:14'!
newNewDirectoryButton
	"Answer a new 'new directory' button."

	^self 
		newButtonFor: self
		getState: nil
		action: #newDirectory
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: MenuIcons smallOpenIcon)
		help: 'Press to create a new directory within the current directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 15:59'!
newOKButton
	"Answer a new OK button."

	^self
		newOKButtonFor: self
		getEnabled: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:24'!
newPreviewMorph
	"Answer a new preview morph."

	self previewType == #image ifTrue: [^self newImagePreviewMorph].
	self previewType == #text ifTrue: [^self newTextPreviewMorph].
	^nil! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:39'!
newTextPreviewMorph
	"Answer a new text preview morph."

	^(self newTextEditorFor: self
			getText: nil setText: nil getEnabled: nil)
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: self previewSize;
		minWidth: self previewSize x;
		minHeight: self previewSize y;
		enabled: false! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:12'!
newUpButton
	"Answer a new up one directory level button."

	^self 
		newButtonFor: self
		getState: nil
		action: #selectParentDirectory
		arguments: nil
		getEnabled: #hasParentDirectory
		label: (ImageMorph new image: MenuIcons smallUndoIcon)
		help: 'Press to switch to the parent of the current directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 10:41'!
ok
	"Apply the changes and close."

	self cancelled: false.
	self applyChanges.
	self answer: (self perform: self actionSelector).
	answer ifNil: [
		self cancelled: true.
		^self delete].
	super ok! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:34'!
okEnabled
	"Answer wether the ok button should be enabled."

	(#(selectedAnyFileDirectory selectedPathName)
			includes: self actionSelector) ifTrue: [^true].
	((#(saveSelectedFile saveForcedSelectedFile)
			includes: self actionSelector) and: [self fileNameText notEmpty]) ifTrue: [^true].
	(self actionSelector = #selectedFileName and: [
		self selectedFileName notNil]) ifTrue: [^true].
	^self selectedFileName notNil and: [self selectedFileEntry isDirectory not]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 15:51'!
openSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [^nil].
	self selectedFileEntry isDirectory ifTrue: [^nil].
	^ (d oldFileNamed: f) ifNil: [d readOnlyFileNamed: f]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:55'!
previewMorph
	"Answer the value of previewMorph"

	^ previewMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:55'!
previewMorph: anObject
	"Set the value of previewMorph"

	previewMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:38'!
previewSize
	"Answer the size of preview to use."

	self previewType == #text ifTrue: [^256@256].
	^128@128! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:30'!
previewType
	"Answer the value of previewType"

	^ previewType! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/14/2007 16:42'!
previewType: anObject
	"Set the value of previewType.
	See #updatePreview for supported types."

	previewType := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:13'!
saveForcedSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [self fileNameText withBlanksTrimmed].
	f ifEmpty: [^nil].
	^d forceNewFileNamed: f! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:22'!
saveSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [self fileNameText withBlanksTrimmed].
	f ifEmpty: [^nil].
	((FileDirectory extensionFor: f) isEmpty and: [self defaultExtension notNil])
		 ifTrue: [f := FileDirectory fileName: f extension: self defaultExtension].
	^[d newFileNamed: f]
		on: FileExistsException do: [
			(self
				proceed: ('The file {1} already exists.
Overwrite the file?' translated format: {f printString})
				title: 'Save File' translated)
			ifTrue: [d forceNewFileNamed: f]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 10:49'!
selectDirectory: aFileDirectory
	"Expand and select the given directory."

	self changed: #(openPath), aFileDirectory pathParts! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/2/2007 12:19'!
selectFileFromPattern
	"If there is a single file matching the pattern then select it.
	If none then try for a directory."

	|f matches subMatches|
	f := self files.
	matches := f select: [:de | self fileNamePattern match: de name].
	subMatches := matches select: [:de | de isDirectory not].
	subMatches size = 1 ifTrue: [
		^self selectedFileIndex: (f indexOf: subMatches first)].
	subMatches := matches select: [:de | de isDirectory].
	subMatches size = 1 ifTrue: [^self selectedFileIndex: (f indexOf: subMatches first)].
	self selectedFileIndex: 0! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:43'!
selectParentDirectory
	"Switch to the parent directory."

	self hasParentDirectory ifFalse: [^self].
	self selectDirectory: self selectedFileDirectory containingDirectory! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:04'!
selectPathName: aString
	"Select the directory and set the file name text
	from the given string."

	|dir local|
	(FileDirectory default directoryExists: aString)
		ifTrue: [self selectDirectory: (FileDirectory on: aString)]
		ifFalse: [((FileDirectory on: '') directoryExists: aString)
					ifTrue: [^self selectDirectory: (FileDirectory on: aString)].
				dir := FileDirectory forFileName: aString.
				dir exists
					ifTrue: [(dir directoryExists: aString)
								ifTrue: [self selectDirectory: (dir directoryNamed: aString)]
								ifFalse: [self selectDirectory: dir.
										local := FileDirectory localNameFor: aString.
										(local notEmpty and: [FileDirectory isLegalFileName: local])
											ifTrue: [self fileNameText: local]]]
					ifFalse: [self selectDirectory: FileDirectory default.
							self fileNameText: '']]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:21'!
selectedAnyFileDirectory
	"Answer the file directory for the selected file or, if none
	or not a directory, the selected file directory."

	^self selectedFileEntry
		ifNil: [self selectedFileDirectory]
		ifNotNilDo: [:fe | self selectedFileDirectory ifNotNilDo: [:fd |
					fe isDirectory ifTrue: [
						fd directoryNamed: fe name]]]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:33'!
selectedDirectory
	"Answer the value of selectedDirectory"

	^ selectedDirectory! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:49'!
selectedDirectory: anObject
	"Set the value of selectedDirectory"

	selectedDirectory := anObject.
	self
		selectedFileIndex: 0;
		updateSelectedDirectory;
		updateFiles! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:14'!
selectedDirectoryName
	"Answer the name of the selected directory."

	^(self selectedFileDirectory ifNil: [^nil]) name! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:13'!
selectedFileDirectory
	"Answer the selected file directory in the tree part."

	^(self selectedDirectory ifNil: [^nil]) item! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 17:01'!
selectedFileEntry
	"Answer the selected file."

	self selectedFileIndex = 0 ifTrue: [^nil].
	^self files at: self selectedFileIndex! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 15:42'!
selectedFileIndex
	"Answer the value of selectedFileIndex"

	^ selectedFileIndex! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:46'!
selectedFileIndex: anObject
	"Set the value of selectedFileIndex"

	selectedFileIndex := anObject.
	self updateSelectedFile! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 17:02'!
selectedFileName
	"Answer the name of the selected file."

	^(self selectedFileEntry ifNil: [^nil]) name! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:14'!
selectedPathName
	"Answer the name of the selected path."

	^(self selectedFileDirectory ifNil: [^nil])
		fullNameFor: (self selectedFileName ifNil: [^self selectedFileDirectory pathName])! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:42'!
showDirectoriesInFileList
	"Answer the value of showDirectoriesInFileList"

	^ showDirectoriesInFileList! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:44'!
showDirectoriesInFileList: anObject
	"Set the value of showDirectoriesInFileList"

	showDirectoriesInFileList := anObject.
	self updateFiles! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:18'!
updateDirectories
	"Update the directory tree and reselect the current."

	|dir|
	dir _ self selectedFileDirectory.
	self changed: #directories.
	self selectDirectory: dir! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 08:46'!
updateFiles
	"Notify that the files have changed."

	self
		changed: #files;
		changed: #fileItems! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:33'!
updateImagePreview
	"Update the image preview."

	|str form|
	(self isImageFile: self selectedFileName)
		ifFalse: [^self previewMorph
					image: nil
					size: self previewSize].
	str := self openSelectedFile.
	str ifNil: [^self].
	[[str binary.
	form := ImageReadWriter formFromStream: str]
		on: Error do: []]
		ensure: [str close].
	self previewMorph
		image: form
		size: self previewSize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:25'!
updatePreview
	"Update the preview."

	self previewType == #image ifTrue: [self updateImagePreview].
	self previewType == #text ifTrue: [self updateTextPreview]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:41'!
updateSelectedDirectory
	"Notify that the selected directory has changed."

	self
		changed: #selectedDirectory;
		changed: #selectedFileDirectory;
		changed: #selectedPathName;
		changed: #hasParentDirectory! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:40'!
updateSelectedFile
	"Notify that the selected file has changed."

	self
		changed: #selectedFileIndex;
		changed: #selectedFileEntry;
		changed: #selectedFileName;
		changed: #selectedPathName;
		changed: #okEnabled;
		changed: #hasSelectedFileOrDirectory.
	self updatePreview! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:36'!
updateTextPreview
	"Update the text preview."

	|str text|
	str := self openSelectedFile.
	str ifNil: [^self].
	[[text := str next: 5000]
		on: Error do: []]
		ensure: [str close].
	text ifNil: [text := ''].
	self previewMorph
		setText: text! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/11/2006 13:33'!
validExtensions: aList
	"Set the filter for the files to be those with the given extensions."
	
	aList notEmpty
		ifTrue: [self defaultExtension: aList first].
	self fileSelectionBlock: [:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [(self fileNamePattern match: de name) and: [
						aList includes: (FileDirectory extensionFor: de name asLowercase)]]] fixTemps! !

DialogWindow subclass: #FontSelectorDialogWindow
	instanceVariableNames: 'fontFamilies selectedFont textPreviewMorph fontFamilyIndex fontSizeIndex isBold isItalic isUnderlined isStruckOut previewText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!FontSelectorDialogWindow commentStamp: 'gvc 5/18/2007 13:04' prior: 0!
Dialog based font chooser with preview.!

!FontSelectorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:42'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallFontsIcon! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/16/2007 13:45'!
defaultFontFamilies
	"Answer the set of available fonts families that are supported as Text objects
	in the font that they represent. Only includes FreeTypeFont/TTCFont."
	
	^(((TextStyle actualTextStyles
		select: [:ts | ts defaultFont isTTCFont])
		collect: [:ts | ts defaultFont familyName]) asSet
		collect: [:fam | |famTs|
			famTs := TextStyle named: fam.
			self isFreeTypeInstalled ifTrue: [ 
				(famTs defaultFont isSymbolFont or:[
						(famTs defaultFont hasDistinctGlyphsForAll: fam) not])
					ifTrue: [famTs := TextStyle default]].
			fam asText
				addAttribute: (TextFontReference
					toFont: (famTs fontOfPointSize: self theme listFont pointSize))])
			asSortedCollection: [:a :b | a asString <= b asString]! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:05'!
defaultPreviewText
	"Answer the default text to use for the preview of the font."

	^(33 to: 127) asByteArray asString! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:47'!
familyName
	"Answer the selected family name or nil if none."

	(self fontFamilyIndex between: 1 and: self fontFamilies size)
		ifFalse: [^nil].
	^(self fontFamilies at: self fontFamilyIndex) asString! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:40'!
fontFamilies
	"Answer the set of available fonts families that are supported as Text objects
	in the font that they represent."
	
	^fontFamilies ifNil: [
		self fontFamilies: self defaultFontFamilies.
		fontFamilies]! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:02'!
fontFamilies: anObject
	"Set the value of fontFamilies"

	fontFamilies := anObject! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 14:30'!
fontFamilyIndex
	"Answer the value of fontFamilyIndex"

	^ fontFamilyIndex! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:19'!
fontFamilyIndex: anObject
	"Set the value of fontFamilyIndex"

	fontFamilyIndex := anObject.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:03'!
fontSize
	"Answer the selected font size or nil if none."

	(self fontSizeIndex between: 1 and: self fontSizes size)
		ifFalse: [^nil].
	^self fontSizes at: self fontSizeIndex! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 14:30'!
fontSizeIndex
	"Answer the value of fontSizeIndex"

	^ fontSizeIndex! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:19'!
fontSizeIndex: anObject
	"Set the value of fontSizeIndex"

	fontSizeIndex := anObject.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 14:31'!
fontSizes
	"Answer the set of available fonts sizes that are supported."

	^#(6 7 8 9 10 11 12 13 14 15 16 18 20 21 22 24 26 28 32 36 48)! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:05'!
initialize
	"Initialize the receiver."

	self
		previewText: self defaultPreviewText;
		fontFamilyIndex: 0;
		fontSizeIndex: 0;
		isBold: false;
		isItalic: false;
		isUnderlined: false;
		isStruckOut: false.
	super initialize! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isBold
	"Answer the value of isBold"

	^ isBold! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isBold: anObject
	"Set the value of isBold"

	isBold := anObject! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/16/2007 13:43'!
isFreeTypeInstalled
	"Answer whether FreeType appears to be installed."
	
	^Smalltalk includesKey: #FreeTypeFont! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isItalic
	"Answer the value of isItalic"

	^ isItalic! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isItalic: anObject
	"Set the value of isItalic"

	isItalic := anObject! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isStruckOut
	"Answer the value of isStruckOut"

	^ isStruckOut! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isStruckOut: anObject
	"Set the value of isStruckOut"

	isStruckOut := anObject! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isUnderlined
	"Answer the value of isUnderlined"

	^ isUnderlined! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isUnderlined: anObject
	"Set the value of isUnderlined"

	isUnderlined := anObject! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:32'!
matchingFont
	"Update the selected font to reflect the choices."

	|ts fs emp|
	ts := (TextStyle named: self familyName) ifNil: [^TextStyle defaultFont].
	fs := self fontSize ifNil: [ts defaultFont pointSize].
	emp := self isBold
		ifTrue: [TextEmphasis bold emphasisCode]
		ifFalse: [TextEmphasis normal emphasisCode].
	self isItalic
		ifTrue: [emp := emp + TextEmphasis italic emphasisCode].
	self isUnderlined
		ifTrue: [emp := emp + TextEmphasis underlined emphasisCode].
	self isStruckOut
		ifTrue: [emp := emp + TextEmphasis struckOut emphasisCode].
	(ts fontOfPointSize: fs) pointSize ~= fs
		ifTrue: [ts addNewFontSize: fs].
	^(ts fontOfPointSize: fs)
		emphasis: emp! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:28'!
newBoldButtonMorph
	"Answer a button for the boldness of the font."
	
	^self
		newButtonFor: self
		getState: #isBold
		action: #toggleBold
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: self theme smallBoldIcon)
		help: 'Toggle bold font' translated! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:34'!
newContentMorph
	"Answer a new content morph."

	self textPreviewMorph: self newTextPreviewMorph.
	^(self newColumn: {
		(self newRow: {
			self newGroupbox: 'Family' translated for:
				self newFontFamilyMorph.
			(self newColumn: {
				(self newGroupbox: 'Style' translated for: 
					(self newRow: {
						self newBoldButtonMorph.
						self newItalicButtonMorph.
						self newUnderlinedButtonMorph.
						self newStruckOutButtonMorph}))
					vResizing: #shrinkWrap.
				self newGroupbox: 'Point size' translated for:
					self newFontSizeMorph})
				hResizing: #shrinkWrap})
			vResizing: #spaceFill.
		(self newGroupbox: 'Preview' translated for:
			self textPreviewMorph)
			vResizing: #shrinkWrap})
		minWidth: 350;
		minHeight: 400! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:49'!
newFontFamilyMorph
	"Answer a list for the font family of the font."

	|highestFont|
	highestFont := self fontFamilies first fontAt: 1 withStyle: TextStyle default.
	self fontFamilies do: [:ff | |f|
		f := ff fontAt: 1 withStyle: TextStyle default.
		f height > highestFont height
			ifTrue: [highestFont := f]].
	^(self
		newListFor: self
		list: #fontFamilies
		selected: #fontFamilyIndex
		changeSelected: #fontFamilyIndex:
		help: nil)
		font: highestFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:49'!
newFontSizeMorph
	"Answer a list for the font size of the font."

	^self
		newListFor: self
		list: #fontSizes
		selected: #fontSizeIndex
		changeSelected: #fontSizeIndex:
		help: nil! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:28'!
newItalicButtonMorph
	"Answer a button for the italic emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isItalic
		action: #toggleItalic
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: self theme smallItalicIcon)
		help: 'Toggle italic font' translated! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:29'!
newStruckOutButtonMorph
	"Answer a button for the struck out emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isStruckOut
		action: #toggleStruckOut
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: self theme smallStrikeOutIcon)
		help: 'Toggle struck-out font' translated! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:31'!
newTextPreviewMorph
	"Answer a text entry morph for the preview of the font."

	^(self
		newTextEditorFor: self
		getText: #previewText 
		setText: nil
		getEnabled: nil)
		vResizing: #rigid;
		enabled: false;
		extent: 20@90! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:29'!
newUnderlinedButtonMorph
	"Answer a button for the italic emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isUnderlined
		action: #toggleUnderlined
		arguments: nil
		getEnabled: nil
		label: (ImageMorph new image: self theme smallUnderlineIcon)
		help: 'Toggle underlined font' translated! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/18/2007 13:05'!
previewText
	"Answer the value of previewText"

	^ previewText! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/18/2007 13:07'!
previewText: anObject
	"Set the value of previewText"

	previewText := anObject.
	self changed: #previewText! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
selectedFont
	"Answer the value of selectedFont"

	^ selectedFont! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
selectedFont: anObject
	"Set the value of selectedFont"

	selectedFont := anObject.
	self updateFromSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
textPreviewMorph
	"Answer the value of textPreviewMorph"

	^ textPreviewMorph! !

!FontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
textPreviewMorph: anObject
	"Set the value of textPreviewMorph"

	textPreviewMorph := anObject! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleBold
	"Toggle the font bold emphasis."

	self isBold: self isBold not.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleItalic
	"Toggle the font italic emphasis."

	self isItalic: self isItalic not.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleStruckOut
	"Toggle the font struck out emphasis."

	self isStruckOut: self isStruckOut not.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleUnderlined
	"Toggle the font underlined emphasis."

	self isUnderlined: self isUnderlined not.
	self updateSelectedFont! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/4/2007 10:27'!
updateFromSelectedFont
	"Update our state based on the selected font."

	|font|
	font := self selectedFont ifNil: [^self].
	fontFamilyIndex := (self fontFamilies indexOf: font familyName).
	fontSizeIndex := (self fontSizes indexOf: font pointSize).
	isBold := (font emphasis allMask: TextEmphasis bold emphasisCode).
	isItalic := (font emphasis allMask: TextEmphasis italic emphasisCode).
	isUnderlined := (font emphasis allMask: TextEmphasis underlined emphasisCode).
	isStruckOut := (font emphasis allMask: TextEmphasis struckOut emphasisCode).
	self
		changed: #fontFamilyIndex;
		changed: #fontSizeIndex;
		changed: #isBold;
		changed: #isItalic;
		changed: #isUnderlined;
		changed: #isStruckOut..
	self textPreviewMorph ifNotNilDo: [:tp |
		tp
			font: self selectedFont;
			scrollToTop]! !

!FontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/4/2007 10:25'!
updateSelectedFont
	"Update the selected font to reflect the choices."

	self selectedFont: self matchingFont! !

DialogWindow subclass: #MessageDialogWindow
	instanceVariableNames: 'textMorph textFont iconMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!MessageDialogWindow commentStamp: 'gvc 5/18/2007 13:27' prior: 0!
Dialog window displaying a message with a single OK button. Escape/return will close. Icon is a themed information icon.!

MessageDialogWindow subclass: #AlertDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!AlertDialogWindow commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
Message dialog with a warning icon.!

!AlertDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallWarningIcon! !

!AlertDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme warningIcon! !

MessageDialogWindow subclass: #ChooseDropListDialogWindow
	instanceVariableNames: 'listMorph list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ChooseDropListDialogWindow commentStamp: 'gvc 5/18/2007 13:46' prior: 0!
Message dialog containing a drop list for selection of an item.!

!ChooseDropListDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallQuestionIcon! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:35'!
initialize
	"Initialize the receiver."

	self list: #().
	super initialize! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:15'!
list
	"Answer the value of list"

	^ list! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 15:21'!
list: anObject
	"Set the value of list"

	list := anObject.
	self
		changed: #list;
		changed: #selectionIndex! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:17'!
listMorph
	"Answer the value of listMorph"

	^ listMorph! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:17'!
listMorph: anObject
	"Set the value of listMorph"

	listMorph := anObject! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:32'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self listMorph: self newListMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self listMorph}! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:17'!
newListMorph
	"Answer a new drop-list morph."

	^self
		newDropListFor: self
		list: #list
		getSelected: #selectionIndex
		setSelected: nil
		getEnabled: nil
		help: nil! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:22'!
selectedItem
	"Answer the selected list item or nil if cancelled."

	^self cancelled ifFalse: [self listMorph selectedItem]! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:15'!
selectionIndex
	"Answer the initial selection index for the list."

	^self list ifEmpty: [0] ifNotEmpty: [1]! !

MessageDialogWindow subclass: #DenyDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!DenyDialogWindow commentStamp: 'gvc 5/18/2007 13:27' prior: 0!
Dialog window displaying a message with a single OK button. Escape/return will close. Icon is a themed lock icon.!

!DenyDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:52'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallLockIcon! !

!DenyDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme lockIcon! !

MessageDialogWindow subclass: #ErrorDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ErrorDialogWindow commentStamp: 'gvc 5/18/2007 14:51' prior: 0!
A message dialog with an error icon.!

!ErrorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:54'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallErrorIcon! !

!ErrorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 14:52'!
icon
	"Answer an icon for the receiver."
	
	^self theme errorIcon! !

!MessageDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 13:58'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallInfoIcon! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme infoIcon! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/29/2007 13:29'!
iconMorph
	"Answer the value of iconMorph"

	^ iconMorph! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/29/2007 13:28'!
iconMorph: anObject
	"Set the value of iconMorph"

	iconMorph := anObject! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 15:15'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true}! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:29'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	^self newGroupboxFor: (self newRow: {self iconMorph. self textMorph})! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:29'!
newIconMorph
	"Answer an icon for the receiver."
	
	^ImageMorph new image: self icon! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/31/2006 17:54'!
newTextMorph
	"Answer a text morph."
	
	^self newText: ''! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/17/2006 14:17'!
text: aStringOrText
	"Set the text."
	
	|t|
	t _ aStringOrText isString
		ifTrue: [aStringOrText asText addAttribute: (TextFontReference toFont: self textFont); yourself]
		ifFalse: [aStringOrText].
	t addAttribute: TextAlignment centered.
	self textMorph newContents: t! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/17/2006 14:19'!
textFont
	"Answer the text font."
	
	^textFont! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/17/2006 14:19'!
textFont: aFont
	"Set the text font."
	
	textFont _  aFont! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/27/2006 10:26'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/27/2006 10:26'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:30'!
themeChanged
	"Update the icon."

	super themeChanged.
	self iconMorph image: self icon! !

MessageDialogWindow subclass: #ProceedDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ProceedDialogWindow commentStamp: 'gvc 5/18/2007 12:22' prior: 0!
Yes/no dialog. Test result as to whether the dialog is cancelled (no) or not (yes).!

!ProceedDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:43'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^UITheme current smallQuestionIcon! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:34'!
keyStroke: evt
	"Check for return and escape keys."

	(super keyStroke: evt) ifTrue: [^true].
	evt keyCharacter = $y ifTrue: [self yes. ^true].
	evt keyCharacter = $n ifTrue: [self no. ^true].
	^false! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:50'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton. self newCancelButton isDefault: true}! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:34'!
no
	"Answer no."

	self cancel! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:34'!
yes
	"Answer yes."

	self ok! !

ProceedDialogWindow subclass: #QuestionDialogWindow
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!QuestionDialogWindow commentStamp: 'gvc 5/18/2007 12:20' prior: 0!
A yes/no/cancel message dialog. Cancel (escape & return) is the default.!

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
answer
	"Answer the value of answer"

	^ answer! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
answer: anObject
	"Set the value of answer"

	answer := anObject! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
newButtons
	"Answer new buttons as appropriate."

	^{self newYesButton. self newNoButton. self newCancelButton isDefault: true}! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:36'!
no
	"Answer no."

	self
		answer: false;
		ok! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
yes
	"Answer yes."

	self
		answer: true;
		ok! !

QuestionDialogWindow subclass: #QuestionWithoutCancelDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!QuestionWithoutCancelDialogWindow commentStamp: 'gvc 5/18/2007 12:20' prior: 0!
A yes/no message dialog. Yes (return) is the default. Escape will answer no.!

!QuestionWithoutCancelDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
escapePressed
	"Default is to cancel."

	self no! !

!QuestionWithoutCancelDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:45'!
newButtons
	"Answer new buttons as appropriate."

	^{self newYesButton isDefault: true. self newNoButton}! !

MessageDialogWindow subclass: #TextEditorDialogWindow
	instanceVariableNames: 'textEditorMorph entryText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TextEditorDialogWindow commentStamp: 'gvc 5/18/2007 11:16' prior: 0!
Multi-line text entry dialog.!

!TextEditorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:43'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^UITheme current smallQuestionIcon! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:23'!
cancel
	"Cancel and close."

	self entryText: nil.
	^super cancel! !

!TextEditorDialogWindow methodsFor: 'nil' stamp: 'gvc 5/1/2007 11:24'!
defaultFocusMorph
	"Answer the morph that should have the keyboard
	focus by default when the dialog is opened."
	
	^self textEditorMorph textMorph! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:31'!
entryHeight: aNumber
	"Set the height of the text editor morph."

	self textEditorMorph
		vResizing: #rigid;
		height: aNumber! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
entryText
	"Answer the value of entryText"

	^ entryText! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:22'!
entryText: anObject
	"Set the value of entryText"

	entryText := anObject.
	self changed: #entryText.
	self textEditorMorph selectAll! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:23'!
initialize
	"Initialize the receiver."

	super initialize.
	self entryText: ''! !

!TextEditorDialogWindow methodsFor: 'nil' stamp: 'gvc 5/1/2007 11:23'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton. self newCancelButton}! !

!TextEditorDialogWindow methodsFor: 'nil' stamp: 'gvc 8/29/2007 13:32'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self textEditorMorph: self newTextEditorMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self textEditorMorph}! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:25'!
newTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEditorFor: self
		getText: #entryText
		setText: #entryText:
		getEnabled: nil) selectAll! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
textEditorMorph
	"Answer the value of textEditorMorph"

	^ textEditorMorph! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
textEditorMorph: anObject
	"Set the value of textEditorMorph"

	textEditorMorph := anObject! !

TextEditorDialogWindow subclass: #TextEntryDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TextEntryDialogWindow commentStamp: 'gvc 5/18/2007 11:16' prior: 0!
Single-line text entry dialog.!

!TextEntryDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2007 13:52'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true. self newCancelButton}! !

!TextEntryDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:22'!
newTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEntryFor: self
		getText: #entryText
		setText: #entryText:
		getEnabled: nil
		help: nil) selectAll! !

DialogWindow subclass: #ModelDependentDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ModelDependentDialogWindow commentStamp: 'gvc 5/18/2007 12:44' prior: 0!
DialogWindow that updates content based upon its model.!

!ModelDependentDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 15:27'!
addInitialPanel
	"Don't until the model is set."! !

!ModelDependentDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 15:27'!
model: anObject
	"Set the model and add the panel for it."
	
	super model: anObject.
	self paneMorphs copy do: [:p | p delete].
	self addMainPanel! !

ModelDependentDialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'contentMorph buttons applyChangesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableDialogWindow commentStamp: 'gvc 8/8/2007 14:08' prior: 0!
Pluggable form of dialog window supporting custom selector on model for applying changes along with configurable content and buttons.!

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 13:04'!
applyChanges
	"Apply the changes."

	super applyChanges.
	self applyChangesSelector ifNotNilDo: [:s |
		self model perform: s withEnoughArguments: {self}]! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector
	"Answer the value of applyChangesSelector"

	^ applyChangesSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector: anObject
	"Set the value of applyChangesSelector"

	applyChangesSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons
	"Answer the value of buttons"

	^ buttons! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons: anObject
	"Set the value of buttons"

	buttons := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:03'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:02'!
newButtons
	"Answer  the plugged buttons."

	^self buttons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/9/2007 13:36'!
newContentMorph
	"Answer the plugged content."
	
	^self contentMorph! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:05'!
useDefaultOKButton
	"Set the buttons to be just an OK button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton isDefault: true}! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useDefaultOKCancelButton
	"Set the buttons to be a default OK button and a cancel button.
	Only effective before the model is set."
	
	self buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useOKDefaultCancelButton
	"Set the buttons to be an OK button and a default cancel button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton. self newCancelButton isDefault: true}! !

ModelDependentDialogWindow subclass: #PopupChoiceDialogWindow
	instanceVariableNames: 'choice labels lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PopupChoiceDialogWindow commentStamp: 'gvc 5/18/2007 12:26' prior: 0!
Presents a list of options in a popup format. If the list is long it will split into multiple columns. If very long, the columns will be scrollable. Maximum extent of the content area is half the display extent.!

!PopupChoiceDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:54'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^UITheme current smallQuestionIcon! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 13:27'!
activate: evt
	"Backstop."
	! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:45'!
choice
	"Answer the value of choice"

	^ choice! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:45'!
choice: anObject
	"Set the value of choice"

	choice := anObject! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 16:00'!
choose: index
	"Set the given choice and ok."

	self choice: (self model
		ifNil: [index]
		ifNotNil: [self model at: index]).
	self ok! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:23'!
deleteIfPopUp: evt
	"For compatibility with MenuMorph."! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:12'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		labels: #();
		lines: #()! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
labels
	"Answer the value of labels"

	^ labels! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
labels: anObject
	"Set the value of labels"

	labels := anObject! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
lines
	"Answer the value of lines"

	^ lines! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
lines: anObject
	"Set the value of lines"

	lines := anObject! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 16:39'!
newButtons
	"Answer new buttons as appropriate."

	^{self newCancelButton isDefault: true}! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 17:20'!
newChoiceButtonFor: index
	"Answer a new choice button."

	^(ToggleMenuItemMorph new
		contents: (self labels at: index);
		target: self;
		selector: #choose:;
		arguments: {index};
		getStateSelector: nil;
		enablementSelector: nil)
		cornerStyle: #square;
		hResizing: #spaceFill
		! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 16:05'!
newChoicesMorph
	"Answer a column of buttons and separators based on the model."

	|answer morphs str maxLines|
	answer := self newRow
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self labels ifEmpty: [^answer].
	maxLines := Display height - 100 // 2 // (self newChoiceButtonFor: 1) height.
	morphs := OrderedCollection new.
	1 to: self labels size do: [:i |
		morphs add: (self newChoiceButtonFor: i).
		(self lines includes: i) ifTrue: [
			morphs add: self newSeparator]].
	str := morphs readStream.
	[str atEnd] whileFalse: [
		answer
			addMorphBack: (self newMenuWith: (str next: maxLines));
			addMorphBack: self newVerticalSeparator].
	answer removeMorph: answer submorphs last.
	answer submorphs last
		hResizing: #spaceFill.
	^answer! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:55'!
newContentMorph
	"Answer a new content morph."

	|sp choices|
	choices := self newChoicesMorph.
	sp := GeneralScrollPane new
		scrollTarget: choices;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	sp
		minWidth: (choices width min: Display width // 2) + sp scrollbarThickness;
		minHeight: (choices height min: Display height // 2).
	choices width > sp minWidth
		ifTrue: [sp minHeight: sp minHeight + sp scrollbarThickness].
	sp
		updateScrollbars.
	^self newGroupboxFor: sp! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:24'!
newMenuWith: morphs
	"Answer menu with the given morphs."

	^(self newEmbeddedMenu addAllMorphs: morphs)
		borderWidth: 0;
		removeDropShadow;
		color: Color transparent;
		hResizing: #spaceFill;
		cornerStyle: #square;
		stayUp: true;
		beSticky;
		popUpOwner: (MenuItemMorph new privateOwner: self)! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/16/2007 16:10'!
openAsIsIn: aWorld
	"Sad fixup for dodgy layout."

	super openAsIsIn: aWorld.
	self scrollPane fitScrollTarget! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 13:03'!
rootMenu
	"Answer the root menu. Answer self."

	^self! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 16:07'!
scrollPane
	"Answer the scroll pane."

	^self findDeeplyA: GeneralScrollPane! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 10:57'!
basicIsSticky
	"Answer the super isSticky."

	^super isSticky! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:36'!
defaultColor
	"Answer the default color/fill style for the receiver"
	
	^self theme windowColor! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:33'!
defaultLabel
	"Answer the default label for the receiver."

	^'Window' translated! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 11:39'!
delete
	"If fullscreen remove the owner too."
	
	self mustNotClose ifTrue: [^ self].
	self model okToChange ifFalse: [^ self].
	self model okToClose ifFalse: [^self].
	self isFullscreen
		ifTrue: [self owner delete]
		ifFalse: [super delete]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 16:26'!
flash
	"Flash the window."
	
	|fs c w d|
	fs := self fillStyle.
	c := self color alphaMixed: 0.5 with: Color white.
	w := self world.
	d := 0.
	2 timesRepeat: [
		(Delay forDuration: d milliSeconds) wait.
		d := 200.
		self color: c.
		w ifNotNil: [w displayWorldSafely].
		(Delay forDuration: d milliSeconds) wait.
		self fillStyle: fs.
		w ifNotNil: [w displayWorldSafely]]
! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:37'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		setLabel: self defaultLabel;
		setWindowColor: self defaultColor! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:47'!
isFullscreen
	"Answer whether the window should be draw as fullscreen, i.e.
	no title bar or borders."

	^self owner isKindOf: FullscreenMorph! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 10:58'!
isSticky
	"Override here to stop the window being grabbed except via title bar."

	^true! !

!StandardWindow methodsFor: 'layout' stamp: 'gvc 9/14/2006 16:49'!
layoutBounds
	"Bounds of pane area only."
	
	^self isFullscreen
		ifTrue: [self perform: #layoutBounds withArguments: #() inSuperclass: Morph]
		ifFalse: [super layoutBounds]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 19:33'!
makeBorderless
	"Remove the border and border  width offsets.."

	|l b|
	b  := self class borderWidth.
	self submorphsDo: [:m |
		l := m layoutFrame.
		l ifNotNil: [
			l rightFraction = 1 ifTrue: [l rightOffset: l rightOffset + b].
			l leftFraction = 0 ifTrue: [l leftOffset: l leftOffset - b].
			l bottomFraction = 1 ifTrue: [l bottomOffset: l bottomOffset + b]]].
	self borderWidth: 0! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 12:12'!
model: anObject
	"Reset the minimum extent."

	super model: anObject.
	self title: self title! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 6/21/2007 16:07'!
mouseMove: evt
	"Handle a mouse-move event"

	| cp |
	self isFullscreen ifTrue: [^self]. "do nothing if fullscreen"
	cp := evt cursorPoint.
	self valueOfProperty: #clickPoint ifPresentDo: 
		[:firstClick |
		((self labelRect containsPoint: firstClick) and: [(cp dist: firstClick) > 3]) ifTrue:
		["If this is a drag that started in the title bar, then pick me up"
		^self basicIsSticky ifFalse:
			[self fastFramingOn 
				ifTrue: [self doFastFrameDrag: firstClick]
				ifFalse: [evt hand grabMorph: self topRendererOrSelf]]]].
	model windowActiveOnFirstClick ifTrue:
		["Normally window takes control on first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: cp) ifTrue: [m mouseMove: evt]]]! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 8/2/2007 13:47'!
newTextEntryFor: aModel getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil 
		help: helpText! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 13:01'!
noteNewOwner: aMorph 
	"Go fullscreen if needed."

	super noteNewOwner: aMorph.
	(self isFullscreen and: [labelArea owner notNil])
		ifTrue: [labelArea delete.
			self
				removeCornerGrips;
				makeBorderless.
			(self submorphs size = 1 and: [self submorphs first isKindOf: PanelMorph])
					ifTrue: [self submorphs first roundedCorners: #()]]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 12:07'!
open
	"Where else would you want to open it?."

	self openInWorld! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 09:55'!
openAsIsIn: aWorld
	"Sad fixup for dodgy layout."

	super openAsIsIn: aWorld.
	self allMorphs do: [:m | m layoutChanged]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:01'!
openFullscreen
	"Open the receiver in a FullscreenMorph."

	^FullscreenMorph new
		setContentMorph: self;
		openInWorld! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 13:00'!
openedFullscreen
	"Should activate and update the layout."

	self allMorphs do: [:m | m layoutChanged].
	self activate! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 9/29/2006 12:11'!
title
	"Answer tht window title."
	
	^self label! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 8/29/2006 16:53'!
title: aString
	"Set the window title."
	
	self setLabel: aString
	! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 19:20'!
wantsRoundedCorners
	"Check to see if the property is set first."
	
	^self isFullscreen
		ifTrue: [false]
		ifFalse: [^super wantsRoundedCorners]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/16/2006 14:15'!
yellowButtonActivity: shiftState 
	"Do nothing."! !

!SystemWindow class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 16:00'!
labelFor: aWindow
	"Return the of label to use for the given window."
	
	^UITheme current windowLabelFor: aWindow! !

!SystemWindow class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 10:24'!
resetForms
	"Set the box forms to nil so that they will be taken from the current theme.
	Don't touch the expand or menu ones, delegated to theme anyway."

	CloseBoxImage := nil.
	CollapseBoxImage := nil! !

!SystemWindow class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 18:03'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallWindowIcon! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 13:44'!
activate
	"Activate the owner too."

	|mo mc|
	mo := self modalOwner.
	mc := self modalChild.
	mc isNil
		ifFalse: [mc owner notNil ifTrue: [
				mc activate.
				^mc modalChild isNil ifTrue: [mc flash]]].
	(self paneMorphs size > 1 and: [self splitters isEmpty])
		ifTrue: [self addPaneSplitters].
	self basicActivate.
	self rememberedKeyboardFocus
		ifNil: [(self respondsTo: #navigateFocusForward)
				ifTrue: [self navigateFocusForward]]
		ifNotNilDo: [:m | m world
						ifNil: [self rememberKeyboardFocus: nil] "deleted"
						ifNotNilDo: [:w | w activeHand newKeyboardFocus: m]].
	(mo notNil and: [mo isKindOf: SystemWindow])
		ifTrue: [mo bringBehind: self]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme windowActiveFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeLabelFillStyle
	"Return the active label fillStyle for the receiver."
	
	^self theme windowActiveLabelFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeTitleFillStyle
	"Return the active title fillStyle for the receiver."
	
	^self theme windowActiveTitleFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 11:16'!
addCollapseBox
	"If I have a labelArea, add a collapse box to it."
	
	| frame |
	labelArea
		ifNil: [^ self].
	collapseBox := self createCollapseBox.
	frame := LayoutFrame new.
	frame leftFraction: 1;
		 leftOffset: self boxExtent x negated;
		 topFraction: 0;
		 topOffset: 0.
	collapseBox layoutFrame: frame.
	labelArea addMorphBack: collapseBox! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/26/2007 14:16'!
addCornerGrips
	"Should add these to the front!!"
	
	|tl tr lh|
	lh := self labelHeight.
	tl  := TopLeftGripMorph new target: self; position: self position.
	tl layoutFrame topOffset: lh negated.
	tr  := TopRightGripMorph new target: self; position: self position.
	tr layoutFrame topOffset: lh negated.
	self
		addMorph: tl;
		addMorph: tr;
		addMorph: (BottomLeftGripMorph new target: self;position: self position);
		addMorph: (BottomRightGripMorph new target: self;position: self position)! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/15/2007 11:52'!
addMenuControl
	"If I have a label area, add a menu control to it."

	labelArea ifNil: [^ self]. "No menu if no label area"
	menuBox
		ifNotNil: [menuBox delete].
	labelArea addMorphBack: (menuBox _ self createMenuBox)! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/21/2007 17:01'!
addMorph: aMorph fullFrame: aLayoutFrame
	"Add a morph to the receiver with the given layout frame."
	
	| left right bottom top windowBorderWidth |
	windowBorderWidth := self class borderWidth.

	left := aLayoutFrame leftOffset ifNil: [0].
	right := aLayoutFrame rightOffset ifNil: [0].

	bottom := aLayoutFrame bottomOffset ifNil: [0].
	top := aLayoutFrame topOffset ifNil: [0].
	
	aLayoutFrame rightFraction = 1 ifTrue: [aLayoutFrame rightOffset: right - windowBorderWidth].
	aLayoutFrame leftFraction = 0
		ifTrue: [aLayoutFrame leftOffset: left + windowBorderWidth]
		ifFalse: [aLayoutFrame leftFraction = 1 ifFalse: [
					aLayoutFrame leftOffset: left + ProportionalSplitterMorph splitterWidth]].

	aLayoutFrame bottomFraction = 1 ifTrue: [aLayoutFrame bottomOffset: bottom - windowBorderWidth].
	aLayoutFrame topFraction = 0
		ifTrue: [aLayoutFrame topOffset: top]
		ifFalse: [aLayoutFrame topFraction = 1 ifFalse: [
					aLayoutFrame topOffset: top + ProportionalSplitterMorph splitterWidth]].
	
	(aMorph class name = #BrowserCommentTextMorph) ifTrue:
		[aLayoutFrame rightOffset: windowBorderWidth negated.
		aLayoutFrame leftOffset: windowBorderWidth.
		aLayoutFrame bottomOffset: windowBorderWidth negated.
		aLayoutFrame topOffset: (windowBorderWidth negated) + 4].
	
	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs := paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	aMorph adoptPaneColor: self paneColor.
	aMorph
		borderStyle: (BorderStyle inset
						color: self paneColor;
						width: (aMorph borderWidth = 0 ifTrue: [0] ifFalse: [1]));
		color: (aMorph initialColorInSystemWindow: self).
	Preferences scrollBarsOnRight	"reorder panes so flop-out right-side scrollbar is visible"
		ifTrue: [self addMorphBack: aMorph].
		
	self owner ifNotNil: [
		self addPaneSplitters] "do when opened for performance"! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/25/2007 11:10'!
addPaneHSplitterBetween: topMorphs and: bottomMorphs
	"Add a horizontal splitter for the given morphs that share a common bottom fraction.
	If there is a horizontal discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetY fixed rightFraction leftFrame rightFrame sorted morph topGroup bottomGroup splitter offset|
	topMorphs ifEmpty: [^self].
	targetY := topMorphs first layoutFrame bottomFraction.
	fixed := topMorphs select: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((topMorphs reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
		asSortedCollection: [:a :b | a layoutFrame rightFraction = b layoutFrame rightFraction
			ifTrue: [a layoutFrame leftFraction <= b layoutFrame leftFraction]
			ifFalse: [a layoutFrame rightFraction <= b layoutFrame rightFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	topGroup := OrderedCollection new.
	rightFraction := sorted contents first layoutFrame leftFraction.
	[sorted atEnd or: [morph := sorted next.
			(morph layoutFrame leftFraction ~= rightFraction and: [
				morph layoutFrame rightFraction ~= rightFraction])]] whileFalse: [
		topGroup add: morph.
		rightFraction := morph layoutFrame rightFraction].
	leftFrame := topGroup first layoutFrame.
	rightFrame := topGroup last layoutFrame.
	bottomGroup := (bottomMorphs 
			reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
			select: [:m |
		(m layoutFrame leftFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction) or: [
		m layoutFrame rightFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction]].
	offset := (topGroup collect: [:m | m layoutFrame bottomOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new
		beSplitsTopAndBottom.
	splitter layoutFrame: (LayoutFrame
		fractions: (leftFrame leftFraction @ targetY
					corner: rightFrame rightFraction @ targetY)
		offsets: (((leftFrame leftOffset ifNil: [0]) @ 0 corner: ((rightFrame rightOffset ifNil: [0])@ 4))
		 	translateBy: 0 @ offset)).
	topGroup := topGroup, fixed.
	topGroup do: [:m | splitter addLeftOrTop: m].
	bottomGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^topGroup! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 13:44'!
addPaneHSplitters
	"Add the horizontal pane splitters."

	|remaining targetBottom sameBottom sameTop|
	remaining := paneMorphs reject: [:each |
			each layoutFrame bottomFraction = 1 or: [
				each layoutFrame bottomFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetBottom := remaining first layoutFrame bottomFraction.
		sameBottom := remaining select: [:each |
			each layoutFrame bottomFraction = targetBottom].
		sameTop := paneMorphs select: [:each |
			each layoutFrame topFraction = targetBottom].
		remaining := remaining
			copyWithoutAll: (self addPaneHSplitterBetween: sameBottom and: sameTop)]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 14:39'!
addPaneSplitters
	"Add the vertical and horizontal pane splitters."
	
	self removePaneSplitters.
	self addPaneVSplitters.
	self addPaneHSplitters.
	self linkSplittersToSplitters! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/25/2007 11:10'!
addPaneVSplitterBetween: leftMorphs and: rightMorphs
	"Add a vertical splitter for the given morphs that share a common right fraction.
	If there is a vertical discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetX fixed bottomFraction topFrame bottomFrame sorted morph leftGroup rightGroup splitter offset|
	leftMorphs ifEmpty: [^self].
	targetX := leftMorphs first layoutFrame rightFraction.
	fixed := leftMorphs select: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((leftMorphs reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
		asSortedCollection: [:a :b | a layoutFrame bottomFraction = b layoutFrame bottomFraction
			ifTrue: [a layoutFrame topFraction <= b layoutFrame topFraction]
			ifFalse: [a layoutFrame bottomFraction <= b layoutFrame bottomFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	leftGroup := OrderedCollection new.
	bottomFraction := sorted contents first layoutFrame topFraction.
	[sorted atEnd or: [morph := sorted next.
			morph layoutFrame topFraction ~= bottomFraction and: [
				morph layoutFrame bottomFraction ~= bottomFraction]]] whileFalse: [
		leftGroup add: morph.
		bottomFraction := morph layoutFrame bottomFraction].
	topFrame := leftGroup first layoutFrame.
	bottomFrame := leftGroup last layoutFrame.
	rightGroup := (rightMorphs
			reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
			select: [:m |
		m layoutFrame topFraction
			between: topFrame topFraction
			and: bottomFrame bottomFraction].
	offset := (leftGroup collect: [:m | m layoutFrame rightOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new.
	splitter layoutFrame: (LayoutFrame
		fractions: (targetX @ topFrame topFraction
					corner: targetX @ bottomFrame bottomFraction)
		offsets: ((0 @ (topFrame topOffset ifNil: [0]) corner: (4@ (bottomFrame bottomOffset ifNil: [0])))
		 	translateBy: offset @ 0)).
	leftGroup := leftGroup, fixed.
	leftGroup do: [:m | splitter addLeftOrTop: m].
	rightGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^leftGroup! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 17:05'!
addPaneVSplitters
	"Add the vertical pane splitters."

	|remaining targetRight sameRight sameLeft |
	remaining := paneMorphs reject: [:each |
			each layoutFrame rightFraction = 1 or: [
				each layoutFrame rightFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetRight := remaining first layoutFrame rightFraction.
		sameRight := remaining select: [:each |
			each layoutFrame rightFraction = targetRight].
		sameLeft := paneMorphs select: [:each |
			each layoutFrame leftFraction = targetRight and: [
				each layoutFrame rightFraction ~= targetRight]].
		remaining := remaining
			copyWithoutAll: (self addPaneVSplitterBetween: sameRight and: sameLeft)]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/24/2007 17:18'!
animateClose
	"Animate closing."
	
	| smallRect restoredRect rects steps|
	self isMinimized ifTrue: [^self].
	restoredRect := self bounds.
	smallRect := restoredRect scaledAndCenteredIn: (0@0 extent: 20@20).
	smallRect := smallRect align: smallRect center with: restoredRect center.
	steps := Preferences windowAnimationSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		smallRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	World displayWorldSafely.
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 11:21'!
animateMaximize
	"Animate maximizing from restored."
	
	|expandedRect restoredRect rects steps|
	expandedRect := self fullScreenBounds.
	restoredRect := self bounds.
	steps := Preferences windowAnimationSteps.
	rects := (1/steps to: 1 by: 1/steps) collect: [:x |
		restoredRect interpolateTo: expandedRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 11:21'!
animateMinimize
	"Animate minimizing."
	
	|tb buttonRect restoredRect rects steps|
	tb := self worldTaskbar ifNil: [^self].
	buttonRect := ((tb taskButtonOf: self) ifNil: [^self]) bounds.
	restoredRect := self isFlexed
		ifTrue: [(owner transform
					globalPointToLocal: fullFrame topLeft)
					extent: fullFrame extent]
		ifFalse: [fullFrame].
	steps := Preferences windowAnimationSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		buttonRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 15:05'!
animateRectangles: rects doing: aBlock
	"Animate the given rectangles."
	
	|rectMorph|
	rectMorph := RectangleMorph new
		color: Color transparent;
		setProperty: #morphicLayerNumber toValue: 12;
		openInWorld.
	rects withIndexDo: [:r :i |
		rectMorph bounds: r rounded.
		aBlock value: rectMorph value: i.
		World doOneCycle.
		(Delay forMilliseconds: 1) wait].
	rectMorph delete! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 11:21'!
animateRestore
	"Animate restoring from maximised."
	
	|expandedRect restoredRect rects steps|
	expandedRect := self bounds.
	restoredRect := self unexpandedFrame.
	steps := Preferences windowAnimationSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		restoredRect interpolateTo: expandedRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 11:21'!
animateRestoreFromMinimized
	"Animate restoring from minimised."
	
	|tb buttonRect restoredRect rects steps|
	tb := self worldTaskbar ifNil: [^self].
	buttonRect := ((tb taskButtonOf: self) ifNil: [^self]) bounds.
	restoredRect := self isFlexed
		ifTrue: [(owner transform
					globalPointToLocal: fullFrame topLeft)
					extent: fullFrame extent]
		ifFalse: [fullFrame].
	steps := Preferences windowAnimationSteps.
	rects := (1/steps to: 1 by: 1/steps) collect: [:x |
		buttonRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/5/2007 11:35'!
basicActivate
	"Bring me to the front and make me able to respond to mouse and keyboard.
	Was #activate (sw 5/18/2001 23:20)"

	| oldTop outerMorph sketchEditor pal |
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop := TopWindow.
	oldTop = self ifTrue: [^self].
	TopWindow := self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].
	labelArea ifNotNil:
		[labelArea submorphsDo: [:m | m unlock].
		self setStripeColorsFrom: self paneColorToUse].
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor := self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal := self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 11:41'!
basicLabel
	"Answer the actual label morph."

	^label! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 13:58'!
basicTaskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."
	
	^super taskThumbnailOfSize: thumbExtent! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:51'!
bringBehind: aMorph
	"Make the receiver be directly behind the given morph.
	Take into account any modal owner and propagate."

	|outerMorph|
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	outerMorph owner addMorph: outerMorph after: aMorph topRendererOrSelf.
	self modalOwner ifNotNilDo: [:mo | mo bringBehind: self]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/27/2007 10:28'!
buildWindowMenu
	"Build and answer the window menu."
	
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'close' translated action: #closeBoxHit.
	aMenu lastItem icon: self theme windowCloseForm.
	aMenu addLine.
	aMenu add: 'change title...' translated action: #relabel.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	aMenu addLine.
	self isMaximized
		ifTrue: [aMenu add: 'restore' translated action: #expandBoxHit.
				aMenu lastItem icon: self theme windowMaximizeForm]
		ifFalse: [aMenu add: 'maximize' translated action: #expandBoxHit.
				aMenu lastItem icon: self theme windowMaximizeForm].
	self isCollapsed ifFalse: [aMenu add: 'window color...' translated action: #setWindowColor].
	^aMenu! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/27/2007 11:00'!
closeBoxHit
	"The user clicked on the close-box control in the window title.
	For Mac users only, the Mac convention of option-click-on-close-box is obeyed if the mac option key is down.
	Play the close sound now since this is the only time we know that the close is user-initiated."

	Preferences useThemeSounds ifTrue: [self playCloseSound].
	Preferences dismissAllOnOptionClose ifTrue:
		[Sensor rawMacOptionKeyPressed ifTrue:
			[^ self world closeUnchangedWindows]].
	self delete
! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:03'!
collapseBoxHit
	"The user has clicked on the collapse box.
	Collapse or expand the receiver as appropriate."
	
	Preferences useThemeSounds ifTrue: [
		isCollapsed
			ifTrue: [self playRestoreUpSound]
			ifFalse: [self playMinimizeSound]].
	self collapseOrExpand! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/18/2007 10:36'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state.
	Use the taskbar if present, otherwise do as normal."
	
	| cf |
	self isTaskbarPresent ifTrue: [^self minimizeOrRestore].
	isCollapsed
		ifTrue: 
			["Expand -- restore panes to morphics structure"
			isCollapsed := false.
			self activate.  "Bring to frint first"
			Preferences collapseWindowsInPlace
				ifTrue: 
					[fullFrame := fullFrame align: fullFrame topLeft with: self getBoundsWithFlex topLeft]
				ifFalse:
					[collapsedFrame := self getBoundsWithFlex].
			collapseBox ifNotNil: [collapseBox setBalloonText: 'collapse this window'].
			self setBoundsWithFlex: fullFrame.
			paneMorphs reverseDo: 
					[:m |  self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m].
			self
				addPaneSplitters;
				addCornerGrips]
		ifFalse: 
			["Collapse -- remove panes from morphics structure"
			isCollapsed := true.
			fullFrame := self getBoundsWithFlex.
			"First save latest fullFrame"
			paneMorphs do: [:m | m delete; releaseCachedState].
			self removePaneSplitters.
			self removeCornerGrips.
			model modelSleep.
			cf := self getCollapsedFrame.
			(collapsedFrame isNil and: [Preferences collapseWindowsInPlace not]) ifTrue:
				[collapsedFrame := cf].
			self setBoundsWithFlex: cf.
			collapseBox ifNotNil: [collapseBox setBalloonText: 'expand this window'].
			expandBox ifNotNil: [expandBox setBalloonText: 'expand to full screen']].
	self layoutChanged! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/24/2007 10:19'!
createCloseBox
	"Answer a button for closing the window.
	Get the image from the theme."
	
	^self createBox
		labelGraphic: self theme windowCloseForm;
		extent: self boxExtent;
		actionSelector: #closeBoxHit;
		setBalloonText: 'close this window' translated! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/27/2007 10:00'!
createCollapseBox
	"Answer a button for minimising the window.
	Get the image from the theme."
	
	^self createBox
		labelGraphic: self theme windowMinimizeForm;
		extent: self boxExtent;
		actionSelector: #collapseBoxHit;
		setBalloonText: 'collapse this window' translated! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/24/2007 11:18'!
createExpandBox
	"Answer a button for maximising/restoring the window.
	Get the image from the theme."
	
	^self createBox
		labelGraphic: self theme windowMaximizeForm;
		extent: self boxExtent;
		actionSelector: #expandBoxHit;
		setBalloonText: 'expand to full screen' translated! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 12:25'!
createMenuBox
	"Answer a button for the window menu.
	Get the image from the theme."
	
	^self createBox
		labelGraphic: (self theme windowMenuIconFor: self);
		extent: self boxExtent;
		actWhen: #buttonDown;
		actionSelector: #offerWindowMenu;
		setBalloonText: 'window menu' translated! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 13:31'!
defaultBackgroundColor
	"Answer the color to be used as the base window color."
	
	^self theme
		windowColorFor: (self model ifNil: [self])! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/21/2007 17:01'!
delete
	"Should activate window before asking model if okToChange
	since likely that a confirmation dialog will be requested."
	
	| thisWorld sketchEditor aPaintBox animateClose|
	self mustNotClose ifTrue: [^ self].
	self activate.
	model okToChange ifFalse: [^ self].
	animateClose := (self visible and: [self world notNil and: [
		Preferences windowAnimation and: [
		Preferences noWindowAnimationForClosing not]]]).
	self removePaneSplitters. "in case we add some panes and reopen!!"
	thisWorld := self world.
	sketchEditor := self extantSketchEditor.
	self isFlexed
		ifTrue: [owner delete]
		ifFalse: [super delete].
	model windowIsClosing; release.
	model := nil.
	animateClose ifTrue: [self animateClose].
	sketchEditor ifNotNil:
		[sketchEditor deleteSelfAndSubordinates.
		thisWorld notNil ifTrue:
			[(aPaintBox := thisWorld paintBoxOrNil) ifNotNil: [aPaintBox delete]]].
		
	SystemWindow noteTopWindowIn: thisWorld.
! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 14:19'!
drawDropShadowOn: aCanvas
	"Speeded up version!!"
	
	aCanvas 
		translateBy: self shadowOffset 
		during: [ :shadowCanvas |
			shadowCanvas shadowColor: self shadowColor.
			shadowCanvas roundCornersOf: self during: [
				shadowCanvas
					fillRectangle: (self bounds bottomLeft - (0 @ self shadowOffset y)
						corner: self bounds bottomRight  - (self shadowOffset x + 6 @ 0))
					fillStyle: self shadowColor;
					fillRectangle: (self bounds topRight - (self shadowOffset x @ 0)
						corner: self bounds bottomRight - (0 @ (self shadowOffset y + 6)))
					fillStyle: self shadowColor;
					fillRectangle: (self bounds bottomRight - (self shadowOffset + 6)
						corner: self bounds bottomRight)
					fillStyle: self shadowColor]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/27/2007 09:58'!
expandBoxHit
	"The full screen expand box has been hit"

	isCollapsed
		ifTrue: [self hide.
			self collapseOrExpand.
			self unexpandedFrame ifNil: [ self unexpandedFrame: fullFrame. ].
			self fullScreen.
			expandBox setBalloonText: 'contract to original size' translated.
			^ self show].
	self unexpandedFrame
		ifNil: [Preferences useThemeSounds ifTrue: [self playMaximizeSound].
			Preferences windowAnimation ifTrue: [self animateMaximize].
			self unexpandedFrame: fullFrame.
			self fullScreen.
			expandBox setBalloonText: 'contract to original size' translated]
		ifNotNil: [Preferences useThemeSounds ifTrue: [self playRestoreDownSound].
			Preferences windowAnimation ifTrue: [self animateRestore].
			self bounds: self unexpandedFrame.
			self unexpandedFrame: nil.
			expandBox setBalloonText: 'expand to full screen' translated]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/23/2007 11:13'!
extent: aPoint 
	"Set the receiver's extent to value provided. Respect my minimumExtent."

	| newExtent |
	newExtent := self isCollapsed
		ifTrue: [aPoint max: (self labelWidgetAllowance @ 0)]
		ifFalse: [aPoint max: self minimumExtent].
	newExtent = self extent ifTrue: [^ self].

	isCollapsed
		ifTrue: [super extent: newExtent x @ self labelHeight]
		ifFalse: [super extent: newExtent].
	isCollapsed
		ifTrue: [collapsedFrame := self bounds]
		ifFalse: [fullFrame := self bounds]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/7/2007 13:26'!
fastAnimateRectangles: rects
	"Animate the given rectangles using the fast method."
	
	|delay col merged|
	rects ifEmpty: [^self].
	delay := Delay forMilliseconds: (Preferences windowAnimationDelay).
	col := Color gray alpha: 0.5.
	merged := rects first.
	rects withIndexDo: [:r :i |
		Display
			border: r rounded
			width: 1
			rule: Form blend
			fillColor: col.
		merged := merged merge: r.
		delay wait].
	merged := merged expandBy: 1.
	World invalidRect: merged from: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:43'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isActive 
		ifTrue: [self activeFillStyle] 
		ifFalse: [self inactiveFillStyle]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 16:41'!
fullScreenBounds
	"Answer the bounds that the receiver would tak if expanded to full screen."
	
	| left right possibleBounds |
	left := right := 0.
	self paneMorphs
		do: [:pane | ((pane isKindOf: ScrollPane)
					and: [pane retractableScrollBar])
				ifTrue: [pane scrollBarOnLeft
						ifTrue: [left := left max: pane scrollBarThickness]
						ifFalse: [right := right max: pane scrollBarThickness]]].
	possibleBounds := (RealEstateAgent maximumUsableAreaInWorld: self world)
				insetBy: (left @ 0 corner: right @ 0).
	((Flaps sharedFlapsAllowed
				and: [Project current flapsSuppressed not])
			or: [Preferences fullScreenLeavesDeskMargins])
		ifTrue: [possibleBounds := possibleBounds insetBy: 22].
	^possibleBounds! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/16/2007 11:32'!
getRawLabel
	"Owner is needed by Preferences class>>refreshFontSettings and
	the #duplicate class is rather time consuming with Freetype fonts.
	Answer a shallowCopy of the label with the contents fitted."
	
	|contentsFit|
	contentsFit := label shallowCopy fitContents.
	contentsFit extent: (label extent x min: contentsFit extent x) @ contentsFit extent y.
	^contentsFit! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 14:54'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	
	(super handlesKeyboard: evt) ifTrue: [^true].
	^evt anyModifierKeyPressed
	! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasCloseBox
	"Answer whether the receiver currently has a close box."

	^closeBox notNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasCollapseBox
	"Answer whether the receiver currently has a collapse box."

	^collapseBox notNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasExpandBox
	"Answer whether the receiver currently has an expand box."

	^expandBox notNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasMenuBox
	"Answer whether the receiver currently has a menu box."

	^menuBox notNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:58'!
inactiveFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme windowInactiveFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:59'!
inactiveLabelFillStyle
	"Return the inactive label fillStyle for the receiver."
	
	^self theme windowInactiveLabelFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:59'!
inactiveTitleFillStyle
	"Return the inactive title fillStyle for the receiver."
	
	^self theme windowInactiveTitleFillStyleFor: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/15/2007 17:27'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	
	super initialize.
	allowReframeHandles := true.
	labelString ifNil: [labelString := 'Untitled Window'].
	isCollapsed := false.
	activeOnlyOnTop := true.
	paneMorphs := Array new.
	borderColor := Color lightGray.
	borderWidth := 1.
	self color: Color lightGray lighter lighter lighter.
	self layoutPolicy: ProportionalLayout new.
	self clipSubmorphs: true.
	
	self initializeLabelArea.

	self cellPositioning: #topLeft. "make the offsets easy to calculate!!"
	self addCornerGrips.
	
	self extent: 300 @ 200.
	mustNotClose := false.
	updatablePanes := Array new.
		
	Preferences menuAppearance3d
		ifTrue: [
			self
				addDropShadow;
				shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.333);
				shadowOffset: 1@1]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:44'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."
	
	label := self class labelFor: self.
	"Add default inital boxes"
	collapseBox := self createCollapseBox. "Add collapse box so #labelHeight will work"
	closeBox := self createCloseBox.
	self wantsExpandBox ifTrue: [expandBox := self createExpandBox].
	menuBox := self createMenuBox.
	stripes := Array
						with: (RectangleMorph newBounds: bounds)
						with: (RectangleMorph newBounds: bounds).
	self addLabelArea.
	labelArea
		goBehind;
		maxCellSize: self boxExtent.
	self replaceBoxes.
	Preferences clickOnLabelToEdit
		ifTrue: [label
					on: #mouseDown
					send: #relabel
					to: self].
	labelArea fillStyle: self activeTitleFillStyle.! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 2/19/2007 15:34'!
isActive
	"Answer active if no owner too to avoid color flickering."
	
	self owner ifNil: [^true].
	self activeOnlyOnTop ifTrue: [^ self == TopWindow].
	^ true! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 10:59'!
isMaximized
	"Answer whether we are maximised."

	^self unexpandedFrame notNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isMinimized
	"Answer whether we are minimised."

	^self isCollapsed! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isNotMaximized
	"Answer whether we are not maximised."

	^self unexpandedFrame isNil! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isNotMinimized
	"Answer whether we are not minimised."

	^self isCollapsed not! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:00'!
isNotRestored
	"Answer whether we are maximised or minimised."

	^self isMinimized or: [self isMaximized]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:03'!
isRestored
	"Answer whether we are neither expanded or collapsed."

	^(self isMinimized or: [self isMaximized]) not! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:47'!
isTaskbarPresent
	"Answer whether there is a taskbar in the world."

	^TaskbarMorph isTaskbarPresent! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/17/2006 10:26'!
justDroppedInto: aMorph event: anEvent
	"Release the mouse focus as well."
	
	isCollapsed
		ifTrue: [self position: ((self position max: 0@0) grid: 8@8).
				collapsedFrame := self bounds]
		ifFalse: [fullFrame := self bounds.
				TopWindow ~~ self ifTrue: [self activate]].
	anEvent hand releaseMouseFocus.
	^super justDroppedInto: aMorph event: anEvent! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 13:17'!
keyStroke: evt
	"Check for close window."

	super keyStroke: evt.
	(self navigationKey: evt) ifTrue: [^true].
	(evt anyModifierKeyPressed and: [
			evt keyCharacter = Character delete])  ifTrue: [
		self delete].
	^false! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/14/2007 12:57'!
labelArea
	"Answer the label area."

	^labelArea! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/11/2007 15:13'!
labelString
	"Answer the actual label string."

	^label isNil
		ifTrue: [labelString]
		ifFalse: [label contents asString]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 11/17/2006 09:53'!
layoutChanged
	"No need to propagate to the world."

	(self owner isNil or: [self owner isWorldMorph not])
		ifTrue: [^super layoutChanged].
	fullBounds ifNil: [^self]. "layout will be recomputed so don't bother"
	fullBounds := nil.
	self layoutPolicy ifNotNilDo: [:layout | layout flushLayoutCache]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/14/2007 14:45'!
linkSplittersToSplitters
	"The pane morphs are already linked. Cross link the splitters as appropriate."
	
	self splitters do: [:each |
		each splitsTopAndBottom
			ifTrue: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame bottomFraction = each layoutFrame topFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame topFraction = each layoutFrame bottomFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]
			ifFalse: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame rightFraction = each layoutFrame leftFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame leftFraction = each layoutFrame rightFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 11:02'!
maximize
	"Maximise the receiver. If collapsed the uncollapse first."

	self isMinimized ifTrue: [self collapseOrExpand].
	self isMaximized ifFalse: [self expandBoxHit]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/15/2007 12:26'!
menuBox
	"Answer the receiver's menu box."

	^menuBox! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:38'!
minimize
	"Minimise the receiver."

	self isMinimized ifFalse: [self collapseBoxHit]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 14:09'!
minimizeAfterGeneratingThumbnail
	"Minimize the window after thumbnail generation."
	
	self isMinimized ifTrue: [^self].
	isCollapsed := true.
	paneMorphs
		do: [:m | m delete; releaseCachedState].
	self setBoundsWithFlex: (-10@-10 extent: 2@2).
	self hide.
	self layoutChanged
	! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 09:59'!
minimizeOrRestore
	"Collapse or expand the window, depending on existing state"
	
	isCollapsed
		ifTrue: ["Expand -- restore panes to morphics structure"
			Preferences windowAnimation ifTrue: [self animateRestoreFromMinimized].
			isCollapsed := false.
			"Bring to front first"
			self setBoundsWithFlex: fullFrame.
			self show.
			self activate.
			paneMorphs
				reverseDo: [:m | 
					self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m]]
		ifFalse: ["Collapse -- remove panes from morphics structure"
			isCollapsed := true.
			fullFrame := self getBoundsWithFlex.
			"First save latest fullFrame"
			paneMorphs
				do: [:m | m delete; releaseCachedState].
			model modelSleep.
			self setBoundsWithFlex: (-10@-10 extent: 2@2).
			self hide.
			Preferences windowAnimation ifTrue: [self animateMinimize]].
	self layoutChanged! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:24'!
modalChild
	"Answer the modal child of the receiver, if any."

	^self valueOfProperty: #modalChild! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:27'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	aSystemWindow
		setProperty: #modalOwner toValue: self.
	self setProperty: #modalChild toValue: aSystemWindow! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:24'!
modalOwner
	"Answer the modal owner of the receiver, if any."

	^self valueOfProperty: #modalOwner! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:26'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	aSystemWindow removeProperty: #modalOwner.
	self removeProperty: #modalChild.
	self activate! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 15:59'!
model: anObject
	"Set the model."
	
	super model: anObject.
	self paneColorTracksModel ifTrue: [
		self
			setProperty: #paneColor toValue: self defaultBackgroundColor;
			fillStyle: self fillStyleToUse;
			setStripeColorsFrom: self paneColorToUse].
	self minimumExtent: (
		(anObject respondsTo: #minimumExtent)
			ifTrue: [anObject minimumExtent]).
	menuBox ifNotNil: [
		menuBox
			labelGraphic: (self theme windowMenuIconFor: self);
			extent: self boxExtent]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 13:30'!
mouseDown: evt
	"Changed to properly process the mouse down event if pasing to
	submorphs."
	
	(self valueOfProperty: #processingMouseDown) == true
		ifTrue: [^self]. "recursive handling"
	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse:
		[TopWindow ifNotNilDo: [:w |
			w rememberKeyboardFocus: evt hand keyboardFocus].
		evt hand releaseKeyboardFocus.
		self activate].
	model windowActiveOnFirstClick ifTrue:
		["Normally window keeps control of first click.
		Need explicit transmission for first-click activity."
		self setProperty: #processingMouseDown toValue: true.
		[evt wasHandled: false.
		self processEvent: evt]
			ensure: [self setProperty: #processingMouseDown toValue: false]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/18/2007 10:57'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Check for menu key to do popup.
	Check for active window naviagation."
	
	(self world navigationKey: event) ifTrue: [^true].
	(self tabKey: event) ifTrue: [^true].
	(event keyCharacter = Character escape and: [
			event anyModifierKeyPressed]) ifTrue: [
		self yellowButtonActivity: false.
		^true].
	^false! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:11'!
nextMorphAcrossInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its next sibling or owner's next sibling etc."

	^self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:05'!
nextMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its first pane."

	^self hasSubmorphs
		ifTrue: [self submorphs first]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/14/2006 17:05'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Set the pane color to match the receiver.
	Answer the system window."
	
	aSystemWindow
		setWindowColor: self paneColor.
	^super openModal: aSystemWindow! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 13:53'!
paneColor
	| cc |
	(cc := self valueOfProperty: #paneColor) ifNotNil: [
		^Preferences fadedBackgroundWindows
			ifTrue: [self isActive
					ifTrue: [cc]
					ifFalse: [cc alphaMixed: 0.5 with: (Color white alpha: cc alpha)]]
			ifFalse: [cc]].
	cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color].
	cc ifNil: [cc := self defaultBackgroundColor].
	cc isTransparent ifTrue: [cc := self defaultBackgroundColor].
	self setProperty: #paneColor toValue: cc.
	^self paneColor! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/29/2006 16:21'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^self paneColor! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/25/2006 13:44'!
paneColorTracksModel
	"Answer true if the colour of the window should be taken from the model."
	
	^true! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 11:01'!
playCloseSound
	"Play the themed sound for closing."
	
	self theme windowCloseSound play! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playMaximizeSound
	"Play the themed sound for maximizing."
	
	self theme windowMaximizeSound play! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playMinimizeSound
	"Play the themed sound for maximizing."
	
	self theme windowMinimizeSound play! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playRestoreDownSound
	"Play the themed sound for restoring from maximized."
	
	self theme windowRestoreDownSound play! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:05'!
playRestoreUpSound
	"Play the themed sound for restoring from minimized."
	
	self theme windowRestoreUpSound play! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:06'!
previousMorphInWindow
	"Answer the previous morph in the window. This will be the
	last submorph recursively of the first pane morph."

	^self hasSubmorphs
		ifTrue: [self lastSubmorphRecursive]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/4/2007 13:35'!
rememberKeyboardFocus: aMorph
	"Record the current keyboard focus for the receiver."
	
	|m|
	m :=aMorph.
	(m notNil and: [(m hasOwner: self) not])
		ifTrue: [m := nil].
	self setProperty: #rememberedFocus toValue: m! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/4/2007 13:42'!
rememberedKeyboardFocus
	"Answer the remembered keyboard focus for the receiver."
	
	^self valueOfProperty: #rememberedFocus! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/25/2007 16:33'!
removeBoxes
	"Remove all label area boxes."

	closeBox ifNotNil: [closeBox delete. closeBox := nil].
	menuBox ifNotNil: [menuBox delete. menuBox := nil].
	expandBox ifNotNil: [expandBox delete. expandBox := nil].
	collapseBox ifNotNil: [collapseBox delete. collapseBox := nil]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 15:59'!
replaceBoxes
	"Rebuild the various boxes."
	
	labelArea removeAllMorphs.
	self setLabelWidgetAllowance.
	self theme configureWindowLabelAreaFor: self.
	self setFramesForLabelArea.
	Preferences noviceMode
		ifFalse: [closeBox ifNotNil: [closeBox setBalloonText: nil].
				menuBox ifNotNil: [menuBox setBalloonText: nil].
				collapseBox ifNotNil: [collapseBox setBalloonText: nil].
				expandBox ifNotNil: [expandBox setBalloonText: nil]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/27/2007 10:36'!
restore
	"Restore the receiver's normal size."

	self isMinimized
		ifTrue: [self collapseBoxHit]
		ifFalse: [self isMaximized ifTrue: [self expandBoxHit]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/23/2007 14:50'!
restoreAndActivate
	"Restore the window if minimised then activate."

	self isMinimized
		ifTrue: [self restore].
	self isActive
		ifFalse: [self activate]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 13:43'!
restoreBeforeGeneratingThumbnail
	"Restore the window without activating unlocking or stepping."
	
	self isMinimized ifFalse: [^self].
	isCollapsed := false.
	self show.
	self setBoundsWithFlex: fullFrame.
	paneMorphs reverseDo: [:m | 
		self addMorph: m].
	self layoutChanged! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/2/2007 11:41'!
setFramesForLabelArea
	"Set the layout for the label area."
	
	| frame windowBorderWidth |
	labelArea ifNil: [^ self].	
	windowBorderWidth := self class borderWidth.
	labelArea
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		wrapCentering: #topLeft;
		layoutInset: (0@windowBorderWidth corner: 0@1).
	label hResizing: #spaceFill.
	frame := LayoutFrame
		fractions: (0@0 corner: 1@0)
		offsets: (windowBorderWidth @ (self labelHeight negated)
					corner: windowBorderWidth negated @ 0).
	labelArea layoutFrame: frame! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/18/2007 14:33'!
setStripeColorsFrom: paneColor 
	"Set the stripe color based on the given paneColor."

	self updateBoxesColor: (self isActive 
				ifTrue: [paneColor]
				ifFalse: [paneColor muchDarker]).
	stripes ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self isActive 
		ifTrue: [label ifNotNil: [label color: self activeLabelFillStyle].
				labelArea fillStyle: self activeTitleFillStyle] 
		ifFalse: [label ifNotNil: [label color: self inactiveLabelFillStyle].
				labelArea fillStyle: self inactiveTitleFillStyle].
	self adoptPaneColor: self paneColor! !

!SystemWindow methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/13/2007 13:16'!
setWindowColor: incomingColor
	"Removed existing color check - looked useless!!"
	
	| aColor |
	incomingColor ifNil: [^ self].  "it happens"
	aColor := incomingColor.
	(aColor = ColorPickerMorph perniciousBorderColor 
		or: [aColor = Color black]) ifTrue: [^ self].
	self setProperty: #paneColor toValue: aColor.
	self setStripeColorsFrom: aColor.
	self changed.! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 13:58'!
taskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."
	
	|min thumb|
	min := self isMinimized
		ifTrue: [self restoreBeforeGeneratingThumbnail.
				true]
		ifFalse: [false].
	thumb := self basicTaskThumbnailOfSize: thumbExtent.
	min ifTrue: [self minimizeAfterGeneratingThumbnail].
	^thumb! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/16/2007 12:30'!
taskbarButtonClicked
	"The taskbar button for the receiver has been clicked.
	If minimised then restore.
	If active then minimize.
	Otherwise make active."

	self isMinimized
		ifTrue: [self restore]
		ifFalse: [self isActive
					ifTrue: [self minimize]
					ifFalse: [self activate]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:01'!
taskbarButtonEntered: aButton event: evt in: aMorph
	"The mouse has entered out taskbar button.
	Show a thumbnail."

	|thumb|
	Preferences worldTaskbarWindowPreview ifFalse: [^self].
	thumb := self valueOfProperty: #taskbarThumbnail.
	thumb
		ifNil: [thumb := self theme newTaskbarThumbnailIn: self for: self]
		ifNotNil: [^self].
	self setProperty: #taskbarThumbnail toValue: thumb.
	thumb bottomLeft: ((aButton left min: aButton owner right - thumb width)@ (aButton owner top - 4)).
	thumb openInWorld! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:01'!
taskbarButtonFor: aTaskbar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^self theme
		newTaskbarButtonIn: aTaskbar
		for: self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 10:13'!
taskbarButtonLeft: aButton event: evt in: aMorph
	"The mouse has left our taskbar button.
	Remove our thumbnail."

	Preferences worldTaskbarWindowPreview ifFalse: [^self].
	self
		valueOfProperty: #taskbarThumbnail
		ifPresentDo: [:thumb |
			thumb delete.
			self removeProperty: #taskbarThumbnail]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/15/2007 12:46'!
taskbarButtonMenu: aMenu
	"Answer the menu for the task bar button."

	| menu theme |
	theme :=  self theme.
	menu := theme newMenuIn: self for: self.
	menu
		addToggle: 'Restore' translated
		target: self
		selector: #restore
		getStateSelector: nil
		enablementSelector: #isNotRestored.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Minimize' translated
		target: self
		selector: #minimize
		getStateSelector: nil
		enablementSelector: #isNotMinimized.
	menu lastItem
		icon: self theme windowMinimizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Maximize' translated
		target: self
		selector: #maximize
		getStateSelector: nil
		enablementSelector: #isNotMaximized.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu addLine.
	menu
		addToggle: 'Close' translated
		target: self
		selector: #delete
		getStateSelector: nil
		enablementSelector: nil.
	menu lastItem
		icon: self theme windowCloseForm;
		font: theme menuFont.
	^menu! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:42'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	self model ifNotNil: [self model taskbarIcon ifNotNilDo: [:ico | ^ico]].
	^super taskbarIcon! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 13:08'!
taskbarState
	"Answer one of #minimized, #restored, #maximized or #active."

	^self isMinimized
		ifTrue: [#minimized]
		ifFalse: [self isMaximized
			ifTrue: [#maximized]
			ifFalse: [self isActive
						ifTrue: [#active]
						ifFalse: [#restored]]]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/25/2007 10:54'!
taskbarTask
	"Answer a new taskbar task for the receiver.
	Answer nil if not required."

	^TaskbarTask
		morph: self
		state: self taskbarState
		icon: self taskbarIcon
		label: (self labelString truncateWithElipsisTo: 30)! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/11/2007 15:06'!
taskbarThumbnailExtent
	"Answer the size of a taskbar thumbnail for the receiver."

	^self isMinimized
		ifTrue: [self fullFrame extent min: self defaultTaskbarThumbnailExtent]
		ifFalse: [super taskbarThumbnailExtent]! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:51'!
theme
	"Answer the ui theme that provides controls.
	Don't call super since that implementation may delegate here."

	(self valueOfProperty: #theme) ifNotNilDo: [:t | ^ t].
	^self class theme! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/9/2007 16:50'!
themeChanged
	"Update the window colour and control boxes."

	self labelArea delete.
	self removeCornerGrips.
	self
		paneColor: self defaultBackgroundColor;
		initializeLabelArea;
		setStripeColorsFrom: self paneColor;
		addCornerGrips.
	super themeChanged! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 10:08'!
window
	"Answer the receiver's window."

	^self! !

!SystemWindow methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 13:16'!
worldTaskbar
	"Answer the world taskbar or nil if none."

	^TaskbarMorph worldTaskbar! !

!PluggableListMorphOfMany methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/16/2006 13:23'!
mouseDown: event
	"Grab keyboard focus and set mouseDownRow."
	
	| oldIndex oldVal row |
	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].
	event hand newKeyboardFocus: self.
	row := self rowAtLocation: event position.
	row = 0 ifTrue: [^super mouseDown: event].
	self mouseDownRow: row.

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff := (self listSelectionAt: row) not.
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.
	"event hand releaseMouseFocus: aMorph."
	"aMorph changed"! !

!PluggableListMorphOfMany methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/16/2006 13:29'!
mouseUp: event
	"Reset the mouseDownRow."
	
	dragOnOrOff := nil.  "So improperly started drags will have not effect".
	event hand hasSubmorphs ifFalse: [
		self mouseDownRow: nil]! !

!InsetBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:41'!
bottomRightColor
	"Changed from direct access to color since, if nil,
	self color is transparent."
	
	^width = 1 
		ifTrue: [self color twiceLighter]
		ifFalse: [self color lighter]! !

!InsetBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:41'!
topLeftColor
	"Changed from direct access to color since, if nil,
	self color is transparent."
	
	^width = 1 
		ifTrue: [self color twiceDarker]
		ifFalse: [self color darker]! !

!LayoutFrame methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/24/2007 15:51'!
minExtentFrom: minExtent
	"Return the minimal extent the given bounds can be represented in."
	
	|width height widthProp heightProp leftO rightO topO bottomO|
	leftO := leftOffset ifNil: [0].
	rightO := rightOffset ifNil: [0].
	topO := topOffset ifNil: [0].
	bottomO := bottomOffset ifNil: [0].
	"calculate proportional area. bottom/right offsets extend in +ve direction."
	width := minExtent x + leftO - rightO.
	height := minExtent y + topO - bottomO.
	"calculate the effective proportion"
	widthProp := (rightFraction ifNil: [1.0]) - (leftFraction ifNil: [0]).
	heightProp := (bottomFraction ifNil: [1.0]) - (topFraction ifNil: [0]).
	"if the proportions are 0 then the minima cannot be determined and
	minExtent cannot be respected."
	width := widthProp = 0
		ifTrue: [0]
		ifFalse: [width / widthProp].
	height := heightProp = 0
		ifTrue: [0]
		ifFalse: [height / heightProp].
	^width truncated @ height truncated! !

!MessageNames class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallFindIcon! !

MenuMorph subclass: #EmbeddedMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!EmbeddedMenuMorph commentStamp: 'gvc 5/18/2007 13:18' prior: 0!
Menu designed to be embedded in another morph rather than popped up directly.!

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:17'!
drawOn: aCanvas
	"Draw the receiver on the canvas."

	self perform: #drawOn: withArguments: {aCanvas} inSuperclass: Morph.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:22'!
handlesKeyboard: evt
	"Answer whether the receiver handles the keystroke represented by the event"

	^true! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:23'!
keyStroke: evt
	"Handle tabbing and arrows and cr/space."
	
	|char selectable|
	(self navigationKey: evt) ifTrue: [^self].
	char := evt keyCharacter.
	char = Character space 
		ifTrue: 
			[selectedItem ifNotNil: 
					[selectedItem hasSubMenu 
						ifTrue: 
							[evt hand newMouseFocus: selectedItem subMenu.
							^evt hand newKeyboardFocus: selectedItem subMenu]
						ifFalse: 
							[^selectedItem invokeWithEvent: evt]].
			(selectable := self items) size = 1 
				ifTrue: [^selectable first invokeWithEvent: evt].
			^self].
	(char = Character arrowLeft or: [char = Character arrowRight]) ifTrue: [
		(selectedItem notNil and: [selectedItem hasSubMenu]) ifTrue: [
			evt hand newMouseFocus: selectedItem subMenu.
			selectedItem subMenu moveSelectionDown: 1 event: evt.
			^evt hand newKeyboardFocus: selectedItem subMenu]].
	char = Character arrowUp ifTrue: [^self moveSelectionDown: -1 event: evt].	"up arrow key"
	char = Character arrowDown ifTrue: [^self moveSelectionDown: 1 event: evt].	"down arrow key"
	char = Character pageUp ifTrue: [^self moveSelectionDown: -5 event: evt].	"page up key"
	char = Character pageDown ifTrue: [^self moveSelectionDown: 5 event: evt].	"page down key"
! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/12/2006 15:32'!
addToggle: aString target: anObject selector: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: nil
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/9/2006 09:25'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/9/2006 09:39'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		enablementSelector: nil
		argumentList: argList! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/9/2006 09:45'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol enablementSelector: enableSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		enablementSelector: enableSymbol
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/9/2006 09:39'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol enablementSelector: enableSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	|item|
	item := ToggleMenuItemMorph new
		contents: aString;
		target: anObject;
		selector: aSymbol;
		arguments: argList asArray;
		getStateSelector: stateSymbol;
		enablementSelector: enableSymbol.
	self addMorphBack: item.
! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/29/2007 16:28'!
adoptPaneColor: paneColor
	"Change our color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: paneColor! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 14:28'!
color: aColor
	"Set the receiver's color. Remember the base color in the case of a gradient background."

	super color: aColor.
	self setProperty: #basicColor toValue: aColor! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 12:59'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!MenuMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:47'!
themeChanged
	"Update the colour if specified."

	self theme menuColor
		ifNotNilDo: [:c | self color: c].
	super themeChanged! !

!MenuMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/29/2007 15:49'!
updateColor
	"Update the color of the menu."
	
	| fill title bc |
	Preferences gradientMenu
		ifFalse: [^ self].
	bc _ self valueOfProperty: #basicColor ifAbsent: [Preferences menuColor].
	fill := GradientFillStyle
		ramp: {0.0 -> (bc alphaMixed: 0.2 with: Color white). 1.0 -> bc}.
	fill
		radial: false;
		origin: self topLeft;
		direction: 0 @ self height.
	self fillStyle: fill.
	"update the title color"
	title := self allMorphs
				detect: [:each | each hasProperty: #titleString]
				ifNone: [^ self].
	fill := GradientFillStyle ramp: {0.0 -> title color twiceLighter. 1 -> title color twiceDarker}.
	fill
		origin: title topLeft;
		direction: title width @ 0.
	title fillStyle: fill! !

LayoutPolicy subclass: #RowLayout
	instanceVariableNames: 'cachedMinExtent cachedMinExtents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!RowLayout commentStamp: 'gvc 5/31/2007 16:12' prior: 0!
A simple row layout.!

!RowLayout methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 17:20'!
flushLayoutCache
	"Flush any cached information associated with the receiver."
	
	cachedMinExtent := nil! !

!RowLayout methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 11:51'!
layout: aMorph in: layoutBounds
	"Compute the layout for the given morph based on the new bounds.
	Supports submorph hResizing, vResizing, cellInset, cellPositioning
	(top, *center, bottom*) and listCentering."

	|props spare fillCount extra x width height inset cell box pos vr newBounds minExt|
	aMorph submorphs ifEmpty: [^self].
	props := aMorph assureTableProperties.
	minExt := aMorph minWidth@aMorph minHeight - aMorph extent + aMorph layoutBounds extent.
	newBounds := layoutBounds origin extent: (layoutBounds extent max: minExt).
	width := 0.
	width := (self minExtentOf: aMorph in: newBounds) x.
	spare := newBounds width - width max: 0.
	fillCount := 0.
	spare > 0
		ifTrue: [fillCount := aMorph submorphs inject: 0 into: [:tot :m |
					tot + (m hResizing == #spaceFill ifTrue: [1] ifFalse: [0])].
				extra := fillCount = 0
					ifTrue: [0]
					ifFalse: [spare // fillCount].
				spare := spare - (fillCount - 1 * extra)]
		ifFalse: [extra := 0].
	x := fillCount > 0
		ifTrue: [newBounds left]
		ifFalse: [props listCentering == #center
					ifTrue: [newBounds center x - (width // 2)]
					ifFalse: [props listCentering == #bottomRight
								ifTrue: [newBounds right - width]
								ifFalse: [newBounds left]]].
	height := newBounds height.
	inset := props cellInset. 
	aMorph submorphs with: cachedMinExtents do: [:m :ext |
		width := m hResizing == #spaceFill
			ifTrue: [fillCount := fillCount - 1.
					ext x + (fillCount > 0
						ifTrue: [spare]
						ifFalse: [extra])]
			ifFalse: [ext x].
		cell := x@newBounds top extent: width@height.
		((vr := m vResizing) == #shrinkWrap or: [m bounds ~= cell])
			ifTrue: [((vr == #shrinkWrap) not and: [m extent = cell extent])
						ifTrue: [m position: cell origin]
						ifFalse: [box := m bounds.
								m hResizing == #spaceFill 
									ifTrue: [box := cell origin extent: cell width @ box height].
								vr  == #spaceFill
									ifTrue: [box := box origin extent: box width @ cell height].
								vr  == #shrinkWrap
									ifTrue:[box := box origin extent: box width @ ext y].
								pos := props cellPositioning.
								box := box align: (box perform: pos) with: (cell perform: pos).
								m bounds: box]].
		x := x + width + inset]! !

!RowLayout methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 17:25'!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	
	|extent min props|
	cachedMinExtent ifNotNil: [^cachedMinExtent].
	aMorph submorphs ifEmpty: [^self].
	extent := 0@0.
	cachedMinExtents _ aMorph submorphs collect: [:m |
		min := m minExtent.
		extent := extent x + min x @ (extent y max: min y).
		min].
	props := aMorph assureTableProperties.
	^cachedMinExtent := extent + (aMorph submorphs size - 1 * props cellInset @ 0)! !

ScrollBar subclass: #GeneralScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!GeneralScrollBar commentStamp: 'gvc 5/18/2007 13:01' prior: 0!
Support for GeneralScrollPane.!

!GeneralScrollBar methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:45'!
setValue: newValue
	"Bypass screwed up scrollbar!!"
	
	^self perform: #setValue: withArguments: {newValue} inSuperclass: Slider! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/11/2007 16:04'!
basicCreateArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"PRIVATE - create an arrow with aSymbolDirectionDirection,  
	finalSizeInteger and aColor.
	aSymbolDirectionDirection = #top, #bottom. #left or #right .
	Try with:  
	(ScrollBar createNewArrowOfDirection: #top size: 32 color: Color  
	lightGreen) asMorph openInHand.  
	Fixed to work with translucent colours."
	
	|form resizeFactor arrow resizedForm |
	resizeFactor := 4.
	form := Form
		extent: finalSizeInteger asPoint * resizeFactor
		depth: Display depth.
	form fillColor: Color transparent.
	arrow := (self createArrowOfDirection: aSymbolDirection in: form boundingBox)
		borderWidth: 1;
		borderColor: aColor lighter.
	self
		updateScrollBarButtonAspect: arrow
		color: (aColor alphaMixed: 0.7 with: Color black).
	arrow fullDrawOn: form getCanvas.
	resizedForm := form
		magnify: form boundingBox
		by: 1 / resizeFactor
		smoothing: 4.
	^resizedForm trimBordersOfColor: Color transparent! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/30/2006 09:43'!
createArrowOfDirection: aSymbol in: aRectangle 
	"PRIVATE - create an arrow bounded in aRectangle"

	| arrow vertices |
	vertices := Preferences alternativeButtonsInScrollBars 
				ifTrue: [self verticesForComplexArrow: aRectangle]
				ifFalse: [self verticesForSimpleArrow: aRectangle].
	""
	arrow := PolygonMorph 
				vertices: vertices
				color: Color transparent
				borderWidth: 0
				borderColor: Color black.
	""
	arrow bounds: (arrow bounds insetBy: (aRectangle width / 6) rounded).
	""
	aSymbol == #right 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 90].
	aSymbol == #bottom 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 180].
	aSymbol == #left 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 270].
	""
	^arrow! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/11/2007 16:06'!
createArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"Defer to current UITheme if available."
	
	^(UITheme ifNil: [^self
			basicCreateArrowOfDirection: aSymbolDirection
			size: finalSizeInteger
			color: aColor]) current
		scrollbarArrowOfDirection: aSymbolDirection
		size: finalSizeInteger
		color: aColor! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:57'!
imageColorFor: aScrollbar
	"Return the (button) image colour for the given scrollbar."
	
	^UITheme current scrollbarImageColorFor: aScrollbar! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/30/2006 10:05'!
verticesForComplexArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a complex arrow"

	|r vertices aux b c|
	r := aRectangle origin extent: aRectangle width asPoint.
	aux := (r width / 5) rounded.
	b := (aux * aux * 2) sqrt.
	c := (b * b * 2) sqrt rounded.
	vertices := OrderedCollection new.
	vertices add: r bottomLeft - (0 @ aux).
	vertices add: r topCenter + (0 @ aux).
	vertices add: r bottomRight - (0 @ aux).
	vertices add: r bottomRight - (aux @ 0).
	vertices add: r topCenter + (0 @ (aux + c)).
	vertices add: r bottomLeft + (aux @ 0).
	^vertices! !

!ScrollBar class methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 13:53'!
verticesForSimpleArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a simple arrow"
	| vertices |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle center x @ (aRectangle top + (aRectangle width / 8)).
	vertices add: aRectangle bottomRight.
	vertices add: aRectangle bottomRight + (0@0.01).
	""
	^ vertices! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:24'!
adoptGradientColor: aColor
	"Adopt the given pane color."

	|c fs bfs bs bbs|
	aColor ifNil:[^self].
	c := aColor.
	self setProperty: #lastPaneColor toValue: c.
	fs := self normalThumbFillStyle.
	bfs := self normalButtonFillStyle.
	bs := self normalThumbBorderStyle.
	bbs := self normalButtonBorderStyle.
	sliderColor := c.
	downButton
		fillStyle: bfs;
		borderStyle: bbs.
	upButton
		fillStyle: bfs clone;
		borderStyle: bbs.
	slider
		fillStyle: fs;
		borderStyle: bs.
	menuButton ifNotNilDo: [:mb |
		mb
			fillStyle: bfs clone;
		borderStyle: bbs].
	self updateMenuButtonImage.
	self updateUpButtonImage.
	self updateDownButtonImage! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 14:58'!
drawOn: aCanvas
	"Don't bother since the submorphs fill the area."! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:23'!
finishedScrolling
	"Scrolling has finished (button or paging area)."
	
	|bcu bcd|
	bcu := upButton borderStyle baseColor.
	bcd := downButton borderStyle baseColor.
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook
		ifTrue:[upButton borderStyle:
					(BorderStyle complexRaised width: upButton borderWidth; baseColor: bcu).
				downButton borderStyle:
					(BorderStyle complexRaised width: downButton borderWidth; baseColor: bcd)]
		ifFalse:[upButton borderRaised.
				upButton borderStyle baseColor: bcu.
				downButton borderRaised.
				downButton borderStyle baseColor: bcd].
	Preferences gradientScrollbarLook ifFalse: [^self].
	pagingArea
		fillStyle: self normalFillStyle;
		borderStyle: self normalBorderStyle! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 16:12'!
finishedScrolling: event
	"Scrolling has finished for a button."
	
	self finishedScrolling.
	(self containsPoint: event position)
		ifTrue: [pagingArea
				fillStyle: self mouseOverFillStyle;
				borderStyle: self mouseOverBorderStyle]
		ifFalse: [pagingArea
				fillStyle: self normalFillStyle;
				borderStyle: self normalBorderStyle].
	(upButton containsPoint: event position)
		ifTrue: [upButton
					fillStyle: self mouseOverButtonFillStyle;
					borderStyle: self mouseOverButtonBorderStyle]
		ifFalse: [(self containsPoint: event position)
					ifTrue: [upButton
							fillStyle: self mouseOverPagingAreaButtonFillStyle;
							borderStyle: self mouseOverPagingAreaButtonBorderStyle]
					ifFalse: [upButton
							fillStyle: self normalButtonFillStyle;
							borderStyle: self normalButtonBorderStyle]].
	(downButton containsPoint: event position)
		ifTrue: [downButton
					fillStyle: self mouseOverButtonFillStyle;
					borderStyle: self mouseOverButtonBorderStyle]
		ifFalse: [(self containsPoint: event position)
					ifTrue: [downButton
							fillStyle: self mouseOverPagingAreaButtonFillStyle;
							borderStyle: self mouseOverPagingAreaButtonBorderStyle]
					ifFalse: [downButton
							fillStyle: self normalButtonFillStyle;
							borderStyle: self normalButtonBorderStyle]]! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/30/2007 11:10'!
initializeDownButton
	"initialize the receiver's downButton"

	downButton := RectangleMorph 
				newBounds: (self innerBounds bottomRight - self buttonExtent 
						extent: self buttonExtent)
				color: self thumbColor.
	downButton 
		on: #mouseDown
		send: #scrollDownInit
		to: self.
	downButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateDownButtonImage.
	self roundedScrollbarLook 
		ifTrue: 
			[downButton color: Color veryLightGray.
			downButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [downButton setBorderWidth: 1 borderColor: Color lightGray].
		
	Preferences gradientScrollbarLook ifFalse:[^self addMorph: downButton].
	downButton on: #mouseUp send: #finishedScrolling: to: self.
	downButton on: #mouseEnter send: #mouseEnterDownButton: to: self.
	downButton on: #mouseLeave send: #mouseLeaveDownButton: to: self.
	self addMorph: downButton! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 16:06'!
initializePagingArea
	"Initialize the receiver's pagingArea."
	
	pagingArea := RectangleMorph
				newBounds: self totalSliderArea
				color: (Color
						r: 0.6
						g: 0.6
						b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea
		on: #mouseDown
		send: #scrollPageInit:
		to: self.
	pagingArea
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook
		ifTrue: [pagingArea
				color: (Color gray: 0.9)].
	Preferences gradientScrollbarLook ifFalse:[^self].
	pagingArea on: #mouseUp send: #finishedScrolling: to: self.
	self on: #mouseEnter send: #mouseEnterPagingArea: to: self.
	self on: #mouseLeave send: #mouseLeavePagingArea: to: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/16/2007 13:55'!
initializeSlider
	"Initialize the receiver's slider."
	
	self roundedScrollbarLook
		ifTrue: [self initializeUpButton; initializeMenuButton; initializeDownButton; initializePagingArea]
		ifFalse: [self initializeMenuButton; initializeUpButton; initializeDownButton; initializePagingArea].
	super initializeSlider.
	self roundedScrollbarLook
		ifTrue: [slider cornerStyle: #rounded.
			slider
				borderStyle: (BorderStyle complexRaised width: 3).
			sliderShadow cornerStyle: #rounded].
	self sliderColor: self sliderColor.
	Preferences gradientScrollbarLook ifFalse: [^self].
	slider on: #mouseEnter send: #mouseEnterThumb: to: self.
	slider on: #mouseLeave send: #mouseLeaveThumb: to: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/4/2007 15:32'!
initializeUpButton
"initialize the receiver's upButton"
	upButton := self roundedScrollbarLook
		ifTrue: [RectangleMorph
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
		ifFalse: [RectangleMorph
						newBounds: ((menuButton
								ifNil: [self innerBounds topLeft]
								ifNotNil: [bounds isWide
										ifTrue: [menuButton bounds topRight]
										ifFalse: [menuButton bounds bottomLeft]])
								extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateUpButtonImage.
	self roundedScrollbarLook
		ifTrue: [upButton color: Color veryLightGray.
			upButton
				borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: Color lightGray].
		
	Preferences gradientScrollbarLook ifFalse: [^self addMorph: upButton].
	upButton on: #mouseUp send: #finishedScrolling: to: self.
	upButton on: #mouseEnter send: #mouseEnterUpButton: to: self.
	upButton on: #mouseLeave send: #mouseLeaveUpButton: to: self.
	self addMorph: upButton! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/30/2007 11:22'!
menuButtonMouseDown: event
	"The menu button has been clicked."
	
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector := sel.  model perform: sel with: event].
	Preferences gradientScrollbarLook ifFalse: [^self].
	self menuButtonMouseLeave: event! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:20'!
menuButtonMouseEnter: event
	"The mouse has entered the menu button."
	
	super menuButtonMouseEnter: event.
	Preferences gradientScrollbarLook ifFalse:[^self].
	menuButton
		fillStyle: self mouseOverButtonFillStyle;
		borderStyle: self mouseOverButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:25'!
menuButtonMouseLeave: event
	"The mouse has left the menu button."
	
	super menuButtonMouseLeave: event.
	Preferences gradientScrollbarLook ifFalse:[^self].
	menuButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:27'!
mouseDownInSlider: event
	"The mouse has been pressed in the slider area."
	
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBar].
	Preferences gradientScrollbarLook ifFalse:[^super mouseDownInSlider: event].
	event redButtonPressed ifFalse: [^self].
	slider fillStyle: self pressedThumbFillStyle.
	slider borderStyle: self pressedThumbBorderStyle.
	sliderShadow color: self sliderShadowColor.
	sliderShadow cornerStyle: slider cornerStyle.
	sliderShadow bounds: slider bounds.
	sliderShadow show! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:20'!
mouseEnterDownButton: event
	"The mouse has entered the down button."
	
	downButton
		fillStyle: self mouseOverButtonFillStyle;
		borderStyle: self mouseOverButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/4/2007 15:38'!
mouseEnterPagingArea: event
	"The mouse has entered the paging area."
	
	pagingArea
		fillStyle: self mouseOverFillStyle;
		borderStyle: self mouseOverBorderStyle;
		changed.
	slider
		fillStyle: self mouseOverPagingAreaThumbFillStyle;
		borderStyle: self mouseOverPagingAreaThumbBorderStyle;
		changed.
	menuButton ifNotNil: [
		menuButton
			fillStyle: self mouseOverPagingAreaButtonFillStyle;
			borderStyle: self mouseOverPagingAreaButtonBorderStyle;
			changed].
	upButton
		fillStyle: self mouseOverPagingAreaButtonFillStyle;
		borderStyle: self mouseOverPagingAreaButtonBorderStyle;
		changed.
	downButton
		fillStyle: self mouseOverPagingAreaButtonFillStyle;
		borderStyle: self mouseOverPagingAreaButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/4/2007 15:11'!
mouseEnterThumb: event
	"The mouse has entered the thumb."
	
	slider
		fillStyle: self mouseOverThumbFillStyle;
		borderStyle: self mouseOverThumbBorderStyle;
		changed.
	menuButton ifNotNil: [
		menuButton
			fillStyle: self mouseOverThumbButtonFillStyle;
			borderStyle: self mouseOverThumbButtonBorderStyle;
			changed].
	upButton
		fillStyle: self mouseOverThumbButtonFillStyle;
		borderStyle: self mouseOverThumbButtonBorderStyle;
		changed.
	downButton
		fillStyle: self mouseOverThumbButtonFillStyle;
		borderStyle: self mouseOverThumbButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:20'!
mouseEnterUpButton: event
	"The mouse has entered the up button."
	
	upButton
		fillStyle: self mouseOverButtonFillStyle;
		borderStyle: self mouseOverButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:23'!
mouseLeaveDownButton: event
	"The mouse has left the down button."
	
	downButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/4/2007 15:45'!
mouseLeavePagingArea: event
	"The mouse has left the paging area."
	
	pagingArea
		fillStyle: self normalFillStyle;
		borderStyle: self normalBorderStyle;
		changed.
	slider
		fillStyle: self normalThumbFillStyle;
		borderStyle: self normalThumbBorderStyle;
		changed.
	menuButton ifNotNil: [
		menuButton
			fillStyle: self normalButtonFillStyle;
			borderStyle: self normalButtonBorderStyle;
			changed].
	upButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed.
	downButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/4/2007 16:08'!
mouseLeaveThumb: event
	"The mouse has left the thumb."
	
	slider
		fillStyle: self normalThumbFillStyle;
		borderStyle: self normalThumbBorderStyle;
		changed.
	menuButton ifNotNil: [
		(self containsPoint: event position)
			ifTrue: [menuButton
					fillStyle: self mouseOverPagingAreaButtonFillStyle;
					borderStyle: self mouseOverPagingAreaButtonBorderStyle]
			ifFalse: [menuButton
					fillStyle: self normalButtonFillStyle;
					borderStyle: self normalButtonBorderStyle]].
	(self containsPoint: event position)
		ifTrue: [upButton
				fillStyle: self mouseOverPagingAreaButtonFillStyle;
				borderStyle: self mouseOverPagingAreaButtonBorderStyle]
		ifFalse: [upButton
				fillStyle: self normalButtonFillStyle;
				borderStyle: self normalButtonBorderStyle].
	(self containsPoint: event position)
		ifTrue: [downButton
				fillStyle: self mouseOverPagingAreaButtonFillStyle;
				borderStyle: self mouseOverPagingAreaButtonBorderStyle]
		ifFalse: [downButton
				fillStyle: self normalButtonFillStyle;
				borderStyle: self normalButtonBorderStyle]! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:24'!
mouseLeaveUpButton: event
	"The mouse has left the up button."
	
	upButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverBorderStyle
	"Return the mouse over borderStyle for the receiver."
	
	^self theme scrollbarMouseOverBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverButtonBorderStyle
	"Return the mouse over button borderStyle for the receiver."
	
	^self theme scrollbarMouseOverButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverButtonFillStyle
	"Return the mouse over button fillStyle for the receiver."
	
	^self theme scrollbarMouseOverButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverFillStyle
	"Return the mouse over fillStyle for the receiver."
	
	^self theme scrollbarMouseOverFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaButtonBorderStyle
	"Return the button borderStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaButtonFillStyle
	"Return the button fillStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaThumbBorderStyle
	"Return the thumb borderStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaThumbFillStyle
	"Return the thumb fillStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbBorderStyle
	"Return the mouse over thumb borderStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbButtonBorderStyle
	"Return the button borderStyle for the receiver when the mouse
	is over the thumb."
	
	^self theme scrollbarMouseOverThumbButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbButtonFillStyle
	"Return the mouse over thumb fillStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbFillStyle
	"Return the mouse over thumb fillStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/4/2007 15:17'!
mouseUpInSlider: event
	"The mouse button has been released."
	
	Preferences gradientScrollbarLook ifFalse:[^super mouseUpInSlider: event].
	sliderShadow hide.
	(slider containsPoint: event position)
		ifTrue: [slider
					fillStyle: self mouseOverThumbFillStyle;
					borderStyle: self mouseOverThumbBorderStyle]
		ifFalse: [self mouseLeaveThumb: event].
	slider changed! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalBorderStyle
	"Return the normal borderStyle for the receiver."
	
	^self theme scrollbarNormalBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalButtonBorderStyle
	"Return the normal button borderStyle for the receiver."
	
	^self theme scrollbarNormalButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalButtonFillStyle
	"Return the normal button fillStyle for the receiver."
	
	^self theme scrollbarNormalButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalFillStyle
	"Return the normal fillStyle for the receiver."
	
	^self theme scrollbarNormalFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalThumbBorderStyle
	"Return the normal thumb borderStyle for the receiver."
	
	^self theme scrollbarNormalThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalThumbFillStyle
	"Return the normal thumb fillStyle for the receiver."
	
	^self theme scrollbarNormalThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedBorderStyle
	"Return the pressed borderStyle for the receiver."
	
	^self theme scrollbarPressedBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedButtonBorderStyle
	"Return the pressed button borderStyle for the receiver."
	
	^self theme scrollbarPressedButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedButtonFillStyle
	"Return the pressed button fillStyle for the receiver."
	
	^self theme scrollbarPressedButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedFillStyle
	"Return the pressed fillStyle for the receiver."
	
	^self theme scrollbarPressedFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedThumbBorderStyle
	"Return the pressed thumb borderStyle for the receiver."
	
	^self theme scrollbarPressedThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedThumbFillStyle
	"Return the pressed thumb fillStyle for the receiver."
	
	^self theme scrollbarPressedThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/6/2006 12:32'!
scrollAbsolute: event
	"Just don't if it is not the red button and we are drawing gradients."
	
	Preferences gradientScrollbarLook ifFalse:[^super scrollAbsolute: event].
	event redButtonPressed ifFalse: [^self].
	^super scrollAbsolute: event! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:26'!
scrollDownInit

	|bc|
	bc := downButton borderStyle baseColor.
	downButton borderInset.
	downButton borderStyle baseColor: bc.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.
	Preferences gradientScrollbarLook ifFalse: [^self].
	downButton fillStyle: self pressedButtonFillStyle.
	downButton borderStyle: self pressedButtonBorderStyle! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:26'!
scrollPageInit: evt
	"Scroll initiated by the paging area."
	
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	Preferences gradientScrollbarLook ifFalse: [^self startStepping].
	pagingArea
		fillStyle: self pressedFillStyle;
		borderStyle: self pressedBorderStyle.
	self startStepping.! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:26'!
scrollUpInit

	|bc|
	bc := upButton borderStyle baseColor.
	upButton borderInset.
	upButton borderStyle baseColor: bc.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.
	Preferences gradientScrollbarLook ifFalse: [^self].
	upButton fillStyle: self pressedButtonFillStyle.
	upButton borderStyle: self pressedButtonBorderStyle! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/7/2006 11:59'!
setValue: newValue
	"Using roundTo: instead of truncateTo: ensures that scrollUp will scroll the same distance as scrollDown.
	Fix for >= 1.0 since, when close the roundTo may round down and not allow the value to reach
	the full range."
	
	newValue >= 1.0
		ifTrue: [^super setValue: 1.0].
	^ super setValue: (newValue roundTo: scrollDelta)! !

!ScrollBar methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/7/2006 12:11'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector _ aSymbol! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2007 15:23'!
sliderColor: aColor 
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor := self thumbColor.
	menuButton
		ifNotNil: [menuButton color: buttonColor].
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor slightlyLighter.
	
	Preferences gradientScrollbarLook ifFalse: [
		self class updateScrollBarButtonsAspect: {menuButton. upButton. downButton} color: buttonColor.
		self updateMenuButtonImage.
		self updateUpButtonImage.
		self updateDownButtonImage].
	
	pagingArea
		fillStyle: self normalFillStyle;
		borderStyle: self normalBorderStyle.
	self borderWidth: 0.
	Preferences gradientScrollbarLook ifTrue: [^self adoptGradientColor: aColor]! !

!ScrollBar methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 14:06'!
thumbColor
	"Problem: Part of the ScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^self class imageColorFor: self! !

!TransformMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 11/17/2006 10:12'!
clipSubmorphs
	"Answer true since we do!!
	This avoids the senseless over-invalidation
	with lists etc."
	
	^true! !

!TransformMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/16/2007 11:35'!
extent: aPoint
	"Changed to not cause layoutChanged on the receiver."
	
	bounds extent = aPoint ifTrue: [^ self].
	self changed.
	bounds := (bounds topLeft extent: aPoint) rounded.
	super layoutChanged. "skip submorph bounds recalculation"
	self changed.
! !

TransformMorph subclass: #TransformWithLayoutMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TransformWithLayoutMorph commentStamp: 'gvc 5/18/2007 10:18' prior: 0!
A transform morph that allows the use of a layout policy to arrange submorphs.!

!TransformWithLayoutMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/1/2006 16:06'!
doLayoutIn: layoutBounds 
	"Compute a new layout based on the given layout bounds."

	"Note: Testing for #bounds or #layoutBounds would be sufficient to
	figure out if we need an invalidation afterwards but #outerBounds
	is what we need for all leaf nodes so we use that."

	| layout box priorBounds |
	priorBounds := self outerBounds.
	submorphs isEmpty ifTrue: [^fullBounds := priorBounds].
	"Send #ownerChanged to our children"
	submorphs do: [:m | m ownerChanged].
	layout := self layoutPolicy.
	layout ifNotNil: [layout layout: self in: (0@0 extent: layoutBounds extent // self scale)].
	self adjustLayoutBounds.
	fullBounds := self privateFullBounds.
	box := self outerBounds.
	box = priorBounds 
		ifFalse: [self invalidRect: (priorBounds quickMerge: box)]! !

!TransformWithLayoutMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2006 14:56'!
fullBounds
	"Do the ordinary thing. See comment in superclass."

	^self perform: #fullBounds withArguments: #() inSuperclass: Morph! !

!Color methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 11:41'!
contrastingColor
	"Answer black or white depending on the luminance."

	self isTransparent ifTrue: [^Color black].
	^self luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]! !

!Color methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/21/2006 09:48'!
pixelWord32
	"Returns an integer representing the bits that appear in a single pixel of this color in a Form of depth 32.
	Transparency: The pixel value zero is reserved for transparent. For depths greater than 8, black maps to the darkest possible blue.
	Just a little quicker if we are dealing with RGBA colors at 32 bit depth."

	| val |
	"eight bits per component; top 8 bits set to all ones (opaque alpha)"
	val := LargePositiveInteger new: 4.
	val at: 3 put: ((rgb bitShift: -22) bitAnd: 16rFF).
	val at: 2 put: ((rgb bitShift: -12) bitAnd: 16rFF).
	val at: 1 put: ((rgb bitShift: -2) bitAnd: 16rFF).
	val = 0 ifTrue: [val at: 1 put: 1].  "closest non-transparent black"
	val at: 4 put: 16rFF.  "opaque alpha"
	^val
! !

PluggableTextMorph subclass: #PluggableTextEditorMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'enabled getEnabledSelector highlights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableTextEditorMorph commentStamp: 'gvc 5/18/2007 12:29' prior: 0!
Multi-line text editor with support for accepting on both each change and/or when keyboard focus changes. Also supports custom selection colour and clickable highlights.!

PluggableTextEditorMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:06'!
acceptOnFocusChange
	"Answer whether the editor accepts its contents when it loses the keyboard focus."

	^self valueOfProperty: #acceptOnFocusChange ifAbsent: [false]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:06'!
acceptOnFocusChange: aBoolean
	"Set whether the editor accepts its contents when it loses the keyboard focus."

	self setProperty: #acceptOnFocusChange toValue: aBoolean.
	self textMorph ifNotNilDo: [:t | t acceptOnFocusChange: aBoolean]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/8/2007 10:27'!
adoptPaneColor: paneColor
	"Use the theme for fillStyle and border."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 15:23'!
alwaysAccept: aBoolean
	"Set the always accept flag."

	aBoolean
		ifTrue: [self setProperty: #alwaysAccept toValue: true]
		ifFalse: [self removeProperty: #alwaysAccept]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 14:27'!
autoAccept
	"Answer whether the editor accepts its contents on each change."

	^self valueOfProperty: #autoAccept ifAbsent: [false]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/9/2006 14:07'!
autoAccept: aBoolean
	"Set whether the editor accepts its contents on each change.
	Only takes effect after the text is set."

	self setProperty: #autoAccept toValue: aBoolean.
	self textMorph ifNotNilDo: [:t | t autoAccept: aBoolean]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 13:09'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textEditorNormalBorderStyleFor: self]
		ifFalse: [self theme textEditorDisabledBorderStyleFor: self]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:17'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/31/2006 16:28'!
drawHighlightsOn: aCanvas
	"Draw the highlights."
	
	|b o|
	b := self innerBounds.
	o := self scroller offset.
	aCanvas clipBy: self clippingBounds during: [:c |
	self highlights do: [:h |
		h
			drawOn: c 
			in: b
			offset: o]]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/23/2006 12:05'!
drawOn: aCanvas.
	"Draw the highlights."
	
	super drawOn: aCanvas.
	self drawHighlightsOn: aCanvas! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:16'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 4/30/2007 11:44'!
enabled
	"Answer whether the receiver is enabled."
	
	^enabled! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 4/30/2007 11:49'!
enabled: aBoolean
	"Set the value of enabled"

	enabled = aBoolean ifTrue: [^self].
	enabled := aBoolean.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:40'!
extent: newExtent
	"Update the gradient."
	
	super extent: newExtent.
	(self fillStyle notNil and: [self fillStyle isSolidFill not])
		ifTrue: [self fillStyle: self fillStyleToUse]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 13:04'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textEditorNormalFillStyleFor: self]
		ifFalse: [self theme textEditorDisabledFillStyleFor: self]! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 9/5/2006 14:40'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 4/30/2007 15:01'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/23/2006 15:02'!
hScrollBarValue: scrollValue
	"Trigger an event too."
	
	super hScrollBarValue: scrollValue.
	self triggerEvent: #hScroll with: scrollValue! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 10/25/2006 12:51'!
highlights
	"Answer the value of highlights"

	^ highlights! !

!PluggableTextEditorMorph methodsFor: 'accessing' stamp: 'gvc 10/25/2006 12:51'!
highlights: anObject
	"Set the value of highlights"

	highlights := anObject! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 12:53'!
initialize
	"Initialize the receiver."

	super initialize.
	enabled := true.
	highlights := OrderedCollection new! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/30/2007 15:01'!
model: aModel
	"Update the enablement state too."

	super model: aModel.
	self updateEnabled! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 17:07'!
scrollBy: delta
	"Move the contents in the direction delta."
	
	super scrollBy: delta.
	self triggerEvent: #hScroll with: self scrollValue x.
	self triggerEvent: #vScroll with: self scrollValue y
	! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/4/2007 10:31'!
scrollToTop
	"Scroll to the top."
	
	self
		vScrollBarValue: 0;
		setScrollDeltas! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:15'!
selectionColor
	"Answer the colour to use for the text selection."

	^self valueOfProperty: #selectionColor ifAbsent: [] ! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:16'!
selectionColor: aColor
	"Set the colour to use for the text selection."

	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	self textMorph ifNotNilDo: [:t | t selectionColor: aColor]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:18'!
setText: aText
	"Set the auto accept on the text morph."
	
	self textMorph ifNil: [
		super setText: aText.
		self textMorph
			autoAccept: self autoAccept;
			selectionColor: self selectionColor.
		^self].
	^super setText: aText! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/23/2006 14:52'!
textExtent
	"Answer the text morph extent."
	
	^(textMorph ifNil: [^0@0]) extent! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/23/2006 14:50'!
textExtent: newExtent
	"If autoFit is on then override to false for the duration of the extent call."
	
	textMorph ifNil: [^self].
	textMorph overrideExtent: newExtent! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/9/2006 14:07'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^TextMorphForEditorView! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 14:41'!
update: aSymbol 
	"Refer to the comment in View|update:."

	super update: aSymbol.
	aSymbol == getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self].
! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 14:41'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/23/2006 15:01'!
vScrollBarValue: scrollValue
	"Trigger an event too."
	
	super vScrollBarValue: scrollValue.
	self triggerEvent: #vScroll with: scrollValue! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/20/2006 12:11'!
wrapFlag
	"Answer the wrap flag on the text morph."
	
	^(self textMorph ifNil: [self setText: '']) wrapFlag! !

!PluggableTextEditorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/20/2006 12:11'!
wrapFlag: aBoolean
	"Set the wrap flag on the text morph."
	
	self textMorph ifNil: [self setText: ''].
	self textMorph wrapFlag: aBoolean! !

PluggableTextEditorMorph subclass: #PluggableTextFieldMorph
	instanceVariableNames: 'converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableTextFieldMorph commentStamp: 'gvc 5/18/2007 12:39' prior: 0!
Single-line text field editor with DialogWindow key integration (return for default, escape for cancel) and keyboard focus navigation (tab/shift-tab). Additionally supports pluggable converters to translate between an object and its string form and vice-versa.!

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:47'!
acceptTextInModel
	"Inform the model that the receiver's textMorph's text should be accepted.
	Answer true if the model accepted ok, false otherwise"
	
	| objectToAccept |
	objectToAccept := self converter isNil
		ifTrue: [textMorph asText]
		ifFalse: [self converter stringAsObject: textMorph asText asString].
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: objectToAccept with: self]
			ifFalse: [model perform: setTextSelector with: objectToAccept]]
! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 13:08'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textFieldNormalBorderStyleFor: self]
		ifFalse: [self theme textFieldDisabledBorderStyleFor: self]! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:22'!
convertTo: aClass
	"Set the converter object class."

	self converter isNil
		ifTrue: [self converter: (ObjectStringConverter forClass: aClass)]
		ifFalse: [self converter objectClass: aClass]! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 12:21'!
converter
	"Answer the value of converter"

	^ converter! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 12:21'!
converter: anObject
	"Set the value of converter"

	converter := anObject! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 13:04'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textFieldNormalFillStyleFor: self]
		ifFalse: [self theme textFieldDisabledFillStyleFor: self]! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 14:06'!
getSelection
	"Answer the model's selection interval.
	If not available keep the current selection."

	getSelectionSelector isNil ifFalse: [^super getSelection].
	^selectionInterval ifNil: [super getSelection]! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:55'!
getText
	"Retrieve the current model text. Set the converter to
	convert between the class of the returned object and string form."

	| newObj |
	getTextSelector isNil ifTrue: [^super getText].
	newObj := model perform: getTextSelector.
	newObj ifNil: [^Text new].
	self converter isNil
		ifTrue: [self convertTo: newObj class].
	^(self converter objectAsString: newObj) shallowCopy! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:00'!
maxLength
	"Answer the maximum number of characters that may be typed."

	^self textMorph maxLength! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:59'!
maxLength: anInteger
	"Set the maximum number of characters that may be typed."

	self textMorph maxLength: anInteger! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/4/2007 15:36'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true.
	Just don't, really!!"
	
	^false! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/4/2007 15:15'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false.
	Redone here to deal with horizontal scrolling!!"
	
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	transform := scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere := transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self innerBounds) ~= (0@0) ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: delta truncated.
		^ true].
	^ false! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/9/2006 14:07'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^TextMorphForFieldView! !

!PluggableTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/21/2007 10:51'!
update: aSymbol
	"Update the receiver based on the given aspect.
	Override to not accept an #appendText for a text field
	since if broadcast by a model it will append to ALL
	text fields/editors."
	
	aSymbol == #appendEntry
		ifTrue: [^self].
	^super update: aSymbol! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/1/2006 16:26'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderStyle baseColor: (self enabled ifTrue: [paneColor twiceDarker] ifFalse: [paneColor darker])! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/5/2007 12:24'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since the drawOn: method is so horrible."

	super drawSubmorphsOn: aCanvas.
	Preferences externalFocusForPluggableText ifTrue: [
		self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]]! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/13/2007 12:39'!
extent: newExtent
	"The inner bounds may have changed due to scrollbar visibility."
	
	super extent: (newExtent max: 36@16).
	textMorph ifNotNil:
		[self innerBounds extent - 6 = textMorph extent
			ifFalse: [textMorph extent: self innerBounds extent - 6]].
	self setScrollDeltas
! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:20'!
hasKeyboardFocus
	"Answer whether the receiver has keyboard focus."

	^super hasKeyboardFocus or: [self textMorph hasKeyboardFocus]! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:49'!
keyboardFocusChange: aBoolean
	"Pass on to text morph."
	
	aBoolean ifTrue: [self world activeHand newKeyboardFocus: self textMorph]! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/19/2006 14:19'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	textMorph ifNotNil:
		[textMorph extent: (self innerBounds width-6)@self height].
	self setScrollDeltas
! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/15/2007 11:03'!
minHeight
	"Implemented here since extent: overriden."

	^super minHeight max: 16! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/15/2007 11:03'!
minWidth
	"Implemented here since extent: overriden."

	^super minWidth max: 36! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 11:57'!
mouseEnter: event
	"Changed to take mouseClickForKeyboardFocus preference into account."
	
	super mouseEnter: event.
	selectionInterval ifNotNil:
		[textMorph editor selectInterval: selectionInterval; setEmphasisHere].
	textMorph selectionChanged.
	Preferences mouseClickForKeyboardFocus
		ifFalse: [event hand newKeyboardFocus: textMorph]! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/18/2007 11:07'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Must override here rather than in #tabKey: otherwise
	the tab will get passed to the window and change the focus."

	(event keyCharacter = Character tab and: [
		(event anyModifierKeyPressed or: [event shiftPressed]) not]) ifTrue: [^false].
	^super navigationKey: event! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/13/2007 12:29'!
resetExtent
	"Reset the extent while maintaining the current selection.  Needed when resizing while the editor is active (when inside the pane)."
	| tempSelection |
	textMorph notNil ifTrue:
		["the current selection gets munged by resetting the extent, so store it"
		tempSelection := self selectionInterval.
		
		"don't reset it if it's not active"
		tempSelection = (Interval from: 1 to: 0) 
						ifTrue: [retractableScrollBar
							ifTrue:[ ^ self]].
		super resetExtent. "adjust scroller"
		self extent: self extent.
		self setSelection: tempSelection]! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/20/2006 18:35'!
roundedCorners
	"Answer the corners to round."

	^self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners] ! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/8/2007 16:54'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:29'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!PluggableTextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/11/2006 14:03'!
wantsFrameAdornments
	"Answer whether the receiver wishes to have red borders, etc.,  
	used to show editing state"
	"A 'long-term temporary workaround': a nonmodular,  
	unsavory, but expedient way to get the desired effect, sorry.  
	Clean up someday."
	^ self
		valueOfProperty: #wantsFrameAdornments
		ifAbsent: [false]! !

!MCTool methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/2/2007 10:13'!
buildWith: builder
	|  windowBuilder |

	windowBuilder := MCToolWindowBuilder builder: builder tool: self.
	(windowBuilder respondsTo: #startWithWindow)
		ifTrue: [windowBuilder startWithWindow].
	self widgetSpecs do:
		[:spec | | send fractions offsets |
		send := spec first.
		fractions := spec at: 2 ifAbsent: [#(0 0 1 1)].
		offsets := spec at: 3 ifAbsent: [#(0 0 0 0)].
		windowBuilder frame: (LayoutFrame
			fractions: (fractions first @ fractions second corner: fractions third @ fractions fourth)
			offsets: (offsets first @ offsets second corner: offsets third @ offsets fourth)).
		windowBuilder perform: send first withArguments: send allButFirst].
	^ windowBuilder build! !

!BorderedMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/16/2007 15:37'!
areasRemainingToFill: aRectangle
	"Fixed here to test the fillStyle rather than color for translucency.
	Since can have a translucent fillStyle while the (calculated) color is not."
	
	self fillStyle isTranslucent
		ifTrue: [^ Array with: aRectangle].
	self wantsRoundedCorners
		ifTrue: [(self borderWidth > 0
					and: [self borderColor isColor
							and: [self borderColor isTranslucent]])
				ifTrue: [^ aRectangle
						areasOutside: (self innerBounds intersect: self boundsWithinCorners)]
				ifFalse: [^ aRectangle areasOutside: self boundsWithinCorners]]
		ifFalse: [(self borderWidth > 0
					and: [self borderColor isColor
							and: [self borderColor isTranslucent]])
				ifTrue: [^ aRectangle areasOutside: self innerBounds]
				ifFalse: [^ aRectangle areasOutside: self bounds]]! !

!BorderedMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2006 15:50'!
colorForInsets
	"Return the color to be used for shading inset borders."
	
	self owner isSystemWindow
		ifTrue: [^self owner colorForInsets].
	^super colorForInsets! !

BorderedMorph subclass: #PanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PanelMorph commentStamp: 'gvc 5/18/2007 12:38' prior: 0!
A container morph that tracks the owner's pane colour unless an explicit fillStyle is specified. Additionally allows hooking of mouseOver events (no button down).!

PanelMorph subclass: #ExpanderMorph
	instanceVariableNames: 'titleMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ExpanderMorph commentStamp: 'gvc 5/18/2007 13:13' prior: 0!
A morph that can expand or collapse to show its contents.!

!ExpanderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:54'!
titleText: aStringOrText
	"Answer a new instance of the receiver with the given title text."

	^self new titleText: aStringOrText! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:24'!
addedMorph: aMorph
	"Notify the receiver that the given morph was just added."

	aMorph == self titleMorph ifFalse: [
		self titleMorph ifNotNil: [
			aMorph
				visible: self expanded;
				disableTableLayout: self expanded not]]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:33'!
defaultTitleMorph
	"Answer a default title morph for the receiver."

	^ExpanderTitleMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:23'!
expanded
	"Answer whether the title is expanded."
	
	^self titleMorph expanded! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:23'!
expanded: aBoolean
	"Set whether the title is expanded."
	
	self titleMorph expanded: aBoolean! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 11:57'!
fixLayout
	"Fix the owner layout, nasty!!"

	self owner ifNil: [^self].
	self owner allMorphsDo: [:m |
		(m respondsTo: #resetExtent) ifTrue: [		
			WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #resetExtent).
			WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #setScrollDeltas)].
		(m isKindOf: self class)
			ifTrue: [WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #adoptPaneColor)]].
	WorldState addDeferredUIMessage: 
				(MessageSend receiver: self owner selector: #changed)! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:29'!
font
	"Answer the title font"

	^self titleMorph font! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:30'!
font: aFont
	"Set the title font"

	self titleMorph font: aFont! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:37'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		titleMorph: self defaultTitleMorph! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:32'!
showMorphs: aBoolean
	"Hide/Show the other morphs."

	self submorphs do: [:m |
		m == self titleMorph ifFalse: [
			m
				visible: aBoolean;
				disableTableLayout: aBoolean not]]! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:30'!
titleMorph
	"Answer the value of titleMorph"

	^ titleMorph! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:35'!
titleMorph: aMorph
	"Set the value of titleMorph"

	titleMorph ifNotNil: [titleMorph delete; removeDependent: self].
	titleMorph := aMorph.
	aMorph ifNotNil: [
		aMorph addDependent: self.
		 self addMorph: aMorph]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:55'!
titleText: aStringOrText
	"Set the text if the title morph is capable."

	(self titleMorph respondsTo: #titleText:)
		ifTrue: [self titleMorph titleText: aStringOrText]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/28/2006 11:26'!
update: aspect
	"Update the receiver."

	aspect = #expanded
		ifTrue: [self vResizing: (self expanded
					ifTrue: [#spaceFill]
					ifFalse: [#shrinkWrap]).
				self showMorphs: self expanded.
				self fixLayout]! !

PanelMorph subclass: #ExpanderTitleMorph
	instanceVariableNames: 'labelMorph expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ExpanderTitleMorph commentStamp: 'gvc 5/18/2007 13:12' prior: 0!
The titlebar area for and ExpanderMorph. Includes title label and expand/collapse button.!

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/17/2007 16:40'!
adoptPaneColor: paneColor
	"Use a gradient."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self normalFillStyle.
	self borderStyle baseColor: paneColor twiceDarker.
	self labelMorph color: paneColor contrastingColor.
	self changed: #expandLabel! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2007 15:33'!
buttonWidth
	"Answer based on scrollbar size."
	
	^Preferences scrollBarsNarrow ifTrue: [12] ifFalse: [16]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/23/2006 16:46'!
defaultBorderStyle
	"Answer the default border style for the receiver."

	^BorderStyle raised width: 1! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/17/2007 16:48'!
expandLabel
	"Answer the label for the expand button."

	^ImageMorph new image: (
		ScrollBar
			arrowOfDirection: (self expanded ifTrue: [#top] ifFalse: [#bottom])
			size: self buttonWidth - 2
			color: self paneColor darker)! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:16'!
expanded
	"Answer the value of expanded"

	^ expanded! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:24'!
expanded: aBoolean
	"Set the value of expanded"

	expanded := aBoolean.
	self
		changed: #expanded;
		changed: #expandLabel! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:29'!
font
	"Answer the label font"

	^((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph font]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:28'!
font: aFont
	"Set the label font"

	((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph font: aFont]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/12/2007 12:53'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		expanded: false;
		changeTableLayout;
		borderStyle: self defaultBorderStyle;
		layoutInset: self borderWidth negated;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #center;
		addMorph: self newExpandButtonMorph;
		labelMorph: self newLabelMorph;
		on: #mouseUp send: #toggleExpanded to: self! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 9/13/2006 10:23'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 3/12/2007 12:55'!
labelMorph: anObject
	"Set the value of labelMorph.
	need to wrap to provide clipping!!"

	labelMorph ifNotNil: [self removeMorph: labelMorph owner].
	labelMorph := anObject.
	labelMorph ifNotNil: [self addMorph: (
		Morph new
			color: Color transparent;
			changeTableLayout;
			listDirection: #leftToRight;
			listCentering: #center;
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			clipSubmorphs: true;
			addMorph: labelMorph)]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:44'!
newExpandButtonMorph
	"Answer a new expand button."

	^(PluggableButtonMorph
			on: self
			getState: nil
			action: #toggleExpanded
			label: #expandLabel)
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: self buttonWidth asPoint! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/12/2007 12:57'!
newLabelMorph
	"Answer a new label morph for the receiver."

	^TextMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		margins: (3@3 corner: 3@0);
		lock! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:28'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme expanderTitleNormalFillStyleFor: self! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 11:15'!
titleText
	"Answer the text if the title morph is capable."

	^((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph contents]
		ifFalse: ['']! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:24'!
titleText: aStringOrText
	"Set the text if the title morph is capable."

	((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph contents: aStringOrText]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:23'!
toggleExpanded
	"Toggle the expanded state."

	self expanded: self expanded not! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 17:15'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self
		valueOfProperty: #fillStyle
		ifAbsent: [self color: paneColor].
	self borderStyle baseColor: paneColor darker! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/26/2006 17:31'!
defaultBorderWidth
	"Answer the default border width for the receiver."
	
	^0! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:36'!
defaultColor
	"Answer the default color for the receiver."

	^Color transparent! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:07'!
handleMouseOver: anEvent
	"System level event handling."
	
	(self handlesMouseOver: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseOver: anEvent]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/12/2007 10:49'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 12:33'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		clipSubmorphs: true;
		beSticky "stop being grabbed"! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:26'!
mouseOver: anEvent
	"Handle a mouseOver event, meaning the mouse just moved within the receiver
	with no button pressed. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseOver: anEvent fromMorph: self]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:25'!
on: eventName send: selector to: recipient
	"Register a recipient for handling an event."
	
	self eventHandler ifNil: [self eventHandler: EventHandlerPlus new].
	self eventHandler on: eventName send: selector to: recipient! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:26'!
on: eventName send: selector to: recipient withValue: value
	"Register a recipient for handling an event."
	
	self eventHandler ifNil: [self eventHandler: EventHandlerPlus new].
	self eventHandler on: eventName send: selector to: recipient withValue: value
! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:54'!
roundedCorners
	"Answer the corners to round."

	^self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners] ! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:54'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

PanelMorph subclass: #PlainGroupboxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PlainGroupboxMorph commentStamp: 'gvc 5/18/2007 12:36' prior: 0!
Groupbox without title with a vertical layout. Appears in a lighter colour than the owner's pane colour.!

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2007 16:37'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor whiter whiter! !

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 15:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill! !

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2006 16:23'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNilDo: [:c | c whiter]! !

PanelMorph subclass: #SeparatorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!SeparatorMorph commentStamp: 'gvc 6/4/2007 14:13' prior: 0!
Simple themed separator morph.!

!SeparatorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 14:21'!
adoptPaneColor: paneColor
	"Change our fill too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: (self theme separatorFillStyleFor: self)! !

PanelMorph subclass: #TabLabelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:26'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^(self bounds width < 6 or: [self bounds height < 6])
		ifTrue: [super focusBounds]
		ifFalse: [super focusBounds insetBy: (2@2 corner: 2@0)]! !

BorderedMorph subclass: #WorkAreaMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!WorkAreaMorph commentStamp: 'gvc 5/18/2007 09:56' prior: 0!
This class is designed to be used as the container for morphs that are placed at absolute positions and is placed within a scroller.
An example would be the background behind a page view in a word processor.
Optimises #layoutChanged to not propagate to owner (assumed to be in a scroller).!

!WorkAreaMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 14:24'!
adoptPaneColor: paneColor
	"Make the receiver's color a bit whiter than the pane color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: (paneColor alphaMixed: 0.4 with: Color white)! !

!WorkAreaMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/30/2006 10:16'!
layoutChanged
	"Don't pass to owner, since the receiver doesn't care!! Improves frame rate."
	
	fullBounds := nil.
	self layoutPolicy ifNotNilDo:[:l | l flushLayoutCache].! !

ThreePhaseButtonMorph subclass: #CheckboxButtonMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'repressedImage enabled'
	classVariableNames: 'DotForm TickForm'
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!CheckboxButtonMorph commentStamp: 'gvc 5/23/2007 12:19' prior: 0!
Checkbox/radio - button only.!

CheckboxButtonMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:21'!
checkBox
	"Answer a button pre-initialized with checkbox images."
	
	^self new
		beCheckbox! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:24'!
dotForm
	"Answer the form to use for a dot."

	^DotForm ifNil: [DotForm := self newDotForm]! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:34'!
newDotForm
	"Answer a new dot form."

	^Form
		extent: 12@12
		depth: 32
		fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402653184 1577058304 1728053248 704643072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1241513984 3841982464 4278190080 4278190080 4093640704 1862270976 16777215 16777215 16777215 16777215 16777215 285212672 3758096384 4278190080 4278190080 4278190080 4278190080 4127195136 822083584 16777215 16777215 16777215 16777215 1308622848 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1996488704 16777215 16777215 16777215 16777215 1308622848 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1996488704 16777215 16777215 16777215 16777215 285212672 3758096384 4278190080 4278190080 4278190080 4278190080 4127195136 822083584 16777215 16777215 16777215 16777215 16777215 1241513984 3841982464 4278190080 4278190080 4093640704 1862270976 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402653184 1577058304 1728053248 704643072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 15:10'!
newTickForm
	"Answer a new tick form."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4278190088 0 0 0 0 0 0 0 0 0 4291217094 4278190088 4286874756 0 0 0 0 0 0 0 0 0 4286874756 4278190088 4291217094 0 0 0 0 0 0 0 0 4291217094 4278190088 4286874756 0 0 0 0 0 0 4278190088 4286874756 0 4286874756 4278190088 4291217094 0 0 0 0 0 0 4286874756 4278190088 4291217094 4278190088 4286874756 0 0 0 0 0 0 0 4291217094 4278190088 4286874756 4278190088 4291217094 0 0 0 0 0 0 0 0 4286874756 4278190088 4286874756 0 0 0 0 0 0 0 0 0 4291217094 4278190088 4291217094 0 0 0 0 0 0 0 0 0 0 4278190088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:21'!
radioButton
	"Answer a button pre-initialized with radio button images."
	
	^self new
		beRadioButton! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 16:59'!
tickForm
	"Answer the form to use for a tick."

	^TickForm ifNil: [TickForm _ self newTickForm]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 11:48'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:23'!
beCheckbox
	"Change the images and square the border
	to be a checkbox."

	self
		onImage: self class tickForm;
		cornerStyle: #square! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 10:10'!
beRadioButton
	"Change the images and round the border
	to be a radio button."

	self
		onImage: self class dotForm;
		cornerStyle: #rounded;
		borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 10:11'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isRadioButton
		ifTrue: [self enabled
			ifTrue: [self theme radioButtonNormalBorderStyleFor: self]
			ifFalse: [self theme radioButtonDisabledBorderStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme checkboxButtonNormalBorderStyleFor: self]
			ifFalse: [self theme checkboxButtonDisabledBorderStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:38'!
colorToUse
	"Answer the color we should use."

	^self paneColor! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:16'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:48'!
drawOn: aCanvas
	"Draw the image for the current state."
	
	|img|
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	img := self imageToUse.
	img ifNotNil: [
		aCanvas
			translucentImage: img
			at: self innerBounds center - (img extent // 2)].
	(self state == #pressed or: [self state == #repressed]) ifTrue: [
		aCanvas fillRectangle: self innerBounds fillStyle: (self paneColor alpha: 0.3)].
	self enabled ifFalse: [aCanvas fillRectangle: self innerBounds fillStyle: (self paneColor alpha: 0.4)]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:16'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 16:04'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 9/5/2006 15:01'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled _ anObject.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 11:47'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self isRadioButton
		ifTrue: [self enabled
			ifTrue: [self theme radioButtonNormalFillStyleFor: self]
			ifFalse: [self theme radioButtonDisabledFillStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme checkboxButtonNormalFillStyleFor: self]
			ifFalse: [self theme checkboxButtonDisabledFillStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:46'!
imageToUse
	"Answer the image we should use."

	^state caseOf: {
		[#off] -> [self offImage].
		[#pressed] -> [self pressedImage].
		[#on] -> [self onImage].
		[#repressed] -> [self repressedImage ifNil: [self onImage]]}
		otherwise: []! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 11:49'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		enabled: true;
		onImage: self class tickForm;
		fillStyle: self fillStyleToUse;
		borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/10/2007 10:12'!
isRadioButton
	"Answer whether the receiver is a radio button."

	^self onImage == self class dotForm! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 13:40'!
mouseDown: evt
	"Handle the transitions."
	
	self enabled ifFalse: [^self perform: #mouseDown: withArguments: {evt} inSuperclass: Morph].
	self isOn
		ifTrue: [self state: #repressed]
		ifFalse: [self state: #pressed].
	actWhen == #buttonDown
		ifTrue:
			[self doButtonAction].
	self mouseStillDown: evt.! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 16:34'!
mouseMove: evt
	"Check for straying."
	
	self enabled ifFalse: [^self perform: #mouseMove: withArguments: {evt} inSuperclass: Morph].
	(self containsPoint: evt cursorPoint)
		ifTrue: [state == #on
					ifTrue: [self state: #repressed].
				state == #off
					ifTrue: [self state: #pressed].
				self perform: #mouseMove: withArguments: {evt} inSuperclass: Morph]
				"Allow on:send:to: to set the response to events other than actWhen"
		ifFalse: [state == #repressed
					ifTrue: [self state: #on].
				state == #pressed
					ifTrue: [self state: #off]].
! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 16:35'!
mouseUp: evt
	"Allow on:send:to: to set the response to events other than actWhen"
	
	self enabled ifFalse: [^self perform: #mouseUp: withArguments: {evt} inSuperclass: Morph].
	actWhen == #buttonUp
		ifFalse: [^self perform: #mouseUp: withArguments: {evt} inSuperclass: Morph].
	(self containsPoint: evt cursorPoint)
		ifTrue: [state == #repressed
					ifTrue: [self state: #off]
					ifFalse: [self state: #on].
				self doButtonAction: evt]
		ifFalse: [target ifNotNil: [target mouseUpBalk: evt]].
	^self perform: #mouseDown: withArguments: {evt} inSuperclass: Morph! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:17'!
repressedImage
	"Answer the value of repressedImage"

	^ repressedImage! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:18'!
repressedImage: anObject
	"Set the value of repressedImage. This is shown when
	pressed after being off."

	repressedImage := anObject.
	self invalidRect: self bounds! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 17:46'!
selected
	"Answer the state taking account of the intermediate states."

	^self state == #repressed or: [self state == #on]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 18:00'!
selected: aBoolean
	"Set the state taking account of the intermediate states."

	(self state == #pressed or: [self state == #repressed])
		ifTrue: [self state: (aBoolean ifTrue: [#repressed] ifFalse: [#pressed])]
		ifFalse: [self state: (aBoolean ifTrue: [#on] ifFalse: [#off])]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 16:41'!
state
	"Answer the state."

	^state! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 16:41'!
state: newState
	"Change the image and invalidate the rect."

	newState == state ifTrue: [^ self].
	state := newState.
	self invalidRect: bounds! !

!Browser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/18/2007 10:32'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^UITheme current smallSystemBrowserIcon! !

!Browser methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/10/2006 12:17'!
buildMorphicSwitches

	| instanceSwitch commentSwitch classSwitch row |

	instanceSwitch _ PluggableButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		borderWidth: 1;
		borderColor: Color gray.
	commentSwitch _ PluggableButtonMorph
		on: self
		getState: #classCommentIndicated
		action: #plusButtonHit.
		
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		borderWidth: 1;
		borderColor: Color gray.
	classSwitch _ PluggableButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		borderWidth: 1;
		borderColor: Color gray.
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellInset: 0;
		borderWidth: 0;
		layoutInset: 0;
		addMorphBack: instanceSwitch;
		addMorphBack: commentSwitch;
		addMorphBack: classSwitch.

	row color: Color white.
	{instanceSwitch. commentSwitch. classSwitch} do: [:m | 
		m 
			color: Color transparent;
			hResizing: #spaceFill;
			vResizing: #spaceFill.].
	^ row
! !

!DamageRecorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/27/2006 12:26'!
recordInvalidRect: newRect
	"Record the given rectangle in my damage list, a list of rectangular areas of the display that should be redraw on the next display cycle."
	"Details: Damaged rectangles are often identical or overlap significantly. In these cases, we merge them to reduce the number of damage rectangles that must be processed when the display is updated. Moreover, above a certain threshold, we ignore the individual rectangles completely, and simply do a complete repaint on the next cycle."

	| mergeRect a |
	totalRepaint ifTrue: [^ self].  "planning full repaint; don't bother collecting damage"

	invalidRects do:
		[:rect |
		((a := (rect intersect: newRect) area) > 40
			and: ["Avoid combining a vertical and horizontal rects.
				  Can make a big diff and we only test when likely."
				  a > (newRect area // 4) or: [a > (rect area // 4)]])
			ifTrue:
			["merge rectangle in place (see note below) if there is significant overlap"
			rect setOrigin: (rect origin min: newRect origin) truncated
				corner: (rect corner max: newRect corner) truncated.
			^ self]].


	invalidRects size >= 50 ifTrue:
		["if there are too many separate areas, merge them all"
		mergeRect := Rectangle merging: invalidRects.
		self reset.
		invalidRects addLast: mergeRect].

	"add the given rectangle to the damage list"
	"Note: We make a deep copy of all rectangles added to the damage list,
		since rectangles in this list may be extended in place."
	invalidRects addLast:
		(newRect topLeft truncated corner: newRect bottomRight truncated).
! !

!Debugger class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 10:44'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^UITheme current smallDebugIcon! !

!Debugger methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2006 11:43'!
buildMorphicNotifierLabelled: label message: messageString
	| notifyPane window extentToUse row|
	self expandStack.
	window := (PreDebugWindow labelled: label) model: self.
	extentToUse := 450 @ 156. "nice and wide to show plenty of the error msg"
	window
		addMorph: (row := self buttonRowForPreDebugWindow: window)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@24)).
	row color: Color transparent.
	Preferences eToyFriendly | messageString notNil
		ifFalse:
			[notifyPane := PluggableListMorph on: self list: #contextStackList
				selected: #contextStackIndex changeSelected: #debugAt:
				menu: nil keystroke: nil]
		ifTrue:
			[notifyPane := PluggableTextMorph on: self text: nil accept: nil
				readSelection: nil menu: #debugProceedMenu:.
			notifyPane editString: (self preDebugNotifierContentsFrom: messageString);
				askBeforeDiscardingEdits: false].
	window
		addMorph: notifyPane
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@24 corner: 0@0)).
	window setBalloonTextForCloseBox.
	^ window openInWorldExtent: extentToUse! !

!Debugger methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2006 11:41'!
buttonRowForPreDebugWindow: aDebugWindow
	| aRow aButton quads |
	aRow := AlignmentMorph newRow hResizing: #spaceFill; vResizing: #spaceFill.
	aRow layoutInset: 1; cellInset: 1.
	aRow beSticky.
	aRow addMorphBack: AlignmentMorph newVariableTransparentSpacer.
	quads := OrderedCollection withAll: self preDebugButtonQuads.
	(self interruptedContext selector == #doesNotUnderstand:) ifTrue: [
		quads add: { 'Create'. #createMethod. #magenta. 'create the missing method' }
	].
	quads do:
			[:quad |
				aButton := PluggableButtonMorph
					on: aDebugWindow
					getState: nil
					action: quad second.
				aButton label: quad first.
				aButton setBalloonText: quad fourth.
				aButton useSquareCorners.
				aRow addMorphBack: aButton.
				aRow addMorphBack: AlignmentMorph newVariableTransparentSpacer].
	^ aRow! !

!Debugger methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2006 11:49'!
customButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'customButtonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| aRow aButton aLabel |
	aRow := AlignmentMorph newRow beSticky.
	aRow layoutInset: 0.
	aRow setNameTo: 'customButtonPane'.
	aRow clipSubmorphs: true.
	self customButtonSpecs do:
		[:tuple |
			aButton := PluggableButtonMorph
				on: self
				getState: nil
				action: tuple second.
			aButton
				hResizing: #spaceFill;
				vResizing: #spaceFill.
			(#(proceed restart send doStep stepIntoBlock fullStack where) includes: tuple second)
				ifTrue:
					[aButton askBeforeChanging: true].

			aLabel := Preferences abbreviatedBrowserButtons 
				ifTrue: [self abbreviatedWordingFor: tuple second]
				ifFalse: [nil].
			aButton label: (aLabel ifNil: [tuple first asString]).

			tuple size > 2 ifTrue: [aButton setBalloonText: tuple third].
			aRow addMorphBack: aButton].
	^ aRow! !

!Debugger methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/23/2006 11:49'!
optionalButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'buttonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| aRow aButton aLabel |
	aRow := AlignmentMorph newRow beSticky.
	aRow layoutInset: 0.
	aRow setNameTo: 'buttonPane'.
	aRow clipSubmorphs: true.
	self optionalButtonPairs do:
		[:tuple |
				aButton := PluggableButtonMorph
					on: self
					getState: nil
					action: tuple second.
				aButton
					hResizing: #spaceFill;
					vResizing: #spaceFill.
				(#(proceed restart send doStep stepIntoBlock fullStack where) includes: tuple second)
					ifTrue:
						[aButton askBeforeChanging: true].

				aLabel := Preferences abbreviatedBrowserButtons 
					ifTrue: [self abbreviatedWordingFor: tuple second]
					ifFalse: [nil].
				aButton label: (aLabel ifNil: [tuple first asString]).

				tuple size > 2 ifTrue: [aButton setBalloonText: tuple third].
				aRow addMorphBack: aButton].
	^ aRow! !

!BorderedSubpaneDividerMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/2/2007 13:56'!
adoptPaneColor: paneColor
	"Match the color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: paneColor! !

PBPreferenceView subclass: #PBUIThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PBUIThemePreferenceView commentStamp: 'gvc 7/16/2007 13:51' prior: 0!
PreferenceBrowser support for selecting a UITheme.!

!PBUIThemePreferenceView class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:28'!
initialize
	"Inititalize the class.
	Register with the PreferenceViewRegistry for ui themes."
	
	PreferenceViewRegistry ofUIThemePreferences register: self.
	Preferences 
		addPreference: #uiTheme 
		categories: #(morphic windows)
		default: UIThemeStandardSqueak
		balloonHelp: ''
		projectLocal: false
		changeInformee: nil
		changeSelector: nil
		viewRegistry: PreferenceViewRegistry ofUIThemePreferences! !

!PBUIThemePreferenceView class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:23'!
unload
	"Unload the class.
	Unregister with the PreferenceViewRegistry for ui themes."
	
	PreferenceViewRegistry ofUIThemePreferences unregister: self! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:13'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	"Answer the morph for the panel."
	
	| innerPanel |
	innerPanel := self horizontalPanel
		addMorphBack: (self blankSpaceOf: 10@0);
		addMorphBack: self uiThemeRadioButtons;
		yourself.
	^self verticalPanel
		color: aColor;
		layoutInset: 2;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: innerPanel! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:17'!
uiThemeRadioButtons
	"Answer a column of butons representing the choices of ui theme"

	| buttonColumn aRow aRadioButton aLabel |
	buttonColumn := self verticalPanel.
	UITheme allThemeClasses do: [:c |
		aRadioButton := UpdatingThreePhaseButtonMorph radioButton
			target: c;
			setBalloonText: 'Use the ', c themeName, ' theme';
			actionSelector: #beCurrent;
			getSelector: #isCurrent;
			arguments: #();
			yourself.
		aLabel := (StringMorph contents: c themeName)
					setBalloonText: 'Use the ', c themeName, ' theme';
					yourself.
		aRow := self horizontalPanel
			cellInset: 4;
			addMorphBack: aRadioButton;
			addMorphBack: aLabel.
		buttonColumn addMorphBack: aRow].
	^buttonColumn! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 10:52'!
disable
	"Disable the button."

	self enabled: false! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/9/2006 11:47'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Whiten the whole thing if disabled."

	super drawSubmorphsOn: aCanvas.
	(self label isMorph and: [self enabled not])
		ifTrue: [aCanvas fillRectangle: self innerBounds fillStyle: (Color white alpha: 0.4)]! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 10:52'!
enable
	"Enable the button."

	self enabled: true! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/7/2007 12:17'!
enabled: aBoolean
	"Set the enabled state of the receiver."
	
	enabled = aBoolean ifTrue: [^self].
	enabled := aBoolean.
	(self labelMorph respondsTo: #enabled:) ifTrue: [
		self labelMorph enabled: aBoolean].
	self changed! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/9/2007 16:18'!
initialize
	"initialize the receiver."
	
	enabled := true.
	super initialize.
	self color: Color transparent! !

!PluggableButtonMorphPlus methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/6/2006 13:39'!
update: aParameter
	"Update the receiver with any changes in the model."
	
	aParameter ifNil: [^self].
	super update: aParameter.
	aParameter == getEnabledSelector ifTrue: [
		^self enabled: (model perform: getEnabledSelector)]! !

!PreferenceViewRegistry class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/22/2007 15:24'!
ofUIThemePreferences
	"Answer the ui theme preference registry."
	
	^(self registryOf: #uiThemePreferences)
		viewOrder: 2;
		yourself! !

!Workspace class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:11'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallWindowIcon! !

!TopRightGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 10:53'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: w negated@w)
			containsPoint: aPoint) not]! !

!TopRightGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 12:13'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds right: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!PreferenceBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:51'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallDoItIcon! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 12:08'!
initialize
	super initialize.
	self extent: self defaultWidth @ self defaultHeight.
	self layoutFrame: self gripLayoutFrame! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/12/2007 16:36'!
mouseDown: anEvent
	"Remember the receiver and target offsets too."
	
	|cp|
	cp _ anEvent cursorPoint.
	lastMouse := {cp. cp - self position. cp - self targetPoint}! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 2/12/2007 16:36'!
mouseMove: anEvent
	"Track the mouse for resizing."
	
	target ifNil: [^ self].
	target fastFramingOn 
		ifTrue: [target doFastWindowReframe: self ptName] 
		ifFalse: [
			lastMouse at: 1 put: anEvent cursorPoint.
			self targetPoint: lastMouse first - lastMouse last.
			self position: (lastMouse first - lastMouse second)].! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/12/2007 16:28'!
target
	"Answer the target."

	^target! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/12/2007 16:36'!
targetPoint
	"Answer the reference point of the target."

	^self target bounds pointAtSideOrCorner: self ptName! !

!CornerGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/5/2007 16:25'!
targetPoint: aPoint
	"Set the reference point of the target."

	|minExt rect|
	rect _ self target bounds withSideOrCorner: self ptName setToPoint: aPoint.
	minExt _ self target minimumExtent.
	rect width <= minExt x ifTrue: [
		(self ptName = #topLeft or: [self ptName = #bottomLeft])
			ifTrue: [rect _ rect withSideOrCorner: #left setToPoint: self target bounds bottomRight - minExt]
			ifFalse: [rect _ rect withSideOrCorner: #right setToPoint: self target bounds topLeft + minExt]].
	rect height <= minExt y ifTrue: [
		(self ptName = #topLeft or: [self ptName = #topRight])
			ifTrue: [rect _ rect withSideOrCorner: #top setToPoint: self target bounds bottomRight - minExt]
			ifFalse: [rect _ rect withSideOrCorner: #bottom setToPoint: self target bounds topLeft + minExt]].
	self target bounds: rect! !

!FlapTab methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/16/2007 12:48'!
spanWorld
	"Fix for making the height/width of a solid tab be the same as the flap."
	
	| container area |
	container := self pasteUpMorph
				ifNil: [self currentWorld].
	area := container clearArea.
	self orientation == #vertical ifTrue: [
		referent vResizing == #rigid
			ifTrue: [self isCurrentlySolid ifTrue: [self height: area height].
					referent height: area height].
		referent hResizing == #rigid
			ifTrue: [referent width: (referent width min: area width - self width)].
		referent top: area top.
		referent bottom: (area bottom min: referent bottom)
	]
	ifFalse: [
		referent hResizing == #rigid
			ifTrue: [self isCurrentlySolid ifTrue: [self width: area width].
					referent width: area width].
		referent vResizing == #rigid
			ifTrue: [referent height: (referent height min: area height - self height)].
		referent left: area left.
		referent right: (area right min: referent right)
	].
! !

!TranslucentColor methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/21/2006 09:49'!
pixelWord32
	"Returns an integer representing the bits that appear in a single pixel of this color in a Form of depth 32.
	Transparency: The pixel value zero is reserved for transparent. For depths greater than 8, black maps to the darkest possible blue.
	Just a little quicker if we are dealing with RGBA colors at 32 bit depth."

	| val |
	val _ super pixelWord32.
	val at: 4 put: alpha.
	^val
! !

!SelectorBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:53'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallInspectItIcon! !

Morph subclass: #BracketMorph
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!BracketMorph commentStamp: 'gvc 5/18/2007 13:48' prior: 0!
Morph displaying opposing arrows.!

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:16'!
drawOn: aCanvas
	"Draw triangles at the edges."
	
	|r|
	r := self horizontal
		ifTrue: [self bounds insetBy: (2@1 corner: 2@1)]
		ifFalse: [self bounds insetBy: (1@2 corner: 1@2)].
	aCanvas
		drawPolygon: (self leftOrTopVertices: self bounds)
		fillStyle: self borderColor;
		drawPolygon: (self leftOrTopVertices: r)
		fillStyle: self fillStyle;
		drawPolygon: (self rightOrBottomVertices: self bounds)
		fillStyle: self borderColor;
		drawPolygon: (self rightOrBottomVertices: r)
		fillStyle: self fillStyle! !

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:48'!
horizontal
	"Answer whether horizontal or vertical."
	
	^self orientation == #horizontal! !

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:54'!
horizontal: aBoolean
	"Set whether horizontal or vertical."
	
	^self orientation: (aBoolean ifTrue: [#horizontal] ifFalse: [#vertical])! !

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:52'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		orientation: #horizontal! !

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:45'!
leftOrTopVertices: r
	"Answer the vertices for a left or top bracket in the given rectangle."
	
	^self orientation == #vertical
		ifTrue: [{r topLeft - (0@1). r left + (r height // 2 + (r height \\ 2))@(r center y - (r height + 1 \\ 2)).
				r left + (r height // 2 + (r height \\ 2))@(r center y). r bottomLeft}]
		ifFalse: [{r topLeft. (r center x - (r width + 1 \\ 2))@(r top + (r width // 2 + (r width \\ 2))).
				r center x@(r top + (r width // 2 + (r width \\ 2))). r topRight}]! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:51'!
orientation
	"Answer the value of orientation"

	^ orientation! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:52'!
orientation: anObject
	"Set the value of orientation"

	orientation := anObject.
	self changed! !

!BracketMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:18'!
rightOrBottomVertices: r
	"Answer the vertices for a right or bottom bracket in the given rectangle."
	
	^self orientation == #vertical
		ifTrue: [{r topRight - (0@1). r right - (r height // 2 + (r height \\ 2))@(r center y - (r height + 1 \\ 2)).
				r right - (r height // 2 + (r height \\ 2))@(r center y). r bottomRight}]
		ifFalse: [{(r center x)@(r bottom - 1 - (r width // 2 + (r width \\ 2))).
				r center x @(r bottom - 1 - (r width // 2 + (r width \\ 2))). r bottomRight. r bottomLeft - (1@0)}]! !

Morph subclass: #FullscreenMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!FullscreenMorph commentStamp: 'gvc 5/18/2007 13:04' prior: 0!
Provides for another morph to occupy the full screen area (less docking bars).!

!FullscreenMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 12:19'!
initialize
	"Set up the halosEnabled and editableStringMorphs preferences here to allow for restricting
	access in a deployed image."

	Preferences
		addPreference: #halosEnabled
		categories: #(halos)
		default: true
		balloonHelp: 'Determines whether blue-button halos are enabled or not.';
		addPreference: #editableStringMorphs
		categories: #(morphic)
		default: false
		balloonHelp: 'Determines whether shift-clicking on a string morph will make the text editable.'! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/30/2006 10:44'!
contentMorph
	"Answer the current content."
	
	^self submorphs first! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/21/2007 15:57'!
defaultColor
	"Return the receiver's default color."
	
	^Color transparent! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:21'!
edgeToAdhereTo
	"Must implement. Answer #none."
	
	^#none! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 12:57'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeProportionalLayout;
		bounds: World clearArea;
		beSticky! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToBottom
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToLeft
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToRight
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToTop
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:11'!
isDockingBar
	"Answer yes so we get updated when the Display is resized."

	^true! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/30/2006 14:06'!
openAsIs
	"Open in the current world with the current position and extent."
	
	^self openAsIsIn: self currentWorld
! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 10:03'!
openAsIsIn: aWorld
	"Start stepping."
	
	aWorld addMorph: self.
	(self submorphs notEmpty and: [self submorphs first isSystemWindow])
		ifTrue: [self submorphs first openedFullscreen].
	aWorld startSteppingSubmorphsOf: self! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 09:04'!
openInWorld: aWorld
	"Open as is."
	
	^self openAsIsIn: aWorld! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 09:08'!
setContentMorph: aMorph
	"Replace the submorphs with aMorph."
	
	self removeAllMorphs.
	self
		addMorph: aMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 19:27'!
updateBounds
	"Update the receiver's bounds to fill the world."

	self bounds: self owner clearArea
	! !

Morph subclass: #GeneralScrollPane
	instanceVariableNames: 'scroller hScrollbar vScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!GeneralScrollPane commentStamp: 'gvc 5/18/2007 13:01' prior: 0!
A scroll pane that handles its contents accurately.!

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 16:03'!
adoptPaneColor: paneColor
	"Adopt the given pane color."
	
	super adoptPaneColor: paneColor.
	self hScrollbar adoptPaneColor: paneColor.
	self vScrollbar adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: (self scrollTarget isNil
		ifTrue: [self paneColor]
		ifFalse: [self scrollTarget color])
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:23'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^ Color transparent! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:43'!
defaultScrollTarget
	"Answer a new default scroll target."

	^RectangleMorph new
		extent: 200@150! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 11:06'!
extent: newExtent
	"Update the receiver's extent. Hide/show the scrollbars and resize the scroller
	as neccessary."
	
	|scrollbarChange|
	bounds extent = newExtent ifTrue: [^ self].
	super extent: newExtent.
	scrollbarChange := (self vScrollbarShowing = self vScrollbarNeeded) not.
	scrollbarChange := scrollbarChange or: [(self hScrollbarShowing = self hScrollbarNeeded) not].
	self	updateScrollbars.
	scrollbarChange ifFalse: [self resizeScroller] "if there is a scrollbar change then done already"! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 16:13'!
fitScrollTarget
	"If the scroller is bigger than the scroll target then
	resize the scroll target to fill the scroller."
	
	|extra|
	extra _ 0.
	self scroller width > self scrollTarget width
		ifTrue: [self scrollTarget width: self scroller width]
		ifFalse: [extra _ self scrollbarThickness].
	self scroller height - extra > self scrollTarget height
		ifTrue: [self scrollTarget height: self scroller height + extra]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
hHideScrollbar
	"Hide the horizontal scrollbar."
	
	self hScrollbarShowing ifFalse: [^self].
	self removeMorph: self hScrollbar.
	self vResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:31'!
hPageDelta
	"Answer the horizontal page delta."
	
	|pd tw sw|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:27'!
hResizeScrollbar
	"Resize the horizontal scrollbar to fit the receiver."
	
	|b|
	b _ self innerBounds.
	b _ b top: b bottom - self scrollbarThickness.
	self vScrollbarShowing ifTrue: [
		b _ b right: b right - self scrollbarThickness].
	self hScrollbar bounds: b! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar
	"Answer the value of hScrollbar"

	^ hScrollbar! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar: anObject
	"Set the value of hScrollbar"

	hScrollbar := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:37'!
hScrollbarInterval
	"Answer the computed size of the thumb of the horizontal scrollbar."
	
	^self scrollBounds width asFloat / self scrollTarget width min: 1.0.! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
hScrollbarNeeded
	"Return whether the horizontal scrollbar is needed."
	
	^self scrollTarget width > self innerBounds width! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:07'!
hScrollbarShowing
	"Answer whether the horizontal scrollbar is showing."
	
	^self hScrollbar owner notNil
	! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:34'!
hScrollbarValue
	"Answer the computed horizontal scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset x asFloat / v min: 1.0].
	^v! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
hScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget width - self scrollBounds width max: 0.
	self scroller
		offset: (r * scrollValue) rounded @ self scroller offset y! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:36'!
hSetScrollDelta
	"Set the horizontal scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self hPageDelta.
	self hScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self hScrollbarInterval;
		setValue: self hScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
hShowScrollbar
	"Show the horizontal scrollbar."
	
	self hResizeScrollbar.
	self hScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self hScrollbar atIndex: 1.
	self vResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:08'!
hUpdateScrollbar
	"Update the visibility and dimensions of the horizontal scrollbar as needed."
	
	self hScrollbarNeeded
		ifTrue: [self hShowScrollbar]
		ifFalse: [self hHideScrollbar]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
handlesKeyboard: evt
	"Yes for page up/down."
	
	^true! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scroller: self newScroller;
		hScrollbar: self newHScrollbar;
		vScrollbar: self newVScrollbar;
		scrollTarget: self defaultScrollTarget.
	self
		addMorph: self scroller;
		resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
keyStroke: evt
	"If pane is not empty, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	(self scrollByKeyboard: evt) ifTrue: [^self].
	self scrollTarget keyStroke: evt! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:45'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^GeneralScrollBar new
		model: self;
		setValueSelector: #hScrollbarValue:! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:50'!
newScroller
	"Answer a new scroller."

	^TransformMorph new
		color: Color transparent! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:45'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^GeneralScrollBar new
		model: self;
		setValueSelector: #vScrollbarValue:! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:57'!
resizeScroller
	"Resize the scroller to fit the scroll bounds."
	
	self scroller bounds: self scrollBounds! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:56'!
scrollBounds
	"Return the visible scroll area taking into account whether
	the scrollbars need to be shown."
	
	|b|
	b _ self innerBounds.
	self vScrollbarNeeded ifTrue: [b _ b right: (b right - self scrollbarThickness)].
	self hScrollbarNeeded ifTrue: [b _ b bottom: (b bottom - self scrollbarThickness)].
	^b! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 14:07'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true."
	
	|sb|
	sb _ event commandKeyPressed
		ifTrue: [self hScrollbar]
		ifFalse: [self vScrollbar].
	(event keyValue = 30 or: [event keyValue = 11]) ifTrue: [
		sb scrollUp: 3.
		^true].
	(event keyValue = 31 or: [event keyValue = 12])ifTrue: [
		sb scrollDown: 3.
		^true].
	^false! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 17:04'!
scrollDeltaHeight
	"Return the increment in pixels which this pane should be scrolled.
	Let it be 1/3 of the visible section."
	
	scroller hasSubmorphs ifFalse: [^1].
	^self innerBounds height squared / self vTotalScrollRange // 5 max: 1
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2006 17:04'!
scrollDeltaWidth
	"Return the increment in pixels which this pane should be scrolled.
	Let it be 1/5 of the visible section."
	
	scroller hasSubmorphs ifFalse: [^1].
	^self innerBounds width squared / self hTotalScrollRange // 5 max: 1
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:48'!
scrollTarget
	"Answer the morph that is scrolled."
	
	^self scroller submorphs first! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:48'!
scrollTarget: aMorph
	"Set the morph that is scrolled."
	
	self scroller
		removeAllMorphs;
		addMorph: aMorph.
	self updateScrollbars! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:56'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^Preferences scrollBarsNarrow
		ifTrue: [10]
		ifFalse: [14]! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller
	"Answer the value of scroller"

	^ scroller! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller: anObject
	"Set the value of scroller"

	scroller := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
setScrollDeltas
	"Set the ScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	
	self
		hSetScrollDelta;
		vSetScrollDelta! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
updateScrollbars
	"Update the visibility, dimensions and values of the scrollbars as needed."
	
	self
		vUpdateScrollbar;
		hUpdateScrollbar;
		setScrollDeltas! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
vHideScrollbar
	"Hide the vertical scrollbar."
	
	self vScrollbarShowing ifFalse: [^self].
	self removeMorph: self vScrollbar.
	self hResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:47'!
vLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	
	^self scrollTarget height - self scrollBounds height max: 0
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vPageDelta
	"Answer the vertical page delta."
	
	|pd tw sw|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:27'!
vResizeScrollbar
	"Resize the vertical scrollbar to fit the receiver."
	
	|b|
	b _ self innerBounds.
	b _ b left: b right - self scrollbarThickness.
	self hScrollbarShowing ifTrue: [
		b _ b bottom: b bottom - self scrollbarThickness].
	self vScrollbar bounds: b! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar
	"Answer the value of vScrollbar"

	^ vScrollbar! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar: anObject
	"Set the value of vScrollbar"

	vScrollbar := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vScrollbarInterval
	"Answer the computed size of the thumb of the vertical scrollbar."
	
	^self scrollBounds height asFloat / self scrollTarget height min: 1.0.! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
vScrollbarNeeded
	"Return whether the vertical scrollbar is needed."
	
	^self scrollTarget height > self innerBounds height! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:15'!
vScrollbarShowing
	"Answer whether the vertical scrollbar is showing."
	
	^self vScrollbar owner notNil
	! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:50'!
vScrollbarValue
	"Answer the computed vertical scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset y asFloat / v min: 1.0].
	^v! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
vScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget height - self scrollBounds height max: 0.
	self scroller
		offset: self scroller offset x @ (r * scrollValue) rounded! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:52'!
vSetScrollDelta
	"Set the vertical scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self vPageDelta.
	self vScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self vScrollbarInterval;
		setValue: self vScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
vShowScrollbar
	"Show the vertical scrollbar."
	
	self vResizeScrollbar.
	self vScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self vScrollbar atIndex: 1.
	self hResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:03'!
vUpdateScrollbar
	"Update the visibility and dimensions of the vertical scrollbar as needed."
	
	self vScrollbarNeeded
		ifTrue: [self
				vShowScrollbar;
				vResizeScrollbar]
		ifFalse: [self vHideScrollbar]! !

Morph subclass: #HSVAColorSelectorMorph
	instanceVariableNames: 'hsvMorph aMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!HSVAColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:55' prior: 0!
Colour selector featuring a saturation/volume area, hue selection strip and alpha selection strip.!

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
aMorph
	"Answer the value of aMorph"

	^ aMorph! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
aMorph: anObject
	"Set the value of aMorph"

	aMorph := anObject! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:58'!
alphaSelected: aFloat
	"The alpha has changed."

	self triggerSelectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:58'!
colorSelected: aColor
	"A color has been selected. Set the base color for the alpha channel."

	self aMorph color: aColor.
	self triggerSelectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:44'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color transparent
! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
hsvMorph
	"Answer the value of hsvMorph"

	^ hsvMorph! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
hsvMorph: anObject
	"Set the value of hsvMorph"

	hsvMorph := anObject! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:47'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		extent: 180@168;
		changeTableLayout;
		cellInset: 4;
		aMorph: self newAColorMorph;
		hsvMorph: self newHSVColorMorph;
		addMorphBack: self hsvMorph;
		addMorphBack: self aMorph.
	self aMorph color: self hsvMorph selectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:11'!
newAColorMorph
	"Answer a new alpha color morph."

	^AColorSelectorMorph new
		model: self;
		hResizing: #spaceFill;
		vResizing: #rigid;
		setValueSelector: #alphaSelected:;
		extent: 24@24! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:00'!
newHSVColorMorph
	"Answer a new hue/saturation/volume color morph."

	^HSVColorSelectorMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		when: #colorSelected send: #colorSelected: to: self! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:18'!
selectedColor
	"Answer the selected color."

	^self hsvMorph selectedColor alpha: self aMorph value! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:12'!
selectedColor: aColor
	"Set the hue and sv components."

	self aMorph value: aColor alpha.
	self hsvMorph selectedColor: aColor asNontranslucentColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:57'!
triggerSelectedColor
	"Trigger the event for the selected colour"

	self triggerEvent: #selectedColor with: self selectedColor! !

Morph subclass: #HSVColorSelectorMorph
	instanceVariableNames: 'svMorph hMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!HSVColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:55' prior: 0!
Colour selector featuring a saturation/volume area and a hue selection strip.!

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:28'!
colorSelected: aColor
	"A color has been selected. Make the hue match."

	"self hMorph value: aColor hue / 360.
	self svMorph basicColor: (Color h: aColor hue s: 1.0 v: 1.0)."
	self triggerEvent: #colorSelected with: aColor! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:44'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color transparent
! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 13:30'!
hMorph
	"Answer the value of hMorph"

	^ hMorph! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 13:30'!
hMorph: anObject
	"Set the value of hMorph"

	hMorph := anObject! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:23'!
hue: aFloat
	"Set the hue in the range 0.0 - 1.0. Update the SV morph and hMorph."

	self hMorph value: aFloat.
	self svMorph color: (Color h: aFloat * 359.9 s: 1.0 v: 1.0)! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:25'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		cellInset: 4;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		svMorph: self newSVColorMorph;
		hMorph: self newHColorMorph;
		addMorphBack: self svMorph;
		addMorphBack: self hMorph;
		extent: 192@152;
		hue: 0.5! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 12:33'!
newHColorMorph
	"Answer a new hue color morph."

	^HColorSelectorMorph new
		model: self;
		setValueSelector: #hue:;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 36@36! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:54'!
newSVColorMorph
	"Answer a new saturation/volume color morph."

	^SVColorSelectorMorph new
		extent: 152@152;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		when: #colorSelected send: #colorSelected: to: self! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:41'!
selectedColor
	"Answer the selected color."

	^self svMorph selectedColor! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:38'!
selectedColor: aColor
	"Set the hue and sv components."

	self hue: aColor hue / 360.
	self svMorph selectedColor: aColor! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 12:26'!
svMorph
	"Answer the value of svMorph"

	^ svMorph! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 12:26'!
svMorph: anObject
	"Set the value of svMorph"

	svMorph := anObject! !

Morph subclass: #ImagePreviewMorph
	instanceVariableNames: 'imageMorph textMorph defaultImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ImagePreviewMorph commentStamp: 'gvc 5/18/2007 12:51' prior: 0!
Displays an image scaled to a fixed size along with a label describing the original dimensions.!

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:33'!
cornerStyle: aSymbol
	"Pass on to selector and content too."

	super cornerStyle: aSymbol.
	self imageMorph cornerStyle: aSymbol! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:32'!
defaultImageFormOfSize: aPoint
	"Answer a default preview image form."

	^(defaultImageForm isNil or: [defaultImageForm extent ~= aPoint])
		ifTrue: [defaultImageForm _ Form extent: aPoint]
		ifFalse: [defaultImageForm]! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:38'!
image: form size: imageSize
	"Set the image and update the description."
	
	form
		ifNil: [self imageMorph
				image: (self defaultImageFormOfSize: imageSize).
			self textMorph
				contents: '']
	ifNotNil: [self imageMorph
				image: form
				size: imageSize.
			self textMorph
				contents: ('{1} x {2} pixels' translated
							format: {form width asString. form height asString})]
	! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
imageMorph
	"Answer the value of imageMorph"

	^ imageMorph! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
imageMorph: anObject
	"Set the value of imageMorph"

	imageMorph := anObject! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:42'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 16;
		imageMorph: self newImageMorph;
		textMorph: self newTextMorph;
		addMorphBack: self imageMorph;
		addMorphBack: self textMorph! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:42'!
newImageMorph
	"Answer a new image morph."

	^AlphaImageMorph new
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		alpha: 1.0! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:34'!
newTextMorph
	"Answer a new text morph."

	^StringMorph contents: ''! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

!Morph class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:48'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/18/2006 11:58'!
adoptPaneColor
	"Adopt our pane color."

	self adoptPaneColor: self paneColor! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/16/2007 11:26'!
changed
	"Report that the area occupied by this morph should be redrawn.
	Fixed to include submorphs outside the outerBounds."
	
	^fullBounds 
		ifNil: [self invalidRect: self privateFullBounds]
		ifNotNil: [self invalidRect: fullBounds]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/20/2007 10:31'!
defaultTaskbarThumbnailExtent
	"Answer the default size of a taskbar thumbnail for the receiver."

	^320@320! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 13:40'!
dialogWindow
	"Answer the receiver's dialog window."

	^self ownerThatIsA: DialogWindow! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/5/2007 12:55'!
drawKeyboardFocusOn: aCanvas
	"Draw the keyboard focus indication."

	self focusIndicatorMorph
		drawOn: aCanvas! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:21'!
enabled
	"Answer whether the receiver is enabled."

	^true! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:31'!
fillStyle: aFillStyle
	"Set the current fillStyle of the receiver.
	Optimized for no change."
	
	(self valueOfProperty: #fillStyle ifAbsent: []) = aFillStyle
		ifTrue: [^self]. "no change optimization"
	self setProperty: #fillStyle toValue: aFillStyle.
	"Workaround for Morphs not yet converted"
	color := aFillStyle asColor.
	self changed.! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:29'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self bounds! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:59'!
focusColor
	"Answer the keyboard focus indication color."

	^self borderStyle color contrastingColor! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/5/2007 12:52'!
focusIndicatorMorph
	"Answer the focus indicator morph for the receiver."

	^self theme newFocusIndicatorMorphFor: self! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:31'!
handlerForBlueButtonDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event.
	Note: Halos handle blue button events themselves so we will only be asked if there is currently no halo on top of us.
	Check whtehr halods are enabled (for deployment)."
	
	Preferences halosEnabled ifFalse: [^nil].
	self wantsHaloFromClick ifFalse:[^nil].
	anEvent handler ifNil:[^self].
	anEvent handler isPlayfieldLike ifTrue:[^self]. "by default exclude playfields"
	(anEvent shiftPressed)
		ifFalse:[^nil] "let outer guy have it"
		ifTrue:[^self] "let me have it"
! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 17:21'!
hasKeyboardFocus
	"Answer whether the receiver has keyboard focus."

	^((self world ifNil: [^false]) 
		activeHand ifNil: [^false])  keyboardFocus = self! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/12/2007 10:12'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color white! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 11:54'!
lastSubmorphRecursive
	"Answer recursive last submoorph of the receiver."

	^self hasSubmorphs
		ifTrue: [self lastSubmorph lastSubmorphRecursive]
		ifFalse: [self]! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:32'!
minExtent
	"Layout specific. Return the minimum size the receiver can be represented in.
	Implementation note: When this message is sent from an owner trying to lay out its children it will traverse down the morph tree and recompute the minimal arrangement of the morphs based on which the minimal extent is returned. When a morph with some layout strategy is encountered, the morph will ask its strategy to compute the new arrangement. However, since the final size given to the receiver is unknown at the point of the query, the assumption is made that the current bounds of the receiver are the base on which the layout should be computed. This scheme prevents strange layout changes when for instance, a table is contained in another table. Unless the inner table has been resized manually (which means its bounds are already enlarged) the arrangement of the inner table will not change here. Thus the entire layout computation is basically an iterative process which may have different results depending on the incremental changes applied.
	Fixed for shrinkWrap."

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #rigid and: [vFit == #rigid]) 
		ifTrue: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].

	"An exception -- a receiver with #shrinkWrap constraints but no children is being treated #rigid (the equivalent to a #spaceFill receiver in a non-layouting owner)"
	self hasSubmorphs 
		ifFalse: 
			[hFit == #shrinkWrap ifTrue: [hFit := #rigid].
			vFit == #shrinkWrap ifTrue: [vFit := #rigid]].
	layout := self layoutPolicy.
	layout isNil 
		ifTrue: [minExtent := 0 @ 0]
		ifFalse: [minExtent := layout minExtentOf: self in: self layoutBounds].
	hFit == #rigid 
		ifTrue: [minExtent := self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			minExtent := (minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/11/2006 09:37'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	self lock! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/11/2006 09:38'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	self unlock! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/16/2007 12:22'!
morphicLayerNumberWithin: anOwner
	"Helpful for insuring some morphs always appear in front of or behind others.
	Smaller numbers are in front.
	Fixed here to call #morphicLayerNumber rather than access property directly."

	^(owner isNil or: [owner isWorldMorph or: [anOwner == owner]]) ifTrue: [
		self morphicLayerNumber
	] ifFalse: [
		owner morphicLayerNumber
	].

	"leave lots of room for special things"! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/7/2006 15:53'!
myDependents
	"Improved performance dependents."
	
	^(self valueOfProperty: #myDependents) ifNil: [super myDependents]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/7/2006 15:55'!
myDependents: aCollectionOrNil
	"Improved performance dependents."
	
	aCollectionOrNil isNil 
		ifTrue: [self removeProperty: #myDependents]
		ifFalse: [self setProperty: #myDependents toValue: aCollectionOrNil]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 16:19'!
navigateFocusBackward
	"Change the keyboard focus to the previous morph."

	self previousMorphWantingFocus ifNotNilDo: [:m |
		m world activeHand newKeyboardFocus: m]
	! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/16/2007 15:03'!
navigateFocusForward
	"Change the keyboard focus to the next morph."

	self nextMorphWantingFocus ifNotNilDo: [:m |
		m world ifNotNilDo: [:w | w activeHand newKeyboardFocus: m]]
	! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/18/2007 10:56'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Check for menu key to do popup."

	(self tabKey: event) ifTrue: [^true].
	(event keyCharacter = Character escape and: [
			event anyModifierKeyPressed]) ifTrue: [
		self yellowButtonActivity: false.
		^true].
	self window ifNotNilDo: [:win |
		(win keyStroke: event) ifTrue: [^true]].
	^false! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 11:32'!
nextMorphAcrossInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its next sibling or owner's next sibling etc."

	^self submorphAfter ifNil: [
		(self owner ifNil: [^self]) nextMorphAcrossInWindow]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 11:34'!
nextMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its first child or next sibling or owner's next sibling etc."

	^self hasSubmorphs
		ifTrue: [self submorphs first]
		ifFalse: [self nextMorphAcrossInWindow]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/8/2007 13:41'!
nextMorphWantingFocus
	"Answer the next morph that wants keyboard focus."

	|m|
	m := self nextMorphInWindow.
	[m = self or: [m wantsKeyboardFocusNavigation]]
		whileFalse: [m := m nextMorphInWindow].
	^m wantsKeyboardFocusNavigation
		ifTrue: [m]
	! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/16/2007 15:18'!
openInWindowLabeled: aString inWorld: aWorld
	"Changed to include the inset margin in the bound calculation."

	| window extent |
	window := (SystemWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth +
			(window class borderWidth * 2 @ (window class borderWidth + 1)). "include inset margin"
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/12/2007 15:57'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	|area mySysWin keyboardFocus|
	keyboardFocus _ self activeHand keyboardFocus.
	mySysWin := self isSystemWindow ifTrue: [self] ifFalse: [self ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := self].
	mySysWin modalLockTo: aSystemWindow.
	area := RealEstateAgent reduceByFlaps: RealEstateAgent maximumUsableArea.
	aSystemWindow extent: aSystemWindow initialExtent.
	aSystemWindow position = (0@0)
		ifTrue: [aSystemWindow
				position: self activeHand position - (aSystemWindow extent // 2)].
	aSystemWindow
		bounds: (aSystemWindow bounds translatedToBeWithin: area).
	[ToolBuilder default runModal: aSystemWindow openAsIs]
		ensure: [mySysWin modalUnlockFrom: aSystemWindow.
				self activeHand newKeyboardFocus: keyboardFocus].
	^aSystemWindow! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/8/2007 09:58'!
optimalExtent
	"Answer the submorphBounds extent plus twice our border width."
	
	^self submorphBounds extent + (self borderWidth * 2)! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/9/2007 12:25'!
paneColor
	"Answer the window's pane color or our color otherwise."

	^self paneColorOrNil ifNil: [self color]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/29/2006 16:21'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^(self owner ifNil: [^nil]) paneColorOrNil! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/13/2007 15:25'!
preferredCornerStyle
	"Answer the preferred corner style."

	^#square! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:06'!
previousMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its previous sibling's last submorph (recursive)
	or owner's previous sibling's last submorph (recursive) etc."

	^self submorphBefore notNil
		ifTrue: [self submorphBefore lastSubmorphRecursive]
		ifFalse: [self owner]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/8/2007 13:41'!
previousMorphWantingFocus
	"Answer the previous morph that wants keyboard focus."

	|m|
	m := self previousMorphInWindow ifNil: [^nil].
	[m = self or: [m wantsKeyboardFocusNavigation]]
		whileFalse: [m := m previousMorphInWindow ifNil: [^nil]].
	^m wantsKeyboardFocusNavigation
		ifTrue: [m]
	! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 11:11'!
tabKey: event
	"Check for tab key activity and change focus as appropriate."

	event keyCharacter = Character tab ifTrue: [
		event shiftPressed
			ifTrue: [self navigateFocusBackward]
			ifFalse: [self navigateFocusForward].
		^true].
	^false! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 12:27'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^ false! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/20/2007 11:30'!
taskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."

	|f t r|
	r := self bounds scaledAndCenteredIn: (0@0 extent: thumbExtent).
	f := Form extent: r extent depth: Display depth.
	t := MatrixTransform2x3 withScale: f extent / self extent.
	f getCanvas
		transformBy: t
		clippingTo: f boundingBox
		during: [:c | c translateBy: self topLeft negated during: [:ct | self fullDrawOn: ct]]
		smoothing: 2.
	^ImageMorph new
		image: f! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:44'!
taskbarButtonFor: aTaskBar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^nil! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 12:30'!
taskbarTask
	"Answer a new taskbar task for the receiver.
	Answer nil if not required."

	^nil! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/11/2007 15:04'!
taskbarThumbnail
	"Answer a new taskbar thumbnail for the receiver."

	^self taskThumbnailOfSize: self taskbarThumbnailExtent! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/11/2007 15:03'!
taskbarThumbnailExtent
	"Answer the size of a taskbar thumbnail for the receiver."

	^self extent min: self defaultTaskbarThumbnailExtent! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:51'!
theme
	"Answer the current theme for the receiver."

	(self valueOfProperty: #theme) ifNotNilDo: [:t | ^ t].
	^(self window ifNil: [self class]) theme! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/23/2007 15:53'!
theme: aUITheme
	"Set the current theme for the receiver."

	self setProperty: #theme toValue: aUITheme.
	self themeChanged! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/24/2007 10:25'!
themeChanged
	"The current theme has changed.
	Update any dependent visual aspects."

	self submorphsDo: [:m | m themeChanged]! !

!Morph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/17/2006 10:36'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean.
	Must update owner layout since its full bounds may depend
	on the receiver extending beyond its bounds."
	
	(extension isNil and:[aBoolean]) ifTrue: [^ self].
	self visible == aBoolean ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed.
	owner ifNotNil: [owner layoutChanged]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 2/8/2007 13:41'!
wantsKeyboardFocusNavigation
	"Answer whether the receiver would like keyboard focus
	when navigated to by keyboard."

	self eventHandler ifNotNil: [(self eventHandler handlesKeyboard: nil)
		ifTrue: [^true]].
	^self takesKeyboardFocus and: [
		self visible and: [self enabled]]! !

!Morph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 10:07'!
window
	"Answer the receiver's window."

	^self ownerThatIsA: SystemWindow! !

Morph subclass: #SVColorSelectorMorph
	instanceVariableNames: 'selectedColor locationMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!SVColorSelectorMorph commentStamp: 'gvc 8/8/2007 14:36' prior: 0!
A colour selector that displays an area with saturation on the x axis and volume on the y axis. Provides interactive selection of colour by mouse. For the moment it is event rather than model based.
Setting the color will specify the hue and setting the selectedColor will specify the saturation and volume (may have a different hue to that displayed if not in sync).!

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:54'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	self borderStyle baseColor: paneColor twiceDarker! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:15'!
basicColor: aColor
	"Set the gradient colors."
	
	super color: aColor asNontranslucentColor.
	self
		fillStyle: self gradient! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:13'!
blackGradient
	"Answer the black gradient. Top to bottom, transparent to black."

	^(InterpolatedGradientFillStyle colors: {Color black alpha: 0. Color black})
		origin: self innerBounds topLeft;
		direction: 0@self innerBounds height! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 11:36'!
blackGradientMorph
	"Answer the black gradient morph."

	^Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: self blackGradient! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:19'!
borderWidth: anInteger
	"Update the gradients after setting."
	
	super borderWidth: anInteger.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:15'!
color: aColor
	"Set the gradient colors."
	
	self
		basicColor: aColor;
		selectedColor: (Color h: aColor hue s: self selectedColor saturation v: self selectedColor brightness)! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 10:42'!
colorAt: aPoint
	"Answer the color in the world at the given point."
	
	^self isInWorld
		ifTrue: [(Display colorAt: aPoint) asNontranslucentColor ]
		ifFalse: [Color black]! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:33'!
extent: p
	"Update the gradient directions."

	super extent: p.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 10:49'!
fillStyle: fillStyle
	"If it is a color then override with gradient."
	
	fillStyle isColor
		ifTrue: [self color: fillStyle]
		ifFalse: [super fillStyle: fillStyle]! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:37'!
gradient
	"Answer the base gradient."

	|b|
	b _ self innerBounds.
	^(GradientFillStyle colors: {Color white. self color})
		origin: b topLeft;
		direction: (b width@0)! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/20/2006 12:50'!
handlesMouseDown: evt
	"Yes for down and move.." 

	^true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:33'!
handlesMouseOverDragging: evt
	"Yes, make the location morph visible when leaving."
	
	^true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:25'!
hideLocation
	"Hide the location morph and update the display."
	
	self locationMorph visible: false.
	World displayWorldSafely.! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:22'!
initialize
	"Initialize the receiver."

	super initialize.
	self locationMorph: self newLocationMorph.
	self
		clipSubmorphs: true;
		color: Color blue;
		borderStyle: (BorderStyle inset width: 1);
		addMorphBack: self locationMorph;
		addMorphBack: self blackGradientMorph! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:23'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 13:37'!
locationMorph
	"Answer the value of locationMorph"

	^ locationMorph! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 13:37'!
locationMorph: anObject
	"Set the value of locationMorph"

	locationMorph := anObject! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 14:04'!
mouseDown: evt 
	"Handle a mouse down event. Select the color at the mouse position."
	
	evt redButtonPressed
		ifFalse: [^super mouseDown: evt].
	evt hand showTemporaryCursor: (Cursor crossHair copy offset: -9@-9).
	self hideLocation.
	self selectColorAt: evt position.
	^super mouseDown: evt! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:56'!
mouseEnterDragging: evt
	"Make the location morph invisible when entering."
	
	self hideLocation.
	evt hand showTemporaryCursor: (Cursor crossHair copy offset: -9@-9).! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:56'!
mouseLeaveDragging: evt
	"Make the location morph visible when leaving."
	
	evt hand showTemporaryCursor: nil.
	self showLocation! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 12:11'!
mouseMove: evt 
	"Handle a mouse move event. Select the color at the mouse position."
	
	evt redButtonPressed
		ifFalse: [^super mouseMove: evt].
	self selectColorAt: evt position.
	^super mouseMove: evt! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:12'!
mouseUp: evt 
	"Handle a up event. Show the location morph again."
	
	evt hand showTemporaryCursor: nil.
	self updateSelectedLocation.
	self locationMorph visible: true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:16'!
newLocationMorph
	"Answer a new morph indicating the location of the selected color."

	^ImageMorph new
		image: Cursor crossHair withMask asCursorForm! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 12:12'!
selectColorAt: aPoint
	"Set the color at the given position."
	
	|b p|
	b := self innerBounds.
	p := (b containsPoint: aPoint)
		ifTrue: [aPoint]
		ifFalse: [b pointNearestTo: aPoint].
	p := p - b topLeft / b extent.
	self selectedColor: (Color
		h: self color hue
		s: p x
		v: 1.0 - p y)! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:08'!
selectedColor
	"Answer the value of selectedColor"

	^selectedColor ifNil: [self color]! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 14:01'!
selectedColor: aColor
	"Set the value of selectedColor."

	selectedColor := aColor.
	self locationMorph visible ifTrue: [self updateSelectedLocation].
	self triggerEvent: #colorSelected with: aColor! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:25'!
selectedLocation
	"Answer the location within the receiver of the selected colour
	relative to the receiver's top left."

	|b c x y|
	b := self innerBounds.
	c := self selectedColor.
	x := c saturation * (b width - 1).
	y := 1 - c brightness * (b height - 1).
	^(x truncated @ y truncated) + b topLeft! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:26'!
showLocation
	"Show the location morph and update the display."
	
	self locationMorph visible: true.
	World displayWorldSafely.! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:22'!
updateGradients
	"Update the gradient directions."

	|bgm b|
	b _ self innerBounds.
	bgm := self submorphs last.
	bgm bounds: b.
	bgm fillStyle
		origin: b topLeft;
		direction: 0@b height.
	self fillStyle
		origin: b topLeft;
		direction: (b width@0).
	self updateSelectedLocation! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:17'!
updateSelectedLocation
	"Position the location morph to indicate the selected colour."
	
	self locationMorph
		position: (self selectedLocation - (self locationMorph extent // 2 + (self locationMorph extent \\ 2)))! !

Morph subclass: #TaskbarMorph
	instanceVariableNames: 'tasks orderedTasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TaskbarMorph commentStamp: 'gvc 5/18/2007 11:28' prior: 0!
Themed synchronous taskbar (not using #step to poll windows). The buttons provide visual feedback as to whether a window is active or minimised (collapsed) plus a popup menu with options to restore, minimise, maximise and close the associated window. Optional (via Preferences) preview of the window while mouse is over a taskbar button.
See the preference browser (PreferenceBrowser open) under "docking bars" for options.!

!TaskbarMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 4/25/2007 16:23'!
initialize
	"Initialize the receiver."
	
	Preferences
		addPreference: #showWorldTaskbar
		categories: #(#'docking bars' windows)
		default: true
		balloonHelp: 'Whether the world''s taskbar should be shown or not.'
		projectLocal: false
		changeInformee: self
		changeSelector: #showTaskbarPreferenceChanged;
		addPreference: #worldTaskbarWindowPreview
		categories: #(#'docking bars' windows)
		default: true
		balloonHelp: 'Whether the world''s taskbar buttons should show previews of the associated window while the mouse is over them.'.
	self showTaskbarPreferenceChanged! !

!TaskbarMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:56'!
isTaskbarPresent
	"Answer whether there is a taskbar in the world."

	^self worldTaskbar notNil! !

!TaskbarMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 4/26/2007 09:44'!
reset
	"Remove the taskbar and add a new one."
	
	(World submorphs select: [:m | m isKindOf: self])
		do: [:tb | tb delete].
	self new openInWorld! !

!TaskbarMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 10:50'!
showTaskbarPreferenceChanged
	"Add or remove the taskbar as appropriate.
	Forget about sub-projects for the moment."
	
	Preferences showWorldTaskbar
		ifTrue: [self isTaskbarPresent
				ifFalse: [self new openInWorld]]
		ifFalse: [(World submorphs select: [:m | m isKindOf: self])
					do: [:tb | tb delete]]! !

!TaskbarMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:56'!
worldTaskbar
	"Answer the world taskbar or nil if none."

	^World findA: TaskbarMorph! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 14:06'!
buttonClicked: targetTask
	"The button has been clicked."
	
	targetTask activate! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 14:44'!
edgeToAdhereTo
	"Must implement. Answer #bottom."
	
	^#bottom! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 16:21'!
handlesMouseDown: evt
	"Best to say we will to avoid being grabbed."
	
	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 14:51'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeLayout;
		initializeAppearance;
		tasks: #();
		orderedTasks: OrderedCollection new! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 12:14'!
initializeAppearance
	"Initialize the appearance."

	self
		color: (Color black alpha: 0.3);
		fillStyle: (self theme taskbarFillStyleFor: self)! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 15:27'!
initializeLayout
	"Initialize the layout."

	self
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		extent: self minimumExtent! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:28'!
intoWorld: aWorld
	"Stick to the bottom left now."
	
	self
		setToAdhereToEdge: #bottomLeft;
		updateBounds.
	super intoWorld: aWorld! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:19'!
isAdheringToBottom
	"Must implement. Answer true."
	
	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToLeft
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToRight
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToTop
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:13'!
isDockingBar
	"Answer yes so we get updated when the Display is resized."

	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 12:09'!
minimumExtent
	"Answer the minimum extent."

	^40@25! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:34'!
morphicLayerNumber
	"Helpful for ensuring some morphs always appear in front of or 
	behind others. Smaller numbers are in front"
	
	^11! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
orderedTasks
	"Answer the value of orderedTasks"

	^ orderedTasks! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
orderedTasks: anObject
	"Set the value of orderedTasks"

	orderedTasks := anObject! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/8/2007 17:16'!
ownerChanged
	"The receiver's owner has changed its layout."
	
	self owner ifNil: [^self].
	[self updateBounds.
	self updateTasks]
		on: Exception
		do: [:ex | self delete. ex pass].
	super ownerChanged! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:59'!
taskButtonOf: aMorph
	"Answer the task button of the given morph or nil if none."

	^self submorphs detect: [:t | t model = aMorph] ifNone: []! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:58'!
taskOf: aMorph
	"Answer the task of the given morph or nil if none."

	^self orderedTasks detect: [:t | t morph = aMorph] ifNone: []! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
tasks
	"Answer the value of tasks"

	^ tasks! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
tasks: anObject
	"Set the value of tasks"

	tasks := anObject! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 15:01'!
updateBounds
	"Update the receiver's bounds to fill the world."

	self width: self owner width! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:21'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	|button|
	self removeAllMorphs.
	self orderedTasks do: [:t |
		button := t taskbarButtonFor: self.
		button ifNotNil: [self addMorphBack: button]]! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 13:05'!
updateTasks
	"Check for changes in the world's submorphs.
	Note that if the task attributes change then a
	task will be considered dead along with a new replacement."
	
	|wm deadTasks newTasks|
	wm := self worldMorphs.
	self tasks: ((wm collect: [:m | m taskbarTask]) select: [:m | m notNil]) asOrderedCollection.
	deadTasks := self orderedTasks difference: self tasks.
	newTasks := self tasks difference: self orderedTasks.
	(newTasks isEmpty and: [deadTasks isEmpty])
		ifTrue: [^self]. "no changes"
	newTasks copy do: [:t |
		(self orderedTasks detect: [:ot | ot morph = t morph] ifNone: []) ifNotNilDo: [:ot |
			self orderedTasks replaceAll: ot with: t.
			deadTasks remove: ot.
			newTasks remove: t]]. "replace in order any changed tasks."
	self orderedTasks
		removeAll: deadTasks;
		addAll: newTasks reversed.
	self updateTaskButtons.
	WorldState addDeferredUIMessage: [self layoutChanged] "may have a different number of rows"! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:30'!
wantsToBeTopmost
	"Answer if the receiver want to be one of the topmost
	objects in its owner."
	
	^ true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 12:39'!
worldMorphs
	"Answer the world's submorphs plus those in hand.
	Nasty case since hand removes the morph before dropping"
	
	^self world submorphs, 
		((self tasks
			select: [:t | t morph owner = self world activeHand])
			collect: [:t | t morph])! !

Morph subclass: #TasklistMorph
	instanceVariableNames: 'tasks taskList preview'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TasklistMorph commentStamp: 'gvc 5/18/2007 11:19' prior: 0!
Themed task list/switcher to select the topmost window. Use cmd + left or right arrows (not ideal but the os typically handles cmd + tab/shift-tab).
On Linux, release of the command key is not detected (vm issue), so press and release cmd again or move the mouse!!!

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:02'!
activeTask
	"Answer the active task"
	
	^self tasks detect: [:t | t isActive] ifNone: []! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:16'!
addMorphs
	"Add our morphs."

	self preview: self newPreviewMorph.
	self taskList: self newTasksMorph.
	self addMorph: (
		(UITheme current newColumnIn: self for: {
			self preview.
			self taskList})
			vResizing: #shrinkWrap;
			cellInset: 8).
	self layoutChanged! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:40'!
defaultPreviewExtent
	"Answer the default extent of the preview holder."

	^320@320! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:56'!
done
	"Close the tasklist and make the active task current."
	
	self delete.
	self activeTask activate! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:51'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:12'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeTasks;
		initializeLayout;
		initializeAppearance;
		addMorphs;
		updateButtonsAndPreview;
		adoptPaneColor: self color! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 12:14'!
initializeAppearance
	"Initialize the appearance."

	self
		color: (Color black alpha: 0.5);
		fillStyle: (self theme tasklistFillStyleFor: self);
		borderStyle: (self theme taskbarThumbnailNormalBorderStyleFor: self);
		cornerStyle: #rounded! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:13'!
initializeLayout
	"Initialize the layout."

	self
		changeTableLayout;
		layoutInset: 16;
		vResizing: #shrinkWrap;
		hResizing: #rigid;
		extent: self minimumExtent! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:27'!
initializeTasks
	"Set up the current tasks."
	
	self tasks: ((World submorphs
		collect: [:m | m taskbarTask])
		select: [:m | m notNil]) asOrderedCollection! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 15:01'!
keyStroke: event 
	"Process keys to switch task."
	
	event commandKeyPressed ifFalse: [self done].
	event keyCharacter = Character arrowLeft
		ifTrue: [^self selectPreviousTask].
	event keyCharacter = Character arrowRight
		ifTrue: [^self selectNextTask]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:14'!
minimumExtent
	"Answer the minimum extent."

	^self defaultPreviewExtent + 64! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:11'!
newPreviewMorph
	"Answer a new preview holder."

	^Morph new
		color: Color transparent;
		extent: self defaultPreviewExtent! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/26/2007 09:45'!
newTasksMorph
	"Answer a new task list."

	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		cellInset: 1;
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:21'!
openAsIs
	"Open in the world."
	
	self openAsIsIn: self currentWorld! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:51'!
openAsIsIn: aWorld
	"Update the layout after opening."

	aWorld addMorphCentered: self.
	self allMorphs do: [:m | m layoutChanged].
	aWorld startSteppingSubmorphsOf: self.
	self activeHand newKeyboardFocus: self! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 11:11'!
preview
	"Answer the value of preview"

	^ preview! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 11:11'!
preview: anObject
	"Set the value of preview"

	preview := anObject! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:35'!
selectNextTask
	"Make the next task active."
	
	self selectTask: (self tasks
		after: self activeTask
		ifAbsent: [self tasks isEmpty
					ifFalse: [self tasks first]])! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:35'!
selectPreviousTask
	"Make the previous task active."
	
	self selectTask: (self tasks
		before: self activeTask
		ifAbsent: [self tasks isEmpty
					ifFalse: [self tasks last]])! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:08'!
selectTask: aTask
	"Make the given task active and update the buttons."
	
	self tasks do: [:t | t state: #restored].
	aTask state: #active.
	self updateButtonsAndPreview! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:58'!
step
	"Check the sensor for the command key to see if we're done."

	Sensor commandKeyPressed
		ifFalse: [self done]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:59'!
stepTime
	"Check quickly."

	^100! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:07'!
taskClicked: aTask
	"A button fro a task has been pressed."
	
	self selectTask: aTask! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:58'!
taskList
	"Answer the value of taskList"

	^ taskList! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:58'!
taskList: anObject
	"Set the value of taskList"

	taskList := anObject! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:16'!
tasks
	"Answer the value of tasks"

	^ tasks! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:16'!
tasks: anObject
	"Set the value of tasks"

	tasks := anObject! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:09'!
updateButtonsAndPreview
	"Update the buttons and the preview.."
	
	self
		updateTaskButtons;
		updatePreview! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:31'!
updatePreview
	"Update the preview.."
	
	self preview removeAllMorphs.
	self activeTask ifNotNilDo: [:t |
		self preview addMorphCentered: (t morph taskThumbnailOfSize: self preview extent)]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:03'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	|button|
	self taskList removeAllMorphs.
	self tasks do: [:t |
		button := t tasklistButtonFor: self.
		button ifNotNil: [self taskList addMorphBack: button]]! !

!Rectangle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 12:51'!
interpolateTo: end at: amountDone
	"Interpolate between the instance and end after the specified amount has been done (0 - 1)."

	^(self origin interpolateTo: end origin at: amountDone)
		corner: (self corner interpolateTo: end corner at: amountDone)! !

!Rectangle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/7/2006 10:44'!
pointAtSideOrCorner: loc
	"Answer the point represented by the given location."
	
	^ self
		perform: (#(topLeft topCenter topRight rightCenter
					bottomRight bottomCenter bottomLeft leftCenter)
						at: (#(topLeft top topRight right
					bottomRight bottom bottomLeft left) indexOf: loc))

	! !

!Rectangle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/13/2006 14:08'!
scaledAndCenteredIn: aRect
	"Answer a new rectangle that fits into aRectangle and is centered
	but with the same aspect ratio as the receiver."
	
	^self width / aRect width > (self height / aRect height)
		ifTrue: [aRect left @ (aRect leftCenter y - (self height * (aRect width / self width) / 2))
					corner: aRect right @ (aRect rightCenter y + (self height * (aRect width / self width) / 2))]
		ifFalse: [aRect topCenter x - (self width * (aRect height / self height) / 2) @ aRect top
					corner: (aRect topCenter x + (self width * (aRect height / self height) / 2)) @ aRect bottom]! !

!Preferences class methodsFor: '*Pinesoft-Widgets-Override' stamp: 'gvc 6/22/2007 13:14'!
disableProgrammerFacilities
	"Warning: do not call this lightly!!  It disables all access to menus, debuggers, halos.  There is no guaranteed return from this, which is to say, you cannot necessarily reenable these things once they are disabled -- you can only use whatever the UI of the current project affords, and you cannot even snapshot -- you can only quit. 

     You can completely reverse the work of this method by calling the dual Preferences method enableProgrammerFacilities, provided you have left yourself leeway to bring about a call to that method.
(does not reverse the ToolSet registrations)

	To set up a system that will come up in such a state, you have to request the snapshot in the same breath as you disable the programmer facilities.  To do this, put the following line into the 'do' menu and then evaluate it from that 'do' menu:

         Preferences disableProgrammerFacilities.

You will be prompted for a new image name under which to save the resulting image."

	Beeper beep.
	(self 
		confirm: 'CAUTION!!!!
This is a drastic step!!
Do you really want to do this?') 
			ifFalse: 
				[Beeper beep.
				^self inform: 'whew!!'].
	self disable: #halosEnabled. "really turn off halos in their entirety"
	self disable: #cmdDotEnabled.	"No user-interrupt-into-debugger"
	self disable: #editableStringMorphs. "turn off shift-click editing"
	ToolSet registeredClasses copy do: [:c | ToolSet unregister: c].
	ToolSet default: nil. "unregister and make sure default is nil to really prevent debug windows"
		"also now takes care of low space watcher interrupts"
	self compileHardCodedPref: #cmdGesturesEnabled enable: false.	"No halos, etc."
	self compileHardCodedPref: #cmdKeysInText enable: false.	"No user commands invokable via cmd-key combos in text editor"
	self enable: #noviceMode.	"No control-menu"
	self disable: #warnIfNoSourcesFile.
	self disable: #warnIfNoChangesFile.
	SmalltalkImage current saveAs! !

!Preferences class methodsFor: '*Pinesoft-Widgets-Override' stamp: 'gvc 6/22/2007 13:14'!
enableProgrammerFacilities
	"Meant as a one-touch recovery from a #disableProgrammerFacilities call."
	"Preferences enableProgrammerFacilities"

	self enable: #halosEnabled.
	self enable: #editableStringMorphs.
	self enable: #cmdDotEnabled.
	self compileHardCodedPref: #cmdGesturesEnabled enable: true. 
	self compileHardCodedPref: #cmdKeysInText enable: true.
	self disable: #noviceMode.
	self enable: #warnIfNoSourcesFile.
	self enable: #warnIfNoChangesFile.! !

!TextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:54'!
drawNullTextOn: aCanvas
	"Make null text frame visible.
	Nicer if not shaded!!"

	aCanvas isPostscriptCanvas ifFalse: [
	aCanvas fillRectangle: bounds color: self backgroundColor]! !

!TextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/5/2007 12:34'!
drawOn: aCanvas
	"Draw the receiver on a canvas.
	Draw keyboard focus if appropriate."

	| fauxBounds |
	self setDefaultContentsIfNil.
	super drawOn: aCanvas.  "Border and background if any"
	false ifTrue: [self debugDrawLineRectsOn: aCanvas].  "show line rects for debugging"
	(self startingIndex > text size)
		ifTrue: [self drawNullTextOn: aCanvas].
	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: color.
	self hasKeyboardFocus ifTrue: [
		(Preferences externalFocusForPluggableText
				and: [(self ownerThatIsA: PluggableTextMorph) notNil])
			ifFalse: [self drawKeyboardFocusOn: aCanvas]]! !

!TextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/5/2007 12:38'!
keyboardFocusChange: aBoolean
	"Changed to update focus indication."
	
	| w ptm |
	paragraph isNil ifFalse:[paragraph focused: aBoolean].
	aBoolean 
		ifTrue: 
			["A hand is wanting to send us characters..."

			self hasFocus ifFalse: [self editor	"Forces install"]]
		ifFalse: 
			["A hand has clicked elsewhere..."

			(w := self world) isNil 
				ifFalse: 
					[w handsDo: [:h | h keyboardFocus == self ifTrue: [^self]].
					"Release control unless some hand is still holding on"
					self releaseEditor]].
	(Preferences externalFocusForPluggableText
			and: [(ptm _ self ownerThatIsA: PluggableTextMorph) notNil])
		ifTrue: [ptm changed]
		ifFalse: [self changed]! !

!TextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/8/2007 09:56'!
optimalExtent
	"Create a new paragraph and answer its extent."
	
	^(self paragraphClass new
		compose: text
		style: textStyle copy
		from: 1
		in: (0@0 extent: 9999999@9999999);
		adjustRightX;
		extent) + (self borderWidth * 2)! !

!TextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/23/2006 14:48'!
overrideExtent: newExtent
	"If autoFit is on then override to false for the duration of the extent call."
	
	self isAutoFit
		ifTrue: [self
				setProperty: #autoFitContents toValue: false;
				extent: newExtent;
				setProperty: #autoFitContents toValue: true]! !

!TextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/20/2006 11:51'!
roundedCorners
	"Answer the corners to round."

	^self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners] ! !

!TextMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/8/2007 16:54'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!TextMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:55'!
yellowButtonActivity: shiftKeyState 
	"Invoke the text-editing menu.
	Check if required first!!"
	
	| menu |
	self wantsYellowButtonMenu
		ifFalse: [^self].
	(menu := self getMenu: shiftKeyState)
		ifNotNil: [""
			menu setInvokingView: self editor.
			menu invokeModal. self changed]! !

Model subclass: #ThemeSettings
	instanceVariableNames: 'windowColor selectionColor autoSelectionColor buttonColor scrollbarColor standardColorsOnly progressBarColor progressBarProgressColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ThemeSettings commentStamp: 'gvc 5/18/2007 10:23' prior: 0!
Configurable basic settings for themes.!

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 12:11'!
applySettingsFrom: aThemeSettings
	"Change the settings to be those of aThemeSettings."
	
	self
		windowColor: aThemeSettings windowColor;
		selectionColor: aThemeSettings selectionColor;
		autoSelectionColor: aThemeSettings autoSelectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/18/2007 11:45'!
autoSelectionColor
	"Answer the value of autoSelectionColor"

	^autoSelectionColor ifNil: [^true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/12/2006 14:04'!
autoSelectionColor: anObject
	"Set the value of autoSelectionColor"

	autoSelectionColor := anObject.
	self
		changed: #autoSelectionColor;
		changed: #manualSelectionColor;
		changed: #selectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:39'!
buttonColor
	"Answer the value of buttonColor"

	^buttonColor ifNil: [self windowColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/13/2007 17:05'!
buttonColor: anObject
	"Set the value of buttonColor"

	buttonColor := anObject! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 17:06'!
defaultButtonColor
	"Answer the default button colour."

	^Color gray! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 13:01'!
defaultScrollbarColor
	"Answer the default scrollbar colour."

	^Color gray! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 17:48'!
defaultSelectionColor
	"Answer the default selection colour."

	^self defaultWindowColor! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 17:14'!
defaultWindowColor
	"Answer the default window colour."

	^Color r: 0.501 g: 0.533 b: 0.976! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 14:39'!
derivedSelectionColor
	"Answer a selection colour based on the window color."

	^self windowColor whiter lighter! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:37'!
fromConfiguration: tree
	"Update the settings from the given tree."
	
	(tree at: #windowColor ifAbsent: []) ifNotNilDo: [:v | self windowColor: v].
	(tree at: #autoSelectionColor ifAbsent: []) ifNotNilDo: [:v | self autoSelectionColor: v].
	(tree at: #selectionColor ifAbsent: []) ifNotNilDo: [:v | self selectionColor: v]! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 13:00'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		autoSelectionColor: true;
		windowColor: self defaultWindowColor;
		selectionColor: self defaultSelectionColor;
		buttonColor: self defaultButtonColor;
		scrollbarColor: self defaultScrollbarColor;
		standardColorsOnly: false! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:41'!
manualSelectionColor
	"Answer the inverse of autoSelectionColor."

	^self autoSelectionColor not! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/26/2006 16:49'!
menuColor
	"Answer the value of menuColor"

	^nil! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/24/2007 11:50'!
progressBarColor
	"Answer the value of progressBarColor"

	^progressBarColor ifNil: [Preferences menuColor muchLighter]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/23/2007 17:20'!
progressBarColor: anObject
	"Set the value of progressBarColor"

	progressBarColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/24/2007 11:50'!
progressBarProgressColor
	"Answer the value of progressBarProgressColor"

	^progressBarProgressColor ifNil: [Preferences menuTitleColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/24/2007 11:45'!
progressBarProgressColor: anObject
	"Set the value of progressBarProgressColor"

	progressBarProgressColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:40'!
scrollbarColor
	"Answer the value of scrollbarColor"

	^scrollbarColor ifNil: [self windowColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:00'!
scrollbarColor: anObject
	"Set the value of scrollbarColor"

	scrollbarColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/26/2006 16:18'!
selectionColor
	"Answer the value of selectionColor"

	^self autoSelectionColor
		ifTrue: [self derivedSelectionColor]
		ifFalse: [selectionColor ifNil: [Preferences textHighlightColor]]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:47'!
selectionColor: anObject
	"Set the value of selectionColor"

	selectionColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/18/2007 11:45'!
standardColorsOnly
	"Answer the value of standardColorsOnly"

	^standardColorsOnly ifNil: [^false]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/13/2007 17:01'!
standardColorsOnly: anObject
	"Set the value of standardColorsOnly"

	standardColorsOnly := anObject! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:37'!
toConfiguration: tree
	"Update the tree from the receiver."
	
	tree at: #windowColor put: self windowColor.
	tree at: #autoSelectionColor put: self autoSelectionColor.
	tree at: #selectionColor put: self selectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:13'!
windowColor
	"Answer the value of windowColor"

	^ windowColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/12/2006 14:06'!
windowColor: anObject
	"Set the value of windowColor"

	windowColor := anObject.
	self changed: #windowColor.
	self autoSelectionColor ifTrue: [self changed: #selectionColor]! !

Slider subclass: #PluggableSliderMorph
	instanceVariableNames: 'getValueSelector enabled min max quantum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableSliderMorph commentStamp: 'gvc 7/16/2007 13:57' prior: 0!
A pluggable slider (rather than one that auto-generates access selectors). Needs to be themed...!

PluggableSliderMorph subclass: #ColorComponentSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ColorComponentSelectorMorph commentStamp: 'gvc 5/18/2007 13:39' prior: 0!
Abstract superclass for morphs that are used to select a component (R, G, B or A) of a colour.!

ColorComponentSelectorMorph subclass: #AColorSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!AColorSelectorMorph commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
ColorComponentSelector showing an alpha gradient over a hatched background.!

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:14'!
color: aColor
	"Set the gradient colors."
	
	super color: aColor asNontranslucentColor.
	self fillStyle: self gradient! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:28'!
drawOn: aCanvas
	"Draw a hatch pattern first."

	aCanvas
		fillRectangle: self innerBounds
		fillStyle: (InfiniteForm with: self hatchForm).
	super drawOn: aCanvas
! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:46'!
fillStyle: fillStyle
	"If it is a color then override with gradient."
	
	fillStyle isColor
		ifTrue: [self color: fillStyle]
		ifFalse: [super fillStyle: fillStyle]! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:59'!
gradient
	"Answer the hue gradient."

	^(GradientFillStyle colors: {self color alpha: 0. self color})
		origin: self topLeft;
		direction: (self bounds isWide
					ifTrue: [self width@0]
					ifFalse: [0@self height])! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:17'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^ColorPresenterMorph hatchForm! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 11:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		value: 1.0;
		color: Color black! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:20'!
extent: aPoint
	"Update the gradient directions."

	super extent: aPoint.
	self updateGradients! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 16:05'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self fillStyle! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:06'!
gradient
	"Answer the gradient."

	self subclassResponsibility! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:27'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		fillStyle: self gradient;
		borderStyle: (BorderStyle inset baseColor: self paneColor; width: 1);
		sliderColor: Color black;
		clipSubmorphs: true! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:53'!
initializeSlider
	"Make the slider raised."
	
	slider :=( BracketMorph newBounds: self totalSliderArea)
		horizontal: self bounds isWide;
		color: self thumbColor;
		borderStyle: (BorderStyle raised baseColor: Color white; width: 1).
	sliderShadow := (BracketMorph newBounds: self totalSliderArea)
		horizontal: self bounds isWide;
		color: self pagingArea color;
		borderStyle: (BorderStyle inset baseColor: (Color white alpha: 0.6); width: 1).
	slider on: #mouseMove send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.
	"(the shadow must have the pagingArea as its owner to highlight properly)"
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
	self computeSlider.
! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:14'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self updateGradients.
	slider horizontal: self bounds isWide.
	sliderShadow horizontal: self bounds isWide! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 11:34'!
roomToMove
	"Allow to run off the edges a bit."
	
	^self bounds isWide
		ifTrue: [self totalSliderArea insetBy: ((self sliderThickness // 2@0) negated corner: (self sliderThickness // 2 + 1)@0)]
		ifFalse: [self totalSliderArea insetBy: (0@(self sliderThickness // 2) negated corner: 0@(self sliderThickness // 2 - (self sliderThickness \\ 2) + 1))]! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:58'!
sliderColor: newColor
	"Set the slider colour."
	
	super sliderColor: Color black.
	slider ifNotNil: [slider borderStyle baseColor: Color white]! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:43'!
sliderShadowColor
	"Answer the color for the slider shadow."
	
	^Color black alpha: 0.6! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:02'!
sliderThickness
	"Answer the thickness of the slider."
	
	^((self bounds isWide
		ifTrue: [self height]
		ifFalse: [self width]) // 2 max: 8) // 2 * 2 + 1! !

!ColorComponentSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:20'!
updateGradients
	"Update the gradient directions."

	|b fs|
	b := self innerBounds.
	fs _ self fillStyle.
	fs origin: b topLeft.
	fs direction: (b isWide
		ifTrue: [b width@0]
		ifFalse: [0@b height])! !

ColorComponentSelectorMorph subclass: #HColorSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!HColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:58' prior: 0!
ColorComponentSelector showing a hue rainbow palette.!

!HColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:13'!
color: aColor
	"Ignore to preserve fill style."
	! !

!HColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:22'!
gradient
	"Answer the hue gradient."

	^(GradientFillStyle colors: ((0.0 to: 359.9 by: 0.1) collect: [:a | Color h: a s: 1.0 v: 1.0]))
		origin: self topLeft;
		direction: (self bounds isWide
					ifTrue: [self width@0]
					ifFalse: [0@self height])! !

!PluggableSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:28'!
on: anObject getValue: getSel setValue: setSel
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		on: anObject
		getValue: getSel
		setValue: setSel! !

!PluggableSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:27'!
on: anObject getValue: getSel setValue: setSel min: min max: max quantum: quantum
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		min: min;
		max: max;
		quantum: quantum;
		on: anObject
		getValue: getSel
		setValue: setSel! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:58'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self
		fillStyle: self fillStyleToUse;
		borderStyle: self borderStyleToUse;
		sliderColor: (self enabled
			ifTrue: [paneColor twiceDarker]
			ifFalse: [self paneColor twiceDarker paler])! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:25'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme sliderNormalBorderStyleFor: self]
		ifFalse: [self theme sliderDisabledBorderStyleFor: self]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 15:02'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color white! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:19'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:19'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/3/2007 15:19'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/3/2007 15:21'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled := anObject.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:24'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme sliderNormalFillStyleFor: self]
		ifFalse: [self theme sliderDisabledFillStyleFor: self]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
getValueSelector
	"Answer the value of getValueSelector"

	^ getValueSelector! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
getValueSelector: anObject
	"Set the value of getValueSelector"

	getValueSelector := anObject! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:27'!
handlesMouseDown: evt
	"Answer true." 

	^true! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 13:14'!
initialize
	"Initialize the receiver."

	min := 0.
	max := 1.
	super initialize.
	self enabled: true! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 15:00'!
initializeSlider
	"Make the slider raised."
	
	super initializeSlider.
	slider borderStyle: (BorderStyle raised baseColor: slider color; width: 1)! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:14'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self computeSlider! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 10:43'!
max
	"Answer the value of max"

	^ max! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:21'!
max: anObject
	"Set the value of max"

	max := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 10:43'!
min
	"Answer the value of min"

	^ min! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:21'!
min: anObject
	"Set the value of min"

	min := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:32'!
minHeight
	"Answer the receiver's minimum height.
	Give it a bit of a chance..."
	
	^8 max: super minHeight! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:35'!
mouseDown: anEvent
	"Set the value directly."
	
	self enabled ifTrue: [
		self
			scrollPoint: anEvent;
			computeSlider].
	super mouseDown: anEvent.
	self enabled ifFalse: [^self].
	anEvent hand newMouseFocus: slider event: anEvent.
	slider
		mouseEnter: anEvent copy;
		mouseDown: anEvent copy
! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:36'!
mouseDownInSlider: event
	"Ignore if disabled."
	
	self enabled ifFalse: [^self].
	^super mouseDownInSlider: event! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:29'!
on: anObject getValue: getSel setValue: setSel
	"Use the given selectors as the interface."

	self
		model: anObject;
		getValueSelector: getSel;
		setValueSelector: setSel;
		updateValue! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:14'!
quantum
	"Answer the value of quantum"

	^ quantum! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:20'!
quantum: anObject
	"Set the value of quantum"

	quantum := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:16'!
scaledValue
	"Answer the scaled value."

	|val|
	val := self value * (self max - self min) + self min.
	self quantum ifNotNilDo: [:q |
		val := val roundTo: q].
	^(val max: self min) min: self max! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:14'!
scaledValue: newValue
	"Set the scaled value."

	|val|
	val _ newValue.
	self quantum ifNotNilDo: [:q |
		val _ val roundTo: q].
	self value: newValue - self min / (self max - self min)! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:37'!
scrollAbsolute: event
	"Ignore if disabled."
	
	self enabled ifFalse: [^self].
	^super scrollAbsolute: event! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:28'!
scrollPoint: event
	"Scroll to the event position."
	
	| r p |
	r := self roomToMove.
	bounds isWide
		ifTrue: [r width = 0 ifTrue: [^ self]]
		ifFalse: [r height = 0 ifTrue: [^ self]].
	p := event position - (self sliderThickness // 2) adhereTo: r.
	self descending
		ifFalse:
			[self setValue: (bounds isWide 
				ifTrue: [(p x - r left) asFloat / r width]
				ifFalse: [(p y - r top) asFloat / r height])]
		ifTrue:
			[self setValue: (bounds isWide
				ifTrue: [(r right - p x) asFloat / r width]
				ifFalse:	[(r bottom - p y) asFloat / r height])]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 13:10'!
setValue: newValue
	"Called internally for propagation to model."

	|scaled|
	value := newValue.
	self scaledValue: (scaled _ self scaledValue).
	self setValueSelector ifNotNilDo: [:sel |
		model perform: sel with: scaled]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:18'!
setValueSelector
	"Answer the set selector."
	
	^setValueSelector! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:57'!
sliderColor: newColor
	"Set the slider colour."
	
	super sliderColor: newColor.
	slider ifNotNil: [slider borderStyle baseColor: newColor]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:27'!
update: aSymbol
	"Update the value."
	
	super update: aSymbol.
	aSymbol = self getValueSelector
		ifTrue: [self updateValue]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:17'!
updateValue
	"Update the value."
	
	self getValueSelector ifNotNil: [
		self scaledValue: (self model perform: self getValueSelector)]! !

!TextMorphForEditView methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/2/2007 16:22'!
keyStroke: evt
	"Handle a keystroke. Deal with navigation keys also."
	
	| view |
	(editView scrollByKeyboard: evt) ifTrue: [^self].
	(acceptOnCR not and: [evt keyCharacter = Character cr])
		ifFalse: [(editView navigationKey: evt) ifTrue: [^self]].
	self editView enabled ifFalse: [^self].
	self editor model: editView model.  "For evaluateSelection"
	view := editView.  "Copy into temp for case of a self-mutating doit"
	(acceptOnCR and: [evt keyCharacter = Character cr])
		ifTrue: [^ self editor accept].
	super keyStroke: evt.
	view scrollSelectionIntoView! !

!TextMorphForEditView methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/5/2007 12:46'!
keyboardFocusChange: aBoolean 
	"rr 3/21/2004 22:55 : removed the #ifFalse: branch, 
	which was responsible of the deselection of text when the 
	paragraph lost focus. This way selection works in a more standard 
	way, and this permits the menu keyboard control to be really effective.
	Changed to update focus indication."
	
	|ptm|
	paragraph isNil ifFalse:[paragraph focused: aBoolean].
	aBoolean 
		ifTrue: 
			["A hand is wanting to send us characters..."

			self hasFocus ifFalse: [self editor	"Forces install"]].
	(Preferences externalFocusForPluggableText
			and: [(ptm := self ownerThatIsA: PluggableTextMorph) notNil])
		ifTrue: [ptm changed]
		ifFalse: [self changed]! !

TextMorphForEditView subclass: #TextMorphForEditorView
	instanceVariableNames: 'autoAccept acceptOnFocusChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TextMorphForEditorView commentStamp: 'gvc 5/18/2007 11:13' prior: 0!
Multi-line text editor with support for accepting on both each change and/or when keyboard focus changes. Also supports custom selection colour and clickable highlights From PluggableTextEditorMorph.!

!TextMorphForEditorView methodsFor: 'accessing' stamp: 'gvc 9/28/2006 12:07'!
acceptOnFocusChange
	"Answer the value of acceptOnFocusChange"

	^ acceptOnFocusChange! !

!TextMorphForEditorView methodsFor: 'accessing' stamp: 'gvc 9/28/2006 12:07'!
acceptOnFocusChange: anObject
	"Set the value of acceptOnFocusChange"

	acceptOnFocusChange := anObject! !

!TextMorphForEditorView methodsFor: 'accessing' stamp: 'gvc 9/9/2006 14:02'!
autoAccept
	"Answer the value of autoAccept"

	^ autoAccept! !

!TextMorphForEditorView methodsFor: 'accessing' stamp: 'gvc 9/9/2006 14:02'!
autoAccept: anObject
	"Set the value of autoAccept"

	autoAccept := anObject! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 15:26'!
basicKeyStroke: evt
	"Do the key stroke and check to see if it should be accepted."

	super keyStroke: evt.
	self autoAccept
		ifTrue: [self editView hasUnacceptedEdits ifTrue: [self editor accept]]! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:09'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		autoAccept: false;
		acceptOnFocusChange: false! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:21'!
keyStroke: evt
	"Don't allow editing keys if the edit view is disabled."
	
	self basicKeyStroke: evt! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:09'!
keyboardFocusChange: aBoolean 
	"If we are losing focus and have acceptOnFocusChange then accept."
	
	super keyboardFocusChange: aBoolean.
	self acceptOnFocusChange
		ifTrue: [self editView hasUnacceptedEdits ifTrue: [self editor accept]]! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 16:11'!
mouseDown: evt
	"Pass to any highlight too."

	|hl|
	super mouseDown: evt.
	hl := self editView highlights
		detect: [:h |
			h containsPoint: evt position
			in: (self bounds: self editView innerBounds from: self)]
		ifNone: [^self].
	hl clicked: evt! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:24'!
paragraph
	"Answer the paragraph."

	|p|
	p _ super paragraph.
	self selectionColor: self selectionColor.
	^p! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:13'!
paragraphClass
	"Answer an appropriate paragraph class."
	
	container ifNil: [^MultiNewParagraphWithSelectionColor].
	^super paragraphClass! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:22'!
selectionColor
	"Answer the colour to use for the text selection."

	^self valueOfProperty: #selectionColor ifAbsent: [] ! !

!TextMorphForEditorView methodsFor: 'as yet unclassified' stamp: 'gvc 10/24/2006 16:26'!
selectionColor: aColor
	"Set the colour to use for the text selection."

	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	paragraph ifNotNilDo: [:p |.
		(p respondsTo: #selectionColor:) ifTrue: [
			p selectionColor: aColor]]! !

TextMorphForEditorView subclass: #TextMorphForFieldView
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TextMorphForFieldView commentStamp: 'gvc 5/18/2007 12:28' prior: 0!
Single-line text field editor with DialogWindow key integration (return for default, escape for cancel) and keyboard focus navigation (tab/shift-tab).!

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:41'!
basicKeyStroke: evt
	"Do the key if max length has not been reached.
	Don't allow tabs."

	(self localHandleKeystroke: evt) ifTrue: [^self].
	(self maxLength isNil or: [self text size < self maxLength or: [self isEditCharacter: evt keyCharacter]])
		ifTrue: [evt keyCharacter = Character cr ifTrue: [self dialogWindow ifNotNilDo: [:w | ^w keyStroke: evt]].
				evt keyCharacter = Character escape ifTrue: [self dialogWindow ifNotNilDo: [:w | ^w keyStroke: evt]].
				super basicKeyStroke: evt]! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 15:11'!
isEditCharacter: aCharacter
	"Answer whether the given character is a key stroke that
	should be allowed despite the max length."

	^aCharacter == Character cr or: [
		aCharacter == Character backspace or: [
		aCharacter == Character delete or: [
		aCharacter == Character arrowLeft or: [
		aCharacter == Character arrowRight]]]]! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 3/20/2007 14:13'!
keyboardFocusChange: aBoolean 
	"If we are losing focus and have acceptOnFocusChange then accept."
	
	aBoolean ifTrue: [self selectAll].
	super keyboardFocusChange: aBoolean! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 4/25/2007 16:05'!
localHandleKeystroke: evt
	"Answer whether we locally handle the keyStroke event.
	Disregard tabs for now."
	
	evt keyCharacter = Character tab ifTrue: [
		evt shiftPressed
			ifTrue: [(self editView respondsTo: #navigateFocusBackward)
						ifTrue: [self editView navigateFocusBackward]]
			ifFalse: [(self editView respondsTo: #navigateFocusForward)
						ifTrue: [self editView navigateFocusForward]].
		^true].
	^false! !

!TextMorphForFieldView methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:58'!
maxLength
	"Answer the value of maxLength"

	^ maxLength! !

!TextMorphForFieldView methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:58'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength := anObject! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 18:25'!
minExtent
	"Overridden to allow text to shrink to minimum extent rather than being (incorrectly)
	treated as rigid. Should be the same for other morphs too. Bah!!"

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].
	layout := self layoutPolicy.
	layout isNil 
		ifTrue: [minExtent := 0 @ 0]
		ifFalse: [minExtent := layout minExtentOf: self in: self layoutBounds].
	hFit == #rigid 
		ifTrue: [minExtent := self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			minExtent := (minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 11:22'!
minHeight
	"Answer the height of one line."

	^self minimumExtent y max: super minHeight! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 11:22'!
minWidth
	"Answer the minimum width."

	^self minimumExtent x max: super minWidth! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 11:55'!
minimumExtent
	"Use the actual paragraph line to take font changes into account."
	
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt := (9@(self paragraph lines first lineHeight ceiling)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 1/4/2007 16:05'!
mouseMove: evt
	"Allow auto scroll in any direction.
	Something else is preventing the left/right case."
	
	| editEvt |
	self perform: #mouseMove: withArguments: {evt} inSuperclass: TextMorph.
	evt redButtonPressed ifFalse: [^ self].
	editEvt := evt transformedBy: (self transformedFrom: editView) inverseTransformation.
	(editView bounds containsPoint: editEvt position) ifFalse:[
		"Start auto-scrolling"
		self startStepping: #autoScrollView:
			at: Time millisecondClockValue
			arguments: (Array with: editEvt)
			stepTime: 100. "fast enough"
	] ifTrue:[
		self stopSteppingSelector: #autoScrollView:.
	].! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:51'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed.
	Don't adjust rightX (as in TexMorph>>paragraph)
	since wrapFlag must be false for layout to work."
	
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := (self paragraphClass new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	"don't adjust the right, let it scroll!!"
	paragraph focused: (self currentHand keyboardFocus == self).
	self fit.
self removeProperty: #CreatingParagraph.

	self selectionColor: self selectionColor.
	^ paragraph! !

!Inspector class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/25/2007 09:55'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallInspectItIcon! !

!RaisedBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:49'!
bottomRightColor
	"Changed from direct access to color since, if nil,
	self color is transparent."
	
	^width = 1 
		ifTrue: [self color twiceDarker]
		ifFalse: [self color darker]! !

!RaisedBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:49'!
topLeftColor
	"Changed from direct access to color since, if nil,
	self color is transparent."

	^width = 1 
		ifTrue: [self color twiceLighter]
		ifFalse: [self color lighter]! !

!SystemProgressMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/3/2007 12:31'!
label: shortDescription min: startMinValue max: startMaxValue
	"Answer the block that updates the progress bar."
	
	"some fun stuff added (by kph)
	
	- bar value: #label. - tell me my current label.
	- bar value: 'newLabel'. - enable changing the label from within the workBlock
	- bar value: #increment. - enable progress by one without keeping a counter
	- bar value: #decrement. - go backwards (if you really have to, useful for an abort, or rollback)!!
 
	- bar value: newBigNum. - change the max on the fly - when you find there is more to do.
	- bar value: (bar value: #setMax) + 20 - change the max on the fly - when you find there is more/less to do.
	- bar value: (bar value: #setMin) - 20 - change the min on the fly - not sure why you would want to.
	- bar value: #stripe to be debugged

	"
	| slot range newBarSize barSize lastRefresh maxValue  minValue bar|
	maxValue := startMaxValue.
	minValue := startMinValue.
	((range := maxValue - minValue) <= 0 or: [(slot := self nextSlotFor: shortDescription) = 0])
		ifTrue: [^[:barVal| 0 ]].
	self openInWorld.
	self align: self fullBounds center with: Display boundingBox center.
	barSize := -1. "Enforces a inital draw of the morph"
	lastRefresh := Time millisecondClockValue.
	bar := bars at: slot.
	bar removeProperty: #useStripe.
	(bar valueOfProperty: #nonStripedFillStyle) ifNotNilDo: [:fs |
		bar fillStyle: fs.
		bar removeProperty: #nonStripedFillStyle].	 "force reset of fill style if striped"
	^[:barVal | | return  |
		return := nil.
		bar := bars at: slot.
		"new fun stuff here"
		barVal == #current  ifTrue: [ return := barSize ].
		barVal == #label ifTrue:[ return := (labels at: slot) contents ].
		barVal == #setMax ifTrue: [ return := maxValue. maxValue := minValue ].
		barVal == #setMin ifTrue: [ return := minValue. minValue := maxValue ].
		barVal == #stripe
			ifTrue: [bar setProperty: #useStripes toValue: true.
					bar setProperty: #nonStripedFillStyle toValue: bar fillStyle.
					bar fillStyle: ((GradientFillStyle ramp: ((1 to: 20)
								collect: [:i| Association key: (i/20.0) value: (i even
											ifTrue: [ Color white ]
											ifFalse: [Color cyan])]))
						origin: bar position;
						direction: 300@0;
						radial: false;
						yourself).
					barVal := #refresh].
		barVal == #increment ifTrue: [return := barVal := barSize + 1].
		barVal == #decrement ifTrue: [ return := barVal := barSize - 1].
		(barVal isString and: [barVal isSymbol not]) ifTrue: [
			(labels at: slot) contents: barVal. 
			barVal := #refresh].
		barVal == #refresh ifTrue: [self currentWorld displayWorld. return := true].	
		(barVal == SmallInteger maxVal or: [ barVal == #finished ]) ifTrue: [return := slot].	 
		return ifNil: [
			barVal > maxValue ifTrue: [return := maxValue := barVal].
			barVal < minValue ifTrue: [return := minValue := barVal].
			(barVal between: minValue and: maxValue)
				ifTrue: [newBarSize := (barVal - minValue / range * BarWidth) truncated.
						newBarSize = barSize
							ifFalse: [barSize := newBarSize.
									(Time millisecondsSince: lastRefresh) > 25
										ifTrue: [barVal := #refresh ]]].	
		barVal == #refresh ifTrue: [
					((bar valueOfProperty: #useStripes) ifNil: [false])
						ifTrue: [bar fillStyle origin: bar position - ((Time millisecondClockValue // 50 \\ 30) @ 0)].
					bar barSize: barSize.
					self currentWorld displayWorld.
					lastRefresh := Time millisecondClockValue]].
		return]! !

!SystemProgressMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 13:00'!
nextSlotFor: shortDescription
	| bar slots label |
	lock critical: [
		slots := bars size.
		activeSlots = slots ifTrue: [^0].
		activeSlots := activeSlots + 1.
		1 to: slots do: [:index |
			bar := (bars at: index).
			bar ifNil: [
				bar _ SystemProgressBarMorph new.
				bar extent: BarWidth@BarHeight + (2 * bar borderWidth).
				bars at: index put: bar.
				label := labels at: index put: (StringMorph contents: shortDescription font: font).
				self
					addMorphBack: label;
					addMorphBack: bar.
				^index].
			bar owner ifNil: [
				bar := bars at: index.
				label := labels at: index.
				self
					addMorphBack: (label contents: shortDescription);
					addMorphBack: (bar barSize: 0).
				^index]]]
		! !

ScaleMorph subclass: #FixedScaleMorph
	instanceVariableNames: 'scaleBy font emphasis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!FixedScaleMorph commentStamp: 'gvc 5/18/2007 09:59' prior: 0!
Instances of this class draw ticks and labels according to a fixed scale, regardless of the morph's extent.!

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:56'!
adoptPaneColor: paneColor
	"Update the label colors."
	
	|c|
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	c := paneColor contrastingColor.
	self labelMorphsDo: [:m | m color: c]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:49'!
buildLabels
	"Build the labels."
	
	|b x1 y1 y2 x captionMorph tickMorph loopStart offset |
	b := self paneColor contrastingColor.
	majorTickLength * minorTickLength < 0 
		ifTrue: [minorTickLength := 0 - minorTickLength].
	self removeLabelMorphs.
	caption ifNotNil: 
			[captionMorph := StringMorph contents: caption font: font emphasis: emphasis.
			captionMorph color: b.
			offset := captionAbove 
				ifTrue: [majorTickLength abs + captionMorph height + 7]
				ifFalse: [2].
			captionMorph align: captionMorph bounds bottomCenter
				with: self bounds bottomCenter - (0 @ offset).
			self addMorph: captionMorph].
	tickPrintBlock ifNotNil: 
			["Calculate the offset for the labels, depending on whether or not 
			  1) there's a caption   
			below, 2) the labels are above or below the ticks, and 3) the   
			ticks go up or down"

			offset := labelsAbove 
						ifTrue: [majorTickLength abs + minorTickLength abs + 2]
						ifFalse: [2].
			caption 
				ifNotNil: [captionAbove ifFalse: [offset := offset + captionMorph height + 2]].
			x1 := self innerBounds left.
			y1 := self innerBounds bottom.
			y2 := y1 - offset.
			"Start loop on multiple of majorTick"
			loopStart := (start / majorTick) ceiling * majorTick.
			loopStart to: stop
				by: majorTick
				do: 
					[:v | 
					x := x1 + (self scaleBy * (v - start)) rounded.
					tickMorph := StringMorph contents: (tickPrintBlock value: v) font: font emphasis: emphasis.
					tickMorph color: b.
					tickMorph align: tickMorph bounds bottomCenter with: x @ y2.
					self addMorph: tickMorph]]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:46'!
drawMajorTicksOn: aCanvas
	"Draw the major ticks."
	
	|b x1 y1 y2 x y3 even yy loopStart checkStart yoffset randomLabel |
	b := self paneColor contrastingColor.
	yoffset := majorTickLength < 0 
		ifTrue: [ majorTickLength abs + 1]
		ifFalse: [1].
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds left.
	y1 := self innerBounds bottom - yoffset.
	y2 := y1 - majorTickLength.
	y3 := y1 - ((minorTickLength + majorTickLength) // 2).
	even := true.
	"Make sure major ticks start drawing on a multiple of majorTick"
	loopStart := (start / majorTick) ceiling * majorTick.
	checkStart := (start / (majorTick / 2.0)) ceiling * majorTick.
	"Check to see if semimajor tick should be drawn before majorTick"
	checkStart = (loopStart * 2) 
		ifFalse: 
			[loopStart := checkStart / 2.0.
			even := false].
	loopStart to: stop
		by: majorTick / 2.0
		do: 
			[:v | 
			x := x1 + (self scaleBy * (v - start)).
			yy := even ifTrue: [y2] ifFalse: [y3].
			aCanvas 
				line: x @ y1
				to: x @ yy
				width: 1
				color: b.
			even := even not]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:46'!
drawMinorTicksOn: aCanvas 
	"Draw the minor ticks."
	
	|b x1 y1 y2 x loopStart yoffset randomLabel |
	b := self paneColor contrastingColor.
	yoffset := majorTickLength < 0 
				ifTrue: [majorTickLength abs + 1]
				ifFalse: [1]. 
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds left.
	y1 := self innerBounds bottom - yoffset.
	y2 := y1 - minorTickLength.
	loopStart := (start / minorTick) ceiling * minorTick.
	loopStart to: stop
		by: minorTick
		do: 
			[:v | 
			x := x1 + (self scaleBy * (v - start)).
			aCanvas 
				line: x @ y1
				to: x @ y2
				width: 1
				color: b]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 11:13'!
drawTicksOn: aCanvas 
	"Clip if needed."
	
	self clipSubmorphs
		ifTrue: [aCanvas clipBy: self bounds during: [:c | super drawTicksOn: c]]
		ifFalse: [super drawTicksOn: aCanvas ]
		! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 10:56'!
extent: aPoint
	"Set the extent using the Morph method."
	
	^self perform: #extent: withArguments: {aPoint} inSuperclass: Morph! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:54'!
font
	"Answer the font that should be used including emphasis."
	
	^self fontToUse! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:54'!
font: aFont emphasis: emphasisCode
	"Set the font and emphasis."
	
	font := aFont.
	emphasis := emphasisCode.
	self buildLabels! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:54'!
fontToUse
	"Answer the font that should be used including emphasis."
	
	| fontToUse |
	fontToUse := font isNil ifTrue: [TextStyle defaultFont] ifFalse: [font].
	(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [^fontToUse]
		ifFalse: [^fontToUse emphasized: emphasis]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 11:05'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scaleBy: 1! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:53'!
labelMorphsDo: aBlock
	"Do the block for just the labels."
	
	(self submorphs select: [:m | m isKindOf: StringMorph]) do: [:m |
		aBlock value: m]! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:56'!
layoutChanged
	"Allow submorphs to be added without constant updating."! !

!FixedScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:53'!
removeLabelMorphs
	"Remove just the labels."
	
	self labelMorphsDo: [:m | m delete]! !

!FixedScaleMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 11:05'!
scaleBy
	"Answer the value of scaleBy"

	^ scaleBy! !

!FixedScaleMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 11:05'!
scaleBy: anObject
	"Set the value of scaleBy"

	scaleBy := anObject! !

FixedScaleMorph subclass: #HScaleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!HScaleMorph commentStamp: 'gvc 5/18/2007 10:00' prior: 0!
Instances of this class draw ticks and labels in a horizontal format.!

FixedScaleMorph subclass: #VScaleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!VScaleMorph commentStamp: 'gvc 5/18/2007 10:00' prior: 0!
Instances of this class draw ticks and labels in a vertical format.!

!VScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:48'!
buildLabels
	"Build the labels."
	
	|b x1 y1 y2 x captionMorph tickMorph loopStart offset |
	b := self paneColor contrastingColor.
	majorTickLength * minorTickLength < 0 
		ifTrue: [minorTickLength := 0 - minorTickLength].
	self removeLabelMorphs.
	caption ifNotNil: 
			[captionMorph := StringMorph contents: caption font: font emphasis: emphasis.
			captionMorph color: b.
			offset := captionAbove 
				ifTrue: [majorTickLength abs + captionMorph height + 7]
				ifFalse: [2].
			captionMorph align: captionMorph bounds bottomCenter
				with: self bounds bottomCenter - (0 @ offset).
			self addMorph: captionMorph].
	tickPrintBlock ifNotNil: 
			["Calculate the offset for the labels, depending on whether or not 
			  1) there's a caption   
			below, 2) the labels are above or below the ticks, and 3) the   
			ticks go up or down"

			offset := labelsAbove 
						ifTrue: [majorTickLength abs + minorTickLength abs + 4]
						ifFalse: [4].
			caption 
				ifNotNil: [captionAbove ifFalse: [offset := offset + captionMorph height + 2]].
			x1 := self innerBounds top.
			y1 := self innerBounds right.
			y2 := y1 - offset.
			"Start loop on multiple of majorTick"
			loopStart := (start / majorTick) ceiling * majorTick.
			loopStart to: stop
				by: majorTick
				do: 
					[:v | 
					x := x1 + (self scaleBy * (v - start)) rounded.
					tickMorph := StringMorph contents: (tickPrintBlock value: v) font: font emphasis: emphasis.
					tickMorph color: b.
					tickMorph align: tickMorph bounds bottomCenter with: y2 @ x.
					self addMorph: tickMorph]]! !

!VScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:47'!
drawMajorTicksOn: aCanvas
	"Draw the major ticks."
	
	|b x1 y1 y2 x y3 even yy loopStart checkStart yoffset randomLabel |
	b := self paneColor contrastingColor.
	yoffset := majorTickLength < 0 
		ifTrue: [ majorTickLength abs + 1]
		ifFalse: [1].
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds top.
	y1 := self innerBounds right - yoffset.
	y2 := y1 - majorTickLength.
	y3 := y1 - ((minorTickLength + majorTickLength) // 2).
	even := true.
	"Make sure major ticks start drawing on a multiple of majorTick"
	loopStart := (start / majorTick) ceiling * majorTick.
	checkStart := (start / (majorTick / 2.0)) ceiling * majorTick.
	"Check to see if semimajor tick should be drawn before majorTick"
	checkStart = (loopStart * 2) 
		ifFalse: 
			[loopStart := checkStart / 2.0.
			even := false].
	loopStart to: stop
		by: majorTick / 2.0
		do: 
			[:v | 
			x := x1 + (self scaleBy * (v - start)).
			yy := even ifTrue: [y2] ifFalse: [y3].
			aCanvas 
				line: y1 @ x
				to: yy @ x
				width: 1
				color: b.
			even := even not]! !

!VScaleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/28/2007 15:47'!
drawMinorTicksOn: aCanvas
	"Draw the minor ticks."
	
	|b x1 y1 y2 x loopStart yoffset randomLabel |
	b := self paneColor contrastingColor.
	yoffset := majorTickLength < 0 
				ifTrue: [majorTickLength abs + 1]
				ifFalse: [1]. 
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds top.
	y1 := self innerBounds right - yoffset.
	y2 := y1 - minorTickLength.
	loopStart := (start / minorTick) ceiling * minorTick.
	loopStart to: stop
		by: minorTick
		do: 
			[:v | 
			x := x1 + (self scaleBy * (v - start)).
			aCanvas 
				line: y1 @ x
				to: y2 @ x
				width: 1
				color: b]! !

!SimpleButtonMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/16/2007 11:29'!
updateVisualState: evt
	"Use the highlight colour if transparent."
	
	oldColor ifNotNil: [
		 self color: 
			((self containsPoint: evt cursorPoint)
				ifTrue: [oldColor isTransparent
							ifTrue: [Preferences textHighlightColor]
							ifFalse: [oldColor mixed: 1/2 with: Color white]]
				ifFalse: [oldColor])]
! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/23/2007 17:04'!
barFillStyle
	"Answer the fillStyle for the bar if present or
	Preferences menuTitleColor otherwise."

	^self valueOfProperty: #barFillStyle ifAbsent: [Preferences menuTitleColor]! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/23/2007 17:04'!
barFillStyle: aFillStyle
	"Set the fillStyle for the bar."

	^self setProperty: #barFillStyle toValue: aFillStyle! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 13:25'!
drawOn: aCanvas
	"Draw the receive with the fill style for the bar."
	
	| area |
	super drawOn: aCanvas.
	barSize > 0 ifTrue: [
		area := self innerBounds.
		area := area origin extent: barSize @ area extent y.
		aCanvas fillRectangle: area fillStyle: self barFillStyle]
! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/24/2007 11:51'!
extent: aPoint
	"Update the bar fillStyle if appropriate."
	
	super extent: aPoint.
	self fillStyle isOrientedFill ifTrue: [
		self fillStyle: (UITheme current progressBarFillStyleFor: self)].
	self barFillStyle isOrientedFill ifTrue: [
		self barFillStyle: (UITheme current progressBarProgressFillStyleFor: self)]! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/24/2007 12:05'!
initialize
	"Initialize the receiver from the current theme."
	
	super initialize.
	barSize := 0.
	self 
		fillStyle: (UITheme current progressBarFillStyleFor: self);
		borderStyle: (UITheme current progressBarBorderStyleFor: self);
		barFillStyle: (UITheme current progressBarProgressFillStyleFor: self)! !

!SystemProgressBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/23/2007 17:04'!
privateMoveBy: delta 
	"Update the bar fillStyle if appropriate."
	
	| fill |
	super privateMoveBy: delta.
	fill := self barFillStyle.
	fill isOrientedFill ifTrue: [fill origin: fill origin + delta]! !

!ScrollPane methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/19/2007 17:22'!
adoptPaneColor: paneColor
	"Match the pane colour."
	
	super adoptPaneColor: paneColor.
	scrollBar adoptPaneColor: paneColor.
	hScrollBar adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderStyle baseColor: paneColor twiceDarker! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/26/2006 15:30'!
getMenuSelector: aSymbol
	"Set the menu selector."

	getMenuSelector := aSymbol! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/26/2006 15:30'!
getMenuTitleSelector: aSymbol
	"Set the menu titleselector."

	getMenuTitleSelector := aSymbol! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/24/2006 12:00'!
hScrollValue: scrollValue
	"Set the horizontal scroll value via the scrollbar itself."

	hScrollBar setValue: scrollValue! !

!ScrollPane methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/30/2006 09:20'!
hideOrShowScrollBar
	"Hide or show the scrollbar depending on if the pane is scrolled/scrollable."

	"Don't do anything with the retractable scrollbar unless we have focus"
	retractableScrollBar & self hasFocus not ifTrue: [^self].
	"Don't show it if we were told not to."
	(self valueOfProperty: #noScrollBarPlease ifAbsent: [false]) ifTrue: [^self].

	self vIsScrollbarNeeded not & self isScrolledFromTop not ifTrue: [self vHideScrollBar].
	self vIsScrollbarNeeded | self isScrolledFromTop ifTrue: [self vShowScrollBar].
! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/15/2007 11:18'!
minHeight
	"Answer the minimum height."

	|noVPlease noHPlease minH|
	noVPlease := self valueOfProperty: #noVScrollBarPlease ifAbsent: [false]. 
	noHPlease := self valueOfProperty: #noHScrollBarPlease ifAbsent: [false]. 
	noVPlease
		ifTrue: [noHPlease
					ifTrue: [minH := 1]
					ifFalse:[minH := self scrollBarThickness]]
		ifFalse: [noHPlease
					ifTrue:[minH := self scrollBarThickness * 3]
					ifFalse: [minH := self scrollBarThickness * 4 + 2]].
	^minH max: super minHeight! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/15/2007 11:14'!
minWidth
	"Answer the minimum width."

	|noVPlease noHPlease minW|
	noVPlease := self valueOfProperty: #noVScrollBarPlease ifAbsent: [false]. 
	noHPlease := self valueOfProperty: #noHScrollBarPlease ifAbsent: [false]. 
	minW := noVPlease
		ifTrue: [noHPlease
					ifTrue: [1]
					ifFalse: [self scrollBarThickness * 3]]
		ifFalse: [noHPlease
					ifTrue: [self scrollBarThickness + 20]
					ifFalse: [self scrollBarThickness * 3 + 2]].
	^minW max: super minWidth! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/6/2006 10:28'!
scrollValue
	"Answer the values of the scrollbars as a point."

	^hScrollBar value @ scrollBar value! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/17/2007 17:23'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^Preferences scrollBarsNarrow
		ifTrue: [10]
		ifFalse: [14]! !

!ScrollPane methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/24/2006 12:00'!
vScrollValue: scrollValue
	"Set the vertical scroll value via the scrollbar itself."

	scrollBar setValue: scrollValue! !

!BorderStyle class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/8/2007 17:20'!
dashed
	"Answer a dashed border style"

	^DashedBorder new! !

!BorderStyle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/14/2007 10:31'!
isComposite
	"Answer false."

	^false! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/15/2007 15:58'!
adjustSubmorphPositions
	"Fixed to not require setting item widths to 9999."
	
	| p h |
	p := 0@0.
	scroller submorphsDo: [ :each |
		h := each height.
		each privateBounds: (p extent: each width@h).
		p := p + (0@h)
	].
	self 
		changed;
		layoutChanged;
		setScrollDeltas.
! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:12'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self selectionColor: self selectionColor.
	self borderStyle baseColor: paneColor twiceDarker! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 11/17/2006 10:25'!
drawLinesOn: aCanvas
	"Draw the lines for the submorphs.
	Modified for performance."
	
	| lColor last|
	lColor := self lineColor.
	aCanvas 
		transformBy: scroller transform
		clippingTo: scroller innerBounds
		during: [:clippedCanvas |
			scroller submorphs do: [ :submorph |
				((submorph isExpanded and: [
					(submorph nextSibling notNil and: [
						clippedCanvas isVisible: (submorph fullBounds topLeft
							corner: submorph nextSibling fullBounds bottomRight)]) or: [
					submorph nextSibling isNil and: [(last _ submorph lastChild) notNil and: [
						clippedCanvas isVisible: (submorph fullBounds topLeft
							corner: last fullBounds bottomRight)]]]]) or: [
				(clippedCanvas isVisible: submorph fullBounds) or: [
				(submorph nextSibling notNil and: [
						clippedCanvas isVisible: submorph nextSibling fullBounds])]]) ifTrue:[
					submorph drawLinesOn: clippedCanvas lineColor: lColor]]]
		smoothing: scroller smoothing
! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 12:11'!
drawOn: aCanvas
	"Draw the selection and lines."
	
	super drawOn: aCanvas.
	selectedMorph ifNotNil:
		[aCanvas clipBy: self innerBounds during: [:c |
			c
				fillRectangle: self selectionFrame
				color: (self selectionColorToUse ifNil: [Preferences textHighlightColor])]].
	self drawLinesOn: aCanvas! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/17/2007 15:20'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/28/2007 13:55'!
expandAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self expandAll: m].
	self adjustSubmorphPositions! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/24/2007 10:30'!
expandedForm
	"Answer the form to use for expanded items."
	
	^self theme treeExpandedForm! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/15/2007 16:00'!
hUnadjustedScrollRange
	"Return the width of the widest item in the list.
	Use super now since actual item widths are correct."

	^super hUnadjustedScrollRange
! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/19/2007 14:53'!
keyStroke: event 
	"Process potential command keys.
	Fix for command key required (like PluggableListMorph)."

	| args aCharacter |
	(self navigationKey: event) ifTrue: [^true].
	(self scrollByKeyboard: event) ifTrue: [^self].
	aCharacter := event keyCharacter.
	(self arrowKey: aCharacter) ifTrue: [^true].
	keystrokeActionSelector isNil ifTrue: [^false].
	event anyModifierKeyPressed ifFalse: [^false].
	(args := keystrokeActionSelector numArgs) = 1 
		ifTrue: [^model perform: keystrokeActionSelector with: aCharacter].
	args = 2 
		ifTrue: 
			[^model 
				perform: keystrokeActionSelector
				with: aCharacter
				with: self].
	^self 
		error: 'The keystrokeActionSelector must be a 1- or 2-keyword symbol'! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:51'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/11/2006 10:34'!
lineColor
	"Answer a good color to use for drawing the lines that connect members of the hierarchy view.
	Used the cached color, or derive it if necessary by finding the receiver or the first owner (up to my root) that is not transparent, then picking a contrasting color.
	Fall back to black if all my owners are transparent."

	| colored |
	lineColor ifNotNil: [^lineColor ].
	colored := self color isTransparent
		ifTrue: [self firstOwnerSuchThat: [:o | o isWorldOrHandMorph not and: [o color isTransparent not]]]
		ifFalse: [self].
	colored ifNil: [^Color black].
	^colored color luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]
	
! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 12:15'!
mouseDown: evt
	"Changed to take keybaord focus."
	
	| aMorph selectors |
	evt hand newKeyboardFocus: self.
	aMorph := self itemFromPoint: evt position.
	(aMorph notNil and:[aMorph inToggleArea: (aMorph point: evt position from: self)])
		ifTrue:[^self toggleExpandedState: aMorph event: evt]. 
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	aMorph ifNil:[^super mouseDown: evt].
	aMorph highlightForMouseDown.
	selectors := Array 
		with: #click:
		with: nil
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 "pixels".! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/11/2006 10:40'!
mouseDownHighlightColor
	"Answer a good color to use for drawing the mouse down highlight.
	Used the line color if not transparent, otherwise a contrasting color in the
	same way as the line color is determined.
	Fall back to black if all my owners are transparent."

	|c colored |
	c := self lineColor.
	c isTransparent ifFalse: [^c].
	colored := self color isTransparent
		ifTrue: [self firstOwnerSuchThat: [:o | o isWorldOrHandMorph not and: [o color isTransparent not]]]
		ifFalse: [self].
	colored ifNil: [^Color black].
	^colored color luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]
! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 12:05'!
mouseEnter: event
	"Changed to take mouseClickForKeyboardFocus preference into account."
	
	super mouseEnter: event.
	Preferences mouseClickForKeyboardFocus
		ifFalse: [event hand newKeyboardFocus: self]! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/12/2006 15:29'!
mouseMove: evt

	|aMorph|
	aMorph := self itemFromPoint: evt position.
	evt hand hasSubmorphs ifFalse: [
		(aMorph isNil or: [aMorph highlightedForMouseDown not])
			ifTrue: [scroller submorphsDo: [:m |
					m highlightedForMouseDown ifTrue: [m highlightForMouseDown: false]].
					aMorph ifNotNil: [aMorph highlightForMouseDown]]].
	(self dropEnabled and:[evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropMorph ifNotNil:[
		(potentialDropMorph containsPoint: (potentialDropMorph point: evt position from: self))
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/24/2006 09:59'!
mouseUp: event 
	"Fixed up highlight problems."
	
	| aMorph wasHigh|
	aMorph := self itemFromPoint: event position.
	wasHigh := aMorph notNil ifTrue: [aMorph highlightedForMouseDown] ifFalse: [false].
	scroller submorphsDo: [:m |
		m highlightedForMouseDown ifTrue: [m highlightForMouseDown: false]].
	aMorph ifNil: [^self].
	wasHigh ifFalse: [^self].
	model okToChange ifFalse: [^self].
	"No change if model is locked"
	((autoDeselect isNil or: [autoDeselect]) and: [aMorph == selectedMorph]) 
		ifTrue: [self setSelectedMorph: nil]
		ifFalse: [self setSelectedMorph: aMorph].
	Cursor normal show! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/24/2007 10:31'!
notExpandedForm
	"Answer the form to use for unexpanded items."
	
	^self theme treeUnexpandedForm! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/13/2006 11:26'!
selectionColor
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColor ifAbsent: [] ! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:14'!
selectionColor: aColor
	"Set the colour for selected items."

	|w|
	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	w := self ownerThatIsA: SystemWindow.
	self selectionColorToUse: ((w isNil or: [w isActive])
		ifTrue: [aColor]
		ifFalse: [self paneColor lighter])! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/13/2006 11:27'!
selectionColorToUse
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColorToUse ifAbsent: [] ! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:14'!
selectionColorToUse: aColor
	"Set the colour for selected items."

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].
	self selectionFrameChanged! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:11'!
selectionFrame
	"Answer the frame of the selected morph in the receiver or nil if none."
	
	^selectedMorph
		ifNotNil: [selectedMorph bounds:  selectedMorph selectionFrame in: self]! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:11'!
selectionFrameChanged
	"Invalidate frame of the current selection if any."
	
	selectedMorph ifNil: [ ^self ].
	self invalidRect: self selectionFrame! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/11/2007 14:06'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:50'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

!SimpleHierarchicalListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 3/28/2007 13:56'!
update: aSymbol 
	aSymbol == getSelectionSelector 
		ifTrue: 
			[self selection: self getCurrentSelectionItem.
			^self].
	aSymbol == getListSelector 
		ifTrue: 
			[self list: self getList.
			^self].
	((aSymbol isKindOf: Array) 
		and: [aSymbol notEmpty and: [aSymbol first == #openPath]]) 
			ifTrue: 
				[^(scroller submorphs at: 1 ifAbsent: [^self]) 
					openPath: aSymbol allButFirst].
	((aSymbol isKindOf: Array) 
		and: [aSymbol size  = 2 and: [aSymbol first = getListSelector and: [
					aSymbol second == #expandRoots]]]) 
			ifTrue: 
				[^self expandRoots].
	((aSymbol isKindOf: Array) 
		and: [aSymbol notEmpty and: [aSymbol first = getListSelector and: [
					aSymbol second == #expandAll]]]) 
			ifTrue: 
				[^self expandAll]! !

SimpleHierarchicalListMorph subclass: #TreeListMorph
	instanceVariableNames: 'font enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TreeListMorph commentStamp: 'gvc 5/18/2007 10:15' prior: 0!
A SimpleHierarchicalListMorph subclass supporting alternative fonts for all items.!

!TreeListMorph methodsFor: 'private' stamp: 'gvc 5/15/2007 16:23'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean
	"Update the font on each morph."
	
	|answer|
	answer := super addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean.
	self scroller submorphsDo: [:i |
		i
			font: self font;
			extent: i minWidth @ i minHeight].
	^answer! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:01'!
font
	"Answer the value of font"

	^font ifNil: [TextStyle defaultFont]! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:00'!
font: anObject
	"Set the value of font"

	font := anObject! !

!TreeListMorph methodsFor: 'private' stamp: 'gvc 5/15/2007 16:16'!
insertNewMorphs: morphList
	"Update the font on each morph."
	
	morphList do: [:m |
		m
			font: self font;
			extent: m minWidth @ m minHeight].
	^super insertNewMorphs: morphList! !

!TreeListMorph methodsFor: 'private' stamp: 'gvc 8/8/2007 13:52'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the scroller and scrollbars now since bounds set driectly
	(not via #extent:)."
	
	super layoutBounds: aRectangle.
	self
		resizeScroller;
		setScrollDeltas! !

!TopLeftGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 10:53'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: w@w)
			containsPoint: aPoint) not]! !

!TopLeftGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 12:12'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds left: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!BottomRightGripMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 10:52'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: (w@w) negated)
			containsPoint: aPoint) not]! !

!BottomRightGripMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/26/2007 12:11'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds right: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!PreferenceBrowserMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 12:01'!
preferenceList
	"Changed to take mouseClickForKeyboardFocus preference into account."
	
	^preferenceList ifNil:
		[preferenceList := ScrollPane new
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill.
		Preferences mouseClickForKeyboardFocus
			ifFalse: [preferenceList scroller
						on: #mouseEnter send: #value: 
						to: [:event | event hand newKeyboardFocus: preferenceList scroller]].
		preferenceList scroller
			on: #keyStroke send: #keyPressed: to: self.
		preferenceList]! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/29/2007 15:31'!
add: wordingString font: aFont icon: aForm help: helpString subMenu: aMenuMorph 
	"Append the given submenu with the given label."
	
	| item |
	item := ToggleMenuItemMorph new.
	item
		font: aFont;
		contents: wordingString;
		subMenu: aMenuMorph;
		icon: aForm.
	helpString isNil
		ifFalse: [item setBalloonText: helpString].
	self addMorphBack: item! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/25/2006 13:37'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	originalColor :=  paneColor.
	self borderStyle baseColor: paneColor.
	self updateColor! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 14:24'!
extent: aPoint 
	"Change the receiver's extent.
	optimized to not keep updating the (gradient) color!!"
	
	|old|
	old := self extent.
	super extent: aPoint.
	self extent = old ifTrue: [^self].
	self updateColor! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/26/2007 15:27'!
originalColor
	"Answer the original color."
	
	^originalColor! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 11/14/2006 15:37'!
updatePosition
	"private - update the receiver's position.
	Fixed so as not to keep changing position!!
	(called twice if adhereing)"
	
	| edgeSymbol margin |
	edgeSymbol := self edgeToAdhereTo.
	edgeSymbol == #none
		ifTrue: [self
				perform: (edgeSymbol , ':') asSymbol
				with: (self owner perform: edgeSymbol)].
	""
	margin := self avoidVisibleBordersAtEdge
				ifTrue: [self borderWidth asPoint]
				ifFalse: [0 asPoint].
	""
	self isAdheringToTop
		ifTrue: [| usedHeight | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			self topLeft: self owner topLeft - margin + (0 @ usedHeight)].
	self isAdheringToBottom
		ifTrue: [| usedHeight | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#bottom ).
			self bottomLeft: self owner bottomLeft + (-1 @ 1 * margin) - (0 @ usedHeight)].
	""
	self isAdheringToLeft
		ifTrue: [| usedHeight usedWidth | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			usedWidth := self usedWidthByPredominantDockingBarsOfChastes: #(#left ).
			self topLeft: self owner topLeft - margin + (usedWidth @ usedHeight)].
	self isAdheringToRight
		ifTrue: [| usedHeight usedWidth | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			usedWidth := self usedWidthByPredominantDockingBarsOfChastes: #(#right ).
			self topRight: self owner topRight + (1 @ -1 * margin) + (usedWidth negated @ usedHeight)]! !

!DockingBarMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/16/2007 14:41'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu.
	Fixed for when generalizedYellowButtonMenu pref is off"
	
	^Preferences noviceMode not and: [Preferences generalizedYellowButtonMenu]! !

DockingBarMorph subclass: #ToolDockingBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ToolDockingBarMorph commentStamp: 'gvc 5/18/2007 10:20' prior: 0!
A non user-moveable docking bar that uses theme-based fill styles.!

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 15:21'!
add: wordingString font: aFont icon: aForm help: helpString subMenu: aMenuMorph 
	"Append the given submenu with the given label."
	
	| item |
	item := ToggleMenuItemMorph new.
	item
		font: aFont;
		contents: wordingString;
		subMenu: aMenuMorph;
		icon: aForm.
	helpString isNil
		ifFalse: [item setBalloonText: helpString].
	self addMorphBack: item! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 13:28'!
gradientRamp
	"If not set answer based on orininal color."
	
	^self normalFillStyle colorRamp! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:28'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme dockingBarNormalFillStyleFor: self! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 13:29'!
updateColor
	"private - update the receiver's color"
	
	self autoGradient
		ifFalse: [^ self].
	self fillStyle: self normalFillStyle! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/16/2006 14:27'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu."
	
	^false! !

!UUniverseBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:54'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallProjectIcon! !

!AlphaBlendingCanvas methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/26/2006 10:14'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Draw the given form. For the 'paint' combination rule use stenciling otherwise simply fill the source rectangle.
	Do a paintAlpha if the rule is blend to cope with translucent images being drawn (via translucentImage:...)."
	
	rule = Form paint ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form paintAlpha
			alpha: alpha.
	].
	rule = Form over ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha.
	].
	rule = Form blend ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha.
	].! !

!ProcessBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:52'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallDoItIcon! !

!PackagePaneBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 10:08'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallProjectIcon! !

!AbstractResizerMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/25/2006 11:59'!
handlesMouseUp: anEvent
	"Answer true to handle resetting of the cursor if it has strayed
	outside the receiver while dragging."

	^true! !

!AbstractResizerMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 3/12/2007 10:59'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary."
	
	(self bounds containsPoint: anEvent cursorPoint) ifFalse: [
		anEvent hand showTemporaryCursor: nil.
		self
			setDefaultColors;
			changed]! !

AbstractResizerMorph subclass: #EdgeGripMorph
	instanceVariableNames: 'target ptName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!EdgeGripMorph commentStamp: 'gvc 5/18/2007 13:20' prior: 0!
Similar to a ProportionalSplitterMorph but designed to attach to an edge of a single morph only. Needs to be themed...!

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 17:07'!
adoptPaneColor: paneColor
	"Change our color too."
	
	|fs|
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	fs := GradientFillStyle ramp: {0.0->paneColor whiter whiter. 0.2->paneColor lighter. 0.8->paneColor darker. 1.0->paneColor blacker}.	
	fs origin: self topLeft; radial: false.
	fs direction: ((#(top bottom topLeft bottomRight) includes: self ptName)
		ifTrue: [(#(top bottom) includes: self ptName)
					ifTrue: [0 @ self height]
					ifFalse: [self width @ self height]]
		ifFalse: [(#(left right) includes: self ptName)
					ifTrue: [self width @ 0]
					ifFalse: [self width @ self height]]).
	self fillStyle: fs! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:56'!
defaultHeight
	"Answer the default height for the receiver."
	
	^22! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:56'!
defaultWidth
	"Answer the default width for the receiver."
	
	^22! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:52'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self
		ptName: #right;
		extent: self defaultWidth+2 @ (self defaultHeight+2)! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:43'!
mouseDown: anEvent
	"Remember the receiver and target offsets too."
	
	|cp|
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position. cp - self targetPoint}! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:59'!
mouseMove: anEvent
	"Track the mouse for resizing."
	
	target ifNil: [^self].
	Preferences fastDragWindowForMorphic 
		ifTrue: [target doFastWindowReframe: self ptName] 
		ifFalse: [
			lastMouse at: 1 put: anEvent cursorPoint.
			self targetPoint: lastMouse first - lastMouse last.
			self positionPoint: (lastMouse first - lastMouse second)].! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:49'!
positionPoint: aPoint
	"Reposition based on ptName."
	
	(#(top bottom) includes: self ptName)
		ifTrue: [^self position: self left @ aPoint y].
	(#(left right) includes: self ptName)
		ifTrue: [^self position: aPoint x @ self top].
	^self position: aPoint! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 16:43'!
ptName
	"Answer the value of ptName"

	^ ptName! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 16:43'!
ptName: anObject
	"Set the value of ptName"

	ptName := anObject! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:59'!
resizeCursor

	^ Cursor resizeForEdge: self ptName! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 16:43'!
target
	"Answer the value of target"

	^ target! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 16:43'!
target: aMorph
	"Set the value of target"

	target _ aMorph! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:52'!
targetPoint
	"Answer the reference point of the target."

	^self target bounds pointAtSideOrCorner: self ptName! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:51'!
targetPoint: aPoint
	"Set the reference point of the target."

	self target bounds: (self target bounds withSideOrCorner: self ptName setToPoint: aPoint)! !

!Project class methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/21/2007 14:03'!
interruptName: labelString preemptedProcess: theInterruptedProcess
	"Create a Notifier on the active scheduling process with the given label.
	Modified to do nothing if no tool set is present (impiles runtime) and
	to notify the world if interrupting."
	
	|preemptedProcess projectProcess suspendingList|
	ToolSet default ifNil: [^self].
	Smalltalk isMorphic ifFalse:
		[^ ScheduledControllers interruptName: labelString].
	ActiveHand ifNotNil:[ActiveHand interrupted].
	ActiveWorld := World. "reinstall active globals"
	ActiveHand := World primaryHand.
	ActiveHand interrupted. "make sure this one's interrupted too"
	ActiveEvent := nil.
	World interrupted. "notify the world too - needed for #syncDisplay:"

	projectProcess := self uiProcess.	"we still need the accessor for a while"
	preemptedProcess := theInterruptedProcess ifNil: [Processor preemptedProcess].
	"Only debug preempted process if its priority is >= projectProcess' priority"
	preemptedProcess priority < projectProcess priority ifTrue:[
		(suspendingList := projectProcess suspendingList) == nil
			ifTrue: [projectProcess == Processor activeProcess
						ifTrue: [projectProcess suspend]]
			ifFalse: [suspendingList remove: projectProcess ifAbsent: [].
					projectProcess offList].
		preemptedProcess := projectProcess.
	] ifFalse:[
		preemptedProcess suspend offList.
	].
	Debugger openInterrupt: labelString onProcess: preemptedProcess
! !

SimpleBorder subclass: #CompositeBorder
	instanceVariableNames: 'borders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!CompositeBorder commentStamp: 'gvc 5/18/2007 13:28' prior: 0!
Border supporting multiple "sub-borders".!

!CompositeBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/29/2007 17:32'!
= aBorderStyle
	"Check the sub-borders too"
	
	^super = aBorderStyle and: [
		self borders = aBorderStyle borders]! !

!CompositeBorder methodsFor: 'accessing' stamp: 'gvc 3/12/2007 11:15'!
borders
	"Answer the value of borders"

	^ borders! !

!CompositeBorder methodsFor: 'accessing' stamp: 'gvc 3/12/2007 11:15'!
borders: anObject
	"Set the value of borders"

	borders := anObject! !

!CompositeBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/12/2007 12:13'!
colorsAtCorners
	"Return the colors of the first border."
	
	^self borders first colorsAtCorners! !

!CompositeBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 10:47'!
frameRectangle: aRectangle on: aCanvas
	"Draw each border in turn."
	
	|r|
	r := aRectangle.
	self borders do: [:b |
		b frameRectangle: r on: aCanvas.
		r := r insetBy: b width]! !

!CompositeBorder methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:29'!
hash
	"Since #= is overridden."
	
	^super hash bitXor: self borders hash! !

!CompositeBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 10:32'!
isComposite
	"Answer true."

	^true! !

SimpleBorder subclass: #DashedBorder
	instanceVariableNames: 'dashColors dashLengths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!DashedBorder commentStamp: 'gvc 5/18/2007 13:28' prior: 0!
Border style supporting dashed lines of configurable patterns and colours.!

!DashedBorder class methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:39'!
width: width dashColors: cols dashLengths: lens
	"Answer a new instance of the receiver with the given
	width, colours and lengths."
	
	^self new
		width: width;
		dashColors: cols dashLengths: lens! !

!DashedBorder methodsFor: 'accessing' stamp: 'gvc 4/24/2007 15:48'!
dashColors
	"Answer the value of dashColors"

	^ dashColors! !

!DashedBorder methodsFor: 'accessing' stamp: 'gvc 4/24/2007 15:48'!
dashColors: anObject
	"Set the value of dashColors"

	dashColors := anObject! !

!DashedBorder methodsFor: 'accessing' stamp: 'gvc 4/24/2007 15:59'!
dashColors: cols dashLengths: lens
	"Set the colours and lengths."

	cols size = lens size ifFalse: [self error: 'Colors and Lengths must have the same size'].
	self
		dashColors: cols;
		dashLengths: lens! !

!DashedBorder methodsFor: 'accessing' stamp: 'gvc 4/24/2007 15:48'!
dashLengths
	"Answer the value of dashLengths"

	^ dashLengths! !

!DashedBorder methodsFor: 'accessing' stamp: 'gvc 4/24/2007 15:48'!
dashLengths: anObject
	"Set the value of dashLengths"

	dashLengths := anObject! !

!DashedBorder methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 15:51'!
frameRectangle: aRectangle on: aCanvas
	"Frame the given rectangle on aCanvas"
	
	(aRectangle width < self width or: [aRectangle height < self width])
		ifTrue: [^self]." don't do if too small"
	aCanvas
		frameRectangle: aRectangle
		width: self width
		colors: self dashColors
		dashes: self dashLengths! !

!DashedBorder methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 15:50'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		dashColors: {Color black. Color white};
		dashLengths: #(1 1)! !

!DashedBorder methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 17:21'!
style
	"Answer #dashed."
	
	^#dashed! !

SimpleBorder subclass: #MarginBorder
	instanceVariableNames: 'margin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!MarginBorder commentStamp: 'gvc 5/18/2007 12:46' prior: 0!
Border with customisable inner margin.!

!MarginBorder methodsFor: 'accessing' stamp: 'gvc 10/17/2006 11:07'!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	"Reduce the width by the margin."
	
	| lineColor |
	lineColor := (stopPoint truncated quadrantOf: startPoint truncated) > 2 
				ifTrue: [self topLeftColor]
				ifFalse: [self bottomRightColor].
	aCanvas 
		line: startPoint
		to: stopPoint 
		width: (self width - self margin max: 0)
		color: lineColor! !

!MarginBorder methodsFor: 'accessing' stamp: 'gvc 10/17/2006 11:06'!
frameRectangle: aRectangle on: aCanvas
	"Reduce width by the margin."
	
	aCanvas frameAndFillRectangle: aRectangle
		fillColor: Color transparent
		borderWidth: (self width - self margin max: 0)
		topLeftColor: self topLeftColor
		bottomRightColor: self bottomRightColor.! !

!MarginBorder methodsFor: 'accessing' stamp: 'gvc 10/17/2006 11:05'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		margin: 0! !

!MarginBorder methodsFor: 'accessing' stamp: 'gvc 10/17/2006 11:04'!
margin
	"Answer the value of margin"

	^ margin! !

!MarginBorder methodsFor: 'accessing' stamp: 'gvc 10/17/2006 11:04'!
margin: anObject
	"Set the value of margin"

	margin := anObject! !

SimpleBorder subclass: #RoundedBorder
	instanceVariableNames: 'cornerRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!RoundedBorder commentStamp: 'gvc 5/18/2007 12:17' prior: 0!
Experimental work-in-progress. Will probably be slow but more flexible than CornerRounder.!

!RoundedBorder methodsFor: 'accessing' stamp: 'gvc 3/14/2007 10:47'!
cornerRadius
	"Answer the value of cornerRadius"

	^ cornerRadius! !

!RoundedBorder methodsFor: 'accessing' stamp: 'gvc 3/14/2007 10:47'!
cornerRadius: anObject
	"Set the value of cornerRadius"

	cornerRadius := anObject! !

!RoundedBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 12:18'!
frameRectangle: aRectangle on: aCanvas
	"Draw the border."
	
	self cornerRadius = 0 ifTrue: [^super frameRectangle: aRectangle on: aCanvas].! !

!RoundedBorder methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 12:16'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		cornerRadius: 0! !

!SimpleBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:50'!
bottomRightColor
	"Changed from direct access to color since, if nil,
	self color is transparent."

	^self color! !

!SimpleBorder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/31/2007 13:50'!
topLeftColor
	"Changed from direct access to color since, if nil,
	self color is transparent."

	^self color! !

Object subclass: #ExampleRadioButtonModel
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beCenter
	"Set the option to #center."

	self option: #center! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beLeft
	"Set the option to #left."

	self option: #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beRight
	"Set the option to #right."

	self option: #right! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		option: #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isCenter
	"Answer whether the option if #center."

	^self option == #center! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isLeft
	"Answer whether the option if #left."

	^self option == #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isRight
	"Answer whether the option if #right."

	^self option == #right! !

!ExampleRadioButtonModel methodsFor: 'accessing' stamp: 'gvc 8/7/2007 13:13'!
option
	"Answer the value of option"

	^ option! !

!ExampleRadioButtonModel methodsFor: 'accessing' stamp: 'gvc 8/7/2007 13:15'!
option: aSymbol
	"Set the value of option"

	option := aSymbol.
	self
		changed: #isLeft;
		changed: #isCenter;
		changed: #isRight! !

Object subclass: #ListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ListModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 12:14'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		list: #();
		selectionIndex: 0! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
list
	"Answer the value of list"

	^ list! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
list: anObject
	"Set the value of list"

	list := anObject.
	self changed: #list! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
selectionIndex
	"Answer the value of selectionIndex"

	^ selectionIndex! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
selectionIndex: anObject
	"Set the value of selectionIndex"

	selectionIndex := anObject.
	self changed: #selectionIndex! !

!Object class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:40'!
taskbarIcon
	"Answer the icon for an instance of the receiver in a task bar
	or nil for the default."

	^nil! !

!Object methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/10/2007 11:41'!
okToClose
	"Sent to models when a window closing.
	Allows this check to be independent of okToChange."
	
	^true! !

!Object methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:41'!
taskbarIcon
	"Answer the icon for the receiver in a task bar
	or nil for the default."

	^self class taskbarIcon! !

!Object methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 12:32'!
windowActiveOnFirstClick
	"Return true if my window should be active on first click."

	^true! !

Object subclass: #ObjectStringConverter
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ObjectStringConverter commentStamp: 'gvc 5/18/2007 12:43' prior: 0!
Generic object<->string converter for use with PluggableTextFieldMorph. #next: and #previous: unused at present.!

!ObjectStringConverter class methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:11'!
forClass: aClass
	"Answer a new instance of the receiver that converts to and from
	the given class of object and a string."

	^self new objectClass: aClass! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 08:55'!
isStringValid: aString
	"Answer whether the given string is valid for conversion."

	^true! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/25/2006 13:20'!
needsConversion
	"Answer whether conversion is required for the receiver's object class."

	^(self objectClass includesBehavior: String) not! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:24'!
next: aString
	"Answer the next item (upwards)."

	self subclassResponsibility! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:06'!
objectAsString: anObject
	"Answer the given object in string form."

	^anObject asString! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:10'!
objectClass
	"Answer the class of object we are dealing with."

	^objectClass! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:10'!
objectClass: aClass
	"Set the class of object we are dealing with."

	objectClass _ aClass! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:25'!
previous: aString
	"Answer the previous item (downwards)."

	self subclassResponsibility! !

!ObjectStringConverter methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:47'!
stringAsObject: aString
	"Answer the given string in object form."

	^self needsConversion
		ifTrue: [self objectClass readFromString: aString]
		ifFalse: [aString]! !

Object subclass: #TableItemWrapper
	instanceVariableNames: 'columnIds headings valueBlocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TableItemWrapper commentStamp: 'gvc 5/18/2007 11:52' prior: 0!
Convenient generalised model for a TableMorph.!

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 16:00'!
columnIds
	"Answer the value of columnIds"

	^ columnIds! !

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 16:00'!
columnIds: anObject
	"Set the value of columnIds"

	columnIds := anObject! !

!TableItemWrapper methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:00'!
headingFor: id
	"Answer the heading for the given column id."

	^self headings at: (self columnIds indexOf: id)! !

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:35'!
headings
	"Answer the value of headings"

	^ headings! !

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:35'!
headings: anObject
	"Set the value of headings"

	headings := anObject! !

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:35'!
valueBlocks
	"Answer the value of valueBlocks"

	^ valueBlocks! !

!TableItemWrapper methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:35'!
valueBlocks: anObject
	"Set the value of valueBlocks"

	valueBlocks := anObject! !

!TableItemWrapper methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:00'!
valueFor: item in: id
	"Answer the value for the given item in the given column id."

	^(self valueBlocks at: (self columnIds indexOf: id)) value: item! !

Object subclass: #TaskbarTask
	instanceVariableNames: 'morph state label icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TaskbarTask commentStamp: 'gvc 5/18/2007 11:20' prior: 0!
Holds the state of a taskbar/tasklist entry.!

!TaskbarTask class methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 12:26'!
morph: aMorph state: aSymbol icon: aForm label: aString
	"Answer a new instance of the receiver with the given parameters."

	^self new
		morph: aMorph;
		state: aSymbol;
		icon: aForm;
		label: aString! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 7/24/2007 12:18'!
= aTaskbarTask
	"Answer whether equal."

	^self species = aTaskbarTask species
		and: [self morph == aTaskbarTask morph
		and: [self state == aTaskbarTask state
		and: [self icon = aTaskbarTask icon
		and: [self label = aTaskbarTask label]]]]! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/23/2007 14:51'!
activate
	"Activate the task."
	
	(self morph respondsTo: #restoreAndActivate)
		ifTrue: [self morph restoreAndActivate]! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:06'!
buttonClickedForTasklist: aTasklist
	"Notify the tasklist."
	
	aTasklist taskClicked: self! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 12:24'!
hash
	"Hash is implemented because #= is implemented."
	
	^self species hash
		bitXor: (self morph hash
		bitXor: (self state hash
		bitXor: (self icon hash
		bitXor: self label hash)))! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
icon
	"Answer the value of icon"

	^ icon! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:49'!
isActive
	"Answer whether the task is active."

	^self state == #active! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:25'!
isMinimized
	"Answer whether the task is minimized."

	^self state == #minimized! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
label
	"Answer the value of label"

	^ label! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
label: anObject
	"Set the value of label"

	label := anObject! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:24'!
morph
	"Answer the value of morph"

	^ morph! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:24'!
morph: anObject
	"Set the value of morph"

	morph := anObject! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
state
	"Answer the value of state"

	^ state! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
state: anObject
	"Set the value of state"

	state := anObject! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:21'!
taskbarButtonFor: aTaskBar
	"Answer a button for the task."
	
	^self morph taskbarButtonFor: aTaskBar! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 5/9/2007 15:30'!
tasklistButtonFor: aTasklist
	"Answer a button for the task."
	
	^UITheme current
		newTasklistButtonIn: aTasklist
		for: self! !

Object subclass: #TextHighlight
	instanceVariableNames: 'color lineRange bounds borderWidth borderColor borderSides fillWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TextHighlight commentStamp: 'gvc 5/18/2007 11:15' prior: 0!
Definition of a clickable highlighted range of text with optional borders.!

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderColor
	"Answer the value of borderColor"

	^ borderColor! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderColor: anObject
	"Set the value of borderColor"

	borderColor := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:57'!
borderSides
	"Answer the value of borderSides"

	^ borderSides! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:57'!
borderSides: anObject
	"Set the value of borderSides"

	borderSides := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderWidth
	"Answer the value of borderWidth"

	^ borderWidth! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderWidth: anObject
	"Set the value of borderWidth"

	borderWidth := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:18'!
bounds
	"Answer the value of bounds"

	^ bounds! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:18'!
bounds: anObject
	"Set the value of bounds"

	bounds := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 16:19'!
clicked: evt
	"The receiver has had a mouse down."

	self triggerEvent: #clicked! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
color
	"Answer the value of color"

	^ color! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
color: anObject
	"Set the value of color"

	color := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 16:00'!
containsPoint: aPoint in: rect
	"Answer whther the bounds contain the given (local coordinate) point."

	|r|
	r := self bounds.
	r := self fillWidth
		ifTrue: [rect left @ r top corner: (rect right @ r bottom)]
		ifFalse: [r]. 
	^r containsPoint: aPoint! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/31/2006 16:29'!
drawOn: aCanvas in: rect offset: o
	"Draw the highlight on the given canvas for the given rectangle."

	|r|
	r := self fillWidth
		ifTrue: [rect left @ (self bounds top + rect top) corner: rect right @ (self bounds bottom + rect top)]
		ifFalse: [self bounds translateBy: rect topLeft].
	r := r translateBy: (self fillWidth ifTrue: [0@o y negated] ifFalse: [o negated]).
	self color isTransparent not ifTrue: [
		aCanvas
			fillRectangle: r
			color: self color].
	(self borderWidth > 0 and: [self borderColor isTransparent not]) ifTrue: [
		(self borderSides includes: #top) ifTrue: [
			aCanvas
				fillRectangle: ( r withHeight: self borderWidth)
				color: self borderColor].
		(self borderSides includes: #right) ifTrue: [
			aCanvas
				fillRectangle: (r withLeft: r right - self borderWidth)
				color: self borderColor].
		(self borderSides includes: #bottom) ifTrue: [
			aCanvas
				fillRectangle: ( r withTop: r bottom - self borderWidth)
				color: self borderColor].
		(self borderSides includes: #left) ifTrue: [
			aCanvas
				fillRectangle: ( r withWidth: self borderWidth)
				color: self borderColor]]! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:38'!
fillWidth
	"Answer the value of fillWidth"

	^ fillWidth! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:38'!
fillWidth: anObject
	"Set the value of fillWidth"

	fillWidth := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/31/2006 11:16'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		color: Color yellow;
		lineRange: (1 to: 0);
		borderWidth: 0;
		borderColor: Color transparent;
		borderSides: #(top right bottom left);
		fillWidth: false! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:03'!
lineNumber
	"Answer the first in the line range."

	^self lineRange first! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:02'!
lineRange
	"Answer the value of lineRange"

	^ lineRange! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:02'!
lineRange: anObject
	"Set the value of lineRange"

	lineRange := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 13:20'!
position
	"Answer the bounds top left."
	
	^self bounds topLeft! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 13:19'!
position: aPoint
	"Set the bounds top left."
	
	self bounds: (aPoint extent: self bounds extent)! !

Object subclass: #ThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

ThemeIcons class
	instanceVariableNames: 'Icons'!

!ThemeIcons commentStamp: 'gvc 5/18/2007 10:25' prior: 0!
Some extra icons in the vein of MenuIcons.!

ThemeIcons class
	instanceVariableNames: 'Icons'!

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 12/21/2006 16:02'!
initialize
	"Initialize the class."
	
	self initializeIcons! !

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 7/25/2006 16:33'!
base64ContentsOfFileNamed: aString 
	"Private - convenient method"
	
	| file base64Contents |
	file := FileStream readOnlyFileNamed: aString.
	base64Contents := (Base64MimeConverter mimeEncode: file binary) contents.
	file close.
	^ base64Contents! !

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 10:25'!
createIconMethodsFromDirectory: directory 
	"Create the methods for the icons.
	(self createIconMethodsFromDirectory: '')."
	
	| iconContentsSourceTemplate iconSourceTemplate normalSize smallSize |
	iconContentsSourceTemplate := '{1}IconContents
	"Private - Method generated with the content of the file {2}"
	^ ''{3}'''.
	iconSourceTemplate := '{1}
	"Private - Generated method"
	^ Icons
			at: #{1}
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self {1}Contents readStream) ].'.
	normalSize := self normalSizeNames.
	smallSize := self smallSizeNames.
	normalSize , smallSize
		do: [:each | 
			| png base64 contentsSelector selector | 
			png := directory , each, '.png'.
			[base64 := self base64ContentsOfFileNamed: png.]
				on: Error do: [base64 := nil].
			base64 ifNotNil: [
				contentsSelector := (each , 'IconContents') asSymbol.
				((self respondsTo: contentsSelector)
						and: [(self perform: contentsSelector) = base64])
					ifFalse: [| contentsSource | 
						contentsSource := iconContentsSourceTemplate format: {each. png. base64}.
						self class compile: contentsSource classified: 'private - icons'].
				selector := (each , 'Icon') asSymbol.
				(self respondsTo: selector)
					ifFalse: [| source | 
						source := iconSourceTemplate format: {selector}.
						self class compile: source classified: 'private - icons']]].
	self initializeIcons! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/29/2007 16:15'!
downArrowIcon
	"Private - Generated method"
	^ Icons
			at: #downArrowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self downArrowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/29/2007 16:20'!
downArrowIconContents
	"Private - Method generated with the content of the file downArrow.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAABGdBTUEAALGPC/xhBQAAABh0
RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYyLjcyclqEXQAAAOpJREFUSEvFVVsSwiAMFFG//PAG
HoWzcCeuy9DCGOQRAqlRO8NHC90lm2SjQggn4UfveD5jRgJq7QfjDdCF/Hduv5Hgr+g4BB3e
XwhUGeaCRHD+jkktGUGnf5JYMMn6mxFUslYSly/e+74KeGX6kyq6DCNANeRHUCVbIsml/vH2
ceWSlSCgrQZkoRqKuzfMARcIOz81u09IVhvteYRk5AhYglKZcUgIu7kdHjZwgQYc/Ah64ZoI
nHMtUW6WBbuelqk2xrAjWRmXYNfKWstquIHmpV2/FZjMg266zeZHsZ/sgrr5gwEGON1c2ACW
SQJu5miG1AAAAABJRU5ErkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/10/2007 10:25'!
errorIcon
	"Private - Generated method"
	^ Icons
			at: #errorIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self errorIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
errorIconContents
	"Private - Method generated with the content of the file icons\base\error.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/10/2007 10:25'!
infoIcon
	"Private - Generated method"
	^ Icons
			at: #infoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self infoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
infoIconContents
	"Private - Method generated with the content of the file icons\base\info.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAN1wAADdcBQiibeAAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAuwSURBVGiBtZl7cFTXfcc/5660D1YP9ECykIRMgoQtwOZlHqaeOKYTSDxOGtcwnqStTcDj
Gsdx3IS0k6Z0JjN1GscOdqGtmweOXXucmZIGQ2yTGMcFBwyYhw3ijUAPjJ4rCe3z3nvuOf1j
70oraSWtRLIzZ/aeK83ez/d3fq9zrtBacyMfsb73lrmVxoY8P7PyfSKY5yMv4CXPACNuq0gk
oaPhhIpEE7rtUqf9UtRUh/UvKm/soenPn4yA0if7l95cKp6oKRb1K+tzZ6y9w1tSmieG/I8G
0u9EEppdJxLhN47HW5tD8uK1Xrm9Zcv0XTeGP0EBwY3h+vnV4oWvLstd9NCd3qKgT9DZL2lo
TdDUZdETkYQiklBYYktN0GdQEBAUBDxUl3hZMivIrAo/ltTsOh6Pb3sn3HClS3635fnKvX9S
AeKRcNniGuM/7rs9Z8V3Vntvsh3NgfMxTrUkaOuzkI5GKo10VPJ6YKih10ozdYqHpbV5PLCs
mOpSH9v3hXu37wsfO9lqfiPys5ln/+gCKjdFli2aYbz88vpAXdALBy7E2Hc2SsxUg4BZwqfm
SikMAfctLmL9ynLy/B6++Wp3828/jmxu3DLzlT+agFs3Rx/5/BzP5mfX+qsutJvsPhamN+rg
OBp7CNQY8MPEKaXQWg8MXw5sXD2dtSum8Z97+7q27ul+7exztd/SWqtsBOSM9ocF34/+63dW
eR9ZtyK3eP+5GL9viGA5OgP80FE4xeDmUj9CQGOHyZXOxKjwSmtipuJHO1s40xrhuw/cPG1O
lffRJ4wLnxJTa9dw/ZKtx3GRjCtQvzm64duf8/7wb5bnFL9xLMLJlvgAxEj4Qes+eGcR9y4s
xGMM5p/3TvfzL7/6hITljIDXaYKU1sypmsKW9XVc6rDNdVsvvnpu6/wnAHOs1TCG36jcFFm6
ao7nn7/2Z7kj4KVKwjvu3EmDv7s+jy8unjoEHuCzcwrYuKp8XHitFKeawzz+X2eZX+P3fetL
lX9Z89CeJ4GgEMKTlQDxSLh00QzjlefW+qvePx8bAW8PuFASPjWXjmJ5Xd6oy7xyXsG48Kn5
mdYI//TaRTasLJ163123PFV4zw8/B+QJITK6+xABS2caW19aF6i72G7x7qnIYBAq5Vp8JLzt
KByl8eWKTL8PgC/XQDA+fGr+1tFOfva7Vn78UFXZrYtWfh+4abSVGBCQ/3i47gvzcj5TEIBd
x/qxR0mPKbdJh7cdzcdNsVEFnLgcRars4FPzF3ZfoaUzwhP3Vny6bPWP1wFlQEAIMcToA5P5
1ca/bVrlrTh4IUZf1Bk/tyuNo/SAmFf2d3P2k/gI+I7rNs/sbJ0QvNIay1Y8/0YT984P+mpv
W/5VcgI1QAngFUIMLLfQWlPw9fD8H9zve/fhFTnFz/2mm6ilxoUfXqhsR6OV5p55Bcye7ifX
I2hsT/DmsRDRhBwaxOOJSbv388fr6IlqtfHp/3297a2ntgGXgV6ttQ1uHagtE0/+1fLc4kMX
o2PDq9HhHSf58D0nenn7eGbYicIrrfn53mv84CvVRnlN/bI2+DUQBhJCCEdrrQyA6UXitsKA
4FRrYmz4DC1COvxYsEMAs4TXWnPo/HWiCZtZlfklBEqr3IAuSBk/R2zom/3sGn91b9ShNWRN
CF6mwc+tDvDZuQUk62Ly4WjQaM60RvnN0e4RcOPBa6UwHc0H565z/5LCgt/d9tfL+w9v6QC6
gX4hhJ0zu9xY9+AS77SG1viE4WWa5WsrfKy9szRjFtr9YRe7j3SOCzva/P1z/XxzdYlRUbf0
9v7D7AOKgQ4gZhQERG1lkUFTlzVp+KQlM6dQpRTSticNnyxuMZQjKQj6pwBBoAjIB3KNAj/5
AKGwvAF4TXIPNhLeNE2ktAddZoLwWilCYRspJX5fjg/wuTFQCHhz8v3kAXSH5aThM62A1hrL
srAsC9uWI4J2ImKuxxQJy8HnzfECue4q5AM+Y4o3uQLd/fak4VMPTIc3TRPTNLEsCynlmIUr
m4Du7DMpDQoPwel5gBcIAF5DCIQGrBuBd++lPinLW5aFaZrYtj0q/HDg0YZl2wiUQHgMN4X6
AK8RM3VYAPl+IwO8ngB8UkDK8ulDSjmh3J9pXhiAjuvSIXo1TrIFygVyjUhCRQAKp3gyFzE1
Mm9ndoOhlh8ybOuG4P25Ag8O0bhpo7VwBXgAj9Ef1+GkACMzvMquBZBSZrS+ZVlIW44UnyW8
0prCAEgpiSdMOy1PCEAY4YRq7YkqZpR605q1icFrpVCOk9H6pmlipwXxROG11lQXCxzHIRqL
J9KzNKCMM9fsl3ceT/Qu+XRwEN6ZGLzWGuk4Ga1vmuakClm62y6oMrjUpXXnlY+b3GBTgARs
Q7900/G3T5rNNdN8TCv0TApeuy6UyfrJNGpPGt4QmrnT4benzEj49P+cdQU4gA3YBkBztzxn
Sc2y2rxJwQ+PgRR86tpOxUCWbpQ+Zk0T+D0OjW2RMLH2uCtAAiZgGQBNXfInOz6Mh7+8pBiP
wcgqm0UPr5QzwvJD6sBEY8C9t+pWQVNI666rF1pc13Fc+OiAgM5tFe+9+F70ZHmhly8unjo0
Y4wnxr0n5RgxkF4HRoPNAD+7XDC3QvPKB1ZvzwfPH3HhLSACXAfMgT3x+WvWt/99bzj0tXvK
CXhFRviR/U9aEI8RA7Y9Rgxk8HutFBrNmoUGp9twLp85fBo7aroCEi58/8AKAHRsqzz0y0PR
D3NzPDy2qmKkdcaowsOz0IgYSHWjWcIrrbm7VlBV6PD6Eaun/8i2o2mBGwF63G855IjiRLO1
8fGXQ01r7pzGl+4ozry0o8SBcuSoMSDtDHVgDPi6MsHaBbDjIxFrOfqrgygp3cCNASGgC4jq
1J449Ulsn3Hl8KXEUz96s6/rH+6vYeGn8rI+jBorBuzhMTAGfEkQHrtLcOIq9u8PnmxInP/1
pbSs00dyJ9bjxsLIs9Gzz1TtfO1A+MW9p+OxZx+u5faaYFbp1BkrBiwra/gn7xb0xdGv7u9u
7n3/6T+48BbJ04gOoA2IaK2djAIAPnq6evPmHaGdx5qsxE+/Xs99d0wbdyVCUcW5NofzHZpL
3QaNIYPGkIemPi/d8dxx4WeXC7632kAqoV94J9bWsWfTW2nwERe+1XUhM8U65guOhf/Y/MzD
dxWs/8bqouLt71zl+V2XsWw1pphsLD0829wz28PaBXCsFfna/s6m9rc3vYmTMNPg24GLQCPQ
o91DrXEFAMz7+8tfWVEXeGbrwzdVdvSabHnjMruPtKMcdcPw9RUGDyw0qCpU7Dgh4u8e/Ohk
z/4hbhMFOkmexjUCXVprM50vq5d81Y813F5TFnjxb/+8eN6DywuCDU19/GRPM/tO9yaPDcfp
Z9LnHqGprzBYPSeHW8o1Jz/Rzi8Px0MtH+44EDu/MxWwKct3Ak3u6AISehhw1q9ZhRBGzYY/
rL15evH3/u4LJbWfucXnjcVNDl3o4/9O9XC6NUZHn0VP2EKlbYLyvFAUFNSUeFgww8PcCkGO
kDR2af3fB+M9lxsOnOw7su0oyaBMZZt+kj7fTNLvezLBT0hASgT+ksCMNa8+WlFWtGZmuW/G
lxfnly2q8eSgHWzbJmHZdPaZJEzJ1IDGwEFKiS0lZ64pvedUPHylLdzf1XLmSs8HLxxGxmwG
W4QYyVTZDlwlmXGuA1Ym+AkLcEUIkqcCeRTOqsxb+OhfVM689fOFU3KK/V4jEPB6/AUBw+cR
WnT3m3Y0nrBjMdPqj8bNzisfXYo2vH6GeGecwcbMImn1MMkM0+6OEMliJcfkmaiANCGpk4F8
kkd9JcBUoBBfUREe3xRi7ZLk3jX99Y1icEOSYLAx6yF55plqEyydxavWSQtwRQgGjzgCrpgC
9zvg3s9NE5Hq5VO+HmWwMYuSdCErVaSyYrgRAcOEDBx1pIGnRkpAyvKSZGOWch8bkNlY/E8i
YMgPJsWkBBlp15BcgdSeVqXmowVoNp//B5V52MnTW/VPAAAAAElFTkSuQmCC'! !

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 7/25/2006 16:35'!
initializeIcons
	"self initializeIcons"
	
	| methods |
	Icons := IdentityDictionary new.
	methods := self class selectors
				select: [:each | '*Icon' match: each asString].
	methods
		do: [:each | Icons
				at: each
				put: (self perform: each)]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/10/2007 10:25'!
lockIcon
	"Private - Generated method"
	^ Icons
			at: #lockIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self lockIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
lockIconContents
	"Private - Method generated with the content of the file icons\base\lock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 1/29/2007 16:15'!
normalSizeNames
	"Answer the names of the normal icons"
	
	^#('error' 'info' 'lock' 'question' 'warning' 'upArrow' 'downArrow')! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/10/2007 10:25'!
questionIcon
	"Private - Generated method"
	^ Icons
			at: #questionIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self questionIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
questionIconContents
	"Private - Method generated with the content of the file icons\base\question.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:36'!
smallBarcodeIcon
	"Private - Generated method"
	^ Icons
			at: #smallBarcodeIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBarcodeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:37'!
smallBarcodeIconContents
	"Private - Method generated with the content of the file smallBarcode.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAA
ABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYyLjcyclqEXQAAAIRJREFUOE/tUkkOgCAMLBef
qSZePPMIn+MLMbWjbWgaT8BRksmwDNNCm5g5EREL2oYYUA8QFdF7gATahj39uY2FsZ/Hsw9t
vfgbDPpEX1CrRixyqNiAPujqRC7HxCWTsAAcscseYBroKvRgU5EJwXPA8mqus0KM1MCieIbp
6qJbZj6DTDcgu0pIJUVp4QAAAABJRU5ErkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:04'!
smallBoldIcon
	"Private - Generated method"
	^ Icons
			at: #smallBoldIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBoldIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 7/25/2006 16:39'!
smallBoldIconContents
	"Private - Method generated with the content of the file smallBold.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABl0
RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoAAAELSURBVDiNndOxLkRREAbgb5Bg
RaJQqZREISERrYYH2JYQiUIlwWOotCqFROEFtpGIUsMb2BCRaESlWEaxe5Objb2b3UkmmTPz
n3PmP/+ZwA5OVFsLTTzhPDM/y8Vj5AD+geXMlJlG+tz8n83iqliM9QBd4BbjWMM+Jkr1pYiY
y8y3Xgc8ZOZ1J76MiBr2ujA19KcQEaNY7Eq/4LmKwlFE1Dttr2C6VHvHbma2isQgKnxhs1Bg
GBWm0YiIm4iYpPcbnGGj44faipStjtMqCgflNjGD7y7M4yAU5rX/RNmm6K3CdkSsduIFrP+D
ua+i0M9/sDXsLPxiPzMbBYVX3FVsSHziTXucG5nZLIp/7M1/esa2s1kAAAAASUVORK5CYII='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 5/21/2007 12:39'!
smallErrorIcon
	"Private - Generated method"
	^ Icons
			at: #smallErrorIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallErrorIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
smallErrorIconContents
	"Private - Method generated with the content of the file icons\base\smallError.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAKQSURBVDiNbZPRS1NhGMaf7zvb3PJigzZrC46BoIbWRSSVoYmKgkj/gBdCGnklgjcSXnkr
giLZhfQnGIVBSKkX6dC5BYJJI7cIczbTuePO8ezM95yvC91w6gMvL+/F732/74GHCSFwXsbE
xAteVfWYTk7uk64HJKfzJwciRjg86x4Z+YwLYvkFRn9/JW9rm9J1vUVdXcVJKgVSVZCqgtnt
8HR2ktNuf5OenBySI5HjogXZvr5K3tW1rASD3tzOTgE0zzoRgYjgqq2Fr6lp5V9395M7QlgA
wDOMMd7S8loJBr25RAKkaafwWc/DJhHSkQj2wuFHfwYH3+ZfwB3Dw71ZoDWXSBSuXoJNE2Sa
ICLszc3hVnl51/OKimcAwHld3UM1FIKZzcIyDJi53GkxBotzCEmCJUkwOYfFOUgIHIZC9uuy
3MsYc9jIZnvgqK5GoKfnosEAACKCoihQFAXpdBpKMomj0VH4ZdkP4J7NNIybktt9JZzL5Yph
RYGi67A0DSUulxvAXZvkcPxILSzcsMsyhBCFMgwDqqpC0zRkMhmoqno67++jlDFsb2+nAXhs
7Pj4WzYWexofGIBJVDAr73x+NokgEeEaEVBfj3g0egDgLzdWVmY9HR103mnzCpjOZhPAUSCg
fYnH4wAS3D02tuiSpClnTU3x1atgIojWVjEzP790SJQCEOYAcDQ9PeRvbv7qaWy8/IU8LATQ
3i5CyeTGx62t7wA+CSG0QhaijHHf+PirlN0+fLC2VqKsr0Pf3QX8fghZRsbnU2cWF5c+xGIb
AJaFEO+LwpRXtKHh9oLX+5LKyhpLSks9v2Ox9K/NzYO5eDyesqwkgHdCiOilNF6KKWMMgBdA
AEAWQBKAIi4A/wHla+UnnITGTwAAAABJRU5ErkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 4/16/2007 17:00'!
smallHierarchyBrowserIcon
	"Private - Generated method"
	^ Icons
			at: #smallHierarchyBrowserIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallHierarchyBrowserIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 4/16/2007 17:00'!
smallHierarchyBrowserIconContents
	"Private - Method generated with the content of the file smallHierarchyBrowser.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAALGPC/xhBQAAABh0
RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYyLjcyclqEXQAAAJlJREFUOE+lU4sOgCAI1B/tI/r9
HAQkzhdoxcYaKcfBYQhkKaWAiCHGyCGQo+HPBQC5zy6mPxSADgbLwAIw2A4AgTOzhkEu+DAo
AYU7DJqcHmA1A23bYlC3WGj3fXsM3gNUGZ6EKu1ciQxiUt48lyXyKkzPra1DGhQNWvR3N3Mm
OydoteVemABwnSz1H4BjD2DRoz8DfZZfvzfCeW5hrgHmOgAAAABJRU5ErkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 5/21/2007 12:39'!
smallInfoIcon
	"Private - Generated method"
	^ Icons
			at: #smallInfoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallInfoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
smallInfoIconContents
	"Private - Method generated with the content of the file icons\base\smallInfo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AALNSURBVDiNZZNNaFxVGIafezIzmbTQjDqxndRMLUI0pooWfyLSUm1RUXFTNxpElBYFwY2b
IsWFdCsoYhXFlaALrShVS2s1C5u25qdRiNJJJhNjbHTS3Dt35p7Jnen9To6LzkyT9Nsenu97
3gOvY61l9bx3un7w9s3qocjIzrAu3cl42zSo8bHZ+vG393f+yLpxmgte/6Le+1i/OhqG4d5f
pzWejtChoEMhHnN4emdK4onkh++f8g+NH8kur1nw6me13sEH1PDZXDl9qXQFHQrbu+L0bU3y
1TmPvy8vIyLsyHawZ0fX+Rc/vvyw/bxvBUA5BwNn7x3qg7O5cnqhdIVq4+pLe9I8O3Aj+wdS
iAhiDOPTPmO5xYE3Bv75tGmgDj+VOMBKbd9C47KuGao1w0eninx/ocSXw4sYYzAiiAgnJxbZ
1rN18LZdLz8DoO7fph4cyesW3MxdrQnnLvrElL1q0LAQEUamSvFs900HHMdJqJiS+7wgWgNH
Irz2xBaOPL+dR+7csAY2IkzOBWRvyWSAu1U9MlvWw2IMFkulUkEHAdKIYBpvRb9OR7K9E7gr
loi1XdShbNa1a7ARQesqbWFAoHUrf9Mis8kyPz/vAym1HDkX4jGIomuwiFD2fVzXvWqwChYR
elIr5GcKLvCfOp+vH3/y3pSs/mkxBq/ksbS0RNCI0MyPNXR3VKqFidMFYEG981znUFu842h/
T7IFGxF8v4zrugRat2Axhn291v70w7EzEpY8YEwBfDJUOfToPZlfdvenWhaTcxV++6vKJS/C
iGCt4fE+bDE/Mpkf/e4P4IS1ttrqgjOYU+++0PVmPPIOj0657b/PlvnXC8lsguwNlq5EoIdO
HDszM/rtJDBsrf1mTZmas+ut3K1p/+dXbt4ouzduaE/NFOb8P6dm3cLEycJK6BWBr621ueva
eF1NHccB0kA3UAOKQNmuA/4HsoMEebPS9UsAAAAASUVORK5CYII='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:04'!
smallItalicIcon
	"Private - Generated method"
	^ Icons
			at: #smallItalicIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallItalicIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 7/25/2006 16:39'!
smallItalicIconContents
	"Private - Method generated with the content of the file smallItalic.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABl0
RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoAAACmSURBVDiNpZIxDsIwEASHFKlo
qCPRRqmo4Al8g5fkT3yBFlLkFYgGCdFBwVLE7nJny7FkXbO78uwZSVgXOAEj0FuaCv8cgR3w
tASpgEOYV1PhPH8DCPgAdQnCPsxR0rcEIQbcHM3yAK+DO1MHnbtqw9wE8xuovAALIa5vkPQr
6SCP3wlIf6B4ZvhXwIupg63HP1si0AbzI2W2SszmtzpYAxfgnBPwB0Q6/v9KP2ylAAAAAElF
TkSuQmCC'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 5/21/2007 12:39'!
smallLockIcon
	"Private - Generated method"
	^ Icons
			at: #smallLockIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLockIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
smallLockIconContents
	"Private - Method generated with the content of the file icons\base\smallLock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAIoSURBVDiNhVI9a1RRED133stuREMQ0aCC34KBdAlYCAs24h+QdIIGbAVReyuxsLMTFCzt
xEILQbTRICFqMEWaYBA1Gy3Edfd+zRmLt/uSDYLFcC5zOTNzzoy7fu3SowMTO1rGLFSFMoPM
oG5FdWT/TxU9n/3qWrj99Nn8w3L/vtHWxQtHDzNHqAZQA6ibb9UEagIZ+5hAFdy5zxuzs7PL
JUxlO7nnAxaWulhZDZg6oZg8rjAOyAmqCQ4sRWSyGntb51fzXfz+E3H2NDH/voNPK70hMhlB
mohIUypdw2N/b3u0pg17d2ecbwkWljrDZE0wY1EURbOsjKrI3W7Au489rG94PHmRkVJArxvw
+UsPbxcjpqfcpg/mxDnXLKm57vz8dRcv33TgvceHZY8QQh3zixG3ru7CySNVEeNIISINYV+C
akL7h4f3VYQQaowxIoSAb21fSzGjABhMUBmUYhgqMCDGGBFjhOYGVK2SQBaVBGq95xD+TR5g
zg2QBmqEmYlzrlEV6DvrXKw1D7puLVKWo2B/AjOKmQ22UDl77kyJ9Taw8dMQApESEaMhJ8Ox
Q03MTBX1PZhZ0fdA6+TBCcPNKztBbWw7nARqHMoZKSLSKEPMgSpDR/I/smpC1kJINsu1r+ne
3Qf5sgPGSRMzEdqIGAshm2JGoVGMLMzMkSyyCsb3nOqIyC9nZpibmxvz3s+QHCvLckRESgA1
OudqNLPSOVc657KqPv4Lpk1zsB8BOCQAAAAASUVORK5CYII='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 5/21/2007 12:39'!
smallQuestionIcon
	"Private - Generated method"
	^ Icons
			at: #smallQuestionIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallQuestionIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
smallQuestionIconContents
	"Private - Method generated with the content of the file icons\base\smallQuestion.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AALxSURBVDiNZdNfbFN1GMbx7zltT1cGroORsdV2iSYjcbsBFSGZYuLChSzeqBdmJkadxguj
3hgSWCIYEq/QGBNiYkyWGENEiUGMpgyEiwobfzaHy2LZVjK7MTpYe7odenp63l9/XAzKgPf6
/Tx53ovX0Fqzer4+5b23udnc4SvZ6nrSWhcKTIJ5+dI178TnrzYM8tAY9wI+OuK17+owD7uu
+9LwpEPe8XFcwXGFUNCgZ2tUQlbdt9+ctPdcPpgoPRDwwQ/l9t5t5t/n0sWmuUIFKwDx9UFa
GkNcmSkxlLZZul2hMxHhxc6mobf6f+zSqU8UgEHfknH0/fDJzHyx+3qhguMKB15v4fENVq3m
QtFn98F/qFSEnU81YHlzA4c+3vWu1rpq9u+2+qiWa9gpKwbO3qL/SJbvT+fQGtYEPLbEQERI
ji7QFo/1PtH1do9hGIb5bJv53IUpp4YdVxgcs/nr3wJHUzl8VcW2bWYXy4hSiAgXrhZCbbGN
7wBhM2jKM/llv4YdV/BFEBH2vZagUi7xUyrH9M0VrEQYn1kmHmuOAZ2m56tNj2ClSDRZvNAR
ZfZGnoHUMuouFqXI2R6RunAD0GlawcB/K/XvYyVCz9PrcRyHX87lcMsrje6d0LxOk81mbSAa
LPnGSCjITt+/j0WE75L/8/sQTGSdB7CIEI8apMczi0DOHJryTry8JSpqFRal+OLNNj57pZ7t
ca+GlQhoRWtk6XZm9NQ0cN089EbDmUAocrgjXlfDSoRAtYRt25jKrWFRiu52rU//cSwlbuEW
MGJordm+fy7yYXd9cnhi/vnBkRwiwlqrSus6n7FZn0pFobWiezM6Nzk8fvbnL5PAr8D52i8Y
vWnzq94N/Zay9168uhgeu1ZkPu/S8hgkGjUbrWXnzJ/HUtMXj18BzgO/aa2rxsPfuOPT4Sc3
eSN9zWtVV/2acONUZsaeSGcWM6PJTNXN3wCOA2l9Fz4SAGAYhgGYQBPQApSBBaCotVard+8A
JLDt2W5OLJMAAAAASUVORK5CYII='! !

!ThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:38'!
smallSizeNames
	"Answer the names of the small icons"
	
	^#('smallError' 'smallInfo' 'smallLock' 'smallQuestion' 'smallWarning' 'smallBold' 'smallItalic' 'smallUnderline' 'smallStrikeOut' 'smallBarcode' 'smallHierarchyBrowser' 'smallSystemBrowser')! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:04'!
smallStrikeOutIcon
	"Private - Generated method"
	^ Icons
			at: #smallStrikeOutIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallStrikeOutIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 7/25/2006 16:39'!
smallStrikeOutIconContents
	"Private - Method generated with the content of the file smallStrikeOut.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABl0
RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoAAAE9SURBVDiNldO/K/5RFMDxF49f
iUHf/JhkkUkpPwaD7BaTkk3Z/AUGizIp5S+wyGy0UQaFRd9MFrFQnkgIcQ2f8+jj6fOQW6d7
u+ec9zn33HOklFQE3VjHHsq4wz42MJa3/fLJOY/gEgkPOMP/OCd8YKkQgBJuwnAZzTlwAxbw
FvqhIsBEKE9RV5gqq2Gzkr9vkK3+2C9SWBesbQzi5dtt2PcG/R0zRRnUkjp0YACLmAvuNQ5D
jvBYkNFJSukNpiP6X6WnUoNyfFcpR29BO9riXFlPuMIzXr9q8JPgH+bjWQkHVXolTGH2F1BX
RH5HZ3Uf3Ad98BfIXthNVgN2QrGJ+hrOrbK2fpDv1FCORlESdjGMptA1YlzWpQlbtYZpLqpc
+aYXnOfACcfoKAQEpA9rEa0sG6Bb2UgvoFT9tE9NmYDjaYSwiQAAAABJRU5ErkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 4/16/2007 17:00'!
smallSystemBrowserIcon
	"Private - Generated method"
	^ Icons
			at: #smallSystemBrowserIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSystemBrowserIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 4/16/2007 17:00'!
smallSystemBrowserIconContents
	"Private - Method generated with the content of the file smallSystemBrowser.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAALGPC/xhBQAAABh0
RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYyLjcyclqEXQAAAINJREFUOE+9UgkOwCAIg/8/GsWI
q45qlmUzIVG5SqmKiFXLjppdLlVlcVLj5hNFvUCY/9G4nuAd0EZyR9LyI2bcscvSMS2AKAbS
Vwi2s/3GQUcxzbxyQ5ECw66FdRPxbj66BUxku/4eAdPDUYlPObgJKQqgRDO1bTlAmEyVdEOn
2U/+Aq6qHwNt2ojQAAAAAElFTkSuQmCC'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 12/21/2006 16:04'!
smallUnderlineIcon
	"Private - Generated method"
	^ Icons
			at: #smallUnderlineIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUnderlineIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 7/25/2006 16:39'!
smallUnderlineIconContents
	"Private - Method generated with the content of the file smallUnderline.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABl0
RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoAAADaSURBVDiN7dMxSkNBEAbgb8UY
wUrwADZ2QsAbWIl4AcGzeI9gZSmpbFJ7Am1jE4hYCAoWWoiCGYs3Jk94SYRYOjDMzuw//+6w
/0ILl+mtiDDLcZa47VrNOiK9vYBglLjOd23FkvZP8EcEH6qngc0F+I2M7xOCiBjjJfOdWZ2l
lDVsZfpcvwHcZNybc/p+xvuIeJxUU2EnqjHecNigwF3cJub0x14N1DWV9AP6Kt1f4zPrPaw2
EiTJAc4xwFPOOsAFjpr+R0FBZ87sTTaMiFfZ3MZdrn9rxxFxBV+mVKeTcAXyQwAAAABJRU5E
rkJggg=='! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 5/21/2007 12:39'!
smallWarningIcon
	"Private - Generated method"
	^ Icons
			at: #smallWarningIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallWarningIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
smallWarningIconContents
	"Private - Method generated with the content of the file icons\base\smallWarning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAJBSURBVDiNpVPNS1RxFD331/tqpim1/ECG0E1qlOEsKkhwMy3bJASFjaILQRBxY4YiLc2W
gvtwWUKg4B8gCH4NuHFqnNLJQd7D/Bj0Nb/nzPvdVkrhKIEHLufCvRzOPXCJmXEZiPMGh0TP
DoPBuQOiWxcqMPOZygLWvmlu7xmG+lpaOtPf33+12B4zFxfYA4b2Kio8b3aWHSHUx0ik478F
fgHVO5omDyYnOZlM8m5raz5RVva9s7OzupjAmQx8w/ggIhGaIcLw8DDWYjEtcHRU83RpaYiI
6MIQHaKHfqHwMjQxYQgh4LouAuEwQoOD4sHm5uuBtrYn54a4DdC2ZcV3OzoKzMzLy8scjUY5
l8uxcl1er6w8/lxXN9fb22sWPcEHXvlC3LsxOnoFAOrr61FbWwvLsuAqBX1kRL+zsfG4NJ3u
OuPgJxBIm+bOwdgY/43p6Wl2HIdTqRTH43FeaWg4/lJTk+np6an6x4EvxFtUVYWu9/UBAPL5
PBYWFjA1NYVUKgXbtmHbNrZiMT2cTleHk8n3pyH+ILrtC/Hm5vi4CV1HNpuF4zhIJBJYXFxE
JpOBbdtwHAfpQABbTU2qcXX1RXd39yMAoHXL+oRg8Pm1gQEhpUTO8yClRE5KeJ6HnJSQJywl
sL+PhpUVzDc3r7nR6H36VlIy8puoq0Ckk+97PkAKIJ+ZTnoFQDELH4AiEiyENt/SEnLKy2PE
zGhvb2/Udf0uAFMIYRCRqZQyAZhEdMpKKZOIDAAGAGia9o4u+85/AMNcgUUP6yM5AAAAAElF
TkSuQmCC'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/29/2007 16:15'!
upArrowIcon
	"Private - Generated method"
	^ Icons
			at: #upArrowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self upArrowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/29/2007 16:20'!
upArrowIconContents
	"Private - Method generated with the content of the file upArrow.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAABGdBTUEAALGPC/xhBQAAABh0
RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYyLjcyclqEXQAAAQpJREFUSEu1lVsSgyAMRaW2/epH
d9CluBb2xEK7AUYJFgyYh1TsDB0EvCcPEs08zwPze4f1L7fJrJuwXgoCQBgG78HLynms9YrG
hz9jrZUgce9nGUw4yIjgtzSH0+M0TSIAi6c54UkWLbyGB+dcDdgsWGNKjiPhara8hlWQFKZk
4IMCxE3O6oPhSrpPCvBpERdysl6OOo7/iEuQAnBGnINkQA9xCtJUYMoNIrV6AHA7uYecwoht
gkxyS9KZQisquocHtQZ4sOUWP3jvm67t6VahVTQCFG2d9YCySLq+TB8qa0tzswHAt+sKsvuK
Ke06nc9X86oQXVZo8jelYw4AtMuDWmiaAcQ+/vgPC/J4A2CzJcVhAAAAAElFTkSuQmCC'! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 1/10/2007 10:25'!
warningIcon
	"Private - Generated method"
	^ Icons
			at: #warningIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self warningIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/29/2007 12:43'!
warningIconContents
	"Private - Method generated with the content of the file icons\base\warning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

ThemeIcons subclass: #VistaryThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!VistaryThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 16:24'!
initialize
	"Initialize the class."
	
	self initializeIcons! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
errorIconContents
	"Private - Method generated with the content of the file icons\new\error.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
infoIconContents
	"Private - Method generated with the content of the file icons\new\info.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
lockIconContents
	"Private - Method generated with the content of the file icons\new\lock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 14:41'!
normalSizeNames
	"Answer the names of the normal icons"
	
	^#('error' 'info' 'lock' 'question' 'warning')! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
questionIconContents
	"Private - Method generated with the content of the file icons\new\question.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallErrorIconContents
	"Private - Method generated with the content of the file icons\new\smallError.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMiSURBVDiNXZPPSxx3HIafnRl3nTVmo3Gprlus7opBYtSGtoLQWv+AkqSF9BiQIHMQc8oh
gSTnECGkkG0PIaJQgreWeJRGTDAQbRGNtoZWXaG4uuvY2dnZHzPf+fZgK5oPvLf3fT6nJyCl
5PhNTEwMxGKx6/Wq2l9jWc2OphUPdP3XzO7uT6ZpfmcYhne8H/gfkEqlwu2JxESP635dnp2l
tLGBa5pUHAe/qopwXx/ZgQFzOZ3+cnh4eOkEIJVK6f1dXdvNS0tnnZUVXNM8HNs2rusehXCY
+hs35Hyx+O3Q0NAUgALQnkhMxFdWzhZXV/HyebxCAbdQwPO8owjfx8lm2bpzJ9DV0PBjKpWK
ACiTk5Nf9CrKN8XVVTzbpm50lJZnzyCZPBxKSceTJ3wyP4+WTFKxbayHD9V4LPYCQGlqarru
vX59+Nm20Ts7CdXUkHz8mMC5c3wwNoZsbSVnWWQvXmSjXOa3hQUi+Xw3QGBxbu7PhqdP2yoH
B7imiUgmaR0bo+y67OdyCN9HCMHb2Vm2796lXCxScV0+u3mTjaamPqXWcT5083k8y8Itldh7
84Zfrl1jb2/vaLy+sMD2vXtUymXQdbQzZ7C2tgCuaI6q2tWWVVdxHDLFIrbnEbt6FSklQgiE
EMQ6Otjt7aWUTiNVFSElNdEoOcgpB5q24CsK2WKRfKVC461bRC5cwPM83i0u4hQKqJpG5+3b
1HZ0ENZ1wtXVhFtaAKaVTCbzs9/dzT+VCq7rEohG8TyPtZcv+fv+fdYePKCQz+NLSSAaJez7
nNI03HjcB9bUwcHBxUhPz4g9N6eXHIedmRkyuRwHU1MEdR2tVMJZXsZcX6fu1StUIWi+fJk/
4AfDMJ4rhmGIt+l0/0cjI9JVFMr7++Snp1GDQdRgkCohqN7cJDozQ8iyON3WxlYikZFSjpxw
YXx8/Er76dNTm48eqfs7O4QiEYKKQkgIgo5DUAjqL11i8/z5HcuyPjcM490JwH9CnYo1Nr6o
tayP5fZ2oJxOEwyFqIrHKScS/l/Z7PdSytHjRgbe1/kY7FPgK8ACngO/G4bhv9/7FxuHuWxf
1Q6XAAAAAElFTkSuQmCC'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallInfoIconContents
	"Private - Method generated with the content of the file icons\new\smallInfo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMMSURBVDiNXZPNbxR1GMc/Mzvd2dntbku3LtsXInFpxFiCepCSmgIHEkPiS8pF48WkwWYO
RP8C/wCPeBj1VHvwwE2DB29iMJqIJWhFoilLXwid0ul2Z9p5+/1mfh4Wk5bn/P18nuc5fDWl
FAdncXHx/Ojo6JWCOTTtJ5UxQ4WRVdhd2tpyv+10Op/bti0P5rX/BY7jlFsnJhZF5ZXLN+8k
tDdiOl1BGKb06TlTk2XOT2531tp/Xpifn797SOA4jnXq1en1u4/H6ssrIZ1dQRhKZi8M8sMt
j/srPiIVlE345IMhFXm/vDc3N3cdQAdonZhYXH4yXr/XjvADiR8IxoYNPnyrwaU3jiCERKSS
bS/k02ur2vDIqW8cxxkAKLRarXO1YzOf3fojxvclXV/gB5JHbsTPSx1u3NwiChOkEEghiSLB
yrrSL54tv3ny5Itf6iMjI1d+vScJAom/14OlkJBnVC1BzdwnCT2SvU3iYJ0kaHP7tzsE8cBp
AL1UGTrbfpTgBz1YpJI0STjzUs47U0/4aLZKEnqkcReR7CNFhEhD/mmHmuM4Z/RQVo8FT+E4
EkT7HlF3AyX3ieMYlESKFClS8izFKsJg1WB1wweYNQqEe35QOhJGKdGeSxoGPUBKhBDougGZ
YLCmUzLLFDSFUhnPDVcAzzOMfPe2TuNiFGyThgEiTREiJZcZ9Xqdnb0+mo0SZqmArmsoDfI8
4/nRMmR8r7uu+93pVk4adhFC9LanCVkmaDQaGH0G/bUSRtlCWRXyYhnD6mf8qMiBv3XP85xz
L+92rJIiEyky7f1rlTRqtRqaXkCZFnGhQkA/kWZxaeY47uMHX9m2neu2bWdr7b+mr75/XOmq
d4FVVLTXuvy+vMNPS5vEmHRkGV+avNCs0RpadZVSVw91YWFhYbZWn7h+7euHhc2tHQYGTHSz
SKabhBTJKPLu1BCTRx9u+r4/Y9v2v4cETwvV32yO/ujH1dfWXaWtuQlmqch4o49WM8m33Qdf
KKU+PthI7dk6H5C9DrwN+MAN4L5t2/mzuf8Ad6/AAZ+lo8QAAAAASUVORK5CYII='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallLockIconContents
	"Private - Method generated with the content of the file icons\new\smallLock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AALVSURBVDiNfdM/aBNhGAbw57vvu/tyd8m1Gmtr26Bp1QoqCBlMUUREHNwcuiiIqKCD0EUc
XFwiFapYCGJ1EcQKWQpWcCmIQkBBaa3oIlSrNbWpNndJ7nJ3uX9OLWKtz/7+eJ8XXhJFEVYy
NDSU1nX9nOM43Y7jLFSr1XyhUPiB/4SsAMPDw8d0XR/VNK27t7f3M6U0WSwWjbm5ucHx8fFn
6wECAExMTKi2bd/MZDIN0zQHBwYGdk1NTWV6enr0/v7+G9lstuW/QKlUutjZ2blnenr6Xi6X
uwsAuVzuW6lUupVOp/va2trOr1shNE5vff9p82OrpqRl+/V1LkaRRCMETQuubWJ6fsdl360t
blE/Xjt+aWFyDRCYRx7o1U9n3j0PoM9TpLaoSHWocM0SqBAinogjJAQfZpe+HL5Q71lToWqY
LQuzHvSfPiQegbEQQejC9RwQkQFMgOXYSCToP+8gaK3cCX0Ks0Kh8hgSigwaeZAEAolSSEzE
0i8DVsP18vn8vnw+H/sTYIvzllye98C5ACoGiIgHs1EHZQwhpfCiAFJMgMJlsU/Z8NoP1CKA
o6sbiIzbzQaDwjk0RUZSUyEENjijiDGGes2C6zowYmdj2exVvn37iyOFQiGxCpS/N+TKkgfK
QoD4qNYNeBEQChQhIbAcB4mEjPZeSR4Z2Y2Zd5MklUreWQUESDaNJGiqjI2aCon4kEUBssgg
cwkVvQorfg7t7ffJ3FcbetkEx9NTY2NjMgAIy2U7RlkIQnz4oYe6ZcIHhQ8CvW5CiSvQUiJc
YwlfZktgaEWz/Ejo6kzeBgDy5smhE3bVHGhRKRQeoa4vgjEGyiiW9RqaHVcObu26kfLMZbx8
tQ3drRUIbg1IDoaWdCBB/vzGvzM6Osr39v20N6szpNmgmPoooUOLEJcJvJDD33TyIVt3GgAh
hFTMfW897JclKWbvzDAXIAEIAfUDVjeM4m+dHTsKS7Yv+wAAAABJRU5ErkJggg=='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallQuestionIconContents
	"Private - Method generated with the content of the file icons\new\smallQuestion.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMdSURBVDiNXZPNbxR1HIefmV129qVd2i2026VQdOVkBeFA0SalHrxooogkajxwaGozB6IH
/gMvXkx8OSzxVNsbniQSk4qk6kENiCFUFIt9p+1sup3dme3Mzu83Mz8PRdPyPX+eJ9/Loyml
2H2Tk5MjpVJpLGEUhpwgdyipPD+TqN+pVq2vbdv+3DTNcPde+09QqVSy5WeOTcrc82/+8HvA
wmoLuyHxPME+PebMQJaRgU17eeHeS+Pj43f3CCqVSua5k0Mrd9cPdc3+42HXJXZD4nuSli+Q
QiKFJGvAB+8WlF/7+e3R0dGr/wumv7vx1Xzr1IV7cx71hqS/O8l7b3TT32uwarW4+esWH12Z
IwgCdCI+vtwVrS391mWaZkOfmpo6q3eevHB/3sd1QxxXopQiVoqNTcHhYpqLr5cYPN5OKEOa
TcEnU06iVOqbAUj29vaO/XI/3IGbEscN+fGWzfRPVVIJycSHZQp5jWKnS8tdQQY+t29J3HOD
JwCS6VzhhYVHAY67A0sRErQCgm2bp/ojYmmzth4yPfMQGWwTygApBH8veFqlUhnUvbD9sPsY
bvkSf7uG31glrbtcvngEFUd8OvGAxeUGcSTIpKCjPcnSqgNwPpnAazpuutPzBX7TQnguoRQM
v1igPaexZm3z7ffLdOR10kaWhKZQKuLggRxQqyWTcf22TvfLvruJ8FykEEgpsKrbXLvxiNkH
Wxw8YGCkE+i6htIgjiP6S1mIuK5blnXtRDlGeA2klIRSEIoA3w/It2mEcUxbPk0ym0FlcsSp
LMlMG309Mgb+1Gu1WuXss3U7k1ZEUhAKQSgFY28d4fTxDl4d6UEZGVqJHC5t+FqGV4aPYq3P
f2GaZqybphktL/wxdOmdo0pXOx9kUorrN9eYnWswc8ehhYEdZnFCg6eLecqFJUspdWlPCxMT
E+fzXceufvblYmKjusX+/Qa6kSLSDTxSRKQ4d6bAQM/ihuM4w6Zpzu0RPA6qrVgszTit9lMr
ltKWrQAjnaKvex/lYhBvWvNXlFLv7y5SezLnXbLTwGuAA3wD/GWaZvzk7l+B2cIZLVTLdwAA
AABJRU5ErkJggg=='! !

!VistaryThemeIcons class methodsFor: 'as yet unclassified' stamp: 'gvc 5/21/2007 12:31'!
smallSizeNames
	"Answer the names of the small icons"
	
	^#('smallError' 'smallInfo' 'smallLock' 'smallQuestion' 'smallWarning')! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallWarningIconContents
	"Private - Method generated with the content of the file icons\new\smallWarning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAJtSURBVDiNjZBNSFRhFIaf77v3juV1dMYZf2auTqb9CGVBEkhta9uqheFCUIqIaFOr9gXh
oiRCZjRxITrgKG5aBC2CFFuUtHAhRcgglObYjD/3jqNz79fKWjhKB87m8Lwv73lRSnHYxuPx
F4lEovcoRiilKDUjIyNXQqHQjFJqL5vNBrq7u/OlOFlSDUQikcHWs0Oiwfrs8/v9Tw7jSsZK
JpMd8/PDnnKF2t6sU3NzH+xkMmmUYksmiMViryL1AwIUprlKqPptuWmaD/7rhcnJycvB4LdL
6fR37t3vovf2DWprBqmvr32cSqUO8AcOlmUNVPr7MHSFzxfGcSQGq/i0N9Wu63YdaTA1NdVR
UfGlPRpZwDy+QzqdZmNjBTsHZd4QTU0n+kZHR8WhBpZlxasD/eQ3QbgujrNFVaUPOwei8ANR
eFenadrNkgbT09PX/eanC6axiJ0Dr+CxuPgVwwiynQU7B/mVBM3NJ59nMpmDBtFoNO6jHzsL
2zko2h6R+jDBSomdAzsL7tYyO+vvrdnZ2c59nVBKMTEx0Xm6eXk8qD1kdwd281DIw+paDIo5
ythkdwf28pB3m2i5lvrZ3t4e/ZsgEAi81AvjFByLgtPAbqERO3+RR8/KmZ65ilLNQAtSP4VZ
ZuD8+hhJpVK9APrw8PDdpkYtXGGewy2exyclmiGQhkZb6wJtZ8JU1saA/fIFtrNEMNj6FHgt
4vH4WDQSvlXtX0EXAil1pNBRSuK5ChAIKQCJ8jyKrsceVWw4OmtrazW6pml3VlZ/j2XWy49p
mlYUQrhAUUrpAp5SyvvXl8TzQKlN4bruUk9PT+YPUsxAEGFWxzgAAAAASUVORK5CYII='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
warningIconContents
	"Private - Method generated with the content of the file icons\new\warning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

Object subclass: #UITheme
	instanceVariableNames: 'settings forms sounds'
	classVariableNames: 'Current Builder'
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!UITheme commentStamp: 'gvc 5/18/2007 10:10' prior: 0!
Common superclass for User Interface themes. Provides methods for creating new morphs in a standard way, various "services" like a file dialog, message dialogs etc. and also methods for customising aspects of the appearance of various morphs.
Though conceptually abstract, no code is "missing". Subclasses, therefore, should override the aspects they wish to change.!

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2007 13:06'!
initialize
	"Set up ui enhancement preferences here."

	Preferences
		addPreference: #externalFocusForPluggableText
		categories: #(morphic)
		default: true
		balloonHelp: 'When enabled the focus indication for PluggableTextMorphs will be drawn in the border rather than around the embedded TextMorph.' translated;
		addPreference: #mouseClickForKeyboardFocus
		categories: #(morphic)
		default: false
		balloonHelp: 'When enabled the mouse button must be clicked within a morph for it to take the keyboard focus.' translated;
		addPreference: #gradientScrollbarLook
		categories: #(scrolling windows)
		default: true
		balloonHelp: 'Scrollbars have a nicer appearance using UITheme.' translated;
		addPreference: #gradientButtonLook
		categories: #(buttons windows)
		default: true
		balloonHelp: 'Buttons have a nicer appearance using UITheme.'  translated;
		addPreference: #windowsActiveOnFirstClick
		categories: #(windows)
		default: false
		balloonHelp: 'When disabled, the first click of an inactive window will only activate it rather than also controlling a submorph.' translated;
		addPreference: #fadedBackgroundWindows
		categories: #(windows)
		default: true
		balloonHelp: 'Background windows appear more "washed out" to distinguish from the active window.' translated;
		addPreference: #windowAnimation
		categories: #(windows)
		default: true
		balloonHelp: 'Animate the minimising, restoring, expanding and (optionally) closing of windows.' translated;
		addPreference: #noWindowAnimationForClosing
		categories: #(windows)
		default: false
		balloonHelp: 'Don''t animate the closing of windows.' translated;
		addNumericPreference: #windowAnimationDelay
		categories:  #(windows)
		default: 10
		balloonHelp: 'The delay between each step of the window animation in milliseconds.' translated;
		addNumericPreference: #windowAnimationSteps
		categories:  #(windows)
		default: 15
		balloonHelp: 'The number of steps in the window animation.'  translated;
		addPreference: #useThemeSounds
		categories: #(media)
		default: true
		balloonHelp: 'Use themed sounds for user interface events.' translated.
	self current class = UITheme ifTrue: [self current: nil] "due to change to being abstract".
	Smalltalk addToStartUpList: self! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:25'!
allThemeClasses
	"Answer the subclasses of the receiver that are considered to be
	concrete (useable as a theme)."

	^self allSubclasses reject: [:c | c isAbstract]! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:25'!
beCurrent
	"Make a new instance of the receiver be the current theme."

	self isAbstract ifTrue: [^self error: self name, ' is abstract, send #beCurrent to a subclass.'].
	self current: self newDefault! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2007 11:43'!
builder
	"Answer a morph that has the TEasilyThemed trait."

	^Builder ifNil: [Builder := self newBuilder. Builder]! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/28/2007 17:26'!
closeExampleDialogs
	"Close the example dialogs."

	DialogWindow allSubInstances do: [:d | d cancel]! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 9/5/2007 13:06'!
current
	"Answer the current ui theme."

	^Current ifNil: [Current := UIThemeSoftSqueak newDefault. Current]! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 5/24/2007 10:29'!
current: aUITheme
	"Set the current ui theme."

	Current := aUITheme.
	SystemProgressMorph reset. "reset to use new fill styles"
	TaskbarMorph reset. "reset to use new fill styles"
	ScrollBar initializeImagesCache. "reset to use new arrows"
	aUITheme updateWorldDockingBars.
	World themeChanged! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/9/2007 18:15'!
exampleBasicControls
	"Open a window with examples of each of the basic controls."

	|dialog builder radioModel treeModel|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example basic controls') useDefaultOKButton.
	radioModel := ExampleRadioButtonModel new.
	treeModel := ValueHolder new contents: TextStyle actualTextStyles explorerContents.
	dialog contentMorph: (dialog newRow: {
		dialog newLabelGroup: {
			'Normal Label'->(dialog newLabel: 'A Label').
			'Disabled Label'->(dialog newLabel: 'A Disabled Label') disable.
			'Normal Button'->(dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button').
			'Disabled Button'->(dialog newButtonFor: nil action: nil label: 'Disabled Button'
							help: 'This is a disabled button') disable.
			'Selected Button'->(dialog newButtonFor: (ValueHolder new contents: true) getState: #contents
							action: nil arguments: #() getEnabled: nil label: 'A Button' help: 'This is a selected button').
			'Selected Disabled Button'->(dialog newButtonFor: (ValueHolder new contents: true) getState: #contents
							action: nil arguments: #() getEnabled: nil label: 'Disabled Button'
							help: 'This is a selected disabled button') disable.
			'Checkbox'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents: label: 'A Checkbox' help: 'This is a checkbox').
			'Disabled Checkbox'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents:
							label: 'A Disabled Checkbox' help: 'This is a disabled checkbox') disable.
			'Radio Buttons'->(dialog newColumn: {
								(dialog newRadioButtonFor: radioModel
									getSelected: #isLeft setSelected: #beLeft label: 'Left' help: 'This is a radio buton').
								(dialog newRadioButtonFor: radioModel
									getSelected: #isCenter setSelected: #beCenter label: 'Center' help: 'This is a radio buton').
								(dialog newRadioButtonFor: radioModel
									getSelected: #isRight setSelected: #beRight label: 'Right' help: 'This is a radio buton')}).
			'Disabled Radio Button'->(dialog newRadioButtonFor: radioModel
									getSelected: #isRight setSelected: #beRight label: 'Right'
									help: 'This is a disabled radio buton') disable.
			'Text Entry'->(dialog newTextEntryFor: (ValueHolder new contents: 'Hello')
							getText: #contents setText: #contents: help: 'This is a text entry').
			'Disabled Text Entry'->(dialog newTextEntryFor: (ValueHolder new contents: 'Hello')
							getText: #contents setText: #contents: help: 'This is a disabled text entry') disable.
			'Slider'->(dialog newSliderFor: (ValueHolder new contents: 0.5)
							getValue: #contents setValue: #contents: help: 'This is a slider').
			'Disabled Slider'->(dialog newSliderFor: (ValueHolder new contents: 0.75)
							getValue: #contents setValue: #contents: help: 'This is a disabled slider') disable}.
			dialog newVerticalSeparator.
			dialog newLabelGroupSpread: {
			'Drop List'->(dialog newDropListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex: help: 'This is a drop list').
			'Disabled Drop List'->(dialog newDropListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a disabled drop list') disable.
			'Morph Drop List'->(dialog newMorphDropListFor: (ListModel new list: ({Color red. Color green. Color blue}
									collect: [:c | Morph new extent: 60@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list').
			'Normal List'->((dialog newListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list selected: #selectionIndex changeSelected: #selectionIndex:
							help: 'This is a list') minWidth: 120).
			'Disabled List'->(dialog newListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list selected: #selectionIndex changeSelected: #selectionIndex:
							help: 'This is a disabled list') disable.
			'Morph List'->(dialog newMorphListFor: (ListModel new list: ((Color wheel: 20)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph list').
			'Tree'->((dialog newTreeFor: treeModel list: #contents selected: nil changeSelected: nil) minHeight: 100)}.
			dialog newVerticalSeparator.
			dialog newColumn: {
				dialog newTitle: 'Text Editor' for: (
					(dialog newTextEditorFor: (ValueHolder new contents: 'Hello')
						getText: #contents setText: #contents:) minWidth: 100).
				dialog newTitle: 'Disabled Text Editor' for: (
					(dialog newTextEditorFor: (ValueHolder new contents: 'Hello')
						getText: #contents setText: #contents:) disable)}});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 7/19/2007 16:50'!
exampleBuilder
	"Answer a morph that implements TEasilyThemed but without honouring modality
	for the example dialogs."

	^ExampleBuilderMorph new! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/8/2007 15:34'!
exampleColorControls
	"Open a window with examples of each of the color controls."

	|dialog builder|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example color controls') useDefaultOKButton.
	dialog contentMorph: (dialog newRow: {
		dialog newLabelGroup: {
			'Alpha Selector'->(dialog newAlphaSelector: (ValueHolder new contents: 0)
							getAlpha: #contents setAlpha: #contents: help: 'This is an alpha channel selector').
			'Hue Selector'->(dialog newHueSelector: (ValueHolder new contents: 0)
							getHue: #contents setHue: #contents: help: 'This is a hue selector').
			'SV Color Selector'->((dialog newSVSelector: Color yellow
									help: 'This is a saturation-volume selector') minHeight: 80).
			'HSV Color Selector'->((dialog newHSVSelector: Color green
									help: 'This is a hue-saturation-volume selector') minHeight: 80; minWidth: 120)}.
		dialog newVerticalSeparator.
		dialog newTitle: 'HSVA Color Selector' for:
			((dialog newHSVASelector: Color cyan
					help: 'This is a hue-saturation-volume-alpha selector')
					minHeight: 184; minWidth: 184)});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/28/2007 17:24'!
exampleDialogs
	"Open an example of each services dialog.
	(self exampleDialogs)."

	self exampleBuilder
		chooseFont: TextStyle default defaultFont;
		chooseColor: (Color r: 0.529 g: 0.611 b: 0.004);
		chooseDirectory: 'Choose folder';
		chooseFileName: 'Pick a file name' extensions: nil path: nil preview: nil;
		textEntry: 'Choose a name for the project' title: 'Save project' entryText: 'My Project';
		chooseDropList: 'Pick one!!' list: #('One' 'Two' 'Three' 'Four');
		deny: 'Opening the safe is not possible!!';
		message: 'Hello!!';
		proceed: 'Save image?';
		alert: 'Danger!!';
		abort: 'Something has gone wrong...';
		question: 'Save the file?' title: 'Exiting application';
		questionWithoutCancel: 'Save image as well?' title: 'Exiting application'! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/8/2007 14:07'!
exampleGroups
	"Open a window with examples of each of the group type morphs."

	|dialog builder|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example groups') useDefaultOKButton.
	dialog contentMorph: (dialog newRow: {
		dialog newLabelGroup: {
			'Plain Groupbox'->(dialog newGroupboxForAll: {
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'}).
			'Groupbox'->(dialog newGroupbox: 'A groupbox' forAll: {
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'})}.
		dialog newLabelGroup: {
			'Tab Group'->(dialog newTabGroup: {
				'Page 1'->(dialog newGroupbox: 'A groupbox' forAll: {
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'}).
				'Page 2'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents: label: 'A Checkbox'
							help: 'This is a checkbox')})}});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'gvc 8/9/2007 16:36'!
exampleOtherControls
	"Open a window with examples of each of the other controls."

	|dialog builder image emboss fuzzy|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example other controls') useDefaultOKButton.
	emboss := (dialog newString: 'Hello there') trackPaneColor: false.
	fuzzy := (dialog newFuzzyLabel: 'A Fuzzy Label') minHeight: 40; minWidth: 160.
	dialog contentMorph: (dialog newRow: {
		dialog newTitle: 'Alpha Image' for: (
			dialog newColumn: {
				((image := dialog newAlphaImage: nil help: 'This is an alpha image')
					borderWidth: 1;
					extent: 160@160).
				dialog newLabelGroup: {
				'Scale'->((dialog newSliderFor: image getValue: #scale setValue: #scale:
					min: 0 max: 4 quantum: nil
					getEnabled: nil help: 'The image scale 0..1')
					minHeight: 16).
				'Alpha'->((dialog newAlphaSelector: image getAlpha: #alpha setAlpha: #alpha: help: 'The image alpha')
					minHeight: 16).
				'Layout'->(dialog newDropListFor: image list: #layoutSymbols
					getSelected: #layout setSelected: #layout:
					getEnabled: nil useIndex: false help: 'The image layout')}}).
		dialog newVerticalSeparator.
		dialog newLabelGroup: {
			'Color presenter'->(dialog newColorPresenterFor: (ValueHolder new contents: (Color blue alpha: 0.6))
					getColor: #contents help: 'This is a color presenter').
			'Color chooser'->(dialog newColorChooserFor: emboss
					getColor: #color setColor: #color: help: 'This is a color chooser').
			'Row with dashed border'->((dialog newRow: {dialog newLabel: 'I have a dashed border!!'})
					borderStyle: (DashedBorder width: 3
							dashColors: {Color red. Color green. Color blue} dashLengths: #(1 2 3))).
			'Embossed string'->emboss.
			'Style'->(dialog newDropListFor: emboss list: #styleSymbols
					getSelected: #style setSelected: #style:
					getEnabled: nil useIndex: false help: 'The embossed string style').
			'Fuzzy label'->fuzzy.
			'Offset'->((dialog newSliderFor: fuzzy getValue: #offset setValue: #offset:
					min: 0 max: 5 quantum: 1
					getEnabled: nil help: 'The fuzzy label offset')
					minHeight: 16).
			'Alpha'->((dialog newAlphaSelector: fuzzy getAlpha: #alpha setAlpha: #alpha:
					help: 'The fuzzy label alpha')
					minHeight: 16)}.
		dialog newVerticalSeparator.
		dialog newTitle: 'Expanders' for: (
			(dialog newColumn: {
				(dialog newExpander: 'An Expander' forAll: {
					dialog newLabel: 'Expanded!!'.
					builder newMorphListFor: (ListModel new list: ((Color wheel: 15)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list'}) minWidth: 100.
				dialog newExpander: 'Another' forAll: {
					dialog newLabel: 'Expanded!!'.
					builder newMorphDropListFor: (ListModel new list: ((Color wheel: 8)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list'}})
				cellInset: 0;
				borderStyle: (BorderStyle inset baseColor: dialog paneColor; width: 1))});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:24'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^true! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:19'!
isCurrent
	"Answer whether an instance of the receiver is the current theme."

	^Current class == self! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2007 11:44'!
newBuilder
	"Answer a new builder morph."

	^ComposableMorph new! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 18:28'!
newDefault
	"Answer a new default ui theme."

	^self new! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 5/10/2007 10:14'!
startUp
	"Reset the system progress morph in case of font changes."

	SystemProgressMorph reset! !

!UITheme class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:18'!
themeName
	"Answer the friendly name of the theme."

	self subclassResponsibility! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:57'!
abortIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of an error dialog (true) with the given label and title."

	Preferences useThemeSounds ifTrue: [self abortSound play].
	^(aThemedMorph openModal: (
		ErrorDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 15:55'!
abortSound
	"Answer the abort sound."

	^self sounds at: #abort ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:57'!
alertIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of an alert dialog (true) with the given label and title."

	Preferences useThemeSounds ifTrue: [self alertSound play].
	^(aThemedMorph openModal: (
		AlertDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 15:56'!
alertSound
	"Answer the alert sound."

	^self sounds at: #alert ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/16/2007 12:57'!
buttonColorFor: aButton
	"Answer the colour for the given button."

	^self settings standardColorsOnly
		ifTrue: [self settings buttonColor]
		ifFalse: [aButton colorToUse]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/14/2007 15:58'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^aThemedMorph preferredCornerStyle! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:27'!
buttonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/26/2007 09:58'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."

	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 9/8/2006 13:59'!
buttonFont
	"Answer the button font to use."

	^self textFont! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 8/7/2007 12:14'!
buttonLabelFor: aButton
	"Answer the label to use for the given button."

	|label|
	label := self buttonLabelForText: aButton label.
	(label respondsTo: #enabled:) ifTrue: [
		label enabled: aButton enabled].
	^label! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 8/7/2007 12:06'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."

	^aTextOrString isString
		ifTrue: [LabelMorph contents: aTextOrString]
		ifFalse: [|t|
				t := TextMorph new newContents: aTextOrString.
				t
					extent: t optimalExtent;
					lock]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:16'!
buttonMouseOverBorderStyleFor: aButton
	"Return the mouse over button borderStyle for the given button."
	
	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:54'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:25'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|c|
	c := aButton colorToUse.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle simple
		width: 1;
		baseColor: c! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:24'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	^self buttonColorFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 15:06'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^aPanel paneColor! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 18:12'!
buttonPressedBorderStyleFor: aButton
	"Return the pressed button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:52'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given color."
	
	^self buttonMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:27'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:29'!
buttonSelectedDisabledBorderStyleFor: aButton
	"Return the selecteddisabled button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedDisabledFillStyleFor: aButton
	"Return the button selected disabled fillStyle for the given color."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:19'!
buttonSelectedMouseOverBorderStyleFor: aButton
	"Return the selected mouse over button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given color."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:19'!
buttonSelectedPressedBorderStyleFor: aButton
	"Return the selected pressed button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:52'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given color."

	^self buttonSelectedMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 5/23/2007 12:26'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: aCheckboxButton paneColor darker! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:17'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	^aCheckboxButton paneColor
		alphaMixed: 0.3
		with: Color white! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 5/23/2007 12:28'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: aCheckboxButton paneColor twiceDarker! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:03'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	^Color white! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 8/2/2007 16:01'!
checkboxLabelFor: aCheckbox
	"Answer the label to use for the given checkbox."

	^self checkboxLabelForText: aCheckbox label! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 8/2/2007 16:08'!
checkboxLabelForText: aTextOrString
	"Answer the label to use for the given text."

	|morph|
	morph _ aTextOrString isString
		ifTrue: [LabelMorph contents: aTextOrString]
		ifFalse: [|t|
				t := TextMorph new newContents: aTextOrString.
				t extent: t optimalExtent].
	^morph 
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		lock! !

!UITheme methodsFor: 'services' stamp: 'gvc 9/22/2006 11:01'!
chooseColorIn: aThemedMorph title: aString color: aColor
	"Answer the result of a color selector dialog with the given title and initial color."

	|d|
	d := aThemedMorph openModal: (
		ColorSelectorDialogWindow new
			title: aString;
			selectedColor: aColor).
	^d  cancelled
		ifFalse: [d selectedColor]! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/15/2007 14:44'!
chooseDirectoryIn: aThemedMorph title: title path: path
	"Answer the result of a file dialog with the given title, choosing directories only."

	|fd|
	fd := FileDialogWindow basicNew
		initialize;
		title: title;
		answerDirectory.
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/12/2007 14:21'!
chooseDropListIn: aThemedMorph text: aStringOrText title: aString list: aList
	"Answer the result of a drop list chooser with the given label, title and list."

	^(aThemedMorph openModal: (
		ChooseDropListDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			list: aList)) selectedItem! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/4/2007 16:07'!
chooseFileIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerFileEntry.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/4/2007 16:07'!
chooseFileNameIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerFileName.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 5/30/2007 12:13'!
chooseFontIn: aThemedMorph title: aString font: aFont
	"Answer the result of a font selector dialog with the given title and initial font."

	|d|
	d := aThemedMorph openModal: (
		Cursor wait showWhile: [
			FontSelectorDialogWindow new
				title: aString;
				selectedFont: aFont]).
	^d  cancelled
		ifFalse: [d selectedFont]! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/17/2007 15:48'!
chooseIn: aThemedMorph title: title labels: labels values: values lines: lines
	"Answer the result of a popup choice with the given title, labels, values and lines."

	|pd|
	pd := PopupChoiceDialogWindow new
		title: (title isEmpty ifTrue: ['Choose' translated] ifFalse: [title asString]);
		labels: labels;
		lines: (lines ifNil: [#()]);
		model: values.
	^(aThemedMorph openModal: pd) choice! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 17:23'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."

	aWindow hasCloseBox ifTrue: [aWindow addCloseBox].
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow basicLabel ifNotNilDo: [:label | aWindow labelArea addMorphBack: label].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox]! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 15:58'!
defaultAbortSound
	"Answer the default abort sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 15:58'!
defaultAlertSound
	"Answer the default alert sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 15:59'!
defaultDenySound
	"Answer the default deny sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 15:59'!
defaultMessageSound
	"Answer the default message sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 15:59'!
defaultQuestionSound
	"Answer the default question sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 11:01'!
defaultWindowCloseSound
	"Answer the default window close sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 10:14'!
defaultWindowMaximizeSound
	"Answer the default window maximize sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 10:14'!
defaultWindowMinimizeSound
	"Answer the default window minimize sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 10:14'!
defaultWindowRestoreDownSound
	"Answer the default window restore down sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 10:14'!
defaultWindowRestoreUpSound
	"Answer the default window restore up sound.
	This is a RestSound of duration 0."

	^RestSound dur: 0! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:57'!
denyIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of an deny dialog (true) with the given label and title."

	Preferences useThemeSounds ifTrue: [self denySound play].
	^(aThemedMorph openModal: (
		DenyDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 15:57'!
denySound
	"Answer the deny sound."

	^self sounds at: #deny ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:53'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^aWindow paneColorToUse lighter! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:52'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window inactive fillStyle for the given window."
	
	^Preferences fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse lighter
					alphaMixed: 0.9
					with: (Color white alpha: aWindow paneColorToUse alpha)]
		ifFalse: [aWindow paneColorToUse lighter]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:34'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor|
	aColor _ aToolDockingBar originalColor.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:41'!
dropListDisabledBorderStyleFor: aDropList
	"Return the disabled borderStyle for the given drop list."

	^self dropListNormalBorderStyleFor: aDropList! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:56'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	^aDropList paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/19/2006 13:10'!
dropListFont
	"Answer the drop list font to use."

	^self textFont! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:42'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^BorderStyle inset
		width: 1;
		baseColor: aDropList paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:56'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	^Color white! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:07'!
dropListNormalListFillStyleFor: aDropList
	"Return the normal fillStyle for the list of the given drop list."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:48'!
errorIcon
	"Answer an error icon."

	^ThemeIcons errorIcon! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 14:25'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	^anExpanderTitle paneColor! !

!UITheme methodsFor: 'services' stamp: 'gvc 9/27/2006 13:43'!
fileOpenIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions path and preview type."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerOpenFile.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 8/31/2006 15:29'!
fileSaveIn: aThemedMorph title: title extensions: exts path: path
	"Answer the result of a file save dialog with the given title, extensions and path."

	|fd|
	fd := FileDialogWindow new
		title: title;
		answerSaveFile.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 5/14/2007 11:39'!
forms
	"Answer the value of forms"

	^ forms! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 5/14/2007 11:39'!
forms: anObject
	"Set the value of forms"

	forms := anObject! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:32'!
infoIcon
	"Answer an information icon."

	^ThemeIcons infoIcon! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 10:17'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeForms;
		initializeSounds;
		settings: ThemeSettings new;
		setStandardColors! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 10:19'!
initializeForms
	"Initialize the receiver's image forms."

	self forms: Dictionary new.
	self forms
		at: #treeExpanded put: self newTreeExpandedForm;
		at: #treeUnexpanded put: self newTreeUnexpandedForm;
		at: #windowClose put: self newWindowCloseForm;
		at: #windowMinimize put: self newWindowMinimizeForm;
		at: #windowMaximize put: self newWindowMaximizeForm;
		at: #windowMenu put: self newWindowMenuForm! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 6/27/2007 16:00'!
initializeSounds
	"Initialize the receiver's event sounds."

	self sounds: Dictionary new.
	self sounds
		at: #abort put: self defaultAbortSound;
		at: #alert put: self defaultAlertSound;
		at: #deny put: self defaultDenySound;
		at: #message put: self defaultMessageSound;
		at: #question put: self defaultQuestionSound;
		at: #windowMinimize put: self defaultWindowMinimizeSound;
		at: #windowMaximize put: self defaultWindowMaximizeSound;
		at: #windowRestoreUp put: self defaultWindowRestoreUpSound;
		at: #windowRestoreDown put: self defaultWindowRestoreDownSound;
		at: #windowClose put: self defaultWindowCloseSound! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 9/8/2006 13:59'!
labelFont
	"Answer the label font to use."

	^self textFont! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:41'!
listDisabledBorderStyleFor: aList
	"Return the disabled borderStyle for the given list."

	^self listNormalBorderStyleFor: aList! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:39'!
listDisabledFillStyleFor: aList
	"Return the disabled fillStyle for the given list."
	
	^aList paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 4/25/2007 11:51'!
listFont
	"Answer the list font to use."

	^TextStyle default
		fontOfPointSize: 9! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:42'!
listNormalBorderStyleFor: aList
	"Return the normal borderStyle for the given list"

	^BorderStyle inset
		width: 1;
		baseColor: aList paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:39'!
listNormalFillStyleFor: aList
	"Return the normal fillStyle for the given list."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
lockIcon
	"Answer a lock icon."

	^ThemeIcons lockIcon! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 9/13/2006 11:26'!
menuBarFont
	"Answer the menu bar font to use."

	^self textFont! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/26/2006 16:48'!
menuColor
	"Answer the menu color to use."

	^self settings menuColor! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/9/2007 14:47'!
menuColorFor: aThemedMorph
	"Answer the menu color to use."

	|w|
	^self menuColor ifNil: [
		aThemedMorph ifNil: [^self windowColor].
		w := aThemedMorph isSystemWindow
			ifTrue: [aThemedMorph]
			ifFalse: [aThemedMorph ownerThatIsA: SystemWindow].
		w isNil
			ifTrue: [self windowColor]
			ifFalse: [(w valueOfProperty: #paneColor) ifNil: [self windowColor]]]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 5/1/2007 16:42'!
menuFont
	"Answer the menu font to use."

	^self listFont! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 6/4/2007 13:05'!
menuItemInDockingBarSelectedBorderStyleFor: aMenuItem
	"Return the selected menu item borderStyle when in a docking bar for the given menu item."

	^self menuItemSelectedBorderStyleFor: aMenuItem! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:53'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	| fill baseColor preferenced |
	Display depth <= 2
		ifTrue: [^ Color gray].
	preferenced := Preferences menuSelectionColor.
	preferenced notNil ifTrue: [^preferenced].
	baseColor := aMenuItem owner color negated.
	Preferences gradientMenu
		ifFalse: [^baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceLighter . 1 -> baseColor twiceDarker}.
	fill origin: aMenuItem topLeft.
	aMenuItem owner isVertical not
		ifTrue: [fill direction: 0 @ aMenuItem height]
		ifFalse: [fill direction: aMenuItem width @ 0].
	^ fill! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 6/4/2007 13:03'!
menuItemSelectedBorderStyleFor: aMenuItem
	"Return the selected menu item borderStyle for the given menu item."

	^BorderStyle simple
		width: 0! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:55'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	| fill baseColor preferenced |
	Display depth <= 2
		ifTrue: [^ Color gray].
	preferenced := Preferences menuSelectionColor.
	preferenced notNil ifTrue: [^preferenced].
	baseColor := aMenuItem owner color negated.
	Preferences gradientMenu
		ifFalse: [^baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceLighter . 1 -> baseColor twiceDarker}.
	fill
		origin: aMenuItem topLeft;
		direction: aMenuItem width @ 0.
	^ fill! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:58'!
messageIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a message dialog (true) with the given label and title."

	Preferences useThemeSounds ifTrue: [self messageSound play].
	^(aThemedMorph openModal: (
		MessageDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 15:56'!
messageSound
	"Answer the message sound."

	^self sounds at: #message ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 15:16'!
newAlphaImageIn: aThemedMorph image: aForm help: helpText
	"Answer an alpha image morph."
	
	|answer|
	answer := AlphaImageMorph new
		hResizing: #rigid;
		vResizing: #rigid;
		setBalloonText: helpText.
	aForm ifNotNil: [answer image: aForm].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/26/2006 11:48'!
newAlphaSelectorIn: aThemedMorph for: aModel getAlpha: getSel setAlpha: setSel help: helpText
	"Answer an alpha selector ."

	^(AColorSelectorMorph
			on: aModel
			getValue: getSel
			setValue: setSel)
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2006 13:50'!
newAutoAcceptTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel
	"Answer a text editor for the given model."

	^PluggableTextEditorMorph new
		autoAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/4/2007 15:52'!
newAutoAcceptTextEntryIn: aThemedMorph for: aModel  get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model.
	Object conversion will be automatic based on the class of
	object returned after performing the get selector, aClass
	is provided in case of initial nil returns."

	|pt|
	pt := PluggableTextFieldMorph new
		autoAccept: true;
		alwaysAccept: true;
		convertTo: aClass;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/14/2007 15:58'!
newButtonIn: aThemedMorph for: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel getLabel: labelSel help: helpText
	"Answer a new button."

	|b|
	b := PluggableButtonMorphPlus
			on: aModel
			getState: stateSel
			action: actionSel
			label: labelSel.
	b
		arguments: (args ifNil: [{b}]);
		getEnabledSelector: enabledSel;
		cornerStyle: (self buttonCornerStyleIn: aThemedMorph);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText.
	^b! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/14/2007 15:58'!
newButtonIn: aThemedMorph for: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel label: label help: helpText
	"Answer a new button."

	|b|
	b := PluggableButtonMorphPlus
			on: aModel getState: stateSel action: actionSel.
	b
		arguments: (args ifNil: [{b}]);
		getEnabledSelector: enabledSel;
		cornerStyle: (self buttonCornerStyleIn: aThemedMorph);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		label: label font: self buttonFont;
		setBalloonText: helpText.
	^b! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 10:55'!
newCancelButtonIn: aThemedMorph for: aModel
	"Answer a new cancel button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #cancel
			arguments: nil
			getEnabled: nil
			label: 'Cancel' translated
			help: 'Cancel changes and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/18/2006 16:27'!
newCheckboxIn: aThemedMorph for: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox with the given label ."

	^(CheckboxMorph
			on: aModel selected: getSel changeSelected: setSel)
		getEnabledSelector: enabledSel;
		font: self labelFont;
		label: label;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 10:56'!
newCloseButtonIn: aThemedMorph for: aModel
	"Answer a new close button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #close
			arguments: nil
			getEnabled: nil
			label: 'Close' translated
			help: 'Close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/22/2007 11:43'!
newColorChooserIn: aThemedMorph for: aModel getColor: getSel setColor: setSel getEnabled: enabledSel help: helpText
	"Answer a color chooser ."

	^(ColorChooserMorph
			on: aModel color: getSel changeColor: setSel)
		getEnabledSelector: enabledSel;
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 10:29'!
newColorPickerIn: aThemedMorph for: target getter: getterSymbol setter: setterSymbol
	"Answer a color picker for the given morph and accessors."

	^PanelMorph new
		borderStyle: (BorderStyle inset width: 1);
		fillStyle: Color white;
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		addMorph: (ColorPickerMorph new
			initializeForPropertiesPanel;
			target: target;
			selector: setterSymbol;
			originalColor: (target perform: getterSymbol));
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/22/2006 09:45'!
newColorPresenterIn: aThemedMorph for: aModel getColor: getSel help: helpText
	"Answer a color presenter."

	^(ColorPresenterMorph
			on: aModel color: getSel)
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/22/2006 09:36'!
newColorPresenterIn: aThemedMorph for: aModel getColor: getSel setColor: setSel help: helpText
	"Answer a color presenter."

	^(ColorPresenterMorph
			on: aModel color: getSel changeColor: setSel)
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 4/16/2007 11:08'!
newColumnIn: aThemedMorph for: controls
	"Answer a morph laid out with a column of controls."

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/15/2007 17:41'!
newDialogPanelIn: aThemedMorph
	"Answer a new (main) dialog panel."

	^self newPanelIn: aThemedMorph! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:03'!
newDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."

	^(DropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		font: self dropListFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 14:15'!
newEmbeddedMenuIn: aThemedMorph for: aModel
	"Answer a new menu."

	^EmbeddedMenuMorph new
		defaultTarget: aModel;
		color: (self menuColorFor: aThemedMorph)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 16:20'!
newExpanderIn: aThemedMorph label: aString forAll: controls
	"Answer an expander with the given label and controls."

	|answer|
	answer _ ExpanderMorph new
		font: self menuFont;
		titleText: aString;
		fillStyle: Color white.
	controls do: [:m |
		answer addMorphBack: m].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/5/2007 12:56'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	^Morph new
		fillStyle: Color transparent;
		borderStyle: (DashedBorder
						width: 1
						dashColors: {aMorph focusColor. Color transparent} dashLengths: #(1 1));
		bounds: aMorph focusBounds! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 12:57'!
newFuzzyLabelIn: aThemedMorph for: aModel label: aString offset: offset alpha: alpha getEnabled: enabledSel
	"Answer a new fuzzy label."

	^(FuzzyLabelMorph contents: aString font: self labelFont)
		offset: offset;
		alpha: alpha;
		model: aModel;
		getEnabledSelector: enabledSel	! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 15:55'!
newGroupboxIn: aThemedMorph
	"Answer a plain groupbox."

	^PlainGroupboxMorph new
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 09:59'!
newGroupboxIn: aThemedMorph for: control
	"Answer a plain groupbox."

	^(self newGroupboxIn: aThemedMorph)
		addMorph: control! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 16:19'!
newGroupboxIn: aThemedMorph forAll: controls
	"Answer a plain groupbox."

	^self
		newGroupboxIn: aThemedMorph
		for: (self newColumnIn: aThemedMorph for: controls)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2006 14:57'!
newGroupboxIn: aThemedMorph label: aString
	"Answer a groupbox with the given label."

	^GroupboxMorph new
		font: self labelFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		label: aString;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 10:12'!
newGroupboxIn: aThemedMorph label: aString for: control
	"Answer a groupbox with the given label and control."

	^(self newGroupboxIn: aThemedMorph label: aString)
		addContentMorph: control;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 14:36'!
newGroupboxIn: aThemedMorph label: aString forAll: controls
	"Answer a groupbox with the given label and controls."

	^(self newGroupboxIn: aThemedMorph label: aString)
		addContentMorph: (self newColumnIn: aThemedMorph for: controls);
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 14:59'!
newHSVASelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a hue-saturation-volume-alpha selector."

	^HSVAColorSelectorMorph new
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 14:46'!
newHSVSelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a hue-saturation-volume selector."

	^HSVColorSelectorMorph new
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/7/2007 16:28'!
newHueSelectorIn: aThemedMorph for: aModel getHue: getSel setHue: setSel help: helpText
	"Answer a hue selector ."

	^(HColorSelectorMorph
			on: aModel
			getValue: getSel
			setValue: setSel)
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/11/2006 13:12'!
newImageIn: aThemedMorph form: aForm
	"Answer a new text label."

	^self
		newImageIn: aThemedMorph
		form: aForm
		size: aForm extent! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/11/2006 13:11'!
newImageIn: aThemedMorph form: aForm size: aPoint
	"Answer a new text label."

	^AlphaImageMorph new
		cornerStyle: aThemedMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		image: aForm size: aPoint! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 13:21'!
newLabelGroupIn: aThemedMorph for: labelsAndControls spaceFill: spaceFill
	"Answer a morph laid out with a column of labels and a column of associated controls.
	If spaceFill is tru then each row will share available space to pad."

	|answer labels labelWidth row lc|
	lc := labelsAndControls collect: [:a |
		(a key isMorph
			ifTrue: [a key]
			ifFalse: [self newLabelIn: aThemedMorph label: a key])
			-> a value].
	answer := Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		changeTableLayout;
		cellInset: 4.
	labels := Morph new
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		changeTableLayout.
	lc do: [:a |
		labels addMorphBack: a key].
	labelWidth := labels minExtent x.
	lc do: [:a |
		a key hResizing: #rigid; extent: labelWidth@ a key height.
		row := self newRowIn: aThemedMorph for: {a key. a value}.
		row vResizing: (spaceFill ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]).
		answer addMorphBack: row].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 15:49'!
newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^(LabelMorph contents: aString font: self labelFont)
		model: aModel;
		getEnabledSelector: enabledSel! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 15:49'!
newLabelIn: aThemedMorph label: aString
	"Answer a new text label."

	^self
		newLabelIn: aThemedMorph
		for: nil
		label: aString
		getEnabled: nil! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/7/2007 11:43'!
newListIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^PluggableListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		autoDeselect: false;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/26/2006 16:48'!
newMenuIn: aThemedMorph for: aModel
	"Answer a new menu."

	^MenuMorph new
		defaultTarget: aModel;
		color: (self menuColorFor: aThemedMorph)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 13:16'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a morph drop list for the given model."

	^self
		newMorphDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:57'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^(MorphDropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #rigid;
		extent: 20@24;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 13:35'!
newMorphListIn: aThemedMorph for: aModel list: listSelector getSelected: getSelector setSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a morph list for the given model."

	^(PluggableMorphListMorph
			on: aModel
			list: listSelector
			selected: getSelector
			changeSelected: setSelector)
		selectionColor: self selectionColor;
		autoDeselect: false;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText
		! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/16/2007 15:51'!
newNoButtonIn: aThemedMorph for: aModel
	"Answer a new No button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #no
			arguments: nil
			getEnabled: nil
			label: 'No' translated
			help: 'Answer no and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/23/2007 15:57'!
newOKButtonIn: aThemedMorph for: aModel getEnabled: enabledSel
	"Answer a new OK button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: enabledSel
			label: 'OK' translated
			help: 'Apply changes and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/4/2007 11:54'!
newPanelIn: aThemedMorph
	"Answer a new panel."

	^PanelMorph new
		changeTableLayout;
		layoutInset: 4;
		cellInset: 8;
		cornerStyle: aThemedMorph preferredCornerStyle;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/2/2007 12:21'!
newPluggableDialogWindowIn: aThemedMorph title: title for: contentMorph
	"Answer a new pluggable dialog panel with the given content."

	|answer|
	answer _ PluggableDialogWindow new
		setWindowColor: aThemedMorph paneColor;
		title: title;
		contentMorph: contentMorph.
	contentMorph ifNotNil: [answer model: nil].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/22/2007 15:39'!
newRadioButtonIn: aThemedMorph for: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox (radio button appearance) with the given label ."

	^(CheckboxMorph
			on: aModel selected: getSel changeSelected: setSel)
		getEnabledSelector: enabledSel;
		font: self labelFont;
		label: label;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText;
		beRadioButton! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 4/24/2007 10:31'!
newRowIn: aThemedMorph for: controls
	"Answer a morph laid out with a row of controls."

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 14:38'!
newSVSelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a saturation-volume selector."

	^SVColorSelectorMorph new
		color: aColor;
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/23/2007 16:25'!
newSeparatorIn: aThemedMorph
	"Answer a new horizontal separator."

	^SeparatorMorph new
		fillStyle: Color transparent;
		borderStyle: (BorderStyle inset baseColor: Color blue; width: 1);
		extent: 2@2;
		hResizing: #spaceFill! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 11:28'!
newSliderIn: aThemedMorph for: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a slider."

	^(PluggableSliderMorph
			on: aModel
			getValue: getSel
			setValue: setSel
			min: min
			max: max
			quantum: quantum)
		hResizing: #spaceFill;
		vResizing: #spaceFIll;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 11:41'!
newStringIn: aThemedMorph label: aStringOrText font: aFont style: aStyle
	"Answer a new string/text morph."

	^(EmbossedStringMorph contents: aStringOrText font: aFont)
		style: aStyle! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/7/2007 15:45'!
newTabGroupIn: aThemedMorph for: labelsAndControls
	"Answer a tab group morph with the given tab labels and associated pages."

	^(TabGroupMorph new
		font: self labelFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		labelsAndPages: labelsAndControls)
		selectedPageIndex: (labelsAndControls isEmpty ifTrue: [0] ifFalse: [1])! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/5/2007 12:42'!
newTaskbarButtonIn: aTaskbar for: aWindow
	"Answer a taskbar button morph for the given window."

	|lm lab button labSize|
	labSize := (150 // (aTaskbar tasks size + 1) max: 10) min: 30.
	lab := (self buttonLabelForText: (aWindow labelString truncateWithElipsisTo: labSize)).
	lm := self
		newRowIn: aTaskbar
		for: {(aWindow taskbarIcon ifNil: [^nil]) asMorph. lab}.
	lm cellInset: 2.
	button := self
		newButtonIn: aTaskbar
		for: aWindow
		getState: #isCollapsed
		action: #taskbarButtonClicked
		arguments: #()
		getEnabled: nil
		label: lm
		help: nil.
	button
		onColor: (self taskbarMinimizedButtonColorFor: button)
		offColor: (aWindow isActive
				ifTrue: [self taskbarActiveButtonColorFor: button]
				ifFalse: [self taskbarButtonColorFor: button]);
		wantsYellowButtonMenu: true;
		getMenuSelector: #taskbarButtonMenu:;
		on: #mouseEnter send: #taskbarButtonEntered:event:in: to: aWindow withValue: button;
		on: #mouseLeave send: #taskbarButtonLeft:event:in: to: aWindow withValue: button.
	lab color: (self taskbarButtonLabelColorFor: button).
	^button! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/7/2007 12:54'!
newTaskbarThumbnailIn: aThemedMorph for: aWindow
	"Answer a taskbar thumbnail morph for the given window."

	|answer thumb|
	thumb := aWindow taskbarThumbnail.
	answer := PanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 8;
		cellInset: 4;
		addMorphBack: thumb;
		addMorphBack: (self
			buttonLabelForText: (aWindow labelString truncateWithElipsisTo: 50));
		useRoundedCorners.
	answer
		extent: answer minExtent;
		fillStyle: (self tasklistFillStyleFor: answer);
		borderStyle: (self taskbarThumbnailNormalBorderStyleFor: aWindow).
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/9/2007 15:31'!
newTasklistButtonIn: aTasklist for: aTask
	"Answer a tasklist button morph for the given task."
	
	|lm lab button|
	lab := (self buttonLabelForText: aTask label).
	lm := self
		newRowIn: aTasklist
		for: {(aTask icon ifNil: [MenuIcons smallWindowIcon]) asMorph. lab}.
	button := self
		newButtonIn: aTasklist
		for: aTask morph
		getState: #isMinimized
		action: #buttonClickedForTasklist:
		arguments: {aTasklist}
		getEnabled: nil
		label: lm
		help: nil.
	button
		onColor: (self taskbarMinimizedButtonColorFor: button)
		offColor: (aTask isActive
				ifTrue: [self taskbarActiveButtonColorFor: button]
				ifFalse: [self taskbarButtonColorFor: button]);
		hResizing: #spaceFill.
	lab color: (self taskbarButtonLabelColorFor: button).
	button model: aTask.
	^button! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2006 13:54'!
newTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel 
	"Answer a text editor for the given model."

	^PluggableTextEditorMorph new
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/4/2007 15:51'!
newTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	|pt|
	pt := PluggableTextFieldMorph new
		convertTo: aClass;
		alwaysAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/11/2006 09:46'!
newTextIn: aThemedMorph text: aStringOrText
	"Answer a new text."

	^TextMorph new
		wrapFlag: true;
		contents: aStringOrText;
		font: self textFont;
		autoFit: true;
		lock;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 14:38'!
newTitleIn: aThemedMorph label: aString for: control
	"Answer a morph laid out with a column with the title and control aligned to the left."

	^(self newColumnIn: aThemedMorph for: {
		self newLabelIn: aThemedMorph label: aString.
		control})
		cellPositioning: #leftCenter;
		cellInset: 2! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 6/20/2007 09:37'!
newToolDockingBarIn: aThemedMorph
	"Answer a new tool docking bar."

	^ToolDockingBarMorph new
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		clipSubmorphs: true! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 10:03'!
newToolSpacerIn: aThemedMorph
	"Answer a new tool spacer."

	^Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 3@3! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 4/16/2007 11:08'!
newToolbarHandleIn: aThemedMorph
	"Answer a new toolbar handle."

	^PanelMorph new
		fillStyle: Color transparent; "non pane color tracking"
		borderStyle: (BorderStyle raised baseColor: Color blue; width: 1);
		extent: 4@3;
		vResizing: #spaceFill! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 10:03'!
newToolbarIn: aThemedMorph
	"Answer a new toolbar."

	|bar|
	bar := Morph new
		borderWidth: 0;
		color: Color transparent;
		changeTableLayout;
		layoutInset: (0@1 corner: 1@1);
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	bar
		addMorphBack: (self newToolSpacerIn: aThemedMorph);
		addMorphBack: (self newToolbarHandleIn: aThemedMorph);
		addMorphBack: (self newToolSpacerIn: aThemedMorph).
	^bar! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 10:05'!
newToolbarIn: aThemedMorph for: controls
	"Answer a new toolbar with the given controls."

	|answer|
	answer _ self newToolbarIn: aThemedMorph.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:44'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
		extent: 9@9
		depth: 32
		fromArray: #( 3749280121 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 3816191606 4218778997 4293256677 4293322470 4292861919 4292401368 4291940817 4291546059 4290953922 4285822068 4218778997 4293059298 4293125091 4292664540 4292203989 4291743438 4291282887 4290624957 4285822068 4218778997 4292664540 4292664540 4292203989 4291743438 4291282887 4290822336 4290164406 4285822068 4218778997 4291809231 4278519045 4278519045 4278519045 4278519045 4278519045 4289769648 4285822068 4218778997 4291743438 4291743438 4291282887 4290822336 4290361785 4289901234 4289309097 4285822068 4218778997 4291348680 4291282887 4290822336 4290361785 4289901234 4289440683 4288848546 4285822068 4218778997 4290559164 4290493371 4290032820 4289638062 4289177511 4288716960 4288256409 4285822068 3665262455 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 3749016949)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/17/2006 12:27'!
newTreeIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector
	"Answer a new tree morph."
	
	^TreeListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false;
		yourself
		! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:44'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
		extent: 9@9
		depth: 32
		fromArray: #( 3749280121 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 3816191606 4218778997 4293256677 4293322470 4292861919 4292401368 4291940817 4291546059 4290953922 4285822068 4218778997 4293059298 4293125091 4292203989 4278519045 4291348680 4291282887 4290624957 4285822068 4218778997 4292664540 4292664540 4291743438 4278190080 4290822336 4290822336 4290164406 4285822068 4218778997 4291809231 4278519045 4278519045 4278190080 4278519045 4278519045 4289769648 4285822068 4218778997 4291743438 4291743438 4290822336 4278190080 4289967027 4289901234 4289309097 4285822068 4218778997 4291348680 4291282887 4290361785 4278190080 4289506476 4289440683 4288848546 4285822068 4218778997 4290559164 4290493371 4290032820 4289638062 4289177511 4288716960 4288256409 4285822068 3665262455 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 3749016949)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/23/2007 16:39'!
newVerticalSeparatorIn: aThemedMorph
	"Answer a new vertical separator."

	^SeparatorMorph new
		fillStyle: Color transparent;
		borderStyle: (BorderStyle inset baseColor: Color blue; width: 1);
		extent: 2@2;
		vResizing: #spaceFill! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 3326099520 3330310272 0 0 0 0 0 0 0 0 4144038145 3326099520 3330310272 0 0 0 4144038145 3326099520 0 0 0 4227924225 3326099520 3330310272 0 4144038145 3326099520 3330310272 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 0 0 4227924225 3326099520 3330310272 3336494814 0 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 4144038145 3326099520 3330310272 3336494814 4144038145 3326099520 3330310272 0 0 4144038145 3326099520 3330310272 3336494814 0 0 4144038145 3326099520 0 0 0 3330310272 3336494814 0 0 0 0 0 0)
		offset: 0@0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 0 0 0 0 3875602689 0 0 0 0 4127260929 3877181721 3877181721 3875602689 0 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 4127260929 3875602689 3875602689 3875602689 3875602689 3212869760 0 3875602689 3212869760 0 3877181721 3212869760 3212869760 3212869760 3212869760 3212869760 0 3875602689 3212869760 0 3877181721 0 0 0 0 0 0 3875602689 3212869760 0 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3212869760 0 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760)
		offset: 0@0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:12'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4227858432 0 4127195136 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4227858432 3212869760 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760)
		offset: 0@0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 0 0 4127260929 4127260929 4127260929 4127260929 4127260929 0 0 0 0 3875602689 3212869760 3212869760 3212869760 3212869760 3212869760 4227924225 0 0 4127260929 3212869760 3212869760 0 0 0 0 3212869760 4127260929 0 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4128708375 3212869760 0 0 0 0 0 0 4127260929 3212869760 0 4127260929 3212869760 0 0 0 0 4127260929 3208659008 3212869760 0 3208659008 4127260929 4127260929 4127260929 4127260929 4127260929 3208659008 3212869760 0 0 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 0 0)
		offset: 0@0! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/16/2007 15:51'!
newYesButtonIn: aThemedMorph for: aModel
	"Answer a new Yes button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #yes
			arguments: nil
			getEnabled: nil
			label: 'Yes' translated
			help: 'Answer yes and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/20/2007 15:04'!
openTasklist: event
	"Open a tasklist to choose a window.
	Answer true if handled, false otherwise."

	Sensor commandKeyPressed ifFalse: [^false].
	 event keyCharacter = Character arrowLeft
		ifTrue: [TasklistMorph new openAsIs selectPreviousTask.
			^true].
	event keyCharacter = Character arrowRight
		ifTrue: [TasklistMorph new openAsIs selectNextTask.
			^true].
	^false! !

!UITheme methodsFor: 'copying' stamp: 'gvc 9/22/2006 17:20'!
postCopy
	"Copy the settings too."
	
	super postCopy.
	self settings: self settings copy! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:58'!
proceedIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a proceed dialog with the given label and title."

	Preferences useThemeSounds ifTrue: [self questionSound play].
	^(aThemedMorph openModal: (
		ProceedDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 4/25/2007 17:17'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	|c|
	c := self progressBarColorFor: aProgressBar.
	^BorderStyle simple
		width: 1;
		baseColor: c darker! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/23/2007 17:22'!
progressBarColorFor: aProgressBar
	"Answer the colour for the given progress bar."

	^self settings progressBarColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:44'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	^(GradientFillStyle ramp: {
			0.0->aColor darker duller. 0.2-> aColor darker.
			0.8->aColor twiceLighter. 1.0->aColor})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/24/2007 11:45'!
progressBarProgressColorFor: aProgressBar
	"Answer the colour for the progress part of the given progress bar."

	^self settings progressBarProgressColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:47'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar innerBounds.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
questionIcon
	"Answer a question icon."

	^ThemeIcons questionIcon! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:58'!
questionIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a question dialog with the given label and title."

	Preferences useThemeSounds ifTrue: [self questionSound play].
	^(aThemedMorph openModal: (
		QuestionDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) answer! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 15:56'!
questionSound
	"Answer the question sound."

	^self sounds at: #question ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 15:58'!
questionWithoutCancelIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a question dialog with the given label and title."

	Preferences useThemeSounds ifTrue: [self questionSound play].
	^(aThemedMorph openModal: (
		QuestionWithoutCancelDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) answer! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 8/10/2007 10:14'!
radioButtonDisabledBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^self checkboxButtonDisabledBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 8/10/2007 11:48'!
radioButtonDisabledFillStyleFor: aRadioButton
	"Return the disabled radio button fillStyle for the given button."
	
	^self checkboxButtonDisabledFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 8/10/2007 10:14'!
radioButtonNormalBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 8/10/2007 11:48'!
radioButtonNormalFillStyleFor: aRadioButton
	"Return the normal radio button fillStyle for the given button."
	
	^self checkboxButtonNormalFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/11/2007 16:04'!
scrollbarArrowOfDirection: aSymbol size: finalSizeInteger color: aColor
	"Answer a new scrollbar arrow form (normally cached by Scrollbar)."
	
	^ScrollBar basicCreateArrowOfDirection: aSymbol size: finalSizeInteger color: aColor! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/16/2007 12:59'!
scrollbarColorFor: aScrollbar
	"Answer the colour for the given scrollbar."

	^self settings standardColorsOnly
		ifTrue: [self settings scrollbarColor]
		ifFalse: [(aScrollbar valueOfProperty: #lastPaneColor)
					 ifNil: [Color white]]! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:02'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^self scrollbarColorFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:15'!
scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:15'!
scrollbarMouseOverBarButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:41'!
scrollbarMouseOverBarThumbBorderStyleFor: aScrollbar
	"Return the thumb borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:42'!
scrollbarMouseOverBarThumbFillStyleFor: aScrollbar
	"Return the thumb fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverBorderStyleFor: aScrollbar
	"Return the mouse over borderStyle for the given scrollbar."

	^self scrollbarNormalBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverButtonBorderStyleFor: aScrollbar
	"Return the mouse over button borderStyle for the given scrollbar."

	^self scrollbarNormalButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:09'!
scrollbarMouseOverButtonFillStyleFor: aScrollbar
	"Return the scrollbar mouse over button fillStyle for the given color."

	^self scrollbarNormalButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:08'!
scrollbarMouseOverFillStyleFor: aScrollbar
	"Return the scrollbar mouse over fillStyle for the given color."

	^self scrollbarNormalFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverThumbBorderStyleFor: aScrollbar
	"Return the mouse over thumb borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:50'!
scrollbarMouseOverThumbButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the thumb."

	^self scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:51'!
scrollbarMouseOverThumbButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the thumb."

	^self scrollbarMouseOverBarButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:15'!
scrollbarMouseOverThumbFillStyleFor: aScrollbar
	"Return the scrollbar mouse over thumb fillStyle for the given color."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:30'!
scrollbarNormalBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:27'!
scrollbarNormalButtonBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:28'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/17/2007 11:36'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^(aColor alphaMixed: 0.4 with: Color white)
		alphaMixed: 0.9 with: Color black! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:15'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^BorderStyle simple
		width: 1;
		baseColor: aColor twiceDarker! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:21'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	^self scrollbarColorFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/5/2007 14:24'!
scrollbarPressedBorderStyleFor: aScrollbar
	"Return the pressed borderStyle for the given scrollbar."

	^self scrollbarNormalBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/2/2007 14:04'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	^self scrollbarPressedThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:42'!
scrollbarPressedButtonFillStyleFor: aScrollbar
	"Return the pressed scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarPressedThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:29'!
scrollbarPressedFillStyleFor: aScrollbar
	"Return the pressed scrollbar fillStyle for the given scrollbar."
	
	^self scrollbarNormalFillStyleFor: aScrollbar ! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:11'!
scrollbarPressedThumbBorderStyleFor: aScrollbar
	"Return the pressed thumb borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:22'!
scrollbarPressedThumbFillStyleFor: aScrollbar
	"Return the pressed scrollbar thumb fillStyle for the given scrollbar."
	
	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/12/2006 14:01'!
selectionColor
	"Answer the selection color to use.."

	^self settings selectionColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 6/4/2007 14:21'!
separatorFillStyleFor: aSeparator
	"Return the separator fillStyle for the given splitter."
	
	|aColor|
	aColor := aSeparator paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor whiter whiter. 0.2->aColor lighter.
		0.8->aColor darker. 1.0->aColor blacker})
		origin: aSeparator topLeft;
		direction: (aSeparator bounds isWide
			ifTrue: [0 @ aSeparator height]
			ifFalse: [aSeparator width @ 0]);
		radial: false! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 4/16/2007 13:01'!
setStandardColors
	"Set the standard colours for the theme."

	self settings
		buttonColor: Color gray;
		scrollbarColor: Color gray! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:19'!
settings
	"Answer the value of settings"

	^ settings! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:19'!
settings: anObject
	"Set the value of settings"

	settings := anObject! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/3/2007 15:25'!
sliderDisabledBorderStyleFor: aSlider
	"Return the disabled slider borderStyle for the given text editor."

	^self sliderNormalBorderStyleFor: aSlider! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:38'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	^aSlider paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/3/2007 15:26'!
sliderNormalBorderStyleFor: aSlider
	"Return the normal slider borderStyle for the given text editor."

	^BorderStyle inset
		width: 1;
		baseColor: aSlider paneColor twiceDarker! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/3/2007 15:27'!
sliderNormalFillStyleFor: aSlider
	"Return the normal fillStyle for the given slider."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:39'!
smallBarcodeIcon
	"Answer a small barcode icon."

	^ThemeIcons smallBarcodeIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:28'!
smallBoldIcon
	"Answer a small bold text icon."

	^ThemeIcons smallBoldIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/22/2007 10:44'!
smallDebugIcon
	"Answer a small debug icon."

	^self smallErrorIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:44'!
smallErrorIcon
	"Answer a small error icon."

	^ThemeIcons smallErrorIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:33'!
smallHierarchyBrowserIcon
	"Answer a small hierarchy browser icon."

	^ThemeIcons smallHierarchyBrowserIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 13:08'!
smallInfoIcon
	"Answer a small information icon."

	^ThemeIcons smallInfoIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:28'!
smallItalicIcon
	"Answer a small italic text icon."

	^ThemeIcons smallItalicIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallLockIcon
	"Answer a small lock icon."

	^ThemeIcons smallLockIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallQuestionIcon
	"Answer a small question icon."

	^ThemeIcons smallQuestionIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:29'!
smallStrikeOutIcon
	"Answer a small strike text icon."

	^ThemeIcons smallStrikeOutIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:31'!
smallSystemBrowserIcon
	"Answer a small browser icon."

	^ThemeIcons smallSystemBrowserIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:29'!
smallUnderlineIcon
	"Answer a small underlined text icon."

	^ThemeIcons smallUnderlineIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallWarningIcon
	"Answer a small warning icon."

	^ThemeIcons smallWarningIcon! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 6/27/2007 10:19'!
sounds
	"Answer the value of sounds"

	sounds ifNil: [self initializeSounds].
	^sounds! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 6/27/2007 10:17'!
sounds: anObject
	"Set the value of sounds"

	sounds := anObject! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:12'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor whiter whiter. 0.2->aColor lighter.
		0.8->aColor darker. 1.0->aColor blacker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:14'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor twiceDarker.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.4-> aColor twiceLighter.
			1.0->aColor darker duller})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 5/1/2007 17:47'!
statusFont
	"Answer the status font to use."

	^((TextStyle named: #'Lucida Console') ifNil: [TextStyle default])
		fontOfPointSize: 8! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:33'!
taskbarActiveButtonColorFor: aButton
	"Answer the colour for the given active taskbar button."

	^(self taskbarButtonColorFor: aButton) twiceDarker! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:33'!
taskbarButtonColorFor: aButton
	"Answer the colour for the given taskbar button."

	^self settings standardColorsOnly
		ifTrue: [self settings buttonColor]
		ifFalse: [(aButton model valueOfProperty: #paneColor) ifNil: [aButton model defaultColor]]! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:17'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^Color black! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:06'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor|
	aColor := aTaskbar color.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: aTaskbar position;
		direction: 0@27;
		radial: false! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:11'!
taskbarMinimizedButtonColorFor: aButton
	"Answer the colour for the given minimized taskbar button."

	^self taskbarButtonColorFor: aButton! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 4/18/2007 11:48'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	|c|
	c := self windowColorFor: aWindow.
	^BorderStyle raised
		width: 1;
		baseColor: c! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/20/2007 10:46'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	|aColor|
	aColor := aTasklist color.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aTasklist topLeft;
		direction: 0 @ aTasklist height;
		radial: false! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:10'!
textEditorDisabledBorderStyleFor: aTextEditor
	"Return the disabled text editor borderStyle for the given text editor."

	^self textEditorNormalBorderStyleFor: aTextEditor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:13'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	^aTextEditor paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'services' stamp: 'gvc 5/1/2007 11:32'!
textEditorIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText
	"Answer the result of a text editor (multiline) dialog ( a string or nil if cancelled)
	with the given label and title."

	^self
		textEditorIn: aThemedMorph
		text: aStringOrText
		title: aString
		entryText: defaultEntryText
		entryHeight: 64! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 16:24'!
textEditorIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText entryHeight: entryHeight
	"Answer the result of a text editor (multiline) dialog ( a string or nil if cancelled)
	with the given label and title."

	Preferences useThemeSounds ifTrue: [self questionSound play].
	^(aThemedMorph openModal: (
		TextEditorDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText;
			entryHeight: entryHeight)) entryText! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:10'!
textEditorNormalBorderStyleFor: aTextEditor
	"Return the normal text editor borderStyle for the given text editor."

	^BorderStyle inset
		width: 1;
		baseColor: aTextEditor paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 12:56'!
textEditorNormalFillStyleFor: aTextEditor
	"Return the normal fillStyle for the given text editor."
	
	^Color white! !

!UITheme methodsFor: 'services' stamp: 'gvc 6/27/2007 16:24'!
textEntryIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText
	"Answer the result of a text entry dialog ( a string or nil if cancelled)
	with the given label and title."

	Preferences useThemeSounds ifTrue: [self questionSound play].
	^(aThemedMorph openModal: (
		TextEntryDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText)) entryText! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:11'!
textFieldDisabledBorderStyleFor: aTextField
	"Return the disabled text field borderStyle for the given text field."

	^self textEditorDisabledBorderStyleFor: aTextField! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:06'!
textFieldDisabledFillStyleFor: aTextField
	"Return the disabled fillStyle for the given text field."
	
	^self textEditorDisabledFillStyleFor: aTextField! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:11'!
textFieldNormalBorderStyleFor: aTextField
	"Return the normal text field borderStyle for the given text field."

	^self textEditorNormalBorderStyleFor: aTextField! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:06'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	^self textEditorNormalFillStyleFor: aTextField! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 4/25/2007 11:53'!
textFont
	"Answer the text font to use."

	^TextStyle default defaultFont! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/14/2007 11:49'!
treeExpandedForm
	"Answer the form to use for an expanded tree item."

	^self forms at: #treeExpanded ifAbsent: [Form extent: 10@9 depth: Display depth]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/14/2007 11:49'!
treeUnexpandedForm
	"Answer the form to use for an unexpanded tree item."

	^self forms at: #treeUnexpanded ifAbsent: [Form extent: 10@9 depth: Display depth]! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 4/26/2007 15:46'!
updateWorldDockingBars
	"Update the world docking bar gradients."
	
	World mainDockingBars do: [:d |
		d
			color: (self worldDockingBarColorFor: d);
			gradientRamp: (UITheme current
				worldMainDockingBarNormalFillStyleFor: d) colorRamp]! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
warningIcon
	"Answer a warning icon."

	^ThemeIcons warningIcon! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 18:01'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^aWindow paneColorToUse! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:16'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^Color black! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 17:32'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given color."
	
	^Color transparent! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:01'!
windowCloseForm
	"Answer the form to use for the close button of a window."

	^self forms at: #windowClose ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 11:02'!
windowCloseSound
	"Answer the window close sound."

	^self sounds at: #windowClose ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/12/2006 14:53'!
windowColor
	"Answer the window color to use."

	^self settings windowColor! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 6/5/2007 12:22'!
windowColorFor: aWindowOrModel
	"Answer the colour for the given window."

	|c|
	self settings standardColorsOnly
		ifTrue: [^self settings windowColor].
	c := (aWindowOrModel isKindOf: SystemWindow)
		ifTrue: [Color colorFrom: (Preferences
					windowColorFor: aWindowOrModel class name)]
		ifFalse: [aWindowOrModel defaultBackgroundColor].
	^c = Color white
		ifTrue: [self settings windowColor]
		ifFalse: [c duller]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 18:04'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^Preferences fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse
					alphaMixed: 0.9
					with: (Color white alpha: aWindow paneColorToUse alpha)]
		ifFalse: [aWindow paneColorToUse]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:21'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^Preferences fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse alphaMixed: 0.6 with: Color black]
		ifFalse: [self windowActiveLabelFillStyleFor: aWindow]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 10:53'!
windowInactiveTitleFillStyleFor: aWindow
	"Return the window inactive title fillStyle for the given color."
	
	^self windowActiveTitleFillStyleFor: aWindow! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/7/2007 12:50'!
windowLabelFor: aWindow
	"Answer the label to use for the given window."

	^self windowLabelForText: aWindow labelString! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/7/2007 12:48'!
windowLabelForText: aTextOrString
	"Answer the window label to use for the given text."

	^StringMorph new
		contents: aTextOrString;
		font: Preferences windowTitleFont emphasis: 0! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:00'!
windowMaximizeForm
	"Answer the form to use for the maximize button of a window."

	^self forms at: #windowMaximize ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 10:15'!
windowMaximizeSound
	"Answer the window maximize sound."

	^self sounds at: #windowMaximize ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:01'!
windowMenuForm
	"Answer the form to use for the menu button of a window."

	^self forms at: #windowMenu ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/25/2007 10:01'!
windowMenuIconFor: aWindow
	"Answer the menu icon for the given window."

	^aWindow taskbarIcon ifNil: [self windowMenuForm]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:00'!
windowMinimizeForm
	"Answer the form to use for the minimize button of a window."

	^self forms at: #windowMinimize ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 10:15'!
windowMinimizeSound
	"Answer the window minimize sound."

	^self sounds at: #windowMinimize ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 10:16'!
windowRestoreDownSound
	"Answer the window restore down sound."

	^self sounds at: #windowRestoreDown ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 6/27/2007 10:16'!
windowRestoreUpSound
	"Answer the window restore up sound."

	^self sounds at: #windowRestoreUp ifAbsent: [RestSound dur: 0]! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/26/2007 15:49'!
worldDockingBarColorFor: aDockingBar
	"Answer the base colour to use for a world docking bar in this theme."

	^ColorTheme current dockingBarColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:56'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	^aDockingBar originalColor! !

UITheme subclass: #UIThemeSoftSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!UIThemeSoftSqueak commentStamp: 'gvc 5/18/2007 10:05' prior: 0!
A soft gradient-based UI theme. Do UIThemeSoftSqueak beCurrent to use.!

!UIThemeSoftSqueak class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:25'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeSoftSqueak class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:18'!
themeName
	"Answer the friendly name of the theme."

	^'Soft Squeak'! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 16:54'!
buttonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given button."

	|c|
	c := aButton colorToUse darker.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle raised
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:00'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."

	|c|
	c :=  aButton colorToUse twiceLighter whiter.
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.2->c twiceLighter.
			0.8->c darker.
			1.0->c darker duller})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'label-styles' stamp: 'gvc 8/7/2007 12:07'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."

	^aTextOrString isString
		ifTrue: [(super buttonLabelForText: aTextOrString) disabledStyle: #inset]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:00'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	|aColor c|
	aColor := aButton colorToUse.
	c := aColor luminance > 0.3
		ifTrue: [aColor blacker]
		ifFalse: [aColor whiter].
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.2->c twiceLighter.
			0.8->c darker.
			1.0->c darker duller})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 16:54'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|c|
	c := aButton colorToUse.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle raised
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:00'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	|aColor|
	aColor := self buttonColorFor: aButton.
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.2->aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:00'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^aPanel paneColor! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:00'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given color."
	
	|aColor c|
	aColor := aButton colorToUse.
	c := aColor luminance > 0.3
		ifTrue: [aColor blacker]
		ifFalse: [aColor whiter].
	^(GradientFillStyle ramp: {
			0.0->c darker duller. 0.2->c darker. 0.8->c twiceLighter. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 16:54'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected button borderStyle for the given button."

	|c|
	c := aButton colorToUse.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle inset
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 16:55'!
buttonSelectedDisabledBorderStyleFor: aButton
	"Return the selecteddisabled button borderStyle for the given button."

	|c|
	c := aButton colorToUse darker.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle inset
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:01'!
buttonSelectedDisabledFillStyleFor: aButton
	"Return the button selected disabled fillStyle for the given color."
	
	|aColor c|
	aColor := aButton colorToUse.
	c :=  aColor twiceLighter whiter.
	^(GradientFillStyle ramp: {
			0.0->c darker duller. 0.2->c darker.
			0.8->c twiceLighter. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:01'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	|aColor|
	aColor := aButton colorToUse.
	^(GradientFillStyle ramp: {
			0.0->aColor darker duller. 0.2->aColor darker.
			0.8->aColor twiceLighter. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:01'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given color."
	
	|aColor c|
	aColor := aButton colorToUse.
	c := aColor luminance > 0.3
		ifTrue: [aColor blacker]
		ifFalse: [aColor whiter].
	^(GradientFillStyle ramp: {
			0.0->c darker duller. 0.2->c darker.
			0.8->c twiceLighter. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 17:01'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given color."

	|aColor c|
	aColor := aButton colorToUse.
	c := aColor luminance > 0.3
		ifTrue: [aColor blacker]
		ifFalse: [aColor whiter].
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.2->c twiceLighter.
			0.8->c darker. 1.0->c darker duller})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 8/10/2007 10:15'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^BorderStyle inset
		width: 1;
		baseColor: aCheckboxButton paneColor darker! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:17'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	|c|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.3
		with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.8->c twiceLighter.
			1.0->c})
		origin: aCheckboxButton bounds origin;
		direction: 0 @ aCheckboxButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/23/2007 12:29'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	^BorderStyle inset
		width: 1;
		baseColor: aCheckboxButton paneColor darker! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:12'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	|c|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.1
		with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.8->c twiceLighter.
			1.0->c})
		origin: aCheckboxButton bounds origin;
		direction: 0 @ aCheckboxButton height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'label-styles' stamp: 'gvc 8/7/2007 12:19'!
checkboxLabelForText: aTextOrString
	"Answer the label to use for the given checkbox."

	^aTextOrString isString
		ifTrue: [(super checkboxLabelForText: aTextOrString) disabledStyle: #inset]
		ifFalse: [super checkboxLabelForText: aTextOrString]! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 16:59'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor|
	aColor := aToolDockingBar originalColor.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:22'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given dropList."
	
	|c|
	c := aDropList paneColor alphaMixed: 0.3 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aDropList topLeft;
		direction: 0 @ aDropList height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:22'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	|c|
	c := aDropList paneColor alphaMixed: 0.1 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c lighter.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aDropList topLeft;
		direction: 0 @ aDropList height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 16:59'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	|aColor|
	aColor := anExpanderTitle paneColor.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.2-> aColor twiceLighter.
			0.8->aColor darker. 1.0->aColor darker duller})
		origin: anExpanderTitle topLeft;
		direction: 0 @ anExpanderTitle height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:57'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	|c fill|
	Display depth <= 2 ifTrue: [^ Color gray].
	c := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	fill := GradientFillStyle ramp: {
		0.0->Color white.
		0.2->c lighter.
		1.0->Color white}.
	fill origin: aMenuItem topLeft.
	aMenuItem owner isVertical
		ifTrue: [fill direction: aMenuItem width @ 0]
		ifFalse: [fill direction: 0 @ aMenuItem height].
	^ fill! !

!UIThemeSoftSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 6/4/2007 13:07'!
menuItemSelectedBorderStyleFor: aMenuItem
	"Return the selected menu item borderStyle for the given menu item."

	|c|
	c := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	Display depth <= 2 ifTrue: [c _ Color black].
	^BorderStyle raised
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 13:06'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	|c|
	Display depth <= 2 ifTrue: [^ Color gray].
	c := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.2->c twiceLighter.
			0.8->c darker.
			1.0->c darker duller})
		origin: aMenuItem topLeft;
		direction: 0 @ aMenuItem height! !

!UIThemeSoftSqueak methodsFor: 'morph creation' stamp: 'gvc 5/15/2007 17:42'!
newDialogPanelIn: aThemedMorph
	"Answer a new (main) dialog panel."

	^(super 
		newDialogPanelIn: aThemedMorph)
		roundedCorners: #(2 3) "only bottom edge"! !

!UIThemeSoftSqueak methodsFor: 'morph creation' stamp: 'gvc 8/7/2007 12:05'!
newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^(super newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel)
		disabledStyle: #inset! !

!UIThemeSoftSqueak methodsFor: 'border-styles' stamp: 'gvc 4/25/2007 17:16'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	|c|
	c := self progressBarColorFor: aProgressBar.
	^BorderStyle inset
		width: 1;
		baseColor: c! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 16:59'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	^(GradientFillStyle ramp: {
			0.0->aColor darker duller. 0.2-> aColor darker.
			0.8->aColor twiceLighter. 1.0->aColor})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 16:59'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar innerBounds.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 16:59'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^(aColor alphaMixed: 0.4 with: Color white)
		alphaMixed: 0.9 with: Color black! !

!UIThemeSoftSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:10'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^BorderStyle raised
		width: 1;
		baseColor: aColor twiceDarker! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 16:59'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.2-> aColor twiceLighter.
			0.8->aColor darker. 1.0->aColor darker duller})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:10'!
scrollbarPressedThumbBorderStyleFor: aScrollbar
	"Return the pressed thumb borderStyle for the given scrollbar."

	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^BorderStyle inset
		width: 1;
		baseColor: aColor twiceDarker! !

!UIThemeSoftSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 16:59'!
scrollbarPressedThumbFillStyleFor: aScrollbar
	"Return the pressed scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^(GradientFillStyle ramp: {
			0.0->aColor darker duller. 0.2-> aColor darker.
			0.8->aColor twiceLighter. 1.0->Color white})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:23'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	|c|
	c := aSlider paneColor alphaMixed: 0.3 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aSlider topLeft;
		direction: 0 @ aSlider height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:23'!
sliderNormalFillStyleFor: aSlider
	"Return the normal fillStyle for the given slider."
	
	|c|
	c := aSlider paneColor alphaMixed: 0.1 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c lighter.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aSlider topLeft;
		direction: 0 @ aSlider height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 17:00'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor|
	aColor := aTaskbar color.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: aTaskbar position;
		direction: 0@27;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 17:00'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	|aColor|
	aColor := aTasklist color.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aTasklist topLeft;
		direction: 0 @ aTasklist height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:15'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	|c|
	c := aTextEditor paneColor alphaMixed: 0.3 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: aTextEditor topLeft;
		direction: 0 @ aTextEditor height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 12:57'!
textEditorNormalFillStyleFor: aTextEditor
	"Return the normal fillStyle for the given text editor."
	
	|c|
	c := aTextEditor paneColor alphaMixed: 0.1 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c lighter.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: aTextEditor topLeft;
		direction: 0 @ aTextEditor height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:16'!
textFieldDisabledFillStyleFor: aTextField
	"Return the disabled fillStyle for the given text field."
	
	|c|
	c := aTextField paneColor alphaMixed: 0.3 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aTextField topLeft;
		direction: 0 @ aTextField height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:13'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	|c|
	c := aTextField paneColor alphaMixed: 0.1 with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2-> c lighter.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: aTextField topLeft;
		direction: 0 @ aTextField height;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 7/18/2007 14:34'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.3 with: Color black! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 17:00'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given color."
	
	|aColor|
	aColor := aWindow paneColorToUse.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 7/18/2007 14:34'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.6 with: Color black! !

!UIThemeSoftSqueak methodsFor: 'label-styles' stamp: 'gvc 5/7/2007 12:49'!
windowLabelForText: aStringOrText
	"Answer the window label to use for the given text."

	^StringMorph new
		contents: aStringOrText;
		font: Preferences windowTitleFont emphasis: 1;
		shadowColor: Color white;
		shadowOffset: 1@1;
		hasDropShadow: true.! !

!UIThemeSoftSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:51'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor|
	aColor := aDockingBar originalColor.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UITheme subclass: #UIThemeStandardSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!UIThemeStandardSqueak commentStamp: 'gvc 5/18/2007 10:04' prior: 0!
A UI theme that tries to make things look like a standard (3.9) Squeak image. Do UIThemeStandardSqueak beCurrent to use.!

!UIThemeStandardSqueak class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:26'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeStandardSqueak class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:19'!
themeName
	"Answer the friendly name of the theme."

	^'Standard Squeak'! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/26/2007 09:58'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."

	^aButton offColor
		ifNil: [Color darkGray]
		ifNotNil: [aButton offColor muchDarker]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:30'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	^(self buttonNormalFillStyleFor: aButton) adjustBrightness: -0.09375! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:54'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	^aButton borderStyle isComposite
		ifTrue: [aButton borderStyle borders first]
		ifFalse: [aButton borderStyle]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/15/2007 17:44'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	^aButton offColor
		ifNil: [Color transparent]
		ifNotNil: [aButton offColor]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:37'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^Color white! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:55'!
buttonPressedBorderStyleFor: aButton
	"Return the pressed button borderStyle for the given button."

	aButton borderStyle isComposite
		ifTrue: [^aButton borderStyle].
	^(CompositeBorder new width: 1)
		borders: {aButton borderStyle.
				BorderStyle simple
				color: Color red;
				width: 2}! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:48'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	^aButton onColor
		ifNil: [Color white darker darker]
		ifNotNil: [aButton onColor]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:49'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given color."
	
	^(self buttonSelectedFillStyleFor: aButton) adjustBrightness: -0.09375! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:53'!
buttonSelectedPressedBorderStyleFor: aButton
	"Return the selected pressed button borderStyle for the given button."

	aButton borderStyle isComposite
		ifTrue: [^aButton borderStyle].
	^(CompositeBorder new width: 1)
		borders: {aButton borderStyle.
				BorderStyle simple
				color: Color red;
				width: 2}! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:54'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^self windowActiveFillStyleFor: aWindow! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:54'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window inactive fillStyle for the given window."
	
	^self windowInactiveFillStyleFor: aWindow! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:31'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor|
	aColor := aToolDockingBar originalColor.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UIThemeStandardSqueak methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:43'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
		extent: 10@9
		depth: 8
		fromArray: #( 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4278255873 16843009 16842752 4294902089 1229539657 33488896 4294967041 1229539585 4294901760 4294967295 21561855 4294901760 4294967295 4278321151 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UIThemeStandardSqueak methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:43'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
		extent: 10@9
		depth: 8
		fromArray: #( 4294967041 4294967295 4294901760 4294967041 33554431 4294901760 4294967041 1224867839 4294901760 4294967041 1229521407 4294901760 4294967041 1229539585 4294901760 4294967041 1229521407 4294901760 4294967041 1224867839 4294901760 4294967041 33554431 4294901760 4294967041 4294967295 4294901760)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UIThemeStandardSqueak methodsFor: 'border-styles' stamp: 'gvc 4/25/2007 17:19'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	^BorderStyle simple
		width: 1;
		baseColor: Preferences menuBorderColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 6/4/2007 14:25'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	^self progressBarColorFor: aProgressBar! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 6/4/2007 14:24'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	^self progressBarProgressColorFor: aProgressBar! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:26'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^((self scrollbarColorFor: aScrollbar)
		alphaMixed: 0.5 with: (Color gray: 0.95)) twiceDarker darker! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:58'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^aScrollbar sliderColor alphaMixed: 0.3 with: Color white! !

!UIThemeStandardSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:16'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 1;
		baseColor: Color lightGray! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:04'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	^aScrollbar sliderColor
		alphaMixed: 0.5 with: (Color gray: 0.95)! !

!UIThemeStandardSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 16:36'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	^BorderStyle inset
		width: 1! !

!UIThemeStandardSqueak methodsFor: 'icons' stamp: 'gvc 5/22/2007 10:45'!
smallDebugIcon
	"Answer a small debug icon."

	^MenuIcons smallDebugIcon! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:19'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	^aSplitter getOldColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:19'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	^Color black! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:41'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	^Preferences menuColor! !

!UIThemeStandardSqueak methodsFor: 'border-styles' stamp: 'gvc 4/25/2007 17:21'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: Preferences menuBorderColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:41'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	^Preferences menuColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:04'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^aWindow
		gradientWithColor: aWindow paneColorToUse lighter lighter lighter! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:04'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^aWindow
		gradientWithColor: aWindow paneColorToUse duller! !

!UIThemeStandardSqueak methodsFor: 'label-styles' stamp: 'gvc 5/25/2007 10:02'!
windowMenuIconFor: aWindow
	"Answer the menu icon for the given window."
	
	^self windowMenuForm! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:56'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor|
	aColor := aDockingBar originalColor.
	^(GradientFillStyle ramp: {0.0 -> aColor muchLighter. 1.0 -> aColor twiceDarker})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UITheme subclass: #UIThemeVistary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!UIThemeVistary commentStamp: 'gvc 5/18/2007 10:02' prior: 0!
A Vista-style UI theme. Do UIThemeVistary beCurrent to use.!

!UIThemeVistary class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 14:26'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeVistary class methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:19'!
themeName
	"Answer the friendly name of the theme."

	^'Vistary'! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 3/14/2007 15:58'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 4/13/2007 17:09'!
buttonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given button."

	|pc oc mc ic|
	pc := self buttonColorFor: aButton.
	oc := (pc alphaMixed: 0.3 with: Color white) alpha: 0.4.
	mc := (pc alphaMixed: 0.6 with: Color black) alpha: 0.5.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/13/2007 10:16'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."
	
	^aButton colorToUse lighter whiter alpha: 0.6! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 4/16/2007 11:14'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	
	^aTextOrString isString
		ifTrue: [(FuzzyLabelMorph contents: aTextOrString)
					alpha: 0.3]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 4/30/2007 15:14'!
buttonMouseOverBorderStyleFor: aButton
	"Return the mouse over button borderStyle for the given button."
	
	|pc oc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	oc := (pc alphaMixed: 0.1 with: (Color white alphaMixed: 0.4 with: selcol)) alpha: 0.4.
	mc := (pc alphaMixed: 0.4 with: (Color black alphaMixed: 0.3 with: selcol)) alpha: 0.5.
	ic := (Color white alphaMixed: 0.7 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/28/2007 14:53'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."
	
	|aColor c cm cd cb selcol|
	aColor := aButton colorToUse.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.7 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.3 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 4/13/2007 17:08'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|pc oc mc ic|
	pc := self buttonColorFor: aButton.
	oc := (pc alphaMixed: 0.4 with: Color white) alpha: 0.4.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/13/2007 17:09'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given color."
	
	|aColor c cm cd cb|
	aColor := self buttonColorFor: aButton.
	aButton isDefault ifTrue: [aColor := aColor
		alphaMixed: 0.5 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0)].
	c := aColor alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.8 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.5->cm. 0.51->cd. 1.0->cb})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 15:15'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	|aColor c cm cd cb|
	aColor := aPanel paneColor.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aPanel topLeft;
		direction: 0 @ aPanel height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:24'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given button."
		
	^self buttonSelectedFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 5/9/2007 10:14'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected borderStyle for the given button."
	
	|pc oc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	oc := (pc alphaMixed: 0.1 with: (Color white alphaMixed: 0.6 with: selcol)) alpha: 0.4.
	mc := (pc alphaMixed: 0.2 with: (Color black alphaMixed: 0.2 with: selcol)) alpha: 0.5.
	ic := (Color white alphaMixed: 0.6 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 12:40'!
buttonSelectedDisabledFillStyleFor: aButton
	"Return the button selected disabled fillStyle for the given color."
	
	|aColor selcol|
	aColor := aButton colorToUse.
	selcol := (aColor mixed: 0.5 with: self selectionColor) lighter whiter.
	^(GradientFillStyle ramp: {0.0->selcol. 1.0->selcol})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/28/2007 14:52'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given button."
	
	|aColor c cm cd cb selcol|
	aColor := aButton colorToUse.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 4/30/2007 15:10'!
buttonSelectedMouseOverBorderStyleFor: aButton
	"Return the selected mouse over button borderStyle for the given button."

	^self buttonMouseOverBorderStyleFor: aButton! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:23'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given button."
	
	^self buttonMouseOverFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:24'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given button."
	
	^self buttonNormalFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 9/5/2007 13:09'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: aCheckboxButton paneColor darker! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 9/5/2007 13:28'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	|c|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.3
		with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.8->c twiceLighter.
			1.0->c})
		origin: aCheckboxButton innerBounds origin;
		direction: 0 @ aCheckboxButton innerBounds height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 9/5/2007 13:40'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	|pc oc mc ic|
	pc := self buttonColorFor: aCheckboxButton.
	oc := pc twiceDarker.
	mc := (pc alphaMixed: 0.4 with: Color white).
	ic := pc lighter. 
	^(CompositeBorder new width: 2)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle inset
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 9/5/2007 13:38'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	|c|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.2
		with: Color white.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.8->c twiceLighter.
			1.0->c})
		origin: aCheckboxButton innerBounds origin;
		direction: 0 @ aCheckboxButton innerBounds height;
		radial: false! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 17:23'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."

	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow basicLabel ifNotNilDo: [:label | aWindow labelArea addMorphBack: label].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox].
	aWindow hasCloseBox ifTrue: [aWindow addCloseBox]! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:38'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor c cm cd cb|
	aColor := aToolDockingBar originalColor.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:12'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.3 with: Color white.
	inner := aDropList innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:11'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.1 with: Color white.
	inner := aDropList innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:18'!
dropListNormalListFillStyleFor: aDropList
	"Return the normal fillStyle for the list of the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.1 with: Color white.
	inner := aDropList listMorph innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
errorIcon
	"Answer an error icon."

	^VistaryThemeIcons errorIcon! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:15'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	|aColor c cm cd cb|
	aColor := anExpanderTitle paneColor.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.9 with: Color white.
	cd := cm alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.6 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: anExpanderTitle topLeft;
		direction: 0 @ anExpanderTitle height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
infoIcon
	"Answer an information icon."

	^VistaryThemeIcons infoIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
lockIcon
	"Answer a lock icon."

	^VistaryThemeIcons lockIcon! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:54'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	|c fill|
	Display depth <= 2 ifTrue: [^ Color gray].
	c := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	fill := GradientFillStyle ramp: {
		0.0->Color white.
		0.2->c lighter.
		1.0->Color white}.
	fill origin: aMenuItem topLeft.
	aMenuItem owner isVertical
		ifTrue: [fill direction: aMenuItem width @ 0]
		ifFalse: [fill direction: 0 @ aMenuItem height].
	^ fill! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:59'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	|c aColor selcol cm cd cb|
	Display depth <= 2 ifTrue: [^ Color gray].
	aColor := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aMenuItem topLeft;
		direction: 0 @ aMenuItem height! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:56'!
newDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."
	
	^(super
		newDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText)
		roundedCorners: #(1 2)! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:57'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^(super
		newMorphDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText)
		roundedCorners: #(1 2)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 10:47'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 4293504934 4293636006 4293701540 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293701540 4293636006 4293503392 4293503392 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293503392 4293436828 4293502364 4287789179 4283717479 4283717479 4283717479 4287854715 4293567642 4287920252 4283717479 4283717479 4283717479 4287789179 4293502364 4293238164 4293369236 4283651686 4294835709 4294901502 4294901502 4283717479 4287788409 4283651686 4294835709 4294901502 4294901502 4283717479 4293369236 4293105548 4293171084 4287590772 4283717479 4294769916 4294835709 4294769916 4283717479 4294704123 4294835709 4294835709 4283783272 4287590772 4293236620 4292840319 4292905855 4292840062 4287589743 4283717479 4294572537 4294638330 4294572537 4294638330 4294638330 4283783272 4287523951 4292905597 4292971391 4292443503 4292509039 4292574575 4292574575 4287391593 4283717479 4293454056 4293519849 4293519849 4283783272 4287391337 4292508782 4292574575 4292509039 4291316278 4291447350 4291578934 4291644470 4286993233 4283651686 4293454056 4293519849 4293519849 4283717479 4286927441 4291513398 4291644470 4291512886 4291117870 4291248942 4291380270 4286926926 4283651686 4292927714 4293059298 4293059298 4293059298 4292993506 4283717478 4286926670 4291380270 4291380014 4291185719 4291317047 4286927697 4283651686 4292532956 4292664540 4292664540 4283783270 4292598748 4292664540 4292598748 4283717478 4286927697 4291382583 4291188800 4291319872 4283651686 4292204247 4292335575 4292335575 4283783270 4286863189 4283717478 4292269783 4292335575 4292270039 4283717478 4291385408 4291454286 4291454286 4286930267 4283717478 4283717478 4283717478 4286995803 4291585101 4287061339 4283717478 4283717478 4283717478 4286930267 4291454286 4291655006 4291720542 4291655006 4291851614 4291851614 4291851614 4291851614 4291917150 4291851614 4291851614 4291851614 4291851870 4291786334 4291720798 4291985771 4291985771 4292182378 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292248170 4292248171 4292248171 4291986026)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:08'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14410989 14476525 14476525 14410989 14410989 14410989 14476525 14410989 14279659 14213610 14016230 13950180 13818594 13687007 14476525 14476525 14476525 14476525 14476525 14410989 14410989 14410988 14279403 14213610 14016230 13950180 13818594 13687007 14476525 3377747815 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 13687007 14345195 4283717479 4294638330 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4283717479 13358300 14082024 4283717479 4294704123 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4283717479 13029336 13490402 4283717479 4294704123 4294769916 4283783272 4283717479 4283717479 4283717479 4283717479 4283717479 4294704123 4294769916 4283717479 12371663 12964315 4283717479 4293454056 4293519849 4283717479 12503765 12569302 12437973 12306386 4283717479 4293454056 4293519849 4283717479 11582405 10859972 4283717479 4293454056 4293519849 4283717479 10399422 10464959 10268092 10070713 4283717479 4293454056 4293519849 4283717479 9017253 10662339 4283717479 4292993506 4293059298 4283717478 4283717479 4283717479 4283717479 4283717479 4283651686 4292993506 4293059298 4283717478 8688033 10728391 4283717479 4292598748 4292664540 4292598748 4292598748 4292598748 4292598748 4292598748 4292598748 4292664540 4292664540 4283717478 8819620 10794440 4283717479 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 8951720 11057614 3377747815 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3377747815 9280942 11517651 11583187 11517393 11385807 11320015 11122893 11057101 10925514 10662598 10531013 10267583 10070204 9938105 9806517 11978203 12175067 12043738 11846616 11846359 11649237 11583445 11451859 11188943 11122893 10793928 10662084 10529986 10201789)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:09'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14410989 14476525 14476525 14410989 14410989 14410989 14476525 14410989 14279659 14213610 14016230 13950180 13818594 13687007 14476525 14476525 14476525 14476525 14476525 14410989 14410989 14410988 14279403 14213610 14016230 13950180 13818594 13687007 14476525 3360970599 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3360970599 13687007 14345195 4283717479 4294638330 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4283717479 13358300 14082024 4283717479 4294704123 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4294769916 4294769916 4294769916 4283717479 13029336 13490402 4283717479 4294704123 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4283717479 12371663 12964315 4283717479 4293454056 4283717479 4283717479 4283717479 4293519849 4283717479 4283717479 4283717479 4293454056 4293519849 4283717479 11582405 10859972 4283717479 4293454056 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293454056 4293519849 4283717479 9017253 10662339 4283717479 4292993506 4283717479 4283717479 4292993506 4283717479 4283717479 4292993506 4283717479 4292993506 4293059298 4283717478 8688033 10728391 4283717479 4292598748 4292664540 4292598748 4292598748 4292598748 4292598748 4292598748 4292598748 4292664540 4292664540 4283717478 8819620 10794440 4283717479 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 8951720 11057614 3377747815 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3411302247 9280942 11517651 11583187 11517393 11385807 11320015 11122893 11057101 10925514 10662598 10531013 10267583 10070204 9938105 9806517 11978203 12175067 12043738 11846616 11846359 11649237 11583445 11451859 11188943 11122893 10793928 10662084 10529986 10201789)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:09'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14345196 14345452 14345452 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14279660 14147817 14147817 14147817 14147817 14147817 14147817 14147817 14147817 14213353 14213353 14147817 14147817 14147817 14082025 13687523 13687523 13687523 13687523 13687523 13687523 13687523 13687523 13687524 13687524 13687523 13621731 13555939 13490403 13095901 13161437 13161437 13161437 13161437 13161437 13161437 13161437 13161437 13161181 13161181 13030109 12964316 12832988 11188679 3360970599 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 10728645 10991559 4283651686 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4283717479 10399940 11188940 4283651686 4292598748 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4283717478 10465992 11320526 4283651686 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 10465993 11583699 3495188327 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3562363241 10532044 11912409 11912152 11912152 11912152 11912152 11912152 11912151 11912151 11846358 11715030 11517909 11189203 10992082 10860754 12372960 12372960 12438496 12438496 12438496 12438496 12372703 12372703 12241375 12109789 11978204 11583963 11452377 11255513)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 4/26/2007 10:30'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	|pc oc mc ic|
	pc := self progressBarColorFor: aProgressBar.
	oc := (pc alphaMixed: 0.4 with: Color white) alpha: 0.4.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 3)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 7/3/2007 12:30'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|aColor area c cm cd cb|
	aColor := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:57'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|aColor area c cm cd cb|
	aColor := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar innerBounds.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:47'!
questionIcon
	"Answer a question icon."

	^VistaryThemeIcons questionIcon! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 9/5/2007 13:37'!
radioButtonNormalBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	|pc|
	pc := self buttonColorFor: aRadioButton.
	^BorderStyle simple
		width: 1;
		baseColor: pc twiceDarker! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:48'!
scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:47'!
scrollbarMouseOverBarButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:20'!
scrollbarMouseOverButtonBorderStyleFor: aScrollbar
	"Return the mouse over button borderStyle for the given scrollbar."

	^self scrollbarMouseOverThumbBorderStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/5/2007 14:23'!
scrollbarMouseOverButtonFillStyleFor: aScrollbar
	"Return the mouse over scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarMouseOverThumbFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:25'!
scrollbarMouseOverThumbBorderStyleFor: aScrollbar
	"Return the mouse over thumb borderStyle for the given scrollbar."

	|aColor oc ic|
	aColor := self scrollbarColorFor: aScrollbar.
	oc := (aColor alphaMixed: 0.2 with: aColor darker)
		alphaMixed: 0.6 with: self selectionColor.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/16/2007 13:04'!
scrollbarMouseOverThumbFillStyleFor: aScrollbar
	"Return the scrollbar mouse over thumb fillStyle for the given color."
	
	|aColor c cm cd cb selcol|
	aColor := self scrollbarColorFor: aScrollbar.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.5 with: selcol.
	cd := aColor alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.3 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 14:55'!
scrollbarNormalButtonBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 0! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/17/2007 16:19'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarNormalFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 14:53'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor c|
	aColor := (self scrollbarColorFor: aScrollbar) alphaMixed: 0.3 with: Color white.
	c := aColor alphaMixed: 0.9 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.15->aColor. 0.9->aColor. 1.0->c})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 14:49'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|aColor oc ic|
	aColor := self scrollbarColorFor: aScrollbar.
	oc := aColor alphaMixed: 0.2 with: aColor darker.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/16/2007 13:04'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor c cm cd cb|
	aColor := self scrollbarColorFor: aScrollbar.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.9 with: Color white.
	cd := cm alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.6 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/5/2007 14:23'!
scrollbarPressedButtonFillStyleFor: aScrollbar
	"Return the pressed scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarPressedThumbFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/16/2007 13:05'!
scrollbarPressedFillStyleFor: aScrollbar
	"Return the pressed scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^aColor alphaMixed: 0.6 with: Color white! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/16/2007 13:05'!
scrollbarPressedThumbFillStyleFor: aScrollbar
	"Return the pressed scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor c cm cd cb selcol|
	aColor := self scrollbarColorFor: aScrollbar.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 4/25/2007 16:05'!
setStandardColors
	"Set the standard colours for the theme."

	self settings
		buttonColor: Color black;
		scrollbarColor: Color black;
		progressBarProgressColor: (Color r: 0.544 g: 0.819 b: 0.09)! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:38'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	|c inner|
	c := aSlider paneColor alphaMixed: 0.3 with: Color white.
	inner := aSlider innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:37'!
sliderNormalFillStyleFor: aSlider
	"Return the normal fillStyle for the given slider."
	
	|c inner|
	c := aSlider paneColor alphaMixed: 0.1 with: Color white.
	inner := aSlider innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/22/2007 10:45'!
smallDebugIcon
	"Answer a small debug icon."

	^self smallWarningIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallErrorIcon
	"Answer a small error icon."

	^VistaryThemeIcons smallErrorIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 13:08'!
smallInfoIcon
	"Answer a small information icon."

	^VistaryThemeIcons smallInfoIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallLockIcon
	"Answer a small lock icon."

	^VistaryThemeIcons smallLockIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallQuestionIcon
	"Answer a small question icon."

	^VistaryThemeIcons smallQuestionIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallWarningIcon
	"Answer a small warning icon."

	^VistaryThemeIcons smallWarningIcon! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:21'!
taskbarActiveButtonColorFor: aButton
	"Answer the colour for the given active taskbar button."

	^self selectionColor! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:19'!
taskbarButtonColorFor: aButton
	"Answer the colour for the given taskbar button."

	^Color black! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:20'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^Color white! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/16/2007 12:11'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor c cm cd cb|
	aColor := aTaskbar color.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: aTaskbar position;
		direction: 0@27;
		radial: false
	! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:20'!
taskbarMinimizedButtonColorFor: aButton
	"Answer the colour for the given minimized taskbar button."

	^Color darkGray! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 4/18/2007 11:49'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	|pc oc mc ic|
	pc := self windowColorFor: aWindow.
	oc := (pc alphaMixed: 0.4 with: Color white) alpha: 0.4.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/20/2007 11:26'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	|aColor c cm cd cb|
	aColor := aTasklist color.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aTasklist topLeft;
		direction: 0 @ aTasklist height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:46'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	|c inner|
	c := aTextEditor paneColor alphaMixed: 0.3 with: Color white.
	inner := aTextEditor innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:46'!
textEditorNormalFillStyleFor: aTextEditor
	"Return the normal fillStyle for the given text editor."
	
	|c inner|
	c := aTextEditor paneColor alphaMixed: 0.1 with: Color white.
	inner := aTextEditor innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c lighter.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:02'!
textFieldDisabledFillStyleFor: aTextField
	"Return the disabled fillStyle for the given text field."
	
	|c inner|
	c := aTextField paneColor alphaMixed: 0.3 with: Color white.
	inner := aTextField innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:02'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	|c inner|
	c := aTextField paneColor alphaMixed: 0.1 with: Color white.
	inner := aTextField innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
warningIcon
	"Answer a warning icon."

	^VistaryThemeIcons warningIcon! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:24'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.3 with: Color black! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:06'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given window."
	
	|aColor c cm cd cb|
	aColor := aWindow paneColorToUse.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.46->cm. 0.47->cd. 1.0->cb})
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false
	! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 7/18/2007 14:22'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.6 with: Color black! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 5/7/2007 12:49'!
windowLabelForText: aStringOrText
	"Answer the window label to use for the given text."

	^FuzzyLabelMorph new
		contents: aStringOrText;
		font: Preferences windowTitleFont emphasis: 1! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 4/26/2007 15:47'!
worldDockingBarColorFor: aDockingBar
	"Answer the base colour to use for a world docking bar in this theme."

	^(Color r: 0.607 g: 0.694 b: 0.066) alpha: 0.3! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:31'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor  c cm cd cb|
	aColor := aDockingBar originalColor.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

!MCSaveVersionDialog class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:49'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallSaveAsIcon! !

!LRUCache methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/29/2007 12:58'!
at: aKey 
	"answer the object for aKey, if not present in the cache creates it.
	Clone the factory block before calling in case of multiple processes!!"
	
	| element keyHash |
	calls := calls + 1.
	keyHash := aKey hash.
	1
		to: size
		do: [:index | 
			element := values at: index.
			(keyHash
						= (element at: 2)
					and: [aKey
							= (element at: 1)])
				ifTrue: ["Found!!"
					hits := hits + 1.
					values
						replaceFrom: 2
						to: index
						with: (values first: index - 1).
					values at: 1 put: element.
					^ element at: 3]].
	"Not found!!"
	element := {aKey. keyHash. factory clone value: aKey}.
	values
		replaceFrom: 2
		to: size
		with: values allButLast.
	values at: 1 put: element.
	^ element at: 3! !

!IconicButton methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/29/2007 10:55'!
handlesMouseOver: anEvent
	"Answer true, otherwise what is all that
	#mouseEnter:/#mouseLeave: stuff about?"

	^true! !

!IconicButton methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 15:34'!
labelGraphic: aForm
	"Changed to look for any image morph rather than just a sketch."
	
	| oldLabel graphicalMorph |
	(oldLabel := self findA: ImageMorph)
		ifNotNil: [oldLabel delete].
	graphicalMorph := ImageMorph new image: aForm.
	self extent: graphicalMorph extent + (self borderWidth + 6).
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock
! !

!IconicButton methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 15:35'!
mouseEnter: evt
	"Remember the old border style."
	
	self setProperty: #oldBorder toValue: self borderStyle.
	self borderStyle: BorderStyle thinGray! !

!IconicButton methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/30/2007 15:35'!
mouseLeave: evt
	"Reinstate the old border style."

	(self valueOfProperty: #oldBorder)
		ifNotNilDo: [:b | self borderStyle: b]
		ifNil: [self borderNormal]! !

InfiniteForm subclass: #AlphaInfiniteForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!AlphaInfiniteForm commentStamp: 'gvc 5/18/2007 13:49' prior: 0!
Alpha aware InfiniteForm.!

!AlphaInfiniteForm methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 16:59'!
displayOnPort: aPort offsetBy: offset

	| targetBox patternBox savedMap top left |

	"this version tries to get the form aligned where the user wants it and not just aligned with the cliprect"

	(patternForm isForm) ifFalse: [
		"patternForm is a Pattern or Color; just use it as a mask for BitBlt"
		^ aPort fill: aPort clipRect fillColor: patternForm rule: Form over].

	"do it iteratively"
	targetBox := aPort clipRect.
	patternBox := patternForm boundingBox.
	savedMap := aPort colorMap.
	aPort sourceForm: patternForm;
		fillColor: nil;
		combinationRule: Form blend;
		sourceRect: (0@0 extent: patternBox extent);
		colorMap: (patternForm colormapIfNeededFor: aPort destForm).
	top := (targetBox top truncateTo: patternBox height) + offset y.
	left :=  (targetBox left truncateTo: patternBox width) + offset x.

	left to: (targetBox right - 1) by: patternBox width do:
		[:x | top to: (targetBox bottom - 1) by: patternBox height do:
			[:y | aPort destOrigin: x@y; copyBits]].
	aPort colorMap: savedMap.
! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 12:42'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self
		fillStyle: self fillStyleToUse;
		selectionColor: self selectionColor.
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/7/2007 12:48'!
basicKeyPressed: aChar 
	| oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionText |
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	max := self maximumSelection.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self getList copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self getList copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionText := nextSelectionList detect: [:a | a asString withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self flash"match not found"].
	(self enabled and: [model okToChange]) ifFalse: [^ self].
	nextSelection := self getList findFirst: [:a | a == nextSelectionText].
	"No change if model is locked or receiver disabled"
	oldSelection == nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 12:42'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme listNormalBorderStyleFor: self]
		ifFalse: [self theme listDisabledBorderStyleFor: self]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 13:34'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/17/2007 15:22'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enabled
	"Answer the enablement state of the receiver."

	^self valueOfProperty: #enabled ifAbsent: [true]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enabled: aBoolean
	"Set the enablement state of the receiver."

	aBoolean = self enabled
		ifFalse: [self setProperty: #enabled toValue: aBoolean.
				self
					adoptPaneColor: self paneColor;
					changed]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 12:39'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme listNormalFillStyleFor: self]
		ifFalse: [self theme listDisabledFillStyleFor: self]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 11:47'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^self valueOfProperty: #getEnabledSelector! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 11:46'!
getEnabledSelector: aSymbol
	"Set the value of getEnabledSelector"

	self setProperty: #getEnabledSelector toValue: aSymbol.
	self updateEnabled! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 14:52'!
handleFocusEvent: anEvent
	"Handle the given event. This message is sent if the receiver currently has the focus and is therefore receiving events directly from some hand."
	
	self processEvent: anEvent. "give submorphs a chance"
	(anEvent isMouse and: [anEvent isMouseDown and: [(self fullContainsPoint: anEvent position) not]])
		ifFalse: [^super handleFocusEvent: anEvent].
	"click outside - pass to event handler"
	self eventHandler
		ifNotNil: [self eventHandler mouseDown: anEvent fromMorph: self]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/12/2006 14:23'!
handlesMouseOverDragging: evt
	"Yes, for mouse down highlight."
	
	^true! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/11/2007 15:17'!
keyStroke: event 
	"Process keys 
	specialKeys are things like up, down, etc. ALWAYS HANDLED 
	modifierKeys are regular characters either 1) accompanied with ctrl, 
	cmd or 2) any character if the list doesn't want to handle basic 
	keys (handlesBasicKeys returns false) 
	basicKeys are any characters"
	| aChar aSpecialKey |
	(self scrollByKeyboard: event) ifTrue: [^self].
	(self navigationKey: event) ifTrue: [^self].
	aChar := event keyCharacter.
	aSpecialKey := aChar asciiValue.
	aSpecialKey < 32 ifTrue: [^ self specialKeyPressed: aSpecialKey].
	(event anyModifierKeyPressed or: [self handlesBasicKeys not])
		ifTrue: [^ self modifierKeyPressed: aChar].
	^ self basicKeyPressed: aChar! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/11/2007 14:45'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/27/2006 11:51'!
maximumSelection
	"If we have a list use it for performance."
	
	list ifNotNil: [^list size].
	^self getListSize! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/20/2006 13:15'!
mouseDown: evt
	| selectors row |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	evt hand newKeyboardFocus: self.
	row := self rowAtLocation: evt position.
	row = 0  ifTrue: [^super mouseDown: evt].
	self mouseDownRow: row.
	selectors := Array 
		with: #click:
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 "pixels".! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/20/2006 10:24'!
mouseDownRow
	"Answer the mouse down row or nil if none."

	^self listMorph mouseDownRow! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/20/2006 10:24'!
mouseDownRow: anIntegerOrNil
	"Set the mouse down row or nil if none."

	self listMorph mouseDownRow: anIntegerOrNil! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/4/2007 11:55'!
mouseEnter: event
	"Changed to take mouseClickForKeyboardFocus preference into account."
	
	super mouseEnter: event.
	Preferences mouseClickForKeyboardFocus
		ifFalse: [event hand newKeyboardFocus: self]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/17/2006 09:46'!
mouseEnterDragging: evt
	"The mouse has entered with a button down.
	Workaround for apparent flaw in MouseOverHandler constantly
	sending this message when dragging."
	
	|row oldPDR|
	row := self rowAtLocation: evt position.
	(self dragEnabled or: [evt hand hasSubmorphs]) ifFalse: [
		self listMorph mouseDownRow: row].
	(evt hand hasSubmorphs and:[self dropEnabled]) ifFalse: ["no d&d"
		^super mouseEnterDragging: evt].
	potentialDropRow = row ifTrue: [^self].
	oldPDR := potentialDropRow.
	potentialDropRow := row.
	evt hand newMouseFocus: self.
	"above is ugly but necessary for now"
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt )
		ifTrue: [self changed]
		ifFalse: [(oldPDR ifNil: [0]) > 0
				ifTrue: [self resetPotentialDropRow]
				ifFalse: [potentialDropRow := 0]]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/27/2006 16:49'!
mouseLeave: event

	super mouseLeave: event! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/12/2006 15:28'!
mouseLeaveDragging: anEvent
	"The mouse has left with a button down."
	
	(self dragEnabled or: [anEvent hand hasSubmorphs]) ifFalse: [
		self listMorph mouseDownRow: nil].
	(self dropEnabled and: [anEvent hand hasSubmorphs]) ifFalse: ["no d&d"
		^super mouseLeaveDragging: anEvent].
	self resetPotentialDropRow.
	anEvent hand releaseMouseFocus: self.
	"above is ugly but necessary for now"! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/16/2006 13:25'!
mouseMove: evt
	"The mouse has moved with a button down."

	|row|
	row := self rowAtLocation: evt position.
	evt hand hasSubmorphs ifFalse: [
		(self containsPoint: evt position) 
			ifTrue: [self mouseDownRow: row]
			ifFalse: [self mouseDownRow: nil]].
	(self dropEnabled and:[evt hand hasSubmorphs]) 
		ifFalse: [^self eventHandler ifNotNil:
				[self eventHandler mouseMove: evt fromMorph: self]].
	(self containsPoint: evt position) 
		ifTrue: [self mouseEnterDragging: evt]
		ifFalse: [self mouseLeaveDragging: evt]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/7/2007 12:45'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	
	| row mdr |
	row := self rowAtLocation: event position.
	event hand hasSubmorphs ifFalse: [
		mdr := self mouseDownRow.
		 self mouseDownRow: nil.
		mdr ifNil: [^self]].
	(self enabled and: [model okToChange])
		ifFalse: [^ self].
	"No change if model is locked or receiver disabled"
	row == self selectionIndex
		ifTrue: [(autoDeselect ifNil: [true]) ifTrue:[row == 0 ifFalse: [self changeModelSelection: 0] ]]
		ifFalse: [self changeModelSelection: row].
	Cursor normal show! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/17/2007 17:22'!
optimalExtent
	"Answer the extent of the list morph."

	^self listMorph extent + (self borderWidth * 2) + self scrollbarThickness! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/19/2006 17:22'!
roundedCorners
	"Answer the corners to round."

	^self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners] ! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/8/2007 16:54'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/12/2006 13:55'!
selectionColor
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColor ifAbsent: [] ! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 11:36'!
selectionColor: aColor
	"Set the colour for selected items."

	|w|
	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	w := self ownerThatIsA: SystemWindow.
	self selectionColorToUse: ((w isNil or: [w isActive])
		ifTrue: [aColor]
		ifFalse: [self paneColor lighter])! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/12/2006 14:36'!
selectionColorToUse
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColorToUse ifAbsent: [] ! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 11:44'!
selectionColorToUse: aColor
	"Set the colour for selected items."

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].
	self listMorph selectionFrameChanged! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/4/2006 15:02'!
selectionIndex: index
	"Called internally to select the index-th item."
	| row |
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self maximumSelection.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 8/7/2007 12:48'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ ActiveEvent shiftPressed
			ifTrue:
				[ActiveWorld putUpWorldMenuFromEscapeKey]
			ifFalse:
				[self yellowButtonActivity: false]].

	max := self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		nextSelection := oldSelection + 1.
		nextSelection > max ifTrue: [nextSelection := 1]].
	asciiValue = 30 ifTrue: 
		[" up arrow"
		nextSelection := oldSelection - 1.
		nextSelection < 1 ifTrue: [nextSelection := max]].
	asciiValue = 1 ifTrue:
		[" home"
		nextSelection := 1].
	asciiValue = 4 ifTrue:
		[" end"
		nextSelection := max].
	howManyItemsShowing := self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		nextSelection := 1 max: oldSelection - howManyItemsShowing].
	asciiValue = 12 ifTrue:
		[" page down"
		nextSelection := oldSelection + howManyItemsShowing min: max].
	(self enabled and: [model okToChange]) ifFalse: [^ self].
	"No change if model is locked"
	oldSelection = nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/20/2006 10:24'!
startDrag: evt 
	|row ddm draggedItem draggedItemMorph passenger |
	evt hand hasSubmorphs
		ifTrue: [^ self].
	(self dragEnabled
			and: [model okToChange])
		ifFalse: [^ self].
	row := self mouseDownRow.
	row ifNil: [^self].
	(draggedItem := self getListItem: row)
		ifNil: [^ self].
	draggedItemMorph := StringMorph contents: draggedItem asStringOrText.
	passenger := self model dragPassengerFor: draggedItemMorph inMorph: self.
	passenger
		ifNil: [^ self].
	self listMorph mouseDownRow: nil.
	ddm := TransferMorph withPassenger: passenger from: self.
	ddm
		dragTransferType: (self model dragTransferTypeForMorph: self).
	[Preferences dragNDropWithAnimation
		ifTrue: [self model dragAnimationFor: draggedItemMorph transferMorph: ddm].
	evt hand grabMorph: ddm]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 1/11/2007 14:06'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/22/2007 14:48'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 8/7/2007 11:46'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 10/19/2006 15:24'!
vExtraScrollRange
	"Return the amount of extra blank space to include below the bottom of the scroll content."

	^8
! !

!PluggableListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/13/2007 11:35'!
verifyContents
	"Verify the contents of the receiver, reconstituting if necessary.  Called whenever window is reactivated, to react to possible structural changes.  Also called periodically in morphic if the smartUpdating preference is true"
	| newList existingSelection oldList |
	oldList := list ifNil: [ #() ].
	newList := self getList.
	((oldList == newList) "fastest" or: [oldList = newList]) ifTrue: [^ self].
	existingSelection := oldList isEmpty
		ifTrue: [self listMorph selectedRow]
		ifFalse: [(self selectionIndex between: 1 and: newList size)
					ifTrue: [self selectionIndex]
					ifFalse: [nil]].
	self updateList.
	existingSelection notNil
		ifTrue:
			[model noteSelectionIndex: existingSelection for: getListSelector.
			self selectionIndex: existingSelection]
		ifFalse:
			[self changeModelSelection: 0]! !

PluggableListMorph subclass: #PluggableMorphListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableMorphListMorph commentStamp: 'gvc 5/18/2007 12:30' prior: 0!
A type of PluggableListMorph that supports morphs for items. Useful for lists with icons etc.!

PluggableMorphListMorph subclass: #PluggableIconListMorph
	instanceVariableNames: 'getIconSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!PluggableIconListMorph commentStamp: 'gvc 5/18/2007 12:31' prior: 0!
A type of PluggableListMorph that supports a single icon (Form) for items. Useful for lists with icons.!

!PluggableIconListMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:56'!
getIconSelector
	"Answer the value of getIconSelector"

	^ getIconSelector! !

!PluggableIconListMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:56'!
getIconSelector: anObject
	"Set the value of getIconSelector"

	getIconSelector := anObject! !

!PluggableIconListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 17:52'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector == nil ifTrue: [^ #()].
	list := model perform: getListSelector.
	list == nil ifTrue: [^ #()].
	list := list collect: [ :item | self itemMorphFor: item].
	^ list! !

!PluggableIconListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 17:51'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^self itemMorphFor: (model perform: getListElementSelector with: index)].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^self getList at: index! !

!PluggableIconListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 18:04'!
itemMorphFor: anObject
	"Answer a morph for the object with the appropriate icon."

	|item icon|
	item := RectangleMorph new
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #center;
		cellInset: 2;
		borderWidth: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 20@16.
	icon := self getIconSelector ifNotNil: [self model perform: self getIconSelector withEnoughArguments: {anObject}].
	icon ifNotNil: [
		item addMorphBack: (ImageMorph new newForm: icon)].
	item addMorphBack: (StringMorph contents: anObject asStringOrText).
	^item! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 15:46'!
basicKeyPressed: aChar 
	| oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionText s|
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	max := self maximumSelection.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (list copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (list copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionText := nextSelectionList detect: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		s withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self flash"match not found"].
	model okToChange ifFalse: [^ self].
	nextSelection := list findFirst: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		a == nextSelectionText].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:23'!
extent: newExtent
	"Change listMorph's bounds to the new width. It is either the size
	of the widest list item, or the size of self, whatever is bigger"

	super extent: newExtent.
	self listMorph width: (self innerBounds width max: listMorph hUnadjustedScrollRange). 
! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 10:37'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector == nil ifTrue: [^ #()].
	list := model perform: getListSelector.
	list == nil ifTrue: [^ #()].
	^ list! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:26'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^model perform: getListElementSelector with: index].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^self getList at: index! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:24'!
hExtraScrollRange
	"Return the amount of extra blank space to include to the right of the scroll content."

	^12! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 09:50'!
listMorphClass
	"Answer the class to use for the list morph."

	^LazyMorphListMorph! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/26/2007 10:22'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/22/2007 14:29'!
bottomBoundary
	"Answer the bottom boundary position by calculating the minimum
	of the minimum heights of the bottom morphs."
	
	|morphs|
	morphs := rightOrBottom reject: [:m |
		m layoutFrame bottomFraction ~= 1 and: [
			m layoutFrame topFraction = m layoutFrame bottomFraction]].
	morphs ifEmpty: [
		^(self splitterBelow
			ifNil: [self containingWindow panelRect bottom]
			ifNotNil: [self splitterBelow top]) - 25].
	^(morphs collect: [:m |
		m bottom - m minExtent y -
			(m layoutFrame topOffset ifNil: [0]) +
			(self layoutFrame bottomOffset ifNil: [0])]) min - self class splitterWidth! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hasLeftOrTop: aMorph
	"Answer whether the reciver has the given morph
	as one of of its left or top morphs."

	^leftOrTop includes: aMorph! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hasRightOrBottom: aMorph
	"Answer whether the reciver has the given morph
	as one of of its right or bottom morphs."

	^rightOrBottom includes: aMorph! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:40'!
hideLeftOrTop
	"Hide the receiver and all left or top morphs."

	self hide.
	leftOrTop do: [:m | m hide]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hideRightOrBottom
	"Hide the receiver and all right or bottom morphs."

	self hide.
	rightOrBottom do: [:m | m hide]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/19/2007 17:17'!
leftBoundary
	"Answer the left boundary position by calculating the minimum
	of the minimum widths of the left morphs."
	
	|morphs|
	morphs _ leftOrTop reject: [:m |
		m layoutFrame leftFraction ~= 0 and: [
			m layoutFrame leftFraction = m layoutFrame rightFraction]].
	morphs ifEmpty: [
		^(self splitterLeft
			ifNil: [self containingWindow panelRect left]
			ifNotNilDo: [:s | s self]) + 25].
	^(morphs collect: [:m |
		m left + m minExtent x +
			(self layoutFrame leftOffset ifNil: [0]) -
			(m layoutFrame rightOffset ifNil: [0])]) max! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/15/2007 11:27'!
mouseDown: anEvent 
	"A mouse button has been pressed.
	Update the color for feedback and store the mouse
	position and relative offset to the receiver."
	
	|cp|
	(self class showSplitterHandles not
			and: [self bounds containsPoint: anEvent cursorPoint])
		ifTrue: [oldColor := self color.
			self setGrabbedColor].
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position}! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 9/25/2006 11:57'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].
	self adoptPaneColor: self paneColor! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme splitterNormalFillStyleFor: self! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 11/10/2006 11:36'!
noteNewOwner: o
	"Update the fill style."
	
	super noteNewOwner: o.
	WorldState addDeferredUIMessage: [self adoptPaneColor: self paneColor]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/14/2007 13:32'!
overlapsHorizontal: aSplitter
	"Answer whether the receiver overlaps the given spiltter
	in the horizontal plane."

	^aSplitter left <= self right and: [aSplitter right >= self left]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 6/14/2007 13:32'!
overlapsVertical: aSplitter
	"Answer whether the receiver overlaps the given spiltter
	in the vertical plane."

	^aSplitter top <= self bottom and: [aSplitter bottom >= self top]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:55'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme splitterPressedFillStyleFor: self! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/22/2007 14:29'!
rightBoundary
	"Answer the right boundary position by calculating the minimum
	of the minimum widths of the right morphs."
	
	|morphs|
	morphs := rightOrBottom reject: [:m |
		m layoutFrame rightFraction ~= 1 and: [
			m layoutFrame leftFraction = m layoutFrame rightFraction]].
	morphs ifEmpty: [
		^(self splitterRight
			ifNil: [self containingWindow panelRect right]
			ifNotNilDo: [:s | s left]) + 25].
	^(morphs collect: [:m |
		m right - m minExtent x -
			(m layoutFrame leftOffset ifNil: [0]) +
			(self layoutFrame rightOffset ifNil: [0])]) min - self class splitterWidth! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/26/2007 10:21'!
setGrabbedColor
	"Set the color of the receiver when it is grabbed."
	
	self fillStyle: self pressedFillStyle! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:40'!
showLeftOrTop
	"Show the receiver and all left or top morphs."

	self show.
	leftOrTop do: [:m | m show]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 5/9/2007 10:47'!
showRightOrBottom
	"Show the receiver and all right or bottom morphs."

	self show.
	rightOrBottom do: [:m | m show]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 13:36'!
splitterAbove
	"Answer the splitter above the receiver that overlaps in its horizontal range."
	
	|splitters|
	splitters := ((self siblingSplitters select: [:each |
		each y > self y and: [self overlapsHorizontal: each]]) asSortedCollection: [:a :b | a y < b y]).
	^splitters ifNotEmpty: [splitters first]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 13:36'!
splitterBelow
	"Answer the splitter below the receiver that overlaps in its horizontal range."

	|splitters|
	splitters := ((self siblingSplitters select: [:each |
		each y < self y and: [self overlapsHorizontal: each]]) asSortedCollection: [:a :b | a y > b y]).
	^splitters ifNotEmpty: [splitters first]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 13:34'!
splitterLeft
	"Answer the splitter to the left of the receiver that overlaps in its vertical range."
	
	|splitters|
	splitters := ((self siblingSplitters select: [:each |
		each x < self x and: [self overlapsVertical: each]]) asSortedCollection: [:a :b | a x > b x]).
	^splitters ifNotEmpty: [splitters first]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/14/2007 13:34'!
splitterRight
	"Answer the splitter to the right of the receiver that overlaps in its vertical range."
	
	|splitters|
	splitters := ((self siblingSplitters select: [:each |
		each x > self x and: [self overlapsVertical: each]]) asSortedCollection: [:a :b | a x < b x]).
	^splitters ifNotEmpty: [splitters first]! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/19/2007 17:18'!
topBoundary
	"Answer the top boundary position by calculating the minimum
	of the minimum heights of the top morphs."
	
	|morphs|
	morphs _ leftOrTop reject: [:m |
		m layoutFrame topFraction ~= 0 and: [
			m layoutFrame topFraction = m layoutFrame bottomFraction]].
	morphs ifEmpty: [
		^(self splitterAbove
			ifNil: [self containingWindow panelRect top]
			ifNotNilDo: [:s | s top]) + 25].
	^(morphs collect: [:m |
		m top + m minExtent y +
			(self layoutFrame topOffset ifNil: [0]) -
			(m layoutFrame bottomOffset ifNil: [0])]) max! !

!ProportionalSplitterMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/15/2007 12:39'!
updateFromEvent: anEvent
	"Update the splitter and attached morph positions from the mouse event.
	Take into account the mouse down offset."
	
	|pNew pOld delta firstRight firstBottom secondLeft secondTop selfTop selfBottom selfLeft selfRight|
	pNew := anEvent cursorPoint - lastMouse second.
	pOld := lastMouse first - lastMouse second.
	delta := splitsTopAndBottom
		ifTrue: [0 @ ((self normalizedY: pNew y) - pOld y)]
		ifFalse: [(self normalizedX: pNew x) - pOld x @ 0].
	lastMouse at: 1 put: (splitsTopAndBottom
		ifTrue: [pNew x @ (self normalizedY: pNew y) + lastMouse second]
		ifFalse: [(self normalizedX: pNew x) @ pNew y + lastMouse second]).
	leftOrTop do: [:each | 
		firstRight := each layoutFrame rightOffset
					ifNil: [0].
		firstBottom := each layoutFrame bottomOffset
					ifNil: [0].
		each layoutFrame rightOffset: firstRight + delta x.
		each layoutFrame bottomOffset: firstBottom + delta y.
		(each layoutFrame leftFraction = each layoutFrame rightFraction and: [
				each layoutFrame leftFraction ~= 0]) "manual splitter"
			ifTrue: [each layoutFrame leftOffset: (each layoutFrame leftOffset ifNil: [0]) + delta x].
		(each layoutFrame topFraction = each layoutFrame bottomFraction and: [
				each layoutFrame topFraction ~= 0]) "manual splitter"
			ifTrue: [each layoutFrame topOffset: (each layoutFrame topOffset ifNil: [0]) + delta y]].
	rightOrBottom do: [:each | 
		secondLeft := each layoutFrame leftOffset
					ifNil: [0].
		secondTop := each layoutFrame topOffset
					ifNil: [0].
		each layoutFrame leftOffset: secondLeft + delta x.
		each layoutFrame topOffset: secondTop + delta y.
		(each layoutFrame leftFraction = each layoutFrame rightFraction and: [
				each layoutFrame rightFraction ~= 1]) "manual splitter"
			ifTrue: [each layoutFrame rightOffset: (each layoutFrame rightOffset ifNil: [0]) + delta x].
		(each layoutFrame topFraction = each layoutFrame bottomFraction and: [
				each layoutFrame bottomFraction ~= 1]) "manual splitter"
			ifTrue: [each layoutFrame bottomOffset: (each layoutFrame bottomOffset ifNil: [0]) + delta y]].
	selfTop := self layoutFrame topOffset ifNil: [0].
	selfBottom := self layoutFrame bottomOffset ifNil: [0].
	selfLeft := self layoutFrame leftOffset ifNil: [0].
	selfRight := self layoutFrame rightOffset ifNil: [0].
	self layoutFrame topOffset: selfTop + delta y.
	self layoutFrame bottomOffset: selfBottom + delta y.
	self layoutFrame leftOffset: selfLeft + delta x.
	self layoutFrame rightOffset: selfRight + delta x.
	self owner layoutChanged! !

!GradientFillStyle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:22'!
= anGradientFillStyle
	"Answer whether equal."

	^super = anGradientFillStyle
		and: [self pixelRamp == anGradientFillStyle pixelRamp] "LRU should make identity equal"! !

!GradientFillStyle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:22'!
hash
	"Hash is implemented because #= is implemented."
	
	^super hash bitXor: self pixelRamp hash! !

GradientFillStyle subclass: #InterpolatedGradientFillStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!InterpolatedGradientFillStyle commentStamp: 'gvc 5/18/2007 12:49' prior: 0!
Gradient fill style that uses proper alpha-aware interpolation.!

!InterpolatedGradientFillStyle methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:49'!
computePixelRampOfSize: length
	"Compute the pixel ramp in the receiver."
	
	| bits lastColor lastIndex nextIndex nextColor distance theta ramp step lastWord nextWord |
	ramp := colorRamp asSortedCollection:[:a1 :a2| a1 key < a2 key].
	bits := Bitmap new: length.
	lastColor := ramp first value.
	lastWord := lastColor pixelWord32.
	lastIndex := 0.
	ramp do:[:assoc|
		nextIndex := (assoc key * length) rounded.
		nextColor := assoc value.
		nextWord := nextColor pixelWord32.
		distance := nextIndex - lastIndex.
		distance = 0 ifTrue: [distance := 1].
		step := 1.0 / distance.
		theta := 0.0.
		lastIndex+1 to: nextIndex do: [:i|
			theta := theta + step.
			bits at: i put: (self interpolatedAlphaMix: theta of: lastWord and: nextWord)].
		lastIndex := nextIndex.
		lastColor := nextColor.
		lastWord := nextWord].
	lastIndex+1 to: length do: [:i| bits at: i put: lastWord].
	^bits! !

!InterpolatedGradientFillStyle methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:48'!
interpolatedAlphaMix: ratio of: rgba1 and: rgba2
	"Answer a proper interpolated value between two RGBA color words.
	Theta is 0..1.."

	| a1 a2 ra ira rgb1 rgb2 alpha br1 br2 bg1 bg2 bb1 bb2 result |
	a1 := rgba1 bitShift: -24. a2 := rgba2 bitShift: -24.
	alpha := ratio * (a2 - a1) + a1.
	ra := ratio * alpha.
	ira := (1.0 - ratio) * alpha.
	rgb1 := rgba1 bitAnd: 16rFFFFFF. rgb2 := rgba2 bitAnd: 16rFFFFFF.
	br1 := (rgb1 bitAnd: 255). br2 := (rgb2 bitAnd: 255).
	bg1 := ((rgb1 bitShift:  -8) bitAnd: 255). bg2 := ((rgb2 bitShift: -8) bitAnd: 255).
	bb1 := ((rgb1 bitShift: -16) bitAnd: 255). bb2 := ((rgb2 bitShift: -16) bitAnd: 255).
	result :=  (ra * br2 + (ira * br1)) rounded // 255.
	result :=  result bitOr: ((ra * bg2 + (ira * bg1)) rounded // 255 bitShift: 8).
	result :=  result bitOr: ((ra * bb2 + (ira * bb1)) rounded // 255 bitShift: 16).
	^result bitOr: (alpha rounded bitShift: 24)! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 16:14'!
currentWindow
	"Answer the top window."

	^SystemWindow topWindow! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/12/2007 17:06'!
handlerForMouseDown: anEvent
	"If we have a modal dialog then answer nil otherwise as usual.."
	
	^(self hasProperty: #submorphLockStates)
		ifFalse: [super handlerForMouseDown: anEvent]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/12/2007 16:57'!
modalLockTo: aSystemWindow
	"Don't lock the world!! Lock the submorphs.
	The modal window gets opened afterwards so is OK."
	
	|lockStates|
	lockStates _ IdentityDictionary new.
	self submorphsDo: [:m |
		lockStates at: m put: m isLocked.
		m lock].
	self
		setProperty: #submorphLockStates
		toValue: lockStates! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 1/12/2007 17:01'!
modalUnlockFrom: aSystemWindow
	"Don't unlock the world!! Unlock the submorphs
	that were not originally locked."
	
	|lockStates|
	lockStates := self
		valueOfProperty: #submorphLockStates
		ifAbsent: [^self].
	self removeProperty: #submorphLockStates.
	lockStates keysAndValuesDo: [:m :locked |
		locked ifFalse: [m unlock]]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/20/2007 14:46'!
navigateWindowBackward
	"Change the active window to the previous window."

	self previousWindow ifNotNilDo: [:m |
		m isCollapsed ifTrue: [m collapseOrExpand].
		m activate]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/4/2007 12:59'!
navigateWindowForward
	"Change the active window to the next window."

	self nextWindow ifNotNilDo: [:m |
		self currentWindow ifNotNilDo: [:w | w sendToBack].
		m isCollapsed ifTrue: [m collapseOrExpand].
		m activate]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/30/2007 15:53'!
navigationKey: event
	"Check for active window navigation."
	
	(event commandKeyPressed and: [event shiftPressed not]) ifTrue: [
		(UITheme current openTasklist: event) ifTrue: [^true].
		event keyCharacter = Character arrowLeft
			ifTrue: [self navigateWindowBackward. 
					^true].
		event keyCharacter = Character arrowRight
			ifTrue: [self navigateWindowForward. 
					^true]].
	^false! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 16:18'!
nextWindow
	"Answer the next window to navigate to."

	|sys|
	sys := self systemWindows.
	sys ifEmpty: [^nil].
	^sys after: self currentWindow ifAbsent: [sys first]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 16:18'!
previousWindow
	"Answer the previous window to navigate to."

	|sys|
	sys := self systemWindows.
	sys ifEmpty: [^nil].
	^sys before: self currentWindow ifAbsent: [sys last]! !

!PasteUpMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/18/2007 14:36'!
systemWindows
	"Answer the system windows in the world."
	
	^self submorphsSatisfying: [:m | m isSystemWindow]! !

ImageMorph subclass: #AlphaImageMorph
	instanceVariableNames: 'alpha cachedForm layout scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!AlphaImageMorph commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
Displays an image with the specified alpha value (translucency) and optional scale and layout (scaled, top-right etc.).!

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/26/2006 09:40'!
alpha
	"Answer the value of alpha"

	^ alpha! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:34'!
alpha: anObject
	"Set the value of alpha"

	alpha := anObject.
	self
		cachedForm: nil;
		changed;
		changed: #alpha! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 3/26/2007 14:52'!
cachedForm
	"Answer the value of cachedForm"
	
	|form i|
	cachedForm ifNil: [
		i := self image.
		self layout == #scaled
			ifTrue: [self extent = i extent
						ifFalse: [i := i magnify: i boundingBox by: (self extent / i extent) smoothing: 2]]
			ifFalse: [self scale ~= 1
					ifTrue: [i := i magnify: i boundingBox by: self scale smoothing: 2]].
		self alpha = 1.0
		ifTrue: [self cachedForm: i]
		ifFalse: [form := Form extent: i extent depth: 32.
				form fillColor: (Color white alpha: 0.003922).
				(form getCanvas asAlphaBlendingCanvas: self alpha)
					drawImage: i
				at: 0@0.
				self cachedForm: form]].
	^cachedForm! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/27/2006 15:02'!
cachedForm: anObject
	"Set the value of cachedForm"

	cachedForm := anObject! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/26/2006 12:40'!
defaultColor
	"Answer the default color for the receiver."

	^Color transparent! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 16:25'!
drawOn: aCanvas
	"Draw with the current alpha
	Can't do simple way since BitBlt rules are dodgy!!."
	
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	(self cachedForm width = 0 or: [self cachedForm height = 0]) ifTrue: [^self].
	self layout == #tiled
		ifTrue: [aCanvas fillRectangle: self innerBounds fillStyle: (AlphaInfiniteForm with: self cachedForm)]
		ifFalse: [aCanvas clipBy: self innerBounds during: [:c |
					c translucentImage: self cachedForm at: self layoutPosition]]! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:02'!
extent: aPoint
	"Allow as normal."
	
	self perform: #extent: withArguments: {aPoint} inSuperclass: Morph
! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/28/2006 14:15'!
image: anImage 
	"Clear the cached form."
	
	^self image: anImage size: anImage extent! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 13:08'!
image: aForm size: aPoint
	"Set the image to be the form scaled to the given size and padded if neccesary."

	|f f2|
	f := aForm scaledToSize: aPoint.
	f2 := Form extent: aPoint depth: 32.
	f2 fillColor: (Color white alpha: 0.003922).
	f2 getCanvas translucentImage: f at: 0@0.
	f depth < 32
		ifTrue: [f2 fixAlpha].
	self cachedForm: nil.
	super image: f2.
	self extent: aPoint + (self borderWidth * 2)! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:45'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scale: 1.0;
		layout: #topLeft;
		alpha: 1.0! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:00'!
layout
	"Answer the value of layout"

	^ layout! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:28'!
layout: aSymbol
	"Set the value of layout"

	|old|
	(old := layout) = aSymbol ifTrue: [^self].
	layout := aSymbol.
	(old = #scaled or: [aSymbol = #scaled])
		ifTrue: [self cachedForm: nil].
	self changed! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 16:09'!
layoutPosition
	"Answer the position that the cached form should be drawn
	based on the layout"
	
	self layout == #topCenter ifTrue: [^self innerBounds topCenter - (self cachedForm width // 2 @ 0)].
	self layout == #topRight ifTrue: [^self innerBounds topRight - (self cachedForm width @ 0)].
	self layout == #rightCenter ifTrue: [^self innerBounds rightCenter - (self cachedForm width @ (self cachedForm height // 2))].
	self layout == #bottomRight ifTrue: [^self innerBounds bottomRight - self cachedForm extent].
	self layout == #bottomCenter ifTrue: [^self innerBounds bottomCenter - (self cachedForm width // 2 @ self cachedForm height)].
	self layout == #bottomLeft ifTrue: [^self innerBounds bottomLeft - (0 @ self cachedForm height)].
	self layout == #leftCenter ifTrue: [^self innerBounds leftCenter - (0 @ (self cachedForm height // 2))].
	self layout == #center ifTrue: [^self innerBounds center - (self cachedForm extent // 2)].
	^self innerBounds topLeft! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 16:10'!
layoutSymbols
	"Answer the available layout options."

	^#(#center #tiled #scaled
		#topLeft #topCenter #topRight #rightCenter
		#bottomRight #bottomCenter #bottomLeft #leftCenter)! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 5/8/2007 09:58'!
optimalExtent
	"Answer the optimal extent for the receiver."
	
	^self image extent + (self borderWidth * 2)! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:43'!
scale
	"Answer the value of scale"

	^ scale! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:34'!
scale: aNumber
	"Set the value of scale"

	scale = aNumber ifTrue: [^self].
	scale := aNumber.
	self
		cachedForm: nil;
		changed;
		changed: #scale! !

!ImageMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/25/2006 15:45'!
adoptPaneColor: paneColor
	"Change our border color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderStyle baseColor: paneColor twiceDarker! !

!ImageMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 4/18/2007 11:52'!
drawOn: aCanvas
	"Draw the border after the image."
	
	| style |
	self isOpaque
		ifTrue:[aCanvas drawImage: image at: self innerBounds origin]
		ifFalse:[aCanvas translucentImage: image at: self innerBounds origin].
	(style := self borderStyle) ifNotNil:[
		style frameRectangle: bounds on: aCanvas]! !

!ImageMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 11/14/2006 14:18'!
image: anImage 
	"Fixed to take account of border width."
	
	image := anImage depth = 1 
				ifTrue: [ColorForm mappingWhiteToTransparentFrom: anImage]
				ifFalse: [anImage]. 
	super extent: 2 * self borderWidth + image extent.
	self changed! !

!PreferencesPanel class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:52'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallDoItIcon! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/11/2006 13:45'!
colorForRow: row
	"Answer the color for the row text."
	
	^self color! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 6/22/2007 10:09'!
display: item  atRow: row on: aCanvas
	"Display the given item at the given row on the given canvas."
	
	| c drawBounds frame attrs useDefaultFont|
	drawBounds := self drawBoundsForRow: row.
	c := self colorForRow: row.
	item isText
		ifTrue: [|f col itemBounds|
				attrs := item attributesAt: 1 forStyle: TextStyle default.
				useDefaultFont := true.
				attrs do: [:att | att forFontInStyle: TextStyle default do: [:fon | useDefaultFont := false]].
				f := useDefaultFont
					ifTrue: [self font]
					ifFalse: [item fontAt: 1 withStyle: TextStyle default].
				col := (item attributesAt: 1) detect: [:a | a isKindOf: TextColor] ifNone: [].
				col ifNotNil: [c := col color].
				itemBounds := drawBounds withHeight: f height.
				itemBounds := itemBounds align: itemBounds leftCenter with: drawBounds leftCenter.
					"centre the item if the font height is different to that of our font"
				aCanvas drawString: item in: itemBounds font: (f emphasized: (item emphasisAt: 1)) color: c]
		ifFalse: [aCanvas drawString: item in: drawBounds font: self font color: c].
	row = ((self respondsTo: #mouseDownRow) "check since MC doesn't manage an atomic load!!"
			ifTrue: [self mouseDownRow])
		ifTrue: [frame := self selectionFrameForRow: row.
				aCanvas 
					frameRectangle: frame
					width: 1
					colors: {c. Color transparent}
					 dashes: #(1 1)]! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 10/12/2006 14:36'!
drawSelectionOn: aCanvas
	"Draw the selection background."
	
	| frame |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	frame := self selectionFrameForRow: selectedRow.
	aCanvas
		fillRectangle: frame
		color: (listSource selectionColorToUse ifNil: [Preferences textHighlightColor])! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 11:21'!
mouseDownRow
	"Answer the row that should have mouse down highlighting if any."

	^self valueOfProperty: #mouseDownRow! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 13:06'!
mouseDownRow: anInteger
	"Set the row that should have mouse down highlighting or nil if none."

	anInteger = self mouseDownRow ifTrue: [^self].
	self mouseDownRowFrameChanged.
	self setProperty: #mouseDownRow toValue: anInteger.
	self mouseDownRowFrameChanged! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 13:06'!
mouseDownRowFrameChanged
	"Invalidate frame of the current mouse down row if any."
	
	|frame row|
	row _ self mouseDownRow ifNil: [ ^self ].
	frame := self selectionFrameForRow: row.
	self invalidRect: frame! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 11:45'!
selectRow: index
	"Select the index-th row."
	
	selectedRows add: index.
	self invalidRect: (self selectionFrameForRow: index)! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 11:46'!
selectedRow: index
	"Select the index-th row.  if nil, remove the current selection."
	
	selectedRow ifNotNil: [self selectionFrameChanged].
	selectedRow := index.
	selectedRow ifNotNil: [self selectionFrameChanged]! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 11:44'!
selectionFrameChanged
	"Invalidate frame of the current selection if any."
	
	| frame |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	frame := self selectionFrameForRow: selectedRow.
	self invalidRect: frame! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 9/12/2006 15:33'!
selectionFrameForRow: row
	"Answer the selection frame rectangle."

	|frame|
	frame := self drawBoundsForRow: row.
	frame := frame intersect: self bounds.
	frame := self bounds: frame in: listSource.
	frame := self
		bounds: ((frame left: listSource innerBounds left) right: listSource innerBounds right)
		from: listSource.
	^frame! !

!LazyListMorph methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/24/2007 11:46'!
unselectRow: index
	"Unselect the index-th row."
	
	selectedRows remove: index ifAbsent: [^self].
	self invalidRect: (self selectionFrameForRow: index)! !

LazyListMorph subclass: #LazyMorphListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!LazyMorphListMorph commentStamp: 'gvc 5/18/2007 12:47' prior: 0!
Support for morph lists in PluggableMorphListMorph.!

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 13:38'!
adjustHeight
	"private.  Adjust our height to match the length of the underlying list.
	Automatic with table layout."
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/13/2006 11:12'!
adjustWidth
	"private.  Adjust our height to match the length of the underlying list"
	
	self width: (listSource innerBounds width max: self hUnadjustedScrollRange). ! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:14'!
display: item  atRow: row on: aCanvas
	"Display the given item at the given row on the given canvas."
	
	|c frame|
	row = self mouseDownRow ifFalse: [^self].
	frame := self selectionFrameForRow: row.
	c := self colorForRow: row.
	aCanvas 
		frameRectangle: frame
		width: 1
		colors: {c. Color transparent}
		 dashes: #(1 1)! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 16:08'!
drawBoundsForRow: row
	"Calculate the bounds that row should be drawn at.  This might be outside our bounds!!"
	
	(row between: 1 and: listItems size)
		ifFalse: [^0@0 corner: 0@0].
	^(listItems at: row) bounds! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:27'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front"

	|drawBlock i|
	submorphs isEmpty ifTrue: [^self].
	drawBlock := [:canvas |
		(self topVisibleRowForCanvas: aCanvas) to: (self bottomVisibleRowForCanvas: aCanvas) do: [ :row |
			i := self item: row.
			canvas fullDrawMorph: i]].
	self clipSubmorphs 
		ifTrue: [aCanvas clipBy: self clippingBounds during: drawBlock]
		ifFalse: [drawBlock value: aCanvas]! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 13:43'!
hUnadjustedScrollRange
	"Answer the width of the widest item."

	|maxW|
	maxW := 0.
	listItems do: 
		[ :each |
			each ifNotNil: 
				[maxW := maxW max: (self widthToDisplayItem: each)]].
	^maxW 
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/13/2006 10:44'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 2;
		vResizing: #shrinkWrap;
		hResizing: #rigid! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/13/2006 11:11'!
listChanged
	"set newList to be the list of strings to display"
	listItems := (1 to: self getListSize) collect: [:i |
		self getListItem: i].
	self removeAllMorphs.
	listItems do: [:i | self addMorphBack: i].
	selectedRow := nil.
	selectedRows := PluggableSet integerSet.
	self
		adjustHeight;
		adjustWidth.
	listItems do: [:i | i layoutChanged].
	self changed.
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 13:36'!
rowAtLocation: aPoint
	"return the number of the row at aPoint"

	| y |
	y := aPoint y.
	y < self top ifTrue: [ ^ 1 ].
	listItems with: (1 to: listItems size) do: [:i :row |
		(y < i bottom) ifTrue: [^row]].
	^listItems size! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 12:24'!
selectRow: index
	"select the index-th row"
	selectedRows add: index.
	self invalidRect: (self drawBoundsForRow: index)! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:33'!
selectionFrameForRow: row
	"Answer the selection frame rectangle."

	|frame|
	frame := self drawBoundsForRow: row.
	frame := frame expandBy: (self cellInset // 2).
	self cellInset odd ifTrue: [frame := frame bottom: frame bottom + 1].
	frame := frame intersect: self bounds.
	frame := self bounds: frame in: listSource.
	frame := self
		bounds: ((frame left: listSource innerBounds left) right: listSource innerBounds right)
		from: listSource.
	^frame! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/10/2006 09:42'!
userString
	"Do I have a text string to be searched on?"

	|usm|
	^ String streamContents: [:strm |
		1 to: self getListSize do: [:i |
			usm := (self getListItem: i) submorphs detect: [:m | m userString notNil] ifNone: [].
			strm nextPutAll: (usm ifNil: [''] ifNotNil: [usm userString]); cr]]! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 11:09'!
widthToDisplayItem: item

	^item minExtent x
	! !

!MCWorkingCopyBrowser class methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 4/17/2007 17:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^MenuIcons smallProjectIcon! !

!MorphicToolBuilder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 7/3/2007 13:16'!
setFrame: aRectangle in: widget
	"Updated to recognize real layout frames for flexibility."
	
	| frame |
	aRectangle ifNil: [^nil].
	frame := aRectangle isRectangle
		ifTrue: [self asFrame: aRectangle]
		ifFalse: [aRectangle]. "assume LayoutFrame"
	widget layoutFrame: frame.
	widget hResizing: #spaceFill; vResizing: #spaceFill.
	(parent isSystemWindow) ifTrue:[
		widget borderWidth: 2; borderColor: #inset]! !

MorphicModel subclass: #CheckboxMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'buttonMorph labelMorph setStateSelector getStateSelector enabled getEnabledSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!CheckboxMorph commentStamp: 'gvc 5/18/2007 13:47' prior: 0!
Checkbox with box button and label with enablement support.!

CheckboxMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!CheckboxMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 16:50'!
on: anObject selected: getSelectionSel changeSelected: setSelectionSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:38'!
beCheckbox
	"Change the button to be a checkbox."
	
	self buttonMorph beCheckbox! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:38'!
beRadioButton
	"Change the button to be a radio button."
	
	self buttonMorph beRadioButton! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
buttonMorph
	"Answer the value of buttonMorph"

	^ buttonMorph! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:11'!
buttonMorph: aMorph
	"Set the value of buttonMorph"

	buttonMorph ifNotNil: [
		self removeDependent: buttonMorph.
		buttonMorph delete].
	buttonMorph := aMorph.
	self
		addDependent: aMorph;
		addMorphFront: aMorph! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 11:38'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:04'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 11:38'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:06'!
enabled: aBoolean
	"Set the value of enabled"

	enabled := aBoolean.
	self labelMorph ifNotNilDo: [:m |
		(m respondsTo: #enabled:) ifTrue: [
			m enabled: aBoolean]].
	self buttonMorph ifNotNilDo: [:m | m enabled: aBoolean].
	self changed: #enabled! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 14:58'!
font
	"Answer the label font"

	^self labelMorph font! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 14:58'!
font: aFont
	"Set the label font"

	self labelMorph font: aFont! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:05'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 18:01'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
getStateSelector
	"Answer the value of getStateSelector"

	^ getStateSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 18:02'!
getStateSelector: anObject
	"Set the value of getStateSelector"

	getStateSelector := anObject.
	self updateSelection! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:20'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:11'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 2; "space for focus"
		borderColor: Color transparent;
		enabled: true;
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		cellInset: 8;
		buttonMorph: self newButtonMorph;
		labelMorph: self newLabelMorph;
		on: #mouseDown send: #updateButton: to: self;
		on: #mouseMove send: #updateButton: to: self;
		on: #mouseUp send: #updateButton: to: self! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 15:14'!
isSelected
	"Answer whether the receiver is selected."

	self model ifNil: [^false].
	^self model perform: (self getStateSelector ifNil: [^false])! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:11'!
keyStroke: event 
	"Process keys navigation and space to toggle."
	
	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character space
		ifTrue: [self toggleSelected]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:17'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:14'!
label
	"Answer the contents of the label morph."

	^(self labelMorph ifNil: [^'']) contents! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:13'!
label: aString
	"Set the contents of the label morph."

	self labelMorph contents: aString.
	self labelMorph: self newLabel! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:09'!
labelMorph: aMorph
	"Set the value of labelMorph"

	labelMorph ifNotNil: [labelMorph delete].
	labelMorph := aMorph.
	self addMorphBack: aMorph! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 18:03'!
newButtonMorph
	"Answer a new button morph"

	^CheckboxButtonMorph new
		target: self;
		actionSelector: #toggleSelected;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:13'!
newLabel
	"Answer a new label morph"

	^self theme checkboxLabelFor: self! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:14'!
newLabelMorph
	"Answer a new label morph"

	^self theme checkboxLabelFor: self! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 18:01'!
on: anObject selected: getSelectionSel changeSelected: setSelectionSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		model: anObject;
		getStateSelector: getSelectionSel;
		setStateSelector: setSelectionSel;
		updateSelection! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:00'!
setStateSelector
	"Answer the value of setStateSelector"

	^ setStateSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:00'!
setStateSelector: anObject
	"Set the value of setStateSelector"

	setStateSelector := anObject! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 12:28'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 14:35'!
toggleSelected
	"Toggle the selection state."

	self enabled ifFalse: [^self].
	self model ifNil: [^self].
	(self setStateSelector ifNil: [^self]) numArgs = 0
		ifTrue: [self model perform: self setStateSelector].
	self setStateSelector numArgs = 1
		ifTrue: [	self model perform: self setStateSelector with: self isSelected not].
	self updateSelection
	! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 17:58'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getStateSelector ifTrue: 
		[self updateSelection.
		^ self].
	aSymbol == self getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 18:06'!
updateButton: evt
	"Update the button due to mouse activity in the receiver."

	self enabled ifFalse: [^self].
	evt isMouseDown ifTrue: [
		self buttonMorph state == #on ifTrue: [^self buttonMorph state: #repressed].
		self buttonMorph state == #off ifTrue: [^self buttonMorph state: #pressed]].
	evt isMouseUp ifTrue: [
		self buttonMorph state == #repressed ifTrue: [
			^self buttonMorph state: #off; doButtonAction].
		self buttonMorph state == #pressed ifTrue: [
			^self buttonMorph state: #on; doButtonAction]].
	evt isMove ifTrue: [
		(self containsPoint: evt cursorPoint)
			ifTrue: [self buttonMorph state == #on ifTrue: [^self buttonMorph state: #repressed].
					self buttonMorph state == #off ifTrue: [^self buttonMorph state: #pressed]]
			ifFalse: [self buttonMorph state == #repressed ifTrue: [^self buttonMorph state: #on].
					self buttonMorph state == #pressed ifTrue: [^self buttonMorph state: #off]]]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:35'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 17:58'!
updateSelection
	"Update the selection state."

	self buttonMorph ifNotNilDo: [:m | m selected: self isSelected].
	self changed: #isSelected! !

MorphicModel subclass: #ColorPresenterMorph
	instanceVariableNames: 'contentMorph labelMorph solidLabelMorph setColorSelector getColorSelector'
	classVariableNames: 'HatchForm'
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ColorPresenterMorph commentStamp: 'gvc 5/18/2007 13:38' prior: 0!
Displays a colour with alpha against a white, hatched and black background.!

ColorPresenterMorph subclass: #ColorChooserMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'enabled getEnabledSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ColorChooserMorph commentStamp: 'gvc 5/18/2007 13:45' prior: 0!
ColorPresenter that opens a colour selector when clicked.!

ColorChooserMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!ColorChooserMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:49'!
on: anObject color: getSel changeColor: setSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		color: getSel
		changeColor: setSel! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:03'!
chooseColor
	"Popup the color picker for now."

	|newColor|
	newColor := self theme
		chooseColorIn: ((self ownerThatIsA: SystemWindow) ifNil: [self])
		title: 'Choose Color'
		color: self labelMorph color.
	newColor ifNil: [^self].
	self labelMorph color: newColor.
	self solidLabelMorph color: newColor asNontranslucentColor.
	self setColorSelector ifNotNil: [self model perform: self setColorSelector with: newColor]! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:46'!
enabled
	"Answer the enabled state of the receiver."
	
	^enabled! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:46'!
enabled: aBoolean
	"Set the enabled state of the receiver."

	enabled _ aBoolean.
	self contentMorph ifNotNilDo: [:m | m enabled: aBoolean].
	self changed: #enabled! !

!ColorChooserMorph methodsFor: 'accessing' stamp: 'gvc 10/12/2006 13:47'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!ColorChooserMorph methodsFor: 'accessing' stamp: 'gvc 10/12/2006 13:51'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:44'!
initialize
	"Initialize the receiver."

	enabled := true.
	super initialize! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:43'!
newContentMorph
	"Answer a new button morph"

	|b|
	b := (self theme
		newButtonIn: self
		for: self
		getState: nil
		action: #chooseColor
		arguments: #()
		getEnabled: #enabled
		label: self newHatchMorph
		help: nil)
		hResizing: #spaceFill.
	b contentHolder hResizing: #spaceFill.
	^b! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:46'!
on: anObject color: getColSel changeColor: setColSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		on: anObject color: getColSel;
		setColorSelector: setColSel! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:51'!
update: aSymbol 
	"Refer to the comment in View|update:."

	super update: aSymbol.
	aSymbol == self getEnabledSelector ifTrue: 
		[self updateEnabled.
		^ self]! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:48'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!ColorPresenterMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:05'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^HatchForm ifNil: [HatchForm := self newHatchForm]! !

!ColorPresenterMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:24'!
newHatchForm
	"Answer a new hatch form."
	
	^(Form
	extent: 8@8
	depth: 1
	fromArray: #( 4026531840 4026531840 4026531840 4026531840 251658240 251658240 251658240 251658240)
	offset: 0@0)! !

!ColorPresenterMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:49'!
on: anObject color: getSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		color: getSel! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:25'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:25'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
getColorSelector
	"Answer the value of getColorSelector"

	^ getColorSelector! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
getColorSelector: anObject
	"Set the value of getColorSelector"

	getColorSelector := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:04'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^self class hatchForm! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:34'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		labelMorph: self newLabelMorph;
		solidLabelMorph: self newLabelMorph;
		contentMorph: self newContentMorph;
		addMorphBack: self contentMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:23'!
newContentMorph
	"Answer a new content morph"

	^Morph new
		color: Color transparent;
		changeTableLayout;
		borderStyle: (BorderStyle inset width: 1);
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		addMorph: self newHatchMorph;
		yourself! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 11:56'!
newHatchMorph
	"Answer a new morph showing a grid hatch pattern."

	^Morph new
		changeProportionalLayout;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		minWidth: 48;
		minHeight: 12;
		addMorph: (Morph new color: Color white)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 0.3@1));
		addMorph: (Morph new fillStyle: (InfiniteForm with: self hatchForm))
		fullFrame: (LayoutFrame fractions: (0.3@0 corner: 0.7@1));
		addMorph: self solidLabelMorph
		fullFrame: (LayoutFrame fractions: (0.7@0 corner: 1@1));
		addMorph: self labelMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:20'!
newLabelMorph
	"Answer a new label morph"

	^Morph new! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:45'!
on: anObject color: getColSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		model: anObject;
		getColorSelector: getColSel;
		updateColor! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 15:58'!
on: anObject color: getColSel changeColor: setColSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		model: anObject;
		getColorSelector: getColSel;
		setColorSelector: setColSel;
		updateColor! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
setColorSelector
	"Answer the value of setColorSelector"

	^ setColorSelector! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
setColorSelector: anObject
	"Set the value of setColorSelector"

	setColorSelector := anObject! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 16:17'!
solidLabelMorph
	"Answer the value of solidLabelMorph"

	^ solidLabelMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 16:17'!
solidLabelMorph: anObject
	"Set the value of solidLabelMorph"

	solidLabelMorph := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:34'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getColorSelector ifTrue: 
		[self updateColor.
		^ self]! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2007 15:14'!
updateColor
	"Update the color state."

	|col|
	self getColorSelector ifNotNil: [
		col _ (self model perform: self getColorSelector) ifNil: [Color transparent].
		self labelMorph color: col.
		self solidLabelMorph color: col asNontranslucentColor]! !

MorphicModel subclass: #ColumnMorph
	uses: TEasilyThemed
	instanceVariableNames: 'id headingMorph listMorph getListSelector getHeadingSelector getValueSelector selectedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ColumnMorph commentStamp: 'gvc 5/18/2007 13:32' prior: 0!
Pluggable column for use with TableMorph.!

ColumnMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!ColumnMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 14:59'!
withName: anId
	"Answer a new instance of the receiver with the given name (id) object."

	^self new name: anId! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getHeadingSelector
	"Answer the value of getHeadingSelector"

	^ getHeadingSelector! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getHeadingSelector: anObject
	"Set the value of getHeadingSelector"

	getHeadingSelector := anObject! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getListSelector
	"Answer the value of getListSelector"

	^ getListSelector! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getListSelector: anObject
	"Set the value of getListSelector"

	getListSelector := anObject! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getValueSelector
	"Answer the value of getValueSelector"

	^ getValueSelector! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:02'!
getValueSelector: anObject
	"Set the value of getValueSelector"

	getValueSelector := anObject! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 15:59'!
headingLabel
	"Answer the label for the heading.
	Can be a String, Text of Morph."

	^self model perform: self getHeadingSelector with: self id! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:59'!
headingMorph
	"Answer the value of headingMorph"

	^ headingMorph! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:59'!
headingMorph: anObject
	"Set the value of headingMorph"

	headingMorph := anObject! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:59'!
id
	"Answer the value of id"

	^ id! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 15:59'!
id: anObject
	"Set the value of id"

	id := anObject! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 14:29'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex _ 0.
	self
		borderWidth: 0;
		changeTableLayout;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #rigid;
		vResizing: #spaceFill;
		headingMorph: self newHeadingMorph;
		listMorph: self newListMorph;
		addMorphBack: self headingMorph;
		addMorphBack: self listMorph;
		extent: self optimalExtent! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:05'!
list
	"Answer the list."

	^self model perform: self getListSelector with: self id! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:59'!
listMorph
	"Answer the value of listMorph"

	^ listMorph! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:59'!
listMorph: anObject
	"Set the value of listMorph"

	listMorph := anObject! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:43'!
newHeadingMorph
	"Answer a new heading morph."

	^(self
		newButtonFor: self
		getState: nil
		action: nil
		arguments: #()
		getEnabled: nil
		getLabel: #headingLabel
		help: nil)
		hResizing: #spaceFill;
		wrapCentering: #topLeft! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:49'!
newListMorph
	"Answer a new list morph."

	^(self
		newListFor: self
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		help: nil)
		hResizing: #spaceFill;
		borderWidth: 0! !

!ColumnMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 17:21'!
optimalExtent
	"Answer the max of the optimal extent of the header and list."

	|ho lo|
	ho := self headingMorph optimalExtent.
	lo := self listMorph optimalExtent.
	^((ho x max: lo x) @ (ho y + lo y)) + (self borderWidth * 2)! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 14:29'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!ColumnMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 14:29'!
selectedIndex: anObject
	"Set the value of selectedIndex"

	selectedIndex := anObject.
	self changed: #selectedIndex! !

MorphicModel subclass: #ComposableMorph
	uses: TEasilyThemed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ComposableMorph commentStamp: 'gvc 5/18/2007 13:32' prior: 0!
Morph with an inset border by default and theme access.!

ComposableMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 09:39'!
defaultBorderColor
	"Answer the default border color/fill style for the receiver"
	
	^#inset! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 09:39'!
defaultBorderWidth
	"Answer the default border width for the receiver."
	
	^ 1! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/29/2006 18:25'!
defaultTitle
	"Answer the default title label for the receiver."

	^'Composite' translated! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 09:44'!
newWindow
	"Answer a new window with the receiver as model."

	|w|
	w := StandardWindow new
		model: self;
		title: self defaultTitle;
		addMorph: self
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
		yourself.
	self
		borderWidth: 0.
	^w! !

MorphicModel subclass: #DropListMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'contentMorph listMorph buttonMorph list listSelectionIndex getListSelector getIndexSelector setIndexSelector getEnabledSelector enabled useSelectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!DropListMorph commentStamp: 'gvc 5/23/2007 14:12' prior: 0!
Displays a selected item and a drop button. When pressed will popup a list to enable changing of the selection. Supports enablement.!

DropListMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!DropListMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 12:25'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!DropListMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:05'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		useSelectionIndex: useIndex;
		on: anObject 
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:58'!
adoptPaneColor: paneColor
	"Pass on to the list morph and border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse].
	self updateContentColor: paneColor.
	self listPaneColor: paneColor.
	self changed: #buttonLabel! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:04'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme dropListNormalBorderStyleFor: self]
		ifFalse: [self theme dropListDisabledBorderStyleFor: self]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/17/2007 16:48'!
buttonLabel
	"Answer the label for the button."

	^ImageMorph new image: (
		ScrollBar
			arrowOfDirection: #bottom
			size: self buttonWidth - 2
			color: self paneColor darker)! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/22/2006 13:25'!
buttonMorph
	"Answer the value of buttonMorph"

	^ buttonMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/22/2006 13:25'!
buttonMorph: anObject
	"Set the value of buttonMorph"

	buttonMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/17/2007 16:47'!
buttonWidth
	"Answer based on scrollbar size."
	
	^Preferences scrollBarsNarrow ifTrue: [12] ifFalse: [16]! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:45'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:45'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/22/2006 13:31'!
cornerStyle: aSymbol
	"Pass on to list and button too."

	super cornerStyle: aSymbol.
	self listMorph cornerStyle: aSymbol.
	self buttonMorph cornerStyle: aSymbol.! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:17'!
defaultColor
	"Answer the default color of the receiver."

	^Color white! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 12:18'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 15:16'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [
		self drawKeyboardFocusOn: aCanvas]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 12:18'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:18'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 9/1/2006 15:57'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled := anObject.
	anObject ifFalse: [self hideList].
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:04'!
extent: newExtent
	"Update the gradient."
	
	super extent: newExtent.
	(self fillStyle notNil and: [self fillStyle isSolidFill not])
		ifTrue: [self fillStyle: self fillStyleToUse]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:03'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme dropListNormalFillStyleFor: self]
		ifFalse: [self theme dropListDisabledFillStyleFor: self]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 15:18'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self innerBounds insetBy: (0@0 corner: self buttonMorph width@0)! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:07'!
font
	"Answer the list font"

	^self listMorph font! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 12:34'!
font: aFont
	"Set the list and content font"

	self listMorph font: aFont.
	self contentMorph beAllFont: aFont! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:51'!
getCurrentSelection
	"Answer the current selection from the model."

	|selection|
	selection _ self model perform: self getIndexSelector.
	^(self list includes: selection)
		ifTrue: [selection]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 12:30'!
getCurrentSelectionIndex
	"Answer the index of the current selection."

	self getIndexSelector ifNil: [^0].
	^self model perform: self getIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:16'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:30'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getIndexSelector
	"Answer the value of getIndexSelector"

	^ getIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getIndexSelector: anObject
	"Set the value of getIndexSelector"

	getIndexSelector := anObject! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getListSelector
	"Answer the value of getListSelector"

	^ getListSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getListSelector: anObject
	"Set the value of getListSelector"

	getListSelector := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 11:30'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event."
	
	^true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/16/2007 15:17'!
hideList
	"Hide the list."

	self listMorph ifNil: [^self].
	self listVisible ifFalse: [^self].
	self listMorph delete.
	self listMorph selectionIndex = self listSelectionIndex
		ifFalse: [self listMorph changeModelSelection: self listMorph selectionIndex].
	(self buttonMorph ifNil: [^self]) roundedCorners: (self roundedCorners copyWithoutAll: #(1 2)).
	self changed.
	self activeHand newKeyboardFocus: self! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:53'!
initialize
	"Initialize the receiver."

	super initialize.
	listSelectionIndex := 0.
	enabled := true.
	list := #().
	self
		useSelectionIndex: true;
		clipSubmorphs: true;
		layoutPolicy: RowLayout new;
		layoutInset: (0@0 corner: -1@0);
		cellPositioning: #center;
		listMorph: self newListMorph;
		contentMorph: self newContentMorph;
		buttonMorph: self newButtonMorph;
		borderStyle: (BorderStyle inset width: 1);
		addMorphBack: self contentMorph;
		addMorphBack: (self addDependent: self buttonMorph);
		on: #mouseDown send: #popList to: self.
	self listMorph fillStyle: (self theme dropListNormalListFillStyleFor: self)! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/8/2007 13:31'!
keyStroke: event
	"Pass on to the list."
	
	(self navigationKey: event) ifTrue: [^self].
	self listMorph keyStroke: event ! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/8/2007 13:40'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:27'!
list
	"Answer the list contents."

	^list! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:31'!
list: aCollection
	"Set the list contents."

	list := aCollection.
	self changed: #list! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 12:16'!
listHeight
	"Answer the height for the list."

	^(self listMorph listMorph height + 6 max: 38) min: 200! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:07'!
listMorph
	"Answer the value of listMorph"

	^ listMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:07'!
listMorph: anObject
	"Set the value of listMorph"

	listMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:42'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableListMorph! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/22/2006 15:44'!
listMouseDown: evt
	"Click outside the list."

	(self listMorph fullContainsPoint: evt position)
		ifTrue: [self listMorph selectionIndex: (self listMorph rowAtLocation: evt position)]
		ifFalse: [self hideList]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 14:03'!
listPaneColor: paneColor
	"Set the pane color for the list."
	
	self listMorph ifNil: [^self].
	self listMorph
		adoptPaneColor: paneColor;
		fillStyle: (self theme dropListNormalListFillStyleFor: self)! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:28'!
listSelectionIndex
	"Answer the list selection."

	^listSelectionIndex! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:08'!
listSelectionIndex: anInteger
	"Set the list selection."

	self hideList.
	anInteger = 0 ifTrue: [^self].
	listSelectionIndex := anInteger.
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: anInteger.
	self model ifNotNilDo: [:m | 
		self setIndexSelector ifNotNilDo: [:s |
			self useSelectionIndex
				ifTrue: [m perform: s with: anInteger]
				ifFalse: [m perform: s with: self selectedItem]]]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:26'!
listVisible
	"Answer whether the list is visible."

	^self listMorph owner notNil! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:27'!
morphicLayerNumber
	"Answer the layer number."

	^self listVisible ifTrue: [10] ifFalse: [super morphicLayerNumber]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/17/2007 16:47'!
newButtonMorph
	"Answer a new button morph"

	^(PluggableButtonMorphPlus
		on: self
		getState: nil
		action: #popList
		label: #buttonLabel)
			roundedCorners: #(3 4);
			getEnabledSelector: #enabled;
			label: (ImageMorph new image: (
					ScrollBar
						arrowOfDirection: #bottom
						size: 13
						color: Color lightGray)); 
			vResizing: #spaceFill;
			hResizing: #rigid;
			extent: self buttonWidth asPoint;
			setProperty: #wantsKeyboardFocusNavigation toValue: false! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/5/2007 09:23'!
newContentMorph
	"Answer a new content morph"

	^TextMorphForFieldView new
		contents: ' ';
		margins: (2@0 corner: 2@1);
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		autoFit: false;
		lock! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 12:14'!
newListMorph
	"Answer a new list morph"

	|m|
	m := (self listMorphClass
		on: self
		list: #list
		selected: #listSelectionIndex
		changeSelected: #listSelectionIndex:)
			roundedCorners: #(2 3);
			setProperty: #morphicLayerNumber toValue: 5;
			color: self color;
			borderStyle: (BorderStyle inset width: 1);
			on: #mouseDown send: #listMouseDown: to: self.
	^m! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:58'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel
	"Set the receiver to the given model parameterized by the given message selectors."

	getListSel isSymbol
		ifTrue: [self  getListSelector: getListSel]
		ifFalse: [self list: getListSel]. "allow direct list"
	self
		model: anObject;
		getIndexSelector: getSelectionSel;
		setIndexSelector: setSelectionSel;
		updateList;
		updateListSelectionIndex;
		updateContents! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/8/2006 10:13'!
outOfWorld: aWorld
	"Get rid of the list if visible."

	self hideList.
	^super outOfWorld: aWorld! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/22/2006 15:00'!
popList
	"Hide / show the list."

	self enabled ifFalse: [^self].
	self listMorph owner isNil
		ifTrue: [self showList]
		ifFalse: [self hideList]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/16/2007 14:58'!
roundedCorners
	"Return a list of those corners to round."

	|rc|
	rc _ self valueOfProperty: #roundedCorners ifAbsent: [super roundedCorners].
	^self listVisible
			ifTrue: [rc copyWithoutAll: #(2 3)]
			ifFalse: [rc]
		! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/16/2007 15:03'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self buttonMorph ifNotNilDo: [:b |
		b roundedCorners: (anArray copyWithoutAll: #(1 2))]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:12'!
selectedItem
	"Answer the selected list item."

	^(self listSelectionIndex between: 1 and: self list size) ifTrue: [
		self list at: self listSelectionIndex]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:58'!
selectionColor
	"Answer the selection color for the receiver."

	^self listMorph selectionColor! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:58'!
selectionColor: aColor
	"Set the selection color for the receiver."

	self listMorph selectionColor: aColor! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
setIndexSelector
	"Answer the value of setIndexSelector"

	^ setIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
setIndexSelector: anObject
	"Set the value of setIndexSelector"

	setIndexSelector := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/16/2007 15:17'!
showList
	"Show the list."

	self listMorph owner isNil
		ifTrue: [self listMorph
					bounds: (self bounds bottomLeft extent: self extent x @ self listHeight).
				self listPaneColor: self paneColor.
				self world addMorphInLayer: self listMorph.
				self buttonMorph roundedCorners: (self roundedCorners copyWithoutAll: #(1 2 3)).
				self changed.
				self activeHand
					newKeyboardFocus: self listMorph;
					newMouseFocus: self listMorph]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 12:50'!
step
	"Reset mouse focus to the list if it is showing."

	self listVisible ifTrue: [
		self activeHand mouseFocus ifNil: [
			self activeHand
				newKeyboardFocus: self listMorph;
				newMouseFocus: self listMorph]]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 12:48'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^100! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 12:30'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 14:46'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 13:18'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector ifTrue: 
		[self updateList.
		^ self].
	aSymbol == getIndexSelector ifTrue:
		[self updateListSelectionIndex.
		^ self].
	aSymbol == getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self].
! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:16'!
updateContentColor: paneColor
	"Change the content text color."
	
	self enabled
		ifTrue: [self contentMorph textColor: Color black]
		ifFalse: [self contentMorph textColor: paneColor duller]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:35'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		contents: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: [' ']) "needs something to keep font"! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 14:55'!
updateEnabled
	"Update the enablement state."

	self getEnabledSelector ifNotNil: [
		self enabled: (self model perform: self getEnabledSelector)]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:57'!
updateList
	"Refresh the list."

	self getListSelector isSymbol ifTrue: [
		self list: (self model perform: self getListSelector).
		listSelectionIndex := 0]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:49'!
updateListSelectionIndex
	"Update the list selection."

	|i|
	self useSelectionIndex
		ifTrue: [i := self getCurrentSelectionIndex.
				listSelectionIndex == i ifTrue: [^self].
				listSelectionIndex := i]
		ifFalse: [i _ self getCurrentSelection.
				i isNil
					ifTrue: [listSelectionIndex _ 0]
					ifFalse: [listSelectionIndex _ self list indexOf: i]].
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: i! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:53'!
useIndex
	"Use the model as returning the selected index rather than item."

	self useSelectionIndex: true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:53'!
useSelection
	"Use the model as returning the selected item rather than index."

	self useSelectionIndex: false! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:53'!
useSelectionIndex
	"Answer the value of useSelectionIndex"

	^ useSelectionIndex! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:53'!
useSelectionIndex: anObject
	"Set the value of useSelectionIndex"

	useSelectionIndex := anObject! !

DropListMorph subclass: #MorphDropListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!MorphDropListMorph commentStamp: 'gvc 5/18/2007 12:43' prior: 0!
Drop list supporting morphs in list.!

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:07'!
font: aFont
	"Set the list font"

	self listMorph font: aFont! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:43'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableMorphListMorph! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:11'!
newContentMorph
	"Answer a new content morph"

	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		layoutInset: 2;
		color: Color transparent;
		borderWidth: 0;
		clipSubmorphs: true;
		lock! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 11:58'!
updateContentColor: paneColor
	"Change the content text color."
	! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 13:35'!
updateContents
	"Update the contents."

	|item|
	self contentMorph removeAllMorphs.
	self listSelectionIndex > 0
		ifTrue: [item := (self list at: self listSelectionIndex) copy
					hResizing: #spaceFill;
					vResizing: #rigid.
				self contentMorph
					addMorph: item]! !

MorphicModel subclass: #ExampleBuilderMorph
	uses: TEasilyThemed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!ExampleBuilderMorph commentStamp: 'gvc 7/19/2007 16:49' prior: 0!
Morph with an inset border by default and theme access. Overrides openModal: to allow multiple free example dialogs to be presented.!

ExampleBuilderMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!ExampleBuilderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/19/2007 17:17'!
openModal: aSystemWindow
	"Open the given window an available position without modality.
	Answer the system window."
	
	|baseArea areas searching foundRect|
	aSystemWindow extent: aSystemWindow initialExtent.
	areas := World submorphs
		select: [:m | m isKindOf: DialogWindow]
		thenCollect: [:m | m bounds expandBy: 8].			.
	baseArea := (RealEstateAgent reduceByFlaps: RealEstateAgent maximumUsableArea)
		insetBy: 8.
	searching := true.
	baseArea allAreasOutsideList: areas do: [:rect |
		searching ifTrue: [
			aSystemWindow extent <= (rect insetBy: 8) extent
				ifTrue: [foundRect := rect.
						searching := false]]].
	searching ifTrue: [foundRect := baseArea].
	aSystemWindow position: foundRect topLeft + 8.
	aSystemWindow openAsIs.
	^aSystemWindow! !

MorphicModel subclass: #GroupboxMorph
	instanceVariableNames: 'contentMorph labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!GroupboxMorph commentStamp: 'gvc 5/18/2007 12:36' prior: 0!
Groupbox with title with a vertical layout. Appears in a lighter colour than the owner's pane colour.!

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:24'!
addContentMorph: aMorph
	"Add a morph to the content."

	^self contentMorph addMorphBack: aMorph! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 17:16'!
adoptPaneColor: paneColor
	"Pass on to the content morph a little lighter."
	
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	self labelMorph
		color: paneColor blacker muchDarker;
		backgroundColor: paneColor whiter whiter.
	super adoptPaneColor: paneColor whiter whiter! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:05'!
containsPoint: aPoint
	"Override here to check the label and content instead."
	
	^(super containsPoint: aPoint) and: [
		(self labelMorph containsPoint: aPoint) or: [
		self contentMorph containsPoint: aPoint]]! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:47'!
cornerStyle: aSymbol
	"Pass on to list too."

	super cornerStyle: aSymbol.
	self labelMorph cornerStyle: aSymbol.
	self contentMorph cornerStyle: aSymbol! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:55'!
font
	"Answer the label font"

	^self labelMorph font! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:55'!
font: aFont
	"Set the label font"

	self labelMorph font: aFont! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/12/2007 10:49'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 16:55'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		labelMorph: self newLabelMorph;
		contentMorph: self newContentMorph;
		addMorphBack: self labelMorph;
		addMorphBack: self contentMorph! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:26'!
label
	"Answer the contents of the label morph."

	^self labelMorph contents! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/8/2007 12:40'!
label: aString
	"Set the contents of the label morph."

	aString ifNil: [self labelMorph delete. ^self].
	self labelMorph owner ifNil: [
		self addMorph: self labelMorph].
	self labelMorph contents: aString! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 15:34'!
minExtent
	"Answer the minmum extent of the receiver.
	Based on label and rounding."

	^super minExtent max: self labelMorph minExtent + (8@0)! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:58'!
newContentMorph
	"Answer a new content morph"

	^PanelMorph new
		roundedCorners: #(2 3 4);
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 16:53'!
newLabelMorph
	"Answer a new label morph"

	^TextMorph new
		roundedCorners: #(1 4);
		margins: (2@1 corner: 2@-2);
		contents: 'groupbox';
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		lock! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:50'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNilDo: [:c | c whiter whiter]! !

MorphicModel subclass: #TabGroupMorph
	instanceVariableNames: 'tabSelectorMorph contentMorph pageMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TabGroupMorph commentStamp: 'gvc 5/18/2007 11:54' prior: 0!
Organises a set of pages sharing the same space and selected through the use of tabs along the top.!

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:13'!
addPage: aMorph label: aStringOrMorph
	"Add a page and its tab."

	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	self pages add: aMorph.
	self tabSelectorMorph addTab: aStringOrMorph! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:32'!
adoptPaneColor: paneColor
	"Pass on to the content morph a little lighter."
	
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	super adoptPaneColor: paneColor whiter whiter! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:28'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:28'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:44'!
cornerStyle: aSymbol
	"Pass on to selector and content too."

	super cornerStyle: aSymbol.
	self tabSelectorMorph cornerStyle: aSymbol.
	self contentMorph cornerStyle: aSymbol! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:47'!
font
	"Answer the label font"

	^self tabSelectorMorph font! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:46'!
font: aFont
	"Set the label font"

	self tabSelectorMorph font: aFont! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:59'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		pageMorphs: OrderedCollection new;
		tabSelectorMorph: self newTabSelectorMorph;
		contentMorph: self newContentMorph;
		addMorphBack: self tabSelectorMorph;
		addMorphBack: self contentMorph.
	self tabSelectorMorph addDependent: self! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:44'!
labelsAndPages: assocs
	"Replace the tabs and the associated pages."

	self contentMorph removeAllMorphs.
	self tabSelectorMorph removeAllMorphs.
	assocs do: [:a | self addPage: a value label: a key]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 18:10'!
minExtent
	"Calculate the min extent of the receiver based on all pages."

	|extra|
	self page ifNil: [^super minExtent].
	extra := 0@(self tabSelectorMorph minExtent y).
	extra := extra + self contentMorph layoutInset topLeft.
	extra := extra + self contentMorph layoutInset bottomRight.
	extra := extra + (8@0).
	^(self pages inject: 0 @ 0 into: [:mw :pm | mw max: pm minExtent]) + extra! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:26'!
newContentMorph
	"Answer a new content morph"

	^PanelMorph new
		roundedCorners: #(2 3 4);
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:30'!
newTabSelectorMorph
	"Answer a new tab selector morph"

	^TabSelectorMorph new
		vResizing: #shrinkWrap;
		hResizing: #spaceFill! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:00'!
page
	"Answer the current page morph if any."

	^self pageMorph! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:58'!
pageMorph
	"Answer the current page morph if any."

	^self contentMorph hasSubmorphs
		ifTrue: [self contentMorph submorphs first]! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:53'!
pageMorphs
	"Answer the value of pageMorphs"

	^ pageMorphs! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:53'!
pageMorphs: anObject
	"Set the value of pageMorphs"

	pageMorphs := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:00'!
pages
	"Answer the pages."

	^self pageMorphs! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:51'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNilDo: [:c | c whiter whiter]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 11:51'!
selectedPageIndex
	"Answer the selected page index."

	^self tabSelectorMorph selectedIndex! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:55'!
selectedPageIndex: index
	"Set the selected page index."

	self tabSelectorMorph selectedIndex: index! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:51'!
tabSelectorMorph
	"Answer the value of tabSelectorMorph"

	^ tabSelectorMorph! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:51'!
tabSelectorMorph: anObject
	"Set the value of tabSelectorMorph"

	tabSelectorMorph := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:59'!
update: aSymbol
	"Handle tab changes."

	super update: aSymbol.
	aSymbol == #selectedIndex
		ifTrue: [self updatePageIndex: self selectedPageIndex]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 16:39'!
updatePageIndex: index
	"Change to the given page index."

	|p|
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pages at: index)]
		ifFalse: [self contentMorph
				replaceSubmorph: p
				by: (self pages at: index)].
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor! !

MorphicModel subclass: #TabSelectorMorph
	instanceVariableNames: 'selectedIndex font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TabSelectorMorph commentStamp: 'gvc 5/18/2007 11:54' prior: 0!
Row of tabs for a TabGroupMorph.!

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:43'!
addTab: aStringOrMorph
	"Add a new tab with the given text."
	
	self
		addMorphBack: (self newLabelMorph: aStringOrMorph);
		adoptPaneColor: self paneColor! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 16:39'!
adoptPaneColor: paneColor
	"Make non-selected tabs blacker."
	
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	super adoptPaneColor: paneColor lighter.
	self selectedTab ifNotNilDo: [:t | t color: paneColor]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:45'!
cornerStyle: aSymbol
	"Pass to tabs only."

	self tabs do: [:t | t cornerStyle: aSymbol]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 14:11'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [
		self selectedTab ifNotNilDo: [:t |
			self clipSubmorphs 
				ifTrue: [aCanvas
							clipBy: self clippingBounds
							during: [:c | t drawKeyboardFocusOn: c]]
				ifFalse: [t drawKeyboardFocusOn: aCanvas]]]! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/16/2006 08:54'!
font
	"Answer the label font"

	^font! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/16/2006 08:48'!
font: aFont
	"Set the label font"

	font == aFont ifTrue: [^self].
	font _ aFont.
	self updateFont! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:09'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 12:57'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex := 0.
	self
		borderWidth: 0;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2@0! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:12'!
keyStroke: event 
	"Process keys navigation and space to toggle."
	
	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character arrowLeft
		ifTrue: [self selectPreviousTab].
	event keyCharacter = Character arrowRight
		ifTrue: [self selectNextTab]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:09'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self changed! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 18:03'!
minExtent
	"Add a bit for the round corner of the group."

	^super minExtent + (8@0)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:23'!
newLabelMorph: aStringOrMorph
	"Answer a new label morph with the given label text."

	|m l|
	l := aStringOrMorph isMorph
		ifTrue: [aStringOrMorph lock]
		ifFalse: [LabelMorph new
				contents: aStringOrMorph;
				font: self font;
				vResizing: #shrinkWrap;
				hResizing: #shrinkWrap;
				lock].
	m := TabLabelMorph new
		roundedCorners: #(1 4);
		useRoundedCorners;
		changeTableLayout;
		listCentering: #center;
		layoutInset: (4@2 corner: 4@0);
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		addMorph: l.
	m on: #mouseDown send: #tabClicked:with: to: self.
	^m! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:14'!
selectNextTab
	"Select the next tab, or the first if none selected."
	
	self selectedIndex: self selectedIndex \\ self tabs size + 1! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:18'!
selectPreviousTab
	"Select the previous tab, or the last if none selected."
	
	self selectedIndex: (self selectedIndex < 2
		ifTrue: [self tabs size]
		ifFalse: [self selectedIndex - 1])! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:37'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:24'!
selectedIndex: index
	"Set the value of selectedIndex"

	selectedIndex == index ifTrue: [^self].
	selectedIndex := index.
	self adoptPaneColor: self paneColor.
	self changed: #selectedIndex! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:45'!
selectedTab
	"Answer the selected tab."
	
	^self selectedIndex = 0
		ifFalse: [self tabs at: self selectedIndex]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:46'!
tabClicked: evt with: aMorph 
	"A tab has been clicked."
	
	self selectedIndex: (self tabs indexOf: aMorph)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:45'!
tabs
	"Answer the tabs."
	
	^self submorphs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:00'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:50'!
updateFont
	"Update the label font."

	self tabs do: [:t |
		 ((t submorphs first isKindOf: StringMorph) or: [t submorphs first isTextMorph])
			ifTrue: [t submorphs first font: self font]]! !

MorphicModel subclass: #TableMorph
	uses: TEasilyThemed
	instanceVariableNames: 'list getListSelector getColumnIdsSelector getHeadingSelector getValueSelector setValueSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!TableMorph commentStamp: 'gvc 5/18/2007 11:29' prior: 0!
Experimental general table morph.!

TableMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!TableMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 11:48'!
example
	"Open an example table.
	(self example)"
	
	|model|
	model := TableItemWrapper new
		columnIds: #(1 2 3 4);
		headings: #('Class' 'Super count' 'Sub count' 'Method count');
		valueBlocks: (Dictionary new
			at: 1 put: [:c | c name];
			at: 2 put: [:c | c allSuperclasses size];
			at: 3 put: [:c | c allSubclasses size];
			at: 4 put: [:c | c instanceSide methodDictionary size + c classSide methodDictionary size ];
			yourself).		
	^self new
		getColumnIdsSelector: #columnIds;
		getHeadingSelector: #headingFor:;
		getValueSelector: #valueFor:in:;
		model: model;
		list: (Object withAllSubclasses asSortedCollection: [:a :b | a name <= b name]);
		openInWindow! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 16:53'!
addNewColumn: name
	"Add a column to the table."

	|col|
	self submorphs isEmpty ifFalse: [self addNewResizer].
	col := ColumnMorph basicNew.
	col
		model: self;
		id: name;
		getListSelector: #listFor:;
		getHeadingSelector: #headingFor:;
		getValueSelector: #valueFor:in:;
		initialize.
	self addMorphBack: col! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 17:12'!
addNewResizer
	"Add resizer."

	self submorphs isEmpty ifTrue: [^self].
	self addMorphBack: (
		EdgeGripMorph new
			target:  self submorphs last;
			ptName: #right;
			extent: 4@20)! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 16:00'!
getColumnIdsSelector
	"Answer the value of getColumnIdsSelector"

	^ getColumnIdsSelector! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 16:00'!
getColumnIdsSelector: anObject
	"Set the value of getColumnIdsSelector"

	getColumnIdsSelector := anObject! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:50'!
getHeadingSelector
	"Answer the value of getHeadingSelector"

	^ getHeadingSelector! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:50'!
getHeadingSelector: anObject
	"Set the value of getHeadingSelector"

	getHeadingSelector := anObject! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:50'!
getListSelector
	"Answer the value of getListSelector"

	^ getListSelector! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:50'!
getListSelector: anObject
	"Set the value of getListSelector"

	getListSelector := anObject! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:52'!
getValueSelector
	"Answer the value of getValueSelector"

	^ getValueSelector! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:52'!
getValueSelector: anObject
	"Set the value of getValueSelector"

	getValueSelector := anObject! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:03'!
headingFor: anId
	"Answer the heading for the column."

	^self model perform: self getHeadingSelector with: anId! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/12/2007 17:09'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		color: Color white! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:50'!
list
	"Answer the value of list"

	^ list! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:53'!
list: anObject
	"Set the value of list"

	list := anObject.
	self updateTable! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:12'!
listFor: anId
	"Answer the list for the column."

	^self list collect: [:i |
		self valueFor: i in: anId]! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:52'!
setValueSelector
	"Answer the value of setValueSelector"

	^ setValueSelector! !

!TableMorph methodsFor: 'accessing' stamp: 'gvc 1/17/2007 14:52'!
setValueSelector: anObject
	"Set the value of setValueSelector"

	setValueSelector := anObject! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:01'!
updateTable
	"Rebuild the entire table."

	|columnNames|
	self removeAllMorphs.
	columnNames := self model perform: self getColumnIdsSelector.
	columnNames do: [:c |
		self addNewColumn: c]! !

!TableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2007 16:03'!
valueFor: anItem in: anId
	"Answer the value for the item in the column."

	^self model perform: self getValueSelector with: anItem with: anId! !

MultiNewParagraph subclass: #MultiNewParagraphWithSelectionColor
	instanceVariableNames: 'selectionColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pinesoft-Widgets'!

!MultiNewParagraphWithSelectionColor commentStamp: 'gvc 5/18/2007 12:43' prior: 0!
Paragraph supporting custom selection colour.!

!MultiNewParagraphWithSelectionColor methodsFor: 'accessing' stamp: 'gvc 10/24/2006 16:12'!
selectionColor
	"Answer the selection color."

	^selectionColor ifNil: [super selectionColor]! !

!MultiNewParagraphWithSelectionColor methodsFor: 'accessing' stamp: 'gvc 10/24/2006 16:11'!
selectionColor: anObject
	"Set the value of selectionColor"

	selectionColor := anObject! !

!SelectedObjectThumbnail methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 11/14/2006 14:13'!
step
	"Update the image to be a thumbnail of the morph under the hand.
	Optimized to not constantly update."
	
	| current |
	current := self selectedObject.
	current == (self valueOfProperty: #currentSelectedObject)
		ifTrue: [^self].
	self setProperty: #currentSelectedObject toValue: current.
	self setBalloonText: (current isNil
				ifTrue: [noSelectedBalloonText]
				ifFalse: [current externalName]).
	""
	self makeThumbnailFrom: current! !

!CodeHolder methodsFor: '*Pinesoft-Widgets-override' stamp: 'gvc 5/19/2006 10:31'!
optionalButtonRow
	"Answer a row of control buttons"
	| aRow aButton aLabel |
	aRow := AlignmentMorph newRow.
	aRow setNameTo: 'buttonPane'.
	aRow beSticky.
	aRow hResizing: #spaceFill.
	aRow wrapCentering: #center;
		 cellPositioning: #leftCenter.
	aRow clipSubmorphs: true.
	aRow cellInset: 0.
	aRow layoutInset: 0.
	aRow color: Color white.
	Preferences menuButtonInToolPane
		ifTrue: [aRow addMorphFront: self menuButton].
	self optionalButtonPairs
		do: [:tuple | 
			aButton := PluggableButtonMorph
						on: self
						getState: nil
						action: tuple second.
			aButton hResizing: #spaceFill;
				 vResizing: #spaceFill.
			aLabel := Preferences abbreviatedBrowserButtons
						ifTrue: [self abbreviatedWordingFor: tuple second].
			aButton
				label: (aLabel
						ifNil: [tuple first asString]).
			tuple size > 2
				ifTrue: [aButton setBalloonText: tuple third].
			tuple size > 3
				ifTrue: [aButton triggerOnMouseDown: tuple fourth].
			aRow addMorphBack: aButton].
	aRow addMorphBack: self codePaneProvenanceButton.
	^ aRow! !

!OrientedFillStyle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:19'!
= anOrientedFillStyle
	"Answer whether equal."

	^self species = anOrientedFillStyle species
		and: [self origin = anOrientedFillStyle origin
		and: [self direction = anOrientedFillStyle direction
		and: [self normal = anOrientedFillStyle normal]]]! !

!OrientedFillStyle methodsFor: '*Pinesoft-Widgets' stamp: 'gvc 7/24/2007 12:20'!
hash
	"Hash is implemented because #= is implemented."
	
	^self species hash
		bitXor: (self origin hash
		bitXor: (self direction hash
		bitXor: (self normal hash)))! !
PBUIThemePreferenceView initialize!
FullscreenMorph initialize!
TaskbarMorph initialize!
ThemeIcons initialize!
VistaryThemeIcons initialize!
UITheme initialize!
